/* kf-backend.c generated by valac 0.56.16, the Vala compiler
 * generated from kf-backend.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include "key-file.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "folks/folks.h"
#include <gio/gio.h>
#include "folks-internal.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_BACKENDS_KF_BACKEND_0_PROPERTY,
	FOLKS_BACKENDS_KF_BACKEND_IS_PREPARED_PROPERTY,
	FOLKS_BACKENDS_KF_BACKEND_IS_QUIESCENT_PROPERTY,
	FOLKS_BACKENDS_KF_BACKEND_NAME_PROPERTY,
	FOLKS_BACKENDS_KF_BACKEND_PERSONA_STORES_PROPERTY,
	FOLKS_BACKENDS_KF_BACKEND_NUM_PROPERTIES
};
static GParamSpec* folks_backends_kf_backend_properties[FOLKS_BACKENDS_KF_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksBackendsKfBackendPrepareData FolksBackendsKfBackendPrepareData;
typedef struct _FolksBackendsKfBackendUnprepareData FolksBackendsKfBackendUnprepareData;

struct _FolksBackendsKfBackendPrivate {
	gboolean _is_prepared;
	gboolean _prepare_pending;
	gboolean _is_quiescent;
	GeeHashMap* _persona_stores;
	GeeMap* _persona_stores_ro;
};

struct _FolksBackendsKfBackendPrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsKfBackend* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	gboolean _tmp1_;
	GFile* file;
	const gchar* path;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GFile* _tmp9_;
	const gchar* _tmp10_;
	FolksBackendsKfPersonaStore* store;
	GFile* _tmp11_;
	FolksBackendsKfPersonaStore* _tmp12_;
	FolksBackendsKfPersonaStore* _tmp13_;
	FolksInternalProfileBlock* _tmp14_;
	GError* _inner_error0_;
};

struct _FolksBackendsKfBackendUnprepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsKfBackend* self;
	gboolean _tmp0_;
	GeeIterator* _persona_store_it;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeIterator* _tmp5_;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	FolksBackendsKfPersonaStore* persona_store;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	FolksBackendsKfPersonaStore* _tmp10_;
	GeeHashMap* _tmp11_;
	GError* _inner_error0_;
};

static gint FolksBackendsKfBackend_private_offset;
static gpointer folks_backends_kf_backend_parent_class = NULL;

static void folks_backends_kf_backend_real_enable_persona_store (FolksBackend* base,
                                                          FolksPersonaStore* store);
static void _folks_backends_kf_backend_add_store (FolksBackendsKfBackend* self,
                                           FolksBackendsKfPersonaStore* store,
                                           gboolean notify);
static void folks_backends_kf_backend_real_disable_persona_store (FolksBackend* base,
                                                           FolksPersonaStore* store);
static void _folks_backends_kf_backend_store_removed_cb (FolksBackendsKfBackend* self,
                                                  FolksPersonaStore* store);
static GFile* _folks_backends_kf_backend_get_default_file (FolksBackendsKfBackend* self,
                                                    const gchar* basename);
static void folks_backends_kf_backend_real_set_persona_stores (FolksBackend* base,
                                                        GeeSet* storeids);
static void _vala_array_add1 (FolksBackendsKfPersonaStore** * array,
                       gint* length,
                       gint* size,
                       FolksBackendsKfPersonaStore* value);
static void _folks_backends_kf_backend_remove_store (FolksBackendsKfBackend* self,
                                              FolksBackendsKfPersonaStore* store,
                                              gboolean notify);
static void folks_backends_kf_backend_real_prepare_data_free (gpointer _data);
static void folks_backends_kf_backend_real_prepare (FolksBackend* base,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static gboolean folks_backends_kf_backend_real_prepare_co (FolksBackendsKfBackendPrepareData* _data_);
static void __folks_backends_kf_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                               gpointer self);
static void folks_backends_kf_backend_real_unprepare_data_free (gpointer _data);
static void folks_backends_kf_backend_real_unprepare (FolksBackend* base,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static gboolean folks_backends_kf_backend_real_unprepare_co (FolksBackendsKfBackendUnprepareData* _data_);
static GObject * folks_backends_kf_backend_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void folks_backends_kf_backend_finalize (GObject * obj);
static GType folks_backends_kf_backend_get_type_once (void);
static void _vala_folks_backends_kf_backend_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
folks_backends_kf_backend_get_instance_private (FolksBackendsKfBackend* self)
{
	return G_STRUCT_MEMBER_P (self, FolksBackendsKfBackend_private_offset);
}

/**
   * {@inheritDoc}
   */
static void
folks_backends_kf_backend_real_enable_persona_store (FolksBackend* base,
                                                     FolksPersonaStore* store)
{
	FolksBackendsKfBackend * self;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 83 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 83 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (store != NULL);
#line 85 "../backends/key-file/kf-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 85 "../backends/key-file/kf-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 85 "../backends/key-file/kf-backend.vala"
	_tmp2_ = _tmp1_;
#line 85 "../backends/key-file/kf-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_) == FALSE) {
#line 87 "../backends/key-file/kf-backend.vala"
		_folks_backends_kf_backend_add_store (self, G_TYPE_CHECK_INSTANCE_CAST (store, FOLKS_BACKENDS_KF_TYPE_PERSONA_STORE, FolksBackendsKfPersonaStore), TRUE);
#line 200 "kf-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static void
folks_backends_kf_backend_real_disable_persona_store (FolksBackend* base,
                                                      FolksPersonaStore* store)
{
	FolksBackendsKfBackend * self;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 94 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 94 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (store != NULL);
#line 96 "../backends/key-file/kf-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 96 "../backends/key-file/kf-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 96 "../backends/key-file/kf-backend.vala"
	_tmp2_ = _tmp1_;
#line 96 "../backends/key-file/kf-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 98 "../backends/key-file/kf-backend.vala"
		_folks_backends_kf_backend_store_removed_cb (self, store);
#line 229 "kf-backend.c"
	}
}

static GFile*
_folks_backends_kf_backend_get_default_file (FolksBackendsKfBackend* self,
                                             const gchar* basename)
{
	gchar* filename = NULL;
	gchar* _tmp0_;
	GFile* file = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result;
#line 102 "../backends/key-file/kf-backend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../backends/key-file/kf-backend.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 104 "../backends/key-file/kf-backend.vala"
	_tmp0_ = g_strconcat (basename, ".ini", NULL);
#line 104 "../backends/key-file/kf-backend.vala"
	filename = _tmp0_;
#line 105 "../backends/key-file/kf-backend.vala"
	_tmp1_ = g_get_user_data_dir ();
#line 105 "../backends/key-file/kf-backend.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 105 "../backends/key-file/kf-backend.vala"
	file = _tmp2_;
#line 106 "../backends/key-file/kf-backend.vala"
	_tmp3_ = file;
#line 106 "../backends/key-file/kf-backend.vala"
	_tmp4_ = g_file_get_child (_tmp3_, "folks");
#line 106 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (file);
#line 106 "../backends/key-file/kf-backend.vala"
	file = _tmp4_;
#line 107 "../backends/key-file/kf-backend.vala"
	_tmp5_ = file;
#line 107 "../backends/key-file/kf-backend.vala"
	_tmp6_ = g_file_get_child (_tmp5_, filename);
#line 107 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (file);
#line 107 "../backends/key-file/kf-backend.vala"
	file = _tmp6_;
#line 108 "../backends/key-file/kf-backend.vala"
	result = file;
#line 108 "../backends/key-file/kf-backend.vala"
	_g_free0 (filename);
#line 108 "../backends/key-file/kf-backend.vala"
	return result;
#line 283 "kf-backend.c"
}

/**
   * {@inheritDoc}
   * In this implementation storeids are assumed to be base filenames for
   * ini files under user_data_dir()/folks/ like the default relationships
   * {@link PersonaStore}.
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 141 "../backends/key-file/kf-backend.vala"
	return self ? g_object_ref (self) : NULL;
#line 297 "kf-backend.c"
}

static void
_vala_array_add1 (FolksBackendsKfPersonaStore** * array,
                  gint* length,
                  gint* size,
                  FolksBackendsKfPersonaStore* value)
{
#line 141 "../backends/key-file/kf-backend.vala"
	if ((*length) == (*size)) {
#line 141 "../backends/key-file/kf-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 141 "../backends/key-file/kf-backend.vala"
		*array = g_renew (FolksBackendsKfPersonaStore*, *array, (*size) + 1);
#line 312 "kf-backend.c"
	}
#line 141 "../backends/key-file/kf-backend.vala"
	(*array)[(*length)++] = value;
#line 141 "../backends/key-file/kf-backend.vala"
	(*array)[*length] = NULL;
#line 318 "kf-backend.c"
}

static void
folks_backends_kf_backend_real_set_persona_stores (FolksBackend* base,
                                                   GeeSet* storeids)
{
	FolksBackendsKfBackend * self;
	gboolean added_stores = FALSE;
	FolksBackendsKfPersonaStore** removed_stores = NULL;
	FolksBackendsKfPersonaStore** _tmp0_;
	gint removed_stores_length1;
	gint _removed_stores_size_;
	gboolean _tmp31_ = FALSE;
#line 117 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 121 "../backends/key-file/kf-backend.vala"
	added_stores = FALSE;
#line 122 "../backends/key-file/kf-backend.vala"
	_tmp0_ = g_new0 (FolksBackendsKfPersonaStore*, 0 + 1);
#line 122 "../backends/key-file/kf-backend.vala"
	removed_stores = _tmp0_;
#line 122 "../backends/key-file/kf-backend.vala"
	removed_stores_length1 = 0;
#line 122 "../backends/key-file/kf-backend.vala"
	_removed_stores_size_ = removed_stores_length1;
#line 344 "kf-backend.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 125 "../backends/key-file/kf-backend.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) storeids);
#line 125 "../backends/key-file/kf-backend.vala"
		_id_it = _tmp1_;
#line 125 "../backends/key-file/kf-backend.vala"
		while (TRUE) {
#line 354 "kf-backend.c"
			GeeIterator* _tmp2_;
			gchar* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeHashMap* _tmp5_;
			const gchar* _tmp6_;
#line 125 "../backends/key-file/kf-backend.vala"
			_tmp2_ = _id_it;
#line 125 "../backends/key-file/kf-backend.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 125 "../backends/key-file/kf-backend.vala"
				break;
#line 367 "kf-backend.c"
			}
#line 125 "../backends/key-file/kf-backend.vala"
			_tmp3_ = _id_it;
#line 125 "../backends/key-file/kf-backend.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 125 "../backends/key-file/kf-backend.vala"
			id = (gchar*) _tmp4_;
#line 127 "../backends/key-file/kf-backend.vala"
			_tmp5_ = self->priv->_persona_stores;
#line 127 "../backends/key-file/kf-backend.vala"
			_tmp6_ = id;
#line 127 "../backends/key-file/kf-backend.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_) == FALSE) {
#line 381 "kf-backend.c"
				GFile* file = NULL;
				const gchar* _tmp7_;
				GFile* _tmp8_;
				FolksBackendsKfPersonaStore* store = NULL;
				GFile* _tmp9_;
				FolksBackendsKfPersonaStore* _tmp10_;
				FolksBackendsKfPersonaStore* _tmp11_;
#line 129 "../backends/key-file/kf-backend.vala"
				_tmp7_ = id;
#line 129 "../backends/key-file/kf-backend.vala"
				_tmp8_ = _folks_backends_kf_backend_get_default_file (self, _tmp7_);
#line 129 "../backends/key-file/kf-backend.vala"
				file = _tmp8_;
#line 131 "../backends/key-file/kf-backend.vala"
				_tmp9_ = file;
#line 131 "../backends/key-file/kf-backend.vala"
				_tmp10_ = folks_backends_kf_persona_store_new (_tmp9_);
#line 131 "../backends/key-file/kf-backend.vala"
				store = _tmp10_;
#line 132 "../backends/key-file/kf-backend.vala"
				_tmp11_ = store;
#line 132 "../backends/key-file/kf-backend.vala"
				_folks_backends_kf_backend_add_store (self, _tmp11_, FALSE);
#line 133 "../backends/key-file/kf-backend.vala"
				added_stores = TRUE;
#line 127 "../backends/key-file/kf-backend.vala"
				_g_object_unref0 (store);
#line 127 "../backends/key-file/kf-backend.vala"
				_g_object_unref0 (file);
#line 411 "kf-backend.c"
			}
#line 125 "../backends/key-file/kf-backend.vala"
			_g_free0 (id);
#line 415 "kf-backend.c"
		}
#line 125 "../backends/key-file/kf-backend.vala"
		_g_object_unref0 (_id_it);
#line 419 "kf-backend.c"
	}
	{
		GeeIterator* _store_it = NULL;
		GeeHashMap* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp12_ = self->priv->_persona_stores;
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp13_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp12_);
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp14_ = _tmp13_;
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp15_ = _tmp14_;
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 137 "../backends/key-file/kf-backend.vala"
		_tmp17_ = _tmp16_;
#line 137 "../backends/key-file/kf-backend.vala"
		_g_object_unref0 (_tmp15_);
#line 137 "../backends/key-file/kf-backend.vala"
		_store_it = _tmp17_;
#line 137 "../backends/key-file/kf-backend.vala"
		while (TRUE) {
#line 447 "kf-backend.c"
			GeeIterator* _tmp18_;
			FolksBackendsKfPersonaStore* store = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			FolksBackendsKfPersonaStore* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
#line 137 "../backends/key-file/kf-backend.vala"
			_tmp18_ = _store_it;
#line 137 "../backends/key-file/kf-backend.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 137 "../backends/key-file/kf-backend.vala"
				break;
#line 461 "kf-backend.c"
			}
#line 137 "../backends/key-file/kf-backend.vala"
			_tmp19_ = _store_it;
#line 137 "../backends/key-file/kf-backend.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 137 "../backends/key-file/kf-backend.vala"
			store = (FolksBackendsKfPersonaStore*) _tmp20_;
#line 139 "../backends/key-file/kf-backend.vala"
			_tmp21_ = store;
#line 139 "../backends/key-file/kf-backend.vala"
			_tmp22_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp21_);
#line 139 "../backends/key-file/kf-backend.vala"
			_tmp23_ = _tmp22_;
#line 139 "../backends/key-file/kf-backend.vala"
			if (!gee_collection_contains ((GeeCollection*) storeids, _tmp23_)) {
#line 477 "kf-backend.c"
				FolksBackendsKfPersonaStore* _tmp24_;
				FolksBackendsKfPersonaStore* _tmp25_;
#line 141 "../backends/key-file/kf-backend.vala"
				_tmp24_ = store;
#line 141 "../backends/key-file/kf-backend.vala"
				_tmp25_ = _g_object_ref0 (_tmp24_);
#line 141 "../backends/key-file/kf-backend.vala"
				_vala_array_add1 (&removed_stores, &removed_stores_length1, &_removed_stores_size_, _tmp25_);
#line 486 "kf-backend.c"
			}
#line 137 "../backends/key-file/kf-backend.vala"
			_g_object_unref0 (store);
#line 490 "kf-backend.c"
		}
#line 137 "../backends/key-file/kf-backend.vala"
		_g_object_unref0 (_store_it);
#line 494 "kf-backend.c"
	}
	{
		gint i = 0;
#line 145 "../backends/key-file/kf-backend.vala"
		i = 0;
#line 500 "kf-backend.c"
		{
			gboolean _tmp26_ = FALSE;
#line 145 "../backends/key-file/kf-backend.vala"
			_tmp26_ = TRUE;
#line 145 "../backends/key-file/kf-backend.vala"
			while (TRUE) {
#line 507 "kf-backend.c"
				FolksBackendsKfPersonaStore** _tmp28_;
				gint _tmp28__length1;
				FolksBackendsKfPersonaStore** _tmp29_;
				gint _tmp29__length1;
				FolksBackendsKfPersonaStore* _tmp30_;
#line 145 "../backends/key-file/kf-backend.vala"
				if (!_tmp26_) {
#line 515 "kf-backend.c"
					gint _tmp27_;
#line 145 "../backends/key-file/kf-backend.vala"
					i = i + 1;
#line 145 "../backends/key-file/kf-backend.vala"
					_tmp27_ = i;
#line 521 "kf-backend.c"
				}
#line 145 "../backends/key-file/kf-backend.vala"
				_tmp26_ = FALSE;
#line 145 "../backends/key-file/kf-backend.vala"
				_tmp28_ = removed_stores;
#line 145 "../backends/key-file/kf-backend.vala"
				_tmp28__length1 = removed_stores_length1;
#line 145 "../backends/key-file/kf-backend.vala"
				if (!(i < _tmp28__length1)) {
#line 145 "../backends/key-file/kf-backend.vala"
					break;
#line 533 "kf-backend.c"
				}
#line 147 "../backends/key-file/kf-backend.vala"
				_tmp29_ = removed_stores;
#line 147 "../backends/key-file/kf-backend.vala"
				_tmp29__length1 = removed_stores_length1;
#line 147 "../backends/key-file/kf-backend.vala"
				_tmp30_ = _tmp29_[i];
#line 147 "../backends/key-file/kf-backend.vala"
				_folks_backends_kf_backend_remove_store (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, FOLKS_BACKENDS_KF_TYPE_PERSONA_STORE, FolksBackendsKfPersonaStore), FALSE);
#line 543 "kf-backend.c"
			}
		}
	}
#line 151 "../backends/key-file/kf-backend.vala"
	if (added_stores) {
#line 151 "../backends/key-file/kf-backend.vala"
		_tmp31_ = TRUE;
#line 551 "kf-backend.c"
	} else {
		FolksBackendsKfPersonaStore** _tmp32_;
		gint _tmp32__length1;
#line 151 "../backends/key-file/kf-backend.vala"
		_tmp32_ = removed_stores;
#line 151 "../backends/key-file/kf-backend.vala"
		_tmp32__length1 = removed_stores_length1;
#line 151 "../backends/key-file/kf-backend.vala"
		_tmp31_ = _tmp32__length1 > 0;
#line 561 "kf-backend.c"
	}
#line 151 "../backends/key-file/kf-backend.vala"
	if (_tmp31_) {
#line 153 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 567 "kf-backend.c"
	}
#line 117 "../backends/key-file/kf-backend.vala"
	removed_stores = (_vala_array_free (removed_stores, removed_stores_length1, (GDestroyNotify) g_object_unref), NULL);
#line 571 "kf-backend.c"
}

/**
   * {@inheritDoc}
   */
FolksBackendsKfBackend*
folks_backends_kf_backend_construct (GType object_type)
{
	FolksBackendsKfBackend * self = NULL;
#line 162 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) g_object_new (object_type, NULL);
#line 160 "../backends/key-file/kf-backend.vala"
	return self;
#line 585 "kf-backend.c"
}

FolksBackendsKfBackend*
folks_backends_kf_backend_new (void)
{
#line 160 "../backends/key-file/kf-backend.vala"
	return folks_backends_kf_backend_construct (FOLKS_BACKENDS_KF_TYPE_BACKEND);
#line 593 "kf-backend.c"
}

static void
folks_backends_kf_backend_real_prepare_data_free (gpointer _data)
{
	FolksBackendsKfBackendPrepareData* _data_;
	_data_ = _data;
#line 35 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (_data_->self);
#line 35 "../backends/key-file/kf-backend.vala"
	g_slice_free (FolksBackendsKfBackendPrepareData, _data_);
#line 605 "kf-backend.c"
}

static void
folks_backends_kf_backend_real_prepare (FolksBackend* base,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	FolksBackendsKfBackend * self;
	FolksBackendsKfBackendPrepareData* _data_;
	FolksBackendsKfBackend* _tmp0_;
#line 35 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 35 "../backends/key-file/kf-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsKfBackendPrepareData);
#line 35 "../backends/key-file/kf-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 35 "../backends/key-file/kf-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_kf_backend_real_prepare_data_free);
#line 35 "../backends/key-file/kf-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "../backends/key-file/kf-backend.vala"
	_data_->self = _tmp0_;
#line 35 "../backends/key-file/kf-backend.vala"
	folks_backends_kf_backend_real_prepare_co (_data_);
#line 630 "kf-backend.c"
}

static void
folks_backends_kf_backend_prepare_finish (FolksBackend* base,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	FolksBackendsKfBackendPrepareData* _data_;
#line 35 "../backends/key-file/kf-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 35 "../backends/key-file/kf-backend.vala"
	if (NULL == _data_) {
#line 35 "../backends/key-file/kf-backend.vala"
		return;
#line 645 "kf-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static gboolean
folks_backends_kf_backend_real_prepare_co (FolksBackendsKfBackendPrepareData* _data_)
{
#line 174 "../backends/key-file/kf-backend.vala"
	switch (_data_->_state_) {
#line 174 "../backends/key-file/kf-backend.vala"
		case 0:
#line 659 "kf-backend.c"
		goto _state_0;
		default:
#line 174 "../backends/key-file/kf-backend.vala"
		g_assert_not_reached ();
#line 664 "kf-backend.c"
	}
	_state_0:
#line 176 "../backends/key-file/kf-backend.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing Kf.Backend", NULL);
#line 176 "../backends/key-file/kf-backend.vala"
	_data_->profiling = _data_->_tmp0_;
#line 178 "../backends/key-file/kf-backend.vala"
	if (_data_->self->priv->_is_prepared) {
#line 178 "../backends/key-file/kf-backend.vala"
		_data_->_tmp1_ = TRUE;
#line 675 "kf-backend.c"
	} else {
#line 178 "../backends/key-file/kf-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_prepare_pending;
#line 679 "kf-backend.c"
	}
#line 178 "../backends/key-file/kf-backend.vala"
	if (_data_->_tmp1_) {
#line 180 "../backends/key-file/kf-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 180 "../backends/key-file/kf-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 180 "../backends/key-file/kf-backend.vala"
		if (_data_->_state_ != 0) {
#line 180 "../backends/key-file/kf-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 180 "../backends/key-file/kf-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 693 "kf-backend.c"
			}
		}
#line 180 "../backends/key-file/kf-backend.vala"
		g_object_unref (_data_->_async_result);
#line 180 "../backends/key-file/kf-backend.vala"
		return FALSE;
#line 700 "kf-backend.c"
	}
	{
#line 185 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 186 "../backends/key-file/kf-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 189 "../backends/key-file/kf-backend.vala"
		_data_->_tmp2_ = g_getenv ("FOLKS_BACKEND_KEY_FILE_PATH");
#line 189 "../backends/key-file/kf-backend.vala"
		_data_->path = _data_->_tmp2_;
#line 191 "../backends/key-file/kf-backend.vala"
		_data_->_tmp3_ = _data_->path;
#line 191 "../backends/key-file/kf-backend.vala"
		if (_data_->_tmp3_ == NULL) {
#line 193 "../backends/key-file/kf-backend.vala"
			_data_->_tmp4_ = _folks_backends_kf_backend_get_default_file (_data_->self, "relationships");
#line 193 "../backends/key-file/kf-backend.vala"
			_g_object_unref0 (_data_->file);
#line 193 "../backends/key-file/kf-backend.vala"
			_data_->file = _data_->_tmp4_;
#line 195 "../backends/key-file/kf-backend.vala"
			_data_->_tmp5_ = _data_->file;
#line 195 "../backends/key-file/kf-backend.vala"
			_data_->_tmp6_ = g_file_get_path (_data_->_tmp5_);
#line 195 "../backends/key-file/kf-backend.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 195 "../backends/key-file/kf-backend.vala"
			g_debug ("Using built-in key file '%s' (override with " "environment variable FOLKS_BACKEND_KEY_FILE_PATH)", _data_->_tmp7_);
#line 195 "../backends/key-file/kf-backend.vala"
			_g_free0 (_data_->_tmp7_);
#line 731 "kf-backend.c"
		} else {
#line 201 "../backends/key-file/kf-backend.vala"
			_data_->_tmp8_ = _data_->path;
#line 201 "../backends/key-file/kf-backend.vala"
			_data_->_tmp9_ = g_file_new_for_path (_data_->_tmp8_);
#line 201 "../backends/key-file/kf-backend.vala"
			_g_object_unref0 (_data_->file);
#line 201 "../backends/key-file/kf-backend.vala"
			_data_->file = _data_->_tmp9_;
#line 202 "../backends/key-file/kf-backend.vala"
			_data_->_tmp10_ = _data_->path;
#line 202 "../backends/key-file/kf-backend.vala"
			g_debug ("Using environment variable " "FOLKS_BACKEND_KEY_FILE_PATH = '%s' to load the key " "file.", _data_->_tmp10_);
#line 745 "kf-backend.c"
		}
#line 208 "../backends/key-file/kf-backend.vala"
		_data_->_tmp11_ = _data_->file;
#line 208 "../backends/key-file/kf-backend.vala"
		_data_->_tmp12_ = folks_backends_kf_persona_store_new (_data_->_tmp11_);
#line 208 "../backends/key-file/kf-backend.vala"
		_data_->store = _data_->_tmp12_;
#line 210 "../backends/key-file/kf-backend.vala"
		_data_->_tmp13_ = _data_->store;
#line 210 "../backends/key-file/kf-backend.vala"
		_folks_backends_kf_backend_add_store (_data_->self, _data_->_tmp13_, TRUE);
#line 212 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 213 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 215 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_is_quiescent = TRUE;
#line 216 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 183 "../backends/key-file/kf-backend.vala"
		_g_object_unref0 (_data_->store);
#line 183 "../backends/key-file/kf-backend.vala"
		_g_object_unref0 (_data_->file);
#line 769 "kf-backend.c"
	}
	__finally0:
	{
#line 220 "../backends/key-file/kf-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 221 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 777 "kf-backend.c"
	}
#line 183 "../backends/key-file/kf-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../backends/key-file/kf-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 183 "../backends/key-file/kf-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 183 "../backends/key-file/kf-backend.vala"
		g_object_unref (_data_->_async_result);
#line 183 "../backends/key-file/kf-backend.vala"
		return FALSE;
#line 789 "kf-backend.c"
	}
#line 224 "../backends/key-file/kf-backend.vala"
	_data_->_tmp14_ = _data_->profiling;
#line 224 "../backends/key-file/kf-backend.vala"
	_data_->profiling = NULL;
#line 224 "../backends/key-file/kf-backend.vala"
	folks_internal_profiling_end (_data_->_tmp14_);
#line 174 "../backends/key-file/kf-backend.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 174 "../backends/key-file/kf-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 174 "../backends/key-file/kf-backend.vala"
	if (_data_->_state_ != 0) {
#line 174 "../backends/key-file/kf-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 174 "../backends/key-file/kf-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 807 "kf-backend.c"
		}
	}
#line 174 "../backends/key-file/kf-backend.vala"
	g_object_unref (_data_->_async_result);
#line 174 "../backends/key-file/kf-backend.vala"
	return FALSE;
#line 814 "kf-backend.c"
}

/**
   * Utility function to add a persona store.
   *
   * @param store the store to add.
   * @param notify whether or not to emit notification signals.
   */
static void
__folks_backends_kf_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                          gpointer self)
{
#line 236 "../backends/key-file/kf-backend.vala"
	_folks_backends_kf_backend_store_removed_cb ((FolksBackendsKfBackend*) self, _sender);
#line 829 "kf-backend.c"
}

static void
_folks_backends_kf_backend_add_store (FolksBackendsKfBackend* self,
                                      FolksBackendsKfPersonaStore* store,
                                      gboolean notify)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 233 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (self != NULL);
#line 233 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (store != NULL);
#line 235 "../backends/key-file/kf-backend.vala"
	_tmp0_ = self->priv->_persona_stores;
#line 235 "../backends/key-file/kf-backend.vala"
	_tmp1_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 235 "../backends/key-file/kf-backend.vala"
	_tmp2_ = _tmp1_;
#line 235 "../backends/key-file/kf-backend.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, store);
#line 236 "../backends/key-file/kf-backend.vala"
	g_signal_connect_object ((FolksPersonaStore*) store, "removed", (GCallback) __folks_backends_kf_backend_store_removed_cb_folks_persona_store_removed, self, 0);
#line 237 "../backends/key-file/kf-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-added", (FolksPersonaStore*) store);
#line 238 "../backends/key-file/kf-backend.vala"
	if (notify) {
#line 240 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 860 "kf-backend.c"
	}
}

/**
   * Utility function to remove a persona store.
   *
   * @param store the store to remove.
   * @param notify whether or not to emit notification signals.
   */
static void
_folks_backends_kf_backend_remove_store (FolksBackendsKfBackend* self,
                                         FolksBackendsKfPersonaStore* store,
                                         gboolean notify)
{
	guint _tmp0_;
	GeeHashMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 250 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (self != NULL);
#line 250 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (store != NULL);
#line 252 "../backends/key-file/kf-backend.vala"
	g_signal_parse_name ("removed", FOLKS_TYPE_PERSONA_STORE, &_tmp0_, NULL, FALSE);
#line 252 "../backends/key-file/kf-backend.vala"
	g_signal_handlers_disconnect_matched ((FolksPersonaStore*) store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __folks_backends_kf_backend_store_removed_cb_folks_persona_store_removed, self);
#line 253 "../backends/key-file/kf-backend.vala"
	_tmp1_ = self->priv->_persona_stores;
#line 253 "../backends/key-file/kf-backend.vala"
	_tmp2_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 253 "../backends/key-file/kf-backend.vala"
	_tmp3_ = _tmp2_;
#line 253 "../backends/key-file/kf-backend.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp3_, NULL);
#line 254 "../backends/key-file/kf-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-removed", (FolksPersonaStore*) store);
#line 256 "../backends/key-file/kf-backend.vala"
	if (notify) {
#line 258 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) self, "persona-stores");
#line 901 "kf-backend.c"
	}
}

static void
folks_backends_kf_backend_real_unprepare_data_free (gpointer _data)
{
	FolksBackendsKfBackendUnprepareData* _data_;
	_data_ = _data;
#line 35 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (_data_->self);
#line 35 "../backends/key-file/kf-backend.vala"
	g_slice_free (FolksBackendsKfBackendUnprepareData, _data_);
#line 914 "kf-backend.c"
}

static void
folks_backends_kf_backend_real_unprepare (FolksBackend* base,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	FolksBackendsKfBackend * self;
	FolksBackendsKfBackendUnprepareData* _data_;
	FolksBackendsKfBackend* _tmp0_;
#line 35 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 35 "../backends/key-file/kf-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsKfBackendUnprepareData);
#line 35 "../backends/key-file/kf-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 35 "../backends/key-file/kf-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_kf_backend_real_unprepare_data_free);
#line 35 "../backends/key-file/kf-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 35 "../backends/key-file/kf-backend.vala"
	_data_->self = _tmp0_;
#line 35 "../backends/key-file/kf-backend.vala"
	folks_backends_kf_backend_real_unprepare_co (_data_);
#line 939 "kf-backend.c"
}

static void
folks_backends_kf_backend_unprepare_finish (FolksBackend* base,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	FolksBackendsKfBackendUnprepareData* _data_;
#line 35 "../backends/key-file/kf-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 35 "../backends/key-file/kf-backend.vala"
	if (NULL == _data_) {
#line 35 "../backends/key-file/kf-backend.vala"
		return;
#line 954 "kf-backend.c"
	}
}

/**
   * {@inheritDoc}
   */
static gboolean
folks_backends_kf_backend_real_unprepare_co (FolksBackendsKfBackendUnprepareData* _data_)
{
#line 265 "../backends/key-file/kf-backend.vala"
	switch (_data_->_state_) {
#line 265 "../backends/key-file/kf-backend.vala"
		case 0:
#line 968 "kf-backend.c"
		goto _state_0;
		default:
#line 265 "../backends/key-file/kf-backend.vala"
		g_assert_not_reached ();
#line 973 "kf-backend.c"
	}
	_state_0:
#line 267 "../backends/key-file/kf-backend.vala"
	if (!_data_->self->priv->_is_prepared) {
#line 267 "../backends/key-file/kf-backend.vala"
		_data_->_tmp0_ = TRUE;
#line 980 "kf-backend.c"
	} else {
#line 267 "../backends/key-file/kf-backend.vala"
		_data_->_tmp0_ = _data_->self->priv->_prepare_pending == TRUE;
#line 984 "kf-backend.c"
	}
#line 267 "../backends/key-file/kf-backend.vala"
	if (_data_->_tmp0_) {
#line 269 "../backends/key-file/kf-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 269 "../backends/key-file/kf-backend.vala"
		if (_data_->_state_ != 0) {
#line 269 "../backends/key-file/kf-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 269 "../backends/key-file/kf-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 996 "kf-backend.c"
			}
		}
#line 269 "../backends/key-file/kf-backend.vala"
		g_object_unref (_data_->_async_result);
#line 269 "../backends/key-file/kf-backend.vala"
		return FALSE;
#line 1003 "kf-backend.c"
	}
	{
#line 274 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 275 "../backends/key-file/kf-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 1010 "kf-backend.c"
		{
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp1_ = _data_->self->priv->_persona_stores;
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp1_);
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp3_ = _data_->_tmp2_;
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp5_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp4_);
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 277 "../backends/key-file/kf-backend.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 277 "../backends/key-file/kf-backend.vala"
			_data_->_persona_store_it = _data_->_tmp6_;
#line 277 "../backends/key-file/kf-backend.vala"
			while (TRUE) {
#line 277 "../backends/key-file/kf-backend.vala"
				_data_->_tmp7_ = _data_->_persona_store_it;
#line 277 "../backends/key-file/kf-backend.vala"
				if (!gee_iterator_next (_data_->_tmp7_)) {
#line 277 "../backends/key-file/kf-backend.vala"
					break;
#line 1036 "kf-backend.c"
				}
#line 277 "../backends/key-file/kf-backend.vala"
				_data_->_tmp8_ = _data_->_persona_store_it;
#line 277 "../backends/key-file/kf-backend.vala"
				_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 277 "../backends/key-file/kf-backend.vala"
				_data_->persona_store = (FolksBackendsKfPersonaStore*) _data_->_tmp9_;
#line 279 "../backends/key-file/kf-backend.vala"
				_data_->_tmp10_ = _data_->persona_store;
#line 279 "../backends/key-file/kf-backend.vala"
				g_signal_emit_by_name ((FolksBackend*) _data_->self, "persona-store-removed", (FolksPersonaStore*) _data_->_tmp10_);
#line 277 "../backends/key-file/kf-backend.vala"
				_g_object_unref0 (_data_->persona_store);
#line 1050 "kf-backend.c"
			}
#line 277 "../backends/key-file/kf-backend.vala"
			_g_object_unref0 (_data_->_persona_store_it);
#line 1054 "kf-backend.c"
		}
#line 282 "../backends/key-file/kf-backend.vala"
		_data_->_tmp11_ = _data_->self->priv->_persona_stores;
#line 282 "../backends/key-file/kf-backend.vala"
		gee_abstract_map_clear ((GeeAbstractMap*) _data_->_tmp11_);
#line 283 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) _data_->self, "persona-stores");
#line 285 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_is_quiescent = FALSE;
#line 286 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 288 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_is_prepared = FALSE;
#line 289 "../backends/key-file/kf-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 1070 "kf-backend.c"
	}
	__finally0:
	{
#line 293 "../backends/key-file/kf-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 294 "../backends/key-file/kf-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 1078 "kf-backend.c"
	}
#line 272 "../backends/key-file/kf-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 272 "../backends/key-file/kf-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 272 "../backends/key-file/kf-backend.vala"
		g_object_unref (_data_->_async_result);
#line 272 "../backends/key-file/kf-backend.vala"
		return FALSE;
#line 1088 "kf-backend.c"
	}
#line 265 "../backends/key-file/kf-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 265 "../backends/key-file/kf-backend.vala"
	if (_data_->_state_ != 0) {
#line 265 "../backends/key-file/kf-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 265 "../backends/key-file/kf-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1098 "kf-backend.c"
		}
	}
#line 265 "../backends/key-file/kf-backend.vala"
	g_object_unref (_data_->_async_result);
#line 265 "../backends/key-file/kf-backend.vala"
	return FALSE;
#line 1105 "kf-backend.c"
}

static void
_folks_backends_kf_backend_store_removed_cb (FolksBackendsKfBackend* self,
                                             FolksPersonaStore* store)
{
#line 298 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (self != NULL);
#line 298 "../backends/key-file/kf-backend.vala"
	g_return_if_fail (store != NULL);
#line 300 "../backends/key-file/kf-backend.vala"
	_folks_backends_kf_backend_remove_store (self, G_TYPE_CHECK_INSTANCE_CAST (store, FOLKS_BACKENDS_KF_TYPE_PERSONA_STORE, FolksBackendsKfPersonaStore), TRUE);
#line 1118 "kf-backend.c"
}

static gboolean
folks_backends_kf_backend_real_get_is_prepared (FolksBackend* base)
{
	gboolean result;
	FolksBackendsKfBackend* self;
#line 52 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 52 "../backends/key-file/kf-backend.vala"
	result = self->priv->_is_prepared;
#line 52 "../backends/key-file/kf-backend.vala"
	return result;
#line 1132 "kf-backend.c"
}

static gboolean
folks_backends_kf_backend_real_get_is_quiescent (FolksBackend* base)
{
	gboolean result;
	FolksBackendsKfBackend* self;
#line 64 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 64 "../backends/key-file/kf-backend.vala"
	result = self->priv->_is_quiescent;
#line 64 "../backends/key-file/kf-backend.vala"
	return result;
#line 1146 "kf-backend.c"
}

static const gchar*
folks_backends_kf_backend_real_get_name (FolksBackend* base)
{
	const gchar* result;
	FolksBackendsKfBackend* self;
#line 70 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 70 "../backends/key-file/kf-backend.vala"
	result = BACKEND_NAME;
#line 70 "../backends/key-file/kf-backend.vala"
	return result;
#line 1160 "kf-backend.c"
}

static GeeMap*
folks_backends_kf_backend_real_get_persona_stores (FolksBackend* base)
{
	GeeMap* result;
	FolksBackendsKfBackend* self;
	GeeMap* _tmp0_;
#line 77 "../backends/key-file/kf-backend.vala"
	self = (FolksBackendsKfBackend*) base;
#line 77 "../backends/key-file/kf-backend.vala"
	_tmp0_ = self->priv->_persona_stores_ro;
#line 77 "../backends/key-file/kf-backend.vala"
	result = _tmp0_;
#line 77 "../backends/key-file/kf-backend.vala"
	return result;
#line 1177 "kf-backend.c"
}

static GObject *
folks_backends_kf_backend_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksBackendsKfBackend * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
#line 165 "../backends/key-file/kf-backend.vala"
	parent_class = G_OBJECT_CLASS (folks_backends_kf_backend_parent_class);
#line 165 "../backends/key-file/kf-backend.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 165 "../backends/key-file/kf-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_KF_TYPE_BACKEND, FolksBackendsKfBackend);
#line 167 "../backends/key-file/kf-backend.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_BACKENDS_KF_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 167 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 167 "../backends/key-file/kf-backend.vala"
	self->priv->_persona_stores = _tmp0_;
#line 168 "../backends/key-file/kf-backend.vala"
	_tmp1_ = self->priv->_persona_stores;
#line 168 "../backends/key-file/kf-backend.vala"
	_tmp2_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp1_);
#line 168 "../backends/key-file/kf-backend.vala"
	_tmp3_ = _tmp2_;
#line 168 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 168 "../backends/key-file/kf-backend.vala"
	self->priv->_persona_stores_ro = _tmp3_;
#line 165 "../backends/key-file/kf-backend.vala"
	return obj;
#line 1216 "kf-backend.c"
}

static void
folks_backends_kf_backend_class_init (FolksBackendsKfBackendClass * klass,
                                      gpointer klass_data)
{
#line 35 "../backends/key-file/kf-backend.vala"
	folks_backends_kf_backend_parent_class = g_type_class_peek_parent (klass);
#line 35 "../backends/key-file/kf-backend.vala"
	g_type_class_adjust_private_offset (klass, &FolksBackendsKfBackend_private_offset);
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->enable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_kf_backend_real_enable_persona_store;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->disable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_kf_backend_real_disable_persona_store;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->set_persona_stores = (void (*) (FolksBackend*, GeeSet*)) folks_backends_kf_backend_real_set_persona_stores;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->prepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_kf_backend_real_prepare;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->prepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_kf_backend_prepare_finish;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->unprepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_kf_backend_real_unprepare;
#line 35 "../backends/key-file/kf-backend.vala"
	((FolksBackendClass *) klass)->unprepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_kf_backend_unprepare_finish;
#line 35 "../backends/key-file/kf-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_prepared = (gboolean (*) (FolksBackend*)) folks_backends_kf_backend_real_get_is_prepared;
#line 35 "../backends/key-file/kf-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_quiescent = (gboolean (*) (FolksBackend*)) folks_backends_kf_backend_real_get_is_quiescent;
#line 35 "../backends/key-file/kf-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_name = (const gchar* (*) (FolksBackend*)) folks_backends_kf_backend_real_get_name;
#line 35 "../backends/key-file/kf-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_persona_stores = (GeeMap* (*) (FolksBackend*)) folks_backends_kf_backend_real_get_persona_stores;
#line 35 "../backends/key-file/kf-backend.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_backends_kf_backend_get_property;
#line 35 "../backends/key-file/kf-backend.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_backends_kf_backend_constructor;
#line 35 "../backends/key-file/kf-backend.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_backends_kf_backend_finalize;
#line 1255 "kf-backend.c"
	/**
	   * Whether this Backend has been prepared.
	   *
	   * See {@link Folks.Backend.is_prepared}.
	   *
	   * @since 0.3.0
	   */
#line 35 "../backends/key-file/kf-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_KF_BACKEND_IS_PREPARED_PROPERTY, folks_backends_kf_backend_properties[FOLKS_BACKENDS_KF_BACKEND_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1265 "kf-backend.c"
	/**
	   * Whether this Backend has reached a quiescent state.
	   *
	   * See {@link Folks.Backend.is_quiescent}.
	   *
	   * @since 0.6.2
	   */
#line 35 "../backends/key-file/kf-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_KF_BACKEND_IS_QUIESCENT_PROPERTY, folks_backends_kf_backend_properties[FOLKS_BACKENDS_KF_BACKEND_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1275 "kf-backend.c"
	/**
	   * {@inheritDoc}
	   */
#line 35 "../backends/key-file/kf-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_KF_BACKEND_NAME_PROPERTY, folks_backends_kf_backend_properties[FOLKS_BACKENDS_KF_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1281 "kf-backend.c"
	/**
	   * {@inheritDoc}
	   */
#line 35 "../backends/key-file/kf-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_KF_BACKEND_PERSONA_STORES_PROPERTY, folks_backends_kf_backend_properties[FOLKS_BACKENDS_KF_BACKEND_PERSONA_STORES_PROPERTY] = g_param_spec_object ("persona-stores", "persona-stores", "persona-stores", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1287 "kf-backend.c"
}

static void
folks_backends_kf_backend_instance_init (FolksBackendsKfBackend * self,
                                         gpointer klass)
{
#line 35 "../backends/key-file/kf-backend.vala"
	self->priv = folks_backends_kf_backend_get_instance_private (self);
#line 37 "../backends/key-file/kf-backend.vala"
	self->priv->_is_prepared = FALSE;
#line 38 "../backends/key-file/kf-backend.vala"
	self->priv->_prepare_pending = FALSE;
#line 39 "../backends/key-file/kf-backend.vala"
	self->priv->_is_quiescent = FALSE;
#line 1302 "kf-backend.c"
}

static void
folks_backends_kf_backend_finalize (GObject * obj)
{
	FolksBackendsKfBackend * self;
#line 35 "../backends/key-file/kf-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_KF_TYPE_BACKEND, FolksBackendsKfBackend);
#line 40 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 41 "../backends/key-file/kf-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 35 "../backends/key-file/kf-backend.vala"
	G_OBJECT_CLASS (folks_backends_kf_backend_parent_class)->finalize (obj);
#line 1317 "kf-backend.c"
}

/**
 * A backend which loads {@link Persona}s from a simple key file in
 * (XDG_DATA_HOME/folks/) and presents them through a single
 * {@link PersonaStore}.
 *
 * @since 0.1.13
 */
static GType
folks_backends_kf_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksBackendsKfBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_backends_kf_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksBackendsKfBackend), 0, (GInstanceInitFunc) folks_backends_kf_backend_instance_init, NULL };
	GType folks_backends_kf_backend_type_id;
	folks_backends_kf_backend_type_id = g_type_register_static (FOLKS_TYPE_BACKEND, "FolksBackendsKfBackend", &g_define_type_info, 0);
	FolksBackendsKfBackend_private_offset = g_type_add_instance_private (folks_backends_kf_backend_type_id, sizeof (FolksBackendsKfBackendPrivate));
	return folks_backends_kf_backend_type_id;
}

GType
folks_backends_kf_backend_get_type (void)
{
	static volatile gsize folks_backends_kf_backend_type_id__once = 0;
	if (g_once_init_enter (&folks_backends_kf_backend_type_id__once)) {
		GType folks_backends_kf_backend_type_id;
		folks_backends_kf_backend_type_id = folks_backends_kf_backend_get_type_once ();
		g_once_init_leave (&folks_backends_kf_backend_type_id__once, folks_backends_kf_backend_type_id);
	}
	return folks_backends_kf_backend_type_id__once;
}

static void
_vala_folks_backends_kf_backend_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	FolksBackendsKfBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_BACKENDS_KF_TYPE_BACKEND, FolksBackendsKfBackend);
#line 35 "../backends/key-file/kf-backend.vala"
	switch (property_id) {
#line 35 "../backends/key-file/kf-backend.vala"
		case FOLKS_BACKENDS_KF_BACKEND_IS_PREPARED_PROPERTY:
#line 35 "../backends/key-file/kf-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_prepared ((FolksBackend*) self));
#line 35 "../backends/key-file/kf-backend.vala"
		break;
#line 35 "../backends/key-file/kf-backend.vala"
		case FOLKS_BACKENDS_KF_BACKEND_IS_QUIESCENT_PROPERTY:
#line 35 "../backends/key-file/kf-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_quiescent ((FolksBackend*) self));
#line 35 "../backends/key-file/kf-backend.vala"
		break;
#line 35 "../backends/key-file/kf-backend.vala"
		case FOLKS_BACKENDS_KF_BACKEND_NAME_PROPERTY:
#line 35 "../backends/key-file/kf-backend.vala"
		g_value_set_string (value, folks_backend_get_name ((FolksBackend*) self));
#line 35 "../backends/key-file/kf-backend.vala"
		break;
#line 35 "../backends/key-file/kf-backend.vala"
		case FOLKS_BACKENDS_KF_BACKEND_PERSONA_STORES_PROPERTY:
#line 35 "../backends/key-file/kf-backend.vala"
		g_value_set_object (value, folks_backend_get_persona_stores ((FolksBackend*) self));
#line 35 "../backends/key-file/kf-backend.vala"
		break;
#line 1383 "kf-backend.c"
		default:
#line 35 "../backends/key-file/kf-backend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../backends/key-file/kf-backend.vala"
		break;
#line 1389 "kf-backend.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

