/* group-details.c generated by valac 0.56.16, the Vala compiler
 * generated from group-details.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 */

#include "folks/folks.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksGroupDetailsChangeGroupsData FolksGroupDetailsChangeGroupsData;
enum  {
	FOLKS_GROUP_DETAILS_GROUP_CHANGED_SIGNAL,
	FOLKS_GROUP_DETAILS_NUM_SIGNALS
};
static guint folks_group_details_signals[FOLKS_GROUP_DETAILS_NUM_SIGNALS] = {0};

struct _FolksGroupDetailsChangeGroupsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksGroupDetails* self;
	GeeSet* groups;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static void folks_group_details_real_change_groups_data_free (gpointer _data);
static void folks_group_details_real_change_groups (FolksGroupDetails* self,
                                             GeeSet* groups,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static gboolean folks_group_details_real_change_groups_co (FolksGroupDetailsChangeGroupsData* _data_);
static void g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GType folks_group_details_get_type_once (void);

/**
   * The reason a group member has changed its membership in the group.
   *
   * These closely follow the
   * [[http://telepathy.freedesktop.org/spec/Channel_Interface_Group.html#Channel_Group_Change_Reason|Channel_Group_Change_Reason]]
   * interface in the Telepathy specification.
   */
static GType
folks_group_details_change_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE, "FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE", "none"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_OFFLINE, "FOLKS_GROUP_DETAILS_CHANGE_REASON_OFFLINE", "offline"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_KICKED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_KICKED", "kicked"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_BUSY, "FOLKS_GROUP_DETAILS_CHANGE_REASON_BUSY", "busy"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_INVITED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_INVITED", "invited"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_BANNED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_BANNED", "banned"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_ERROR, "FOLKS_GROUP_DETAILS_CHANGE_REASON_ERROR", "error"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_INVALID_MEMBER, "FOLKS_GROUP_DETAILS_CHANGE_REASON_INVALID_MEMBER", "invalid-member"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_NO_ANSWER, "FOLKS_GROUP_DETAILS_CHANGE_REASON_NO_ANSWER", "no-answer"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_RENAMED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_RENAMED", "renamed"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_PERMISSION_DENIED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_PERMISSION_DENIED", "permission-denied"}, {FOLKS_GROUP_DETAILS_CHANGE_REASON_SEPARATED, "FOLKS_GROUP_DETAILS_CHANGE_REASON_SEPARATED", "separated"}, {0, NULL, NULL}};
	GType folks_group_details_change_reason_type_id;
	folks_group_details_change_reason_type_id = g_enum_register_static ("FolksGroupDetailsChangeReason", values);
	return folks_group_details_change_reason_type_id;
}

GType
folks_group_details_change_reason_get_type (void)
{
	static volatile gsize folks_group_details_change_reason_type_id__once = 0;
	if (g_once_init_enter (&folks_group_details_change_reason_type_id__once)) {
		GType folks_group_details_change_reason_type_id;
		folks_group_details_change_reason_type_id = folks_group_details_change_reason_get_type_once ();
		g_once_init_leave (&folks_group_details_change_reason_type_id__once, folks_group_details_change_reason_type_id);
	}
	return folks_group_details_change_reason_type_id__once;
}

void
folks_group_details_change_group (FolksGroupDetails* self,
                                  const gchar* group,
                                  gboolean is_member,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	FolksGroupDetailsIface* _iface_;
#line 32 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 32 "../folks/group-details.vala"
	if (_iface_->change_group) {
#line 32 "../folks/group-details.vala"
		_iface_->change_group (self, group, is_member, _callback_, _user_data_);
#line 118 "group-details.c"
	}
}

void
folks_group_details_change_group_finish (FolksGroupDetails* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	FolksGroupDetailsIface* _iface_;
#line 32 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 32 "../folks/group-details.vala"
	if (_iface_->change_group_finish) {
#line 32 "../folks/group-details.vala"
		_iface_->change_group_finish (self, _res_, error);
#line 134 "group-details.c"
	}
}

static void
folks_group_details_real_change_groups_data_free (gpointer _data)
{
	FolksGroupDetailsChangeGroupsData* _data_;
	_data_ = _data;
#line 32 "../folks/group-details.vala"
	_g_object_unref0 (_data_->groups);
#line 32 "../folks/group-details.vala"
	_g_object_unref0 (_data_->self);
#line 32 "../folks/group-details.vala"
	g_slice_free (FolksGroupDetailsChangeGroupsData, _data_);
#line 149 "group-details.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../folks/group-details.vala"
	return self ? g_object_ref (self) : NULL;
#line 157 "group-details.c"
}

static void
folks_group_details_real_change_groups (FolksGroupDetails* self,
                                        GeeSet* groups,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	FolksGroupDetailsChangeGroupsData* _data_;
	FolksGroupDetails* _tmp0_;
	GeeSet* _tmp1_;
#line 32 "../folks/group-details.vala"
	g_return_if_fail (groups != NULL);
#line 32 "../folks/group-details.vala"
	_data_ = g_slice_new0 (FolksGroupDetailsChangeGroupsData);
#line 32 "../folks/group-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 32 "../folks/group-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_group_details_real_change_groups_data_free);
#line 32 "../folks/group-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 32 "../folks/group-details.vala"
	_data_->self = _tmp0_;
#line 32 "../folks/group-details.vala"
	_tmp1_ = _g_object_ref0 (groups);
#line 32 "../folks/group-details.vala"
	_g_object_unref0 (_data_->groups);
#line 32 "../folks/group-details.vala"
	_data_->groups = _tmp1_;
#line 32 "../folks/group-details.vala"
	folks_group_details_real_change_groups_co (_data_);
#line 189 "group-details.c"
}

static void
folks_group_details_real_change_groups_finish (FolksGroupDetails* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	FolksGroupDetailsChangeGroupsData* _data_;
#line 32 "../folks/group-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 32 "../folks/group-details.vala"
	if (NULL == _data_) {
#line 32 "../folks/group-details.vala"
		return;
#line 204 "group-details.c"
	}
}

/**
   * Change the contact's groups.
   *
   * It's preferred to call this rather than setting {@link GroupDetails.groups}
   * directly, as this method gives error notification and will only return once
   * the groups have been written to the relevant backing store (or the
   * operation's failed).
   *
   * @param groups the complete set of groups the contact should be a member of
   * @throws PropertyError if setting the groups failed
   * @since 0.6.2
   */
static gboolean
folks_group_details_real_change_groups_co (FolksGroupDetailsChangeGroupsData* _data_)
{
#line 169 "../folks/group-details.vala"
	switch (_data_->_state_) {
#line 169 "../folks/group-details.vala"
		case 0:
#line 227 "group-details.c"
		goto _state_0;
		default:
#line 169 "../folks/group-details.vala"
		g_assert_not_reached ();
#line 232 "group-details.c"
	}
	_state_0:
#line 173 "../folks/group-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Groups are not writeable on this contact."));
#line 173 "../folks/group-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 173 "../folks/group-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 173 "../folks/group-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 173 "../folks/group-details.vala"
		g_object_unref (_data_->_async_result);
#line 173 "../folks/group-details.vala"
		return FALSE;
#line 247 "group-details.c"
	} else {
#line 173 "../folks/group-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 173 "../folks/group-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 173 "../folks/group-details.vala"
		g_object_unref (_data_->_async_result);
#line 173 "../folks/group-details.vala"
		return FALSE;
#line 257 "group-details.c"
	}
#line 169 "../folks/group-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 169 "../folks/group-details.vala"
	if (_data_->_state_ != 0) {
#line 169 "../folks/group-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 169 "../folks/group-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 267 "group-details.c"
		}
	}
#line 169 "../folks/group-details.vala"
	g_object_unref (_data_->_async_result);
#line 169 "../folks/group-details.vala"
	return FALSE;
#line 274 "group-details.c"
}

void
folks_group_details_change_groups (FolksGroupDetails* self,
                                   GeeSet* groups,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	FolksGroupDetailsIface* _iface_;
#line 32 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 32 "../folks/group-details.vala"
	if (_iface_->change_groups) {
#line 32 "../folks/group-details.vala"
		_iface_->change_groups (self, groups, _callback_, _user_data_);
#line 290 "group-details.c"
	}
}

void
folks_group_details_change_groups_finish (FolksGroupDetails* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	FolksGroupDetailsIface* _iface_;
#line 32 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 32 "../folks/group-details.vala"
	if (_iface_->change_groups_finish) {
#line 32 "../folks/group-details.vala"
		_iface_->change_groups_finish (self, _res_, error);
#line 306 "group-details.c"
	}
}

GeeSet*
folks_group_details_get_groups (FolksGroupDetails* self)
{
	FolksGroupDetailsIface* _iface_;
#line 128 "../folks/group-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 128 "../folks/group-details.vala"
	if (_iface_->get_groups) {
#line 128 "../folks/group-details.vala"
		return _iface_->get_groups (self);
#line 322 "group-details.c"
	}
#line 128 "../folks/group-details.vala"
	return NULL;
#line 326 "group-details.c"
}

void
folks_group_details_set_groups (FolksGroupDetails* self,
                                GeeSet* value)
{
	FolksGroupDetailsIface* _iface_;
#line 128 "../folks/group-details.vala"
	g_return_if_fail (self != NULL);
#line 128 "../folks/group-details.vala"
	_iface_ = FOLKS_GROUP_DETAILS_GET_INTERFACE (self);
#line 128 "../folks/group-details.vala"
	if (_iface_->set_groups) {
#line 128 "../folks/group-details.vala"
		_iface_->set_groups (self, value);
#line 342 "group-details.c"
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_BOOLEAN) (gpointer data1, const char* arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "../folks/group-details.vala"
	g_return_if_fail (n_param_values == 3);
#line 32 "../folks/group-details.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "../folks/group-details.vala"
		data1 = closure->data;
#line 32 "../folks/group-details.vala"
		data2 = param_values->data[0].v_pointer;
#line 368 "group-details.c"
	} else {
#line 32 "../folks/group-details.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "../folks/group-details.vala"
		data2 = closure->data;
#line 374 "group-details.c"
	}
#line 32 "../folks/group-details.vala"
	callback = (GMarshalFunc_VOID__STRING_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 32 "../folks/group-details.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 380 "group-details.c"
}

static void
folks_group_details_default_init (FolksGroupDetailsIface * iface,
                                  gpointer iface_data)
{
	/**
	   * A set of group IDs for groups containing the member.
	   *
	   * The complete set of freeform identifiers for all the groups the contact is
	   * a member of.
	   *
	   * @since 0.5.1
	   */
#line 32 "../folks/group-details.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("groups", "groups", "groups", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 397 "group-details.c"
	/**
	   * Emitted when the contact's membership status changes for a group.
	   *
	   * This is emitted if the contact becomes a member of a group they weren't in
	   * before, or leaves a group they were in.
	   *
	   * @param group a freeform group identifier for the group being left or joined
	   * @param is_member whether the contact is joining or leaving the group
	   * @since 0.1.11
	   */
#line 32 "../folks/group-details.vala"
	folks_group_details_signals[FOLKS_GROUP_DETAILS_GROUP_CHANGED_SIGNAL] = g_signal_new ("group-changed", FOLKS_TYPE_GROUP_DETAILS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_BOOLEAN);
#line 32 "../folks/group-details.vala"
	iface->change_groups = folks_group_details_real_change_groups;
#line 32 "../folks/group-details.vala"
	iface->change_groups_finish = folks_group_details_real_change_groups_finish;
#line 414 "group-details.c"
}

/**
 * Groups for a contact.
 *
 * This allows contacts to be collected into user-defined groups (or categories)
 * for organisational purposes. Groups are non-exclusive and non-hierarchical,
 * so a single contact can be put into many groups, but groups may not
 * themselves be put into groups.
 */
static GType
folks_group_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksGroupDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_group_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_group_details_type_id;
	folks_group_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksGroupDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_group_details_type_id, G_TYPE_OBJECT);
	return folks_group_details_type_id;
}

GType
folks_group_details_get_type (void)
{
	static volatile gsize folks_group_details_type_id__once = 0;
	if (g_once_init_enter (&folks_group_details_type_id__once)) {
		GType folks_group_details_type_id;
		folks_group_details_type_id = folks_group_details_get_type_once ();
		g_once_init_leave (&folks_group_details_type_id__once, folks_group_details_type_id);
	}
	return folks_group_details_type_id__once;
}

