/* potential-match.c generated by valac 0.56.16, the Vala compiler
 * generated from potential-match.vala, do not modify */

/*
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Raul Gutierrez Segales <raul.gutierrez.segales@collabora.co.uk>
 */

#include "folks/folks.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "folks/small-set.h"
#include <glib-object.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define FOLKS_POTENTIAL_MATCH__SEPARATORS "._-+"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_POTENTIAL_MATCH_0_PROPERTY,
	FOLKS_POTENTIAL_MATCH_NUM_PROPERTIES
};
static GParamSpec* folks_potential_match_properties[FOLKS_POTENTIAL_MATCH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FolksPotentialMatchPrivate {
	FolksIndividual* _individual_a;
	FolksIndividual* _individual_b;
};

static gint FolksPotentialMatch_private_offset;
static gpointer folks_potential_match_parent_class = NULL;
GeeSet* folks_potential_match_known_email_aliases = NULL;
static gdouble folks_potential_match__DIST_THRESHOLD;
static gdouble folks_potential_match__DIST_THRESHOLD = 0.70;

static FolksMatchResult _folks_potential_match_inspect_im_addresses (FolksPotentialMatch* self,
                                                              FolksMatchResult old_result);
static FolksMatchResult _folks_potential_match_inspect_emails (FolksPotentialMatch* self,
                                                        FolksMatchResult old_result);
static FolksMatchResult _folks_potential_match_inspect_phone_numbers (FolksPotentialMatch* self,
                                                               FolksMatchResult old_result);
static FolksMatchResult _folks_potential_match_name_similarity (FolksPotentialMatch* self,
                                                         FolksMatchResult old_result);
static gboolean _folks_potential_match_look_alike (FolksPotentialMatch* self,
                                            const gchar* a,
                                            const gchar* b);
static gboolean _folks_potential_match_look_alike_or_identical (FolksPotentialMatch* self,
                                                         const gchar* a,
                                                         const gchar* b,
                                                         gboolean* exact);
VALA_EXTERN gboolean _folks_utils_str_equal_safe (const gchar* a,
                                      const gchar* b);
static FolksMatchResult _folks_potential_match_inc_match_level (FolksPotentialMatch* self,
                                                         FolksMatchResult current_level,
                                                         gint times);
static gboolean _folks_potential_match_check_initials_expansion (FolksPotentialMatch* self,
                                                          gchar** tokens_a,
                                                          gint tokens_a_length1,
                                                          gchar** tokens_b,
                                                          gint tokens_b_length1);
static gboolean _folks_potential_match_match_tokens (FolksPotentialMatch* self,
                                              gchar** tokens_a,
                                              gint tokens_a_length1,
                                              gchar** tokens_b,
                                              gint tokens_b_length1);
static gboolean _folks_potential_match_do_check_initials_expansion (FolksPotentialMatch* self,
                                                             gchar** expanded_name,
                                                             gint expanded_name_length1,
                                                             const gchar* initials);
static gboolean _folks_potential_match_do_match_tokens (FolksPotentialMatch* self,
                                                 gchar** bigger_set,
                                                 gint bigger_set_length1,
                                                 gchar** smaller_set,
                                                 gint smaller_set_length1);
static gunichar* _folks_potential_match_strip_string (FolksPotentialMatch* self,
                                               const gchar* s,
                                               gint* result_length1);
static gdouble _folks_potential_match_jaro_dist (FolksPotentialMatch* self,
                                          gunichar* s1,
                                          gint s1_length1,
                                          gunichar* s2,
                                          gint s2_length1);
static gint _folks_potential_match_matches (FolksPotentialMatch* self,
                                     gunichar* s1,
                                     gint s1_length1,
                                     gunichar* s2,
                                     gint s2_length1,
                                     gint max_dist,
                                     gdouble* t);
static gunichar _folks_potential_match_stripped_char (FolksPotentialMatch* self,
                                               gunichar ch);
static gint _folks_potential_match_contains (FolksPotentialMatch* self,
                                      gunichar* haystack,
                                      gint haystack_length1,
                                      gunichar c,
                                      guint pos,
                                      guint max_dist);
static void folks_potential_match_finalize (GObject * obj);
static GType folks_potential_match_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * Likely-ness of a potential match.
 *
 * Note that the order should be maintained.
 *
 * @since 0.5.0
 */
static GType
folks_match_result_get_type_once (void)
{
	static const GEnumValue values[] = {{FOLKS_MATCH_RESULT_NONE, "FOLKS_MATCH_RESULT_NONE", "none"}, {FOLKS_MATCH_RESULT_VERY_LOW, "FOLKS_MATCH_RESULT_VERY_LOW", "very-low"}, {FOLKS_MATCH_RESULT_LOW, "FOLKS_MATCH_RESULT_LOW", "low"}, {FOLKS_MATCH_RESULT_MEDIUM, "FOLKS_MATCH_RESULT_MEDIUM", "medium"}, {FOLKS_MATCH_RESULT_HIGH, "FOLKS_MATCH_RESULT_HIGH", "high"}, {FOLKS_MATCH_RESULT_VERY_HIGH, "FOLKS_MATCH_RESULT_VERY_HIGH", "very-high"}, {FOLKS_MATCH_RESULT_MIN, "FOLKS_MATCH_RESULT_MIN", "min"}, {FOLKS_MATCH_RESULT_MAX, "FOLKS_MATCH_RESULT_MAX", "max"}, {0, NULL, NULL}};
	GType folks_match_result_type_id;
	folks_match_result_type_id = g_enum_register_static ("FolksMatchResult", values);
	return folks_match_result_type_id;
}

GType
folks_match_result_get_type (void)
{
	static volatile gsize folks_match_result_type_id__once = 0;
	if (g_once_init_enter (&folks_match_result_type_id__once)) {
		GType folks_match_result_type_id;
		folks_match_result_type_id = folks_match_result_get_type_once ();
		g_once_init_leave (&folks_match_result_type_id__once, folks_match_result_type_id);
	}
	return folks_match_result_type_id__once;
}

static inline gpointer
folks_potential_match_get_instance_private (FolksPotentialMatch* self)
{
	return G_STRUCT_MEMBER_P (self, FolksPotentialMatch_private_offset);
}

/**
   * Create a new PotentialMatch.
   *
   * @return a new PotentialMatch
   *
   * @since 0.5.0
   */
FolksPotentialMatch*
folks_potential_match_construct (GType object_type)
{
	FolksPotentialMatch * self = NULL;
#line 125 "../folks/potential-match.vala"
	self = (FolksPotentialMatch*) g_object_new (object_type, NULL);
#line 123 "../folks/potential-match.vala"
	return self;
#line 186 "potential-match.c"
}

FolksPotentialMatch*
folks_potential_match_new (void)
{
#line 123 "../folks/potential-match.vala"
	return folks_potential_match_construct (FOLKS_TYPE_POTENTIAL_MATCH);
#line 194 "potential-match.c"
}

/**
   * Whether two individuals are likely to be the same person.
   *
   * @param a an individual to compare
   * @param b another individual to compare
   *
   * @since 0.5.0
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 138 "../folks/potential-match.vala"
	return self ? g_object_ref (self) : NULL;
#line 210 "potential-match.c"
}

FolksMatchResult
folks_potential_match_potential_match (FolksPotentialMatch* self,
                                       FolksIndividual* a,
                                       FolksIndividual* b)
{
	FolksIndividual* _tmp0_;
	FolksIndividual* _tmp1_;
	FolksMatchResult _result_ = 0;
	gboolean _tmp2_ = FALSE;
	FolksTrustLevel _tmp3_;
	FolksTrustLevel _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	FolksIndividual* _tmp9_;
	FolksGender _tmp10_;
	FolksGender _tmp11_;
	FolksMatchResult result;
#line 136 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 136 "../folks/potential-match.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 136 "../folks/potential-match.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 138 "../folks/potential-match.vala"
	_tmp0_ = _g_object_ref0 (a);
#line 138 "../folks/potential-match.vala"
	_g_object_unref0 (self->priv->_individual_a);
#line 138 "../folks/potential-match.vala"
	self->priv->_individual_a = _tmp0_;
#line 139 "../folks/potential-match.vala"
	_tmp1_ = _g_object_ref0 (b);
#line 139 "../folks/potential-match.vala"
	_g_object_unref0 (self->priv->_individual_b);
#line 139 "../folks/potential-match.vala"
	self->priv->_individual_b = _tmp1_;
#line 140 "../folks/potential-match.vala"
	_result_ = FOLKS_MATCH_RESULT_MIN;
#line 145 "../folks/potential-match.vala"
	_tmp3_ = folks_individual_get_trust_level (a);
#line 145 "../folks/potential-match.vala"
	_tmp4_ = _tmp3_;
#line 145 "../folks/potential-match.vala"
	if (_tmp4_ == FOLKS_TRUST_LEVEL_NONE) {
#line 145 "../folks/potential-match.vala"
		_tmp2_ = TRUE;
#line 258 "potential-match.c"
	} else {
		FolksTrustLevel _tmp5_;
		FolksTrustLevel _tmp6_;
#line 145 "../folks/potential-match.vala"
		_tmp5_ = folks_individual_get_trust_level (b);
#line 145 "../folks/potential-match.vala"
		_tmp6_ = _tmp5_;
#line 145 "../folks/potential-match.vala"
		_tmp2_ = _tmp6_ == FOLKS_TRUST_LEVEL_NONE;
#line 268 "potential-match.c"
	}
#line 145 "../folks/potential-match.vala"
	if (_tmp2_) {
#line 147 "../folks/potential-match.vala"
		result = _result_;
#line 147 "../folks/potential-match.vala"
		return result;
#line 276 "potential-match.c"
	}
#line 152 "../folks/potential-match.vala"
	if (folks_individual_has_anti_link_with_individual (a, b)) {
#line 154 "../folks/potential-match.vala"
		result = _result_;
#line 154 "../folks/potential-match.vala"
		return result;
#line 284 "potential-match.c"
	}
#line 157 "../folks/potential-match.vala"
	_result_ = FOLKS_MATCH_RESULT_VERY_LOW;
#line 160 "../folks/potential-match.vala"
	_tmp9_ = self->priv->_individual_a;
#line 160 "../folks/potential-match.vala"
	_tmp10_ = folks_gender_details_get_gender ((FolksGenderDetails*) _tmp9_);
#line 160 "../folks/potential-match.vala"
	_tmp11_ = _tmp10_;
#line 160 "../folks/potential-match.vala"
	if (_tmp11_ != FOLKS_GENDER_UNSPECIFIED) {
#line 296 "potential-match.c"
		FolksIndividual* _tmp12_;
		FolksGender _tmp13_;
		FolksGender _tmp14_;
#line 161 "../folks/potential-match.vala"
		_tmp12_ = self->priv->_individual_b;
#line 161 "../folks/potential-match.vala"
		_tmp13_ = folks_gender_details_get_gender ((FolksGenderDetails*) _tmp12_);
#line 161 "../folks/potential-match.vala"
		_tmp14_ = _tmp13_;
#line 161 "../folks/potential-match.vala"
		_tmp8_ = _tmp14_ != FOLKS_GENDER_UNSPECIFIED;
#line 308 "potential-match.c"
	} else {
#line 160 "../folks/potential-match.vala"
		_tmp8_ = FALSE;
#line 312 "potential-match.c"
	}
#line 160 "../folks/potential-match.vala"
	if (_tmp8_) {
#line 316 "potential-match.c"
		FolksIndividual* _tmp15_;
		FolksGender _tmp16_;
		FolksGender _tmp17_;
		FolksIndividual* _tmp18_;
		FolksGender _tmp19_;
		FolksGender _tmp20_;
#line 162 "../folks/potential-match.vala"
		_tmp15_ = self->priv->_individual_a;
#line 162 "../folks/potential-match.vala"
		_tmp16_ = folks_gender_details_get_gender ((FolksGenderDetails*) _tmp15_);
#line 162 "../folks/potential-match.vala"
		_tmp17_ = _tmp16_;
#line 162 "../folks/potential-match.vala"
		_tmp18_ = self->priv->_individual_b;
#line 162 "../folks/potential-match.vala"
		_tmp19_ = folks_gender_details_get_gender ((FolksGenderDetails*) _tmp18_);
#line 162 "../folks/potential-match.vala"
		_tmp20_ = _tmp19_;
#line 162 "../folks/potential-match.vala"
		_tmp7_ = _tmp17_ != _tmp20_;
#line 337 "potential-match.c"
	} else {
#line 160 "../folks/potential-match.vala"
		_tmp7_ = FALSE;
#line 341 "potential-match.c"
	}
#line 160 "../folks/potential-match.vala"
	if (_tmp7_) {
#line 164 "../folks/potential-match.vala"
		result = _result_;
#line 164 "../folks/potential-match.vala"
		return result;
#line 349 "potential-match.c"
	}
#line 168 "../folks/potential-match.vala"
	_result_ = _folks_potential_match_inspect_im_addresses (self, _result_);
#line 169 "../folks/potential-match.vala"
	if (_result_ == FOLKS_MATCH_RESULT_MAX) {
#line 170 "../folks/potential-match.vala"
		result = _result_;
#line 170 "../folks/potential-match.vala"
		return result;
#line 359 "potential-match.c"
	}
#line 173 "../folks/potential-match.vala"
	_result_ = _folks_potential_match_inspect_emails (self, _result_);
#line 174 "../folks/potential-match.vala"
	if (_result_ == FOLKS_MATCH_RESULT_MAX) {
#line 175 "../folks/potential-match.vala"
		result = _result_;
#line 175 "../folks/potential-match.vala"
		return result;
#line 369 "potential-match.c"
	}
#line 178 "../folks/potential-match.vala"
	_result_ = _folks_potential_match_inspect_phone_numbers (self, _result_);
#line 179 "../folks/potential-match.vala"
	if (_result_ == FOLKS_MATCH_RESULT_MAX) {
#line 180 "../folks/potential-match.vala"
		result = _result_;
#line 180 "../folks/potential-match.vala"
		return result;
#line 379 "potential-match.c"
	}
#line 183 "../folks/potential-match.vala"
	_result_ = _folks_potential_match_name_similarity (self, _result_);
#line 184 "../folks/potential-match.vala"
	if (_result_ == FOLKS_MATCH_RESULT_MAX) {
#line 185 "../folks/potential-match.vala"
		result = _result_;
#line 185 "../folks/potential-match.vala"
		return result;
#line 389 "potential-match.c"
	}
#line 187 "../folks/potential-match.vala"
	result = _result_;
#line 187 "../folks/potential-match.vala"
	return result;
#line 395 "potential-match.c"
}

static FolksMatchResult
_folks_potential_match_inspect_phone_numbers (FolksPotentialMatch* self,
                                              FolksMatchResult old_result)
{
	GeeSet* set_a = NULL;
	FolksIndividual* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* set_b = NULL;
	FolksIndividual* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
	FolksMatchResult result;
#line 190 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 192 "../folks/potential-match.vala"
	_tmp0_ = self->priv->_individual_a;
#line 192 "../folks/potential-match.vala"
	_tmp1_ = folks_phone_details_get_phone_numbers ((FolksPhoneDetails*) _tmp0_);
#line 192 "../folks/potential-match.vala"
	_tmp2_ = _tmp1_;
#line 192 "../folks/potential-match.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 192 "../folks/potential-match.vala"
	set_a = _tmp3_;
#line 193 "../folks/potential-match.vala"
	_tmp4_ = self->priv->_individual_b;
#line 193 "../folks/potential-match.vala"
	_tmp5_ = folks_phone_details_get_phone_numbers ((FolksPhoneDetails*) _tmp4_);
#line 193 "../folks/potential-match.vala"
	_tmp6_ = _tmp5_;
#line 193 "../folks/potential-match.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 193 "../folks/potential-match.vala"
	set_b = _tmp7_;
#line 435 "potential-match.c"
	{
		GeeIterator* _phone_fd_a_it = NULL;
		GeeSet* _tmp8_;
		GeeIterator* _tmp9_;
#line 195 "../folks/potential-match.vala"
		_tmp8_ = set_a;
#line 195 "../folks/potential-match.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 195 "../folks/potential-match.vala"
		_phone_fd_a_it = _tmp9_;
#line 195 "../folks/potential-match.vala"
		while (TRUE) {
#line 448 "potential-match.c"
			GeeIterator* _tmp10_;
			FolksPhoneFieldDetails* phone_fd_a = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
#line 195 "../folks/potential-match.vala"
			_tmp10_ = _phone_fd_a_it;
#line 195 "../folks/potential-match.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 195 "../folks/potential-match.vala"
				break;
#line 459 "potential-match.c"
			}
#line 195 "../folks/potential-match.vala"
			_tmp11_ = _phone_fd_a_it;
#line 195 "../folks/potential-match.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 195 "../folks/potential-match.vala"
			phone_fd_a = (FolksPhoneFieldDetails*) _tmp12_;
#line 467 "potential-match.c"
			{
				GeeIterator* _phone_fd_b_it = NULL;
				GeeSet* _tmp13_;
				GeeIterator* _tmp14_;
#line 197 "../folks/potential-match.vala"
				_tmp13_ = set_b;
#line 197 "../folks/potential-match.vala"
				_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 197 "../folks/potential-match.vala"
				_phone_fd_b_it = _tmp14_;
#line 197 "../folks/potential-match.vala"
				while (TRUE) {
#line 480 "potential-match.c"
					GeeIterator* _tmp15_;
					FolksPhoneFieldDetails* phone_fd_b = NULL;
					GeeIterator* _tmp16_;
					gpointer _tmp17_;
					FolksPhoneFieldDetails* _tmp18_;
					FolksPhoneFieldDetails* _tmp19_;
#line 197 "../folks/potential-match.vala"
					_tmp15_ = _phone_fd_b_it;
#line 197 "../folks/potential-match.vala"
					if (!gee_iterator_next (_tmp15_)) {
#line 197 "../folks/potential-match.vala"
						break;
#line 493 "potential-match.c"
					}
#line 197 "../folks/potential-match.vala"
					_tmp16_ = _phone_fd_b_it;
#line 197 "../folks/potential-match.vala"
					_tmp17_ = gee_iterator_get (_tmp16_);
#line 197 "../folks/potential-match.vala"
					phone_fd_b = (FolksPhoneFieldDetails*) _tmp17_;
#line 199 "../folks/potential-match.vala"
					_tmp18_ = phone_fd_a;
#line 199 "../folks/potential-match.vala"
					_tmp19_ = phone_fd_b;
#line 199 "../folks/potential-match.vala"
					if (folks_abstract_field_details_values_equal ((FolksAbstractFieldDetails*) _tmp18_, (FolksAbstractFieldDetails*) _tmp19_)) {
#line 201 "../folks/potential-match.vala"
						result = FOLKS_MATCH_RESULT_HIGH;
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (phone_fd_b);
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (_phone_fd_b_it);
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (phone_fd_a);
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (_phone_fd_a_it);
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (set_b);
#line 201 "../folks/potential-match.vala"
						_g_object_unref0 (set_a);
#line 201 "../folks/potential-match.vala"
						return result;
#line 523 "potential-match.c"
					}
#line 197 "../folks/potential-match.vala"
					_g_object_unref0 (phone_fd_b);
#line 527 "potential-match.c"
				}
#line 197 "../folks/potential-match.vala"
				_g_object_unref0 (_phone_fd_b_it);
#line 531 "potential-match.c"
			}
#line 195 "../folks/potential-match.vala"
			_g_object_unref0 (phone_fd_a);
#line 535 "potential-match.c"
		}
#line 195 "../folks/potential-match.vala"
		_g_object_unref0 (_phone_fd_a_it);
#line 539 "potential-match.c"
	}
#line 206 "../folks/potential-match.vala"
	result = old_result;
#line 206 "../folks/potential-match.vala"
	_g_object_unref0 (set_b);
#line 206 "../folks/potential-match.vala"
	_g_object_unref0 (set_a);
#line 206 "../folks/potential-match.vala"
	return result;
#line 549 "potential-match.c"
}

static FolksMatchResult
_folks_potential_match_name_similarity (FolksPotentialMatch* self,
                                        FolksMatchResult old_result)
{
	gdouble similarity = 0.0;
	gboolean exact_match = FALSE;
	FolksIndividual* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	FolksIndividual* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	FolksIndividual* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	FolksIndividual* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_;
	FolksStructuredName* _a = NULL;
	FolksIndividual* _tmp41_;
	FolksStructuredName* _tmp42_;
	FolksStructuredName* _tmp43_;
	FolksStructuredName* _tmp44_;
	FolksStructuredName* _b = NULL;
	FolksIndividual* _tmp45_;
	FolksStructuredName* _tmp46_;
	FolksStructuredName* _tmp47_;
	FolksStructuredName* _tmp48_;
	gboolean _tmp49_ = FALSE;
	FolksStructuredName* _tmp50_;
	FolksMatchResult result;
#line 215 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 217 "../folks/potential-match.vala"
	similarity = 0.0;
#line 218 "../folks/potential-match.vala"
	exact_match = FALSE;
#line 220 "../folks/potential-match.vala"
	_tmp0_ = self->priv->_individual_a;
#line 220 "../folks/potential-match.vala"
	_tmp1_ = folks_name_details_get_nickname ((FolksNameDetails*) _tmp0_);
#line 220 "../folks/potential-match.vala"
	_tmp2_ = _tmp1_;
#line 220 "../folks/potential-match.vala"
	_tmp3_ = self->priv->_individual_b;
#line 220 "../folks/potential-match.vala"
	_tmp4_ = folks_name_details_get_nickname ((FolksNameDetails*) _tmp3_);
#line 220 "../folks/potential-match.vala"
	_tmp5_ = _tmp4_;
#line 220 "../folks/potential-match.vala"
	if (_folks_potential_match_look_alike (self, _tmp2_, _tmp5_)) {
#line 223 "../folks/potential-match.vala"
		similarity += 0.20;
#line 610 "potential-match.c"
	}
#line 226 "../folks/potential-match.vala"
	_tmp9_ = self->priv->_individual_a;
#line 226 "../folks/potential-match.vala"
	_tmp10_ = folks_name_details_get_full_name ((FolksNameDetails*) _tmp9_);
#line 226 "../folks/potential-match.vala"
	_tmp11_ = _tmp10_;
#line 226 "../folks/potential-match.vala"
	_tmp12_ = self->priv->_individual_b;
#line 226 "../folks/potential-match.vala"
	_tmp13_ = folks_name_details_get_full_name ((FolksNameDetails*) _tmp12_);
#line 226 "../folks/potential-match.vala"
	_tmp14_ = _tmp13_;
#line 226 "../folks/potential-match.vala"
	_tmp16_ = _folks_potential_match_look_alike_or_identical (self, _tmp11_, _tmp14_, &_tmp15_);
#line 226 "../folks/potential-match.vala"
	exact_match = _tmp15_;
#line 226 "../folks/potential-match.vala"
	if (_tmp16_) {
#line 226 "../folks/potential-match.vala"
		_tmp8_ = TRUE;
#line 632 "potential-match.c"
	} else {
		FolksIndividual* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		FolksIndividual* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_;
#line 229 "../folks/potential-match.vala"
		_tmp17_ = self->priv->_individual_a;
#line 229 "../folks/potential-match.vala"
		_tmp18_ = folks_alias_details_get_alias ((FolksAliasDetails*) _tmp17_);
#line 229 "../folks/potential-match.vala"
		_tmp19_ = _tmp18_;
#line 229 "../folks/potential-match.vala"
		_tmp20_ = self->priv->_individual_b;
#line 229 "../folks/potential-match.vala"
		_tmp21_ = folks_name_details_get_full_name ((FolksNameDetails*) _tmp20_);
#line 229 "../folks/potential-match.vala"
		_tmp22_ = _tmp21_;
#line 229 "../folks/potential-match.vala"
		_tmp24_ = _folks_potential_match_look_alike_or_identical (self, _tmp19_, _tmp22_, &_tmp23_);
#line 229 "../folks/potential-match.vala"
		exact_match = _tmp23_;
#line 229 "../folks/potential-match.vala"
		_tmp8_ = _tmp24_;
#line 660 "potential-match.c"
	}
#line 226 "../folks/potential-match.vala"
	if (_tmp8_) {
#line 226 "../folks/potential-match.vala"
		_tmp7_ = TRUE;
#line 666 "potential-match.c"
	} else {
		FolksIndividual* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		FolksIndividual* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		gboolean _tmp31_ = FALSE;
		gboolean _tmp32_;
#line 232 "../folks/potential-match.vala"
		_tmp25_ = self->priv->_individual_a;
#line 232 "../folks/potential-match.vala"
		_tmp26_ = folks_name_details_get_full_name ((FolksNameDetails*) _tmp25_);
#line 232 "../folks/potential-match.vala"
		_tmp27_ = _tmp26_;
#line 232 "../folks/potential-match.vala"
		_tmp28_ = self->priv->_individual_b;
#line 232 "../folks/potential-match.vala"
		_tmp29_ = folks_alias_details_get_alias ((FolksAliasDetails*) _tmp28_);
#line 232 "../folks/potential-match.vala"
		_tmp30_ = _tmp29_;
#line 232 "../folks/potential-match.vala"
		_tmp32_ = _folks_potential_match_look_alike_or_identical (self, _tmp27_, _tmp30_, &_tmp31_);
#line 232 "../folks/potential-match.vala"
		exact_match = _tmp31_;
#line 232 "../folks/potential-match.vala"
		_tmp7_ = _tmp32_;
#line 694 "potential-match.c"
	}
#line 226 "../folks/potential-match.vala"
	if (_tmp7_) {
#line 226 "../folks/potential-match.vala"
		_tmp6_ = TRUE;
#line 700 "potential-match.c"
	} else {
		FolksIndividual* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		FolksIndividual* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp38_;
		gboolean _tmp39_ = FALSE;
		gboolean _tmp40_;
#line 235 "../folks/potential-match.vala"
		_tmp33_ = self->priv->_individual_a;
#line 235 "../folks/potential-match.vala"
		_tmp34_ = folks_alias_details_get_alias ((FolksAliasDetails*) _tmp33_);
#line 235 "../folks/potential-match.vala"
		_tmp35_ = _tmp34_;
#line 235 "../folks/potential-match.vala"
		_tmp36_ = self->priv->_individual_b;
#line 235 "../folks/potential-match.vala"
		_tmp37_ = folks_alias_details_get_alias ((FolksAliasDetails*) _tmp36_);
#line 235 "../folks/potential-match.vala"
		_tmp38_ = _tmp37_;
#line 235 "../folks/potential-match.vala"
		_tmp40_ = _folks_potential_match_look_alike_or_identical (self, _tmp35_, _tmp38_, &_tmp39_);
#line 235 "../folks/potential-match.vala"
		exact_match = _tmp39_;
#line 235 "../folks/potential-match.vala"
		_tmp6_ = _tmp40_;
#line 728 "potential-match.c"
	}
#line 226 "../folks/potential-match.vala"
	if (_tmp6_) {
#line 239 "../folks/potential-match.vala"
		similarity += 0.70;
#line 734 "potential-match.c"
	}
#line 242 "../folks/potential-match.vala"
	_tmp41_ = self->priv->_individual_a;
#line 242 "../folks/potential-match.vala"
	_tmp42_ = folks_name_details_get_structured_name ((FolksNameDetails*) _tmp41_);
#line 242 "../folks/potential-match.vala"
	_tmp43_ = _tmp42_;
#line 242 "../folks/potential-match.vala"
	_tmp44_ = _g_object_ref0 (_tmp43_);
#line 242 "../folks/potential-match.vala"
	_a = _tmp44_;
#line 243 "../folks/potential-match.vala"
	_tmp45_ = self->priv->_individual_b;
#line 243 "../folks/potential-match.vala"
	_tmp46_ = folks_name_details_get_structured_name ((FolksNameDetails*) _tmp45_);
#line 243 "../folks/potential-match.vala"
	_tmp47_ = _tmp46_;
#line 243 "../folks/potential-match.vala"
	_tmp48_ = _g_object_ref0 (_tmp47_);
#line 243 "../folks/potential-match.vala"
	_b = _tmp48_;
#line 245 "../folks/potential-match.vala"
	_tmp50_ = _a;
#line 245 "../folks/potential-match.vala"
	if (_tmp50_ != NULL) {
#line 760 "potential-match.c"
		FolksStructuredName* _tmp51_;
#line 245 "../folks/potential-match.vala"
		_tmp51_ = _b;
#line 245 "../folks/potential-match.vala"
		_tmp49_ = _tmp51_ != NULL;
#line 766 "potential-match.c"
	} else {
#line 245 "../folks/potential-match.vala"
		_tmp49_ = FALSE;
#line 770 "potential-match.c"
	}
#line 245 "../folks/potential-match.vala"
	if (_tmp49_) {
#line 774 "potential-match.c"
		FolksStructuredName* a = NULL;
		FolksStructuredName* _tmp52_;
		FolksStructuredName* _tmp53_;
		FolksStructuredName* b = NULL;
		FolksStructuredName* _tmp54_;
		FolksStructuredName* _tmp55_;
		gboolean _tmp56_ = FALSE;
		FolksStructuredName* _tmp57_;
		FolksStructuredName* _tmp60_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		FolksStructuredName* _tmp63_;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
		gboolean _tmp66_ = FALSE;
		FolksStructuredName* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		FolksStructuredName* _tmp70_;
		const gchar* _tmp71_;
		const gchar* _tmp72_;
		FolksStructuredName* _tmp79_;
		const gchar* _tmp80_;
		const gchar* _tmp81_;
		FolksStructuredName* _tmp82_;
		const gchar* _tmp83_;
		const gchar* _tmp84_;
		FolksStructuredName* _tmp85_;
		const gchar* _tmp86_;
		const gchar* _tmp87_;
		FolksStructuredName* _tmp88_;
		const gchar* _tmp89_;
		const gchar* _tmp90_;
		FolksStructuredName* _tmp91_;
		const gchar* _tmp92_;
		const gchar* _tmp93_;
		FolksStructuredName* _tmp94_;
		const gchar* _tmp95_;
		const gchar* _tmp96_;
#line 247 "../folks/potential-match.vala"
		_tmp52_ = _a;
#line 247 "../folks/potential-match.vala"
		_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, FOLKS_TYPE_STRUCTURED_NAME, FolksStructuredName));
#line 247 "../folks/potential-match.vala"
		a = _tmp53_;
#line 248 "../folks/potential-match.vala"
		_tmp54_ = _b;
#line 248 "../folks/potential-match.vala"
		_tmp55_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, FOLKS_TYPE_STRUCTURED_NAME, FolksStructuredName));
#line 248 "../folks/potential-match.vala"
		b = _tmp55_;
#line 250 "../folks/potential-match.vala"
		_tmp57_ = a;
#line 250 "../folks/potential-match.vala"
		if (folks_structured_name_is_empty (_tmp57_) == FALSE) {
#line 830 "potential-match.c"
			FolksStructuredName* _tmp58_;
			FolksStructuredName* _tmp59_;
#line 250 "../folks/potential-match.vala"
			_tmp58_ = a;
#line 250 "../folks/potential-match.vala"
			_tmp59_ = b;
#line 250 "../folks/potential-match.vala"
			_tmp56_ = folks_structured_name_equal (_tmp58_, _tmp59_);
#line 839 "potential-match.c"
		} else {
#line 250 "../folks/potential-match.vala"
			_tmp56_ = FALSE;
#line 843 "potential-match.c"
		}
#line 250 "../folks/potential-match.vala"
		if (_tmp56_) {
#line 252 "../folks/potential-match.vala"
			result = FOLKS_MATCH_RESULT_HIGH;
#line 252 "../folks/potential-match.vala"
			_g_object_unref0 (b);
#line 252 "../folks/potential-match.vala"
			_g_object_unref0 (a);
#line 252 "../folks/potential-match.vala"
			_g_object_unref0 (_b);
#line 252 "../folks/potential-match.vala"
			_g_object_unref0 (_a);
#line 252 "../folks/potential-match.vala"
			return result;
#line 859 "potential-match.c"
		}
#line 255 "../folks/potential-match.vala"
		_tmp60_ = a;
#line 255 "../folks/potential-match.vala"
		_tmp61_ = folks_structured_name_get_given_name (_tmp60_);
#line 255 "../folks/potential-match.vala"
		_tmp62_ = _tmp61_;
#line 255 "../folks/potential-match.vala"
		_tmp63_ = b;
#line 255 "../folks/potential-match.vala"
		_tmp64_ = folks_structured_name_get_given_name (_tmp63_);
#line 255 "../folks/potential-match.vala"
		_tmp65_ = _tmp64_;
#line 255 "../folks/potential-match.vala"
		if (_folks_utils_str_equal_safe (_tmp62_, _tmp65_)) {
#line 256 "../folks/potential-match.vala"
			similarity += 0.20;
#line 877 "potential-match.c"
		}
#line 258 "../folks/potential-match.vala"
		_tmp67_ = a;
#line 258 "../folks/potential-match.vala"
		_tmp68_ = folks_structured_name_get_family_name (_tmp67_);
#line 258 "../folks/potential-match.vala"
		_tmp69_ = _tmp68_;
#line 258 "../folks/potential-match.vala"
		_tmp70_ = b;
#line 258 "../folks/potential-match.vala"
		_tmp71_ = folks_structured_name_get_family_name (_tmp70_);
#line 258 "../folks/potential-match.vala"
		_tmp72_ = _tmp71_;
#line 258 "../folks/potential-match.vala"
		if (_folks_potential_match_look_alike (self, _tmp69_, _tmp72_)) {
#line 893 "potential-match.c"
			FolksStructuredName* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			FolksStructuredName* _tmp76_;
			const gchar* _tmp77_;
			const gchar* _tmp78_;
#line 259 "../folks/potential-match.vala"
			_tmp73_ = a;
#line 259 "../folks/potential-match.vala"
			_tmp74_ = folks_structured_name_get_given_name (_tmp73_);
#line 259 "../folks/potential-match.vala"
			_tmp75_ = _tmp74_;
#line 259 "../folks/potential-match.vala"
			_tmp76_ = b;
#line 259 "../folks/potential-match.vala"
			_tmp77_ = folks_structured_name_get_given_name (_tmp76_);
#line 259 "../folks/potential-match.vala"
			_tmp78_ = _tmp77_;
#line 259 "../folks/potential-match.vala"
			_tmp66_ = _folks_potential_match_look_alike (self, _tmp75_, _tmp78_);
#line 914 "potential-match.c"
		} else {
#line 258 "../folks/potential-match.vala"
			_tmp66_ = FALSE;
#line 918 "potential-match.c"
		}
#line 258 "../folks/potential-match.vala"
		if (_tmp66_) {
#line 261 "../folks/potential-match.vala"
			similarity += 0.40;
#line 924 "potential-match.c"
		}
#line 264 "../folks/potential-match.vala"
		_tmp79_ = a;
#line 264 "../folks/potential-match.vala"
		_tmp80_ = folks_structured_name_get_additional_names (_tmp79_);
#line 264 "../folks/potential-match.vala"
		_tmp81_ = _tmp80_;
#line 264 "../folks/potential-match.vala"
		_tmp82_ = b;
#line 264 "../folks/potential-match.vala"
		_tmp83_ = folks_structured_name_get_additional_names (_tmp82_);
#line 264 "../folks/potential-match.vala"
		_tmp84_ = _tmp83_;
#line 264 "../folks/potential-match.vala"
		if (_folks_utils_str_equal_safe (_tmp81_, _tmp84_)) {
#line 266 "../folks/potential-match.vala"
			similarity += 0.5;
#line 942 "potential-match.c"
		}
#line 268 "../folks/potential-match.vala"
		_tmp85_ = a;
#line 268 "../folks/potential-match.vala"
		_tmp86_ = folks_structured_name_get_prefixes (_tmp85_);
#line 268 "../folks/potential-match.vala"
		_tmp87_ = _tmp86_;
#line 268 "../folks/potential-match.vala"
		_tmp88_ = b;
#line 268 "../folks/potential-match.vala"
		_tmp89_ = folks_structured_name_get_prefixes (_tmp88_);
#line 268 "../folks/potential-match.vala"
		_tmp90_ = _tmp89_;
#line 268 "../folks/potential-match.vala"
		if (_folks_utils_str_equal_safe (_tmp87_, _tmp90_)) {
#line 269 "../folks/potential-match.vala"
			similarity += 0.5;
#line 960 "potential-match.c"
		}
#line 271 "../folks/potential-match.vala"
		_tmp91_ = a;
#line 271 "../folks/potential-match.vala"
		_tmp92_ = folks_structured_name_get_suffixes (_tmp91_);
#line 271 "../folks/potential-match.vala"
		_tmp93_ = _tmp92_;
#line 271 "../folks/potential-match.vala"
		_tmp94_ = b;
#line 271 "../folks/potential-match.vala"
		_tmp95_ = folks_structured_name_get_suffixes (_tmp94_);
#line 271 "../folks/potential-match.vala"
		_tmp96_ = _tmp95_;
#line 271 "../folks/potential-match.vala"
		if (_folks_utils_str_equal_safe (_tmp93_, _tmp96_)) {
#line 272 "../folks/potential-match.vala"
			similarity += 0.5;
#line 978 "potential-match.c"
		}
#line 245 "../folks/potential-match.vala"
		_g_object_unref0 (b);
#line 245 "../folks/potential-match.vala"
		_g_object_unref0 (a);
#line 984 "potential-match.c"
	}
#line 275 "../folks/potential-match.vala"
	g_debug ("potential-match.vala:275: [name_similarity] Got %f\n", similarity);
#line 277 "../folks/potential-match.vala"
	if (similarity >= folks_potential_match__DIST_THRESHOLD) {
#line 990 "potential-match.c"
		gint inc = 0;
#line 279 "../folks/potential-match.vala"
		inc = 2;
#line 284 "../folks/potential-match.vala"
		if (exact_match) {
#line 285 "../folks/potential-match.vala"
			inc += 1;
#line 998 "potential-match.c"
		}
#line 286 "../folks/potential-match.vala"
		result = _folks_potential_match_inc_match_level (self, old_result, inc);
#line 286 "../folks/potential-match.vala"
		_g_object_unref0 (_b);
#line 286 "../folks/potential-match.vala"
		_g_object_unref0 (_a);
#line 286 "../folks/potential-match.vala"
		return result;
#line 1008 "potential-match.c"
	}
#line 289 "../folks/potential-match.vala"
	result = old_result;
#line 289 "../folks/potential-match.vala"
	_g_object_unref0 (_b);
#line 289 "../folks/potential-match.vala"
	_g_object_unref0 (_a);
#line 289 "../folks/potential-match.vala"
	return result;
#line 1018 "potential-match.c"
}

/**
   * Number of equal IM addresses between two individuals.
   *
   * This compares the addresses without comparing their associated protocols.
   *
   * @since 0.5.0
   */
static FolksMatchResult
_folks_potential_match_inspect_im_addresses (FolksPotentialMatch* self,
                                             FolksMatchResult old_result)
{
	GeeHashSet* addrs = NULL;
	GeeHashSet* _tmp0_;
	FolksMatchResult result;
#line 299 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 301 "../folks/potential-match.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 301 "../folks/potential-match.vala"
	addrs = _tmp0_;
#line 1041 "potential-match.c"
	{
		GeeIterator* _im_a_it = NULL;
		FolksIndividual* _tmp1_;
		GeeMultiMap* _tmp2_;
		GeeMultiMap* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 303 "../folks/potential-match.vala"
		_tmp1_ = self->priv->_individual_a;
#line 303 "../folks/potential-match.vala"
		_tmp2_ = folks_im_details_get_im_addresses ((FolksImDetails*) _tmp1_);
#line 303 "../folks/potential-match.vala"
		_tmp3_ = _tmp2_;
#line 303 "../folks/potential-match.vala"
		_tmp4_ = gee_multi_map_get_values (_tmp3_);
#line 303 "../folks/potential-match.vala"
		_tmp5_ = _tmp4_;
#line 303 "../folks/potential-match.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 303 "../folks/potential-match.vala"
		_tmp7_ = _tmp6_;
#line 303 "../folks/potential-match.vala"
		_g_object_unref0 (_tmp5_);
#line 303 "../folks/potential-match.vala"
		_im_a_it = _tmp7_;
#line 303 "../folks/potential-match.vala"
		while (TRUE) {
#line 1071 "potential-match.c"
			GeeIterator* _tmp8_;
			FolksImFieldDetails* im_a = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			GeeHashSet* _tmp11_;
			FolksImFieldDetails* _tmp12_;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
#line 303 "../folks/potential-match.vala"
			_tmp8_ = _im_a_it;
#line 303 "../folks/potential-match.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 303 "../folks/potential-match.vala"
				break;
#line 1086 "potential-match.c"
			}
#line 303 "../folks/potential-match.vala"
			_tmp9_ = _im_a_it;
#line 303 "../folks/potential-match.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 303 "../folks/potential-match.vala"
			im_a = (FolksImFieldDetails*) _tmp10_;
#line 305 "../folks/potential-match.vala"
			_tmp11_ = addrs;
#line 305 "../folks/potential-match.vala"
			_tmp12_ = im_a;
#line 305 "../folks/potential-match.vala"
			_tmp13_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp12_);
#line 305 "../folks/potential-match.vala"
			_tmp14_ = _tmp13_;
#line 305 "../folks/potential-match.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, (const gchar*) _tmp14_);
#line 303 "../folks/potential-match.vala"
			_g_object_unref0 (im_a);
#line 1106 "potential-match.c"
		}
#line 303 "../folks/potential-match.vala"
		_g_object_unref0 (_im_a_it);
#line 1110 "potential-match.c"
	}
	{
		GeeIterator* _im_b_it = NULL;
		FolksIndividual* _tmp15_;
		GeeMultiMap* _tmp16_;
		GeeMultiMap* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
#line 308 "../folks/potential-match.vala"
		_tmp15_ = self->priv->_individual_b;
#line 308 "../folks/potential-match.vala"
		_tmp16_ = folks_im_details_get_im_addresses ((FolksImDetails*) _tmp15_);
#line 308 "../folks/potential-match.vala"
		_tmp17_ = _tmp16_;
#line 308 "../folks/potential-match.vala"
		_tmp18_ = gee_multi_map_get_values (_tmp17_);
#line 308 "../folks/potential-match.vala"
		_tmp19_ = _tmp18_;
#line 308 "../folks/potential-match.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 308 "../folks/potential-match.vala"
		_tmp21_ = _tmp20_;
#line 308 "../folks/potential-match.vala"
		_g_object_unref0 (_tmp19_);
#line 308 "../folks/potential-match.vala"
		_im_b_it = _tmp21_;
#line 308 "../folks/potential-match.vala"
		while (TRUE) {
#line 1141 "potential-match.c"
			GeeIterator* _tmp22_;
			FolksImFieldDetails* im_b = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			GeeHashSet* _tmp25_;
			FolksImFieldDetails* _tmp26_;
			gconstpointer _tmp27_;
			gconstpointer _tmp28_;
#line 308 "../folks/potential-match.vala"
			_tmp22_ = _im_b_it;
#line 308 "../folks/potential-match.vala"
			if (!gee_iterator_next (_tmp22_)) {
#line 308 "../folks/potential-match.vala"
				break;
#line 1156 "potential-match.c"
			}
#line 308 "../folks/potential-match.vala"
			_tmp23_ = _im_b_it;
#line 308 "../folks/potential-match.vala"
			_tmp24_ = gee_iterator_get (_tmp23_);
#line 308 "../folks/potential-match.vala"
			im_b = (FolksImFieldDetails*) _tmp24_;
#line 310 "../folks/potential-match.vala"
			_tmp25_ = addrs;
#line 310 "../folks/potential-match.vala"
			_tmp26_ = im_b;
#line 310 "../folks/potential-match.vala"
			_tmp27_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp26_);
#line 310 "../folks/potential-match.vala"
			_tmp28_ = _tmp27_;
#line 310 "../folks/potential-match.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp25_, (const gchar*) _tmp28_) == TRUE) {
#line 312 "../folks/potential-match.vala"
				result = FOLKS_MATCH_RESULT_HIGH;
#line 312 "../folks/potential-match.vala"
				_g_object_unref0 (im_b);
#line 312 "../folks/potential-match.vala"
				_g_object_unref0 (_im_b_it);
#line 312 "../folks/potential-match.vala"
				_g_object_unref0 (addrs);
#line 312 "../folks/potential-match.vala"
				return result;
#line 1184 "potential-match.c"
			}
#line 308 "../folks/potential-match.vala"
			_g_object_unref0 (im_b);
#line 1188 "potential-match.c"
		}
#line 308 "../folks/potential-match.vala"
		_g_object_unref0 (_im_b_it);
#line 1192 "potential-match.c"
	}
#line 316 "../folks/potential-match.vala"
	result = old_result;
#line 316 "../folks/potential-match.vala"
	_g_object_unref0 (addrs);
#line 316 "../folks/potential-match.vala"
	return result;
#line 1200 "potential-match.c"
}

/**
   * Inspect email addresses.
   *
   * @since 0.5.0
   */
static FolksMatchResult
_folks_potential_match_inspect_emails (FolksPotentialMatch* self,
                                       FolksMatchResult old_result)
{
	GeeSet* set_a = NULL;
	FolksIndividual* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* set_b = NULL;
	FolksIndividual* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
	FolksMatchResult _result_ = 0;
	FolksMatchResult result;
#line 324 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 326 "../folks/potential-match.vala"
	_tmp0_ = self->priv->_individual_a;
#line 326 "../folks/potential-match.vala"
	_tmp1_ = folks_email_details_get_email_addresses ((FolksEmailDetails*) _tmp0_);
#line 326 "../folks/potential-match.vala"
	_tmp2_ = _tmp1_;
#line 326 "../folks/potential-match.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 326 "../folks/potential-match.vala"
	set_a = _tmp3_;
#line 327 "../folks/potential-match.vala"
	_tmp4_ = self->priv->_individual_b;
#line 327 "../folks/potential-match.vala"
	_tmp5_ = folks_email_details_get_email_addresses ((FolksEmailDetails*) _tmp4_);
#line 327 "../folks/potential-match.vala"
	_tmp6_ = _tmp5_;
#line 327 "../folks/potential-match.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 327 "../folks/potential-match.vala"
	set_b = _tmp7_;
#line 328 "../folks/potential-match.vala"
	_result_ = old_result;
#line 1248 "potential-match.c"
	{
		GeeIterator* _fd_a_it = NULL;
		GeeSet* _tmp8_;
		GeeIterator* _tmp9_;
#line 330 "../folks/potential-match.vala"
		_tmp8_ = set_a;
#line 330 "../folks/potential-match.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 330 "../folks/potential-match.vala"
		_fd_a_it = _tmp9_;
#line 330 "../folks/potential-match.vala"
		while (TRUE) {
#line 1261 "potential-match.c"
			GeeIterator* _tmp10_;
			FolksEmailFieldDetails* fd_a = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			gchar** email_split_a = NULL;
			FolksEmailFieldDetails* _tmp13_;
			gconstpointer _tmp14_;
			gconstpointer _tmp15_;
			gchar** _tmp16_;
			gchar** _tmp17_;
			gint email_split_a_length1;
			gint _email_split_a_size_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			gchar** tokens_a = NULL;
			gchar** _tmp22_;
			gint _tmp22__length1;
			const gchar* _tmp23_;
			gchar** _tmp24_;
			gchar** _tmp25_;
			gint tokens_a_length1;
			gint _tokens_a_size_;
#line 330 "../folks/potential-match.vala"
			_tmp10_ = _fd_a_it;
#line 330 "../folks/potential-match.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 330 "../folks/potential-match.vala"
				break;
#line 1290 "potential-match.c"
			}
#line 330 "../folks/potential-match.vala"
			_tmp11_ = _fd_a_it;
#line 330 "../folks/potential-match.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 330 "../folks/potential-match.vala"
			fd_a = (FolksEmailFieldDetails*) _tmp12_;
#line 332 "../folks/potential-match.vala"
			_tmp13_ = fd_a;
#line 332 "../folks/potential-match.vala"
			_tmp14_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp13_);
#line 332 "../folks/potential-match.vala"
			_tmp15_ = _tmp14_;
#line 332 "../folks/potential-match.vala"
			_tmp17_ = _tmp16_ = g_strsplit ((const gchar*) _tmp15_, "@", 0);
#line 332 "../folks/potential-match.vala"
			email_split_a = _tmp17_;
#line 332 "../folks/potential-match.vala"
			email_split_a_length1 = _vala_array_length (_tmp16_);
#line 332 "../folks/potential-match.vala"
			_email_split_a_size_ = email_split_a_length1;
#line 335 "../folks/potential-match.vala"
			_tmp18_ = email_split_a;
#line 335 "../folks/potential-match.vala"
			_tmp18__length1 = email_split_a_length1;
#line 335 "../folks/potential-match.vala"
			if (_tmp18__length1 < 2) {
#line 1318 "potential-match.c"
				FolksEmailFieldDetails* _tmp19_;
				gconstpointer _tmp20_;
				gconstpointer _tmp21_;
#line 337 "../folks/potential-match.vala"
				_tmp19_ = fd_a;
#line 337 "../folks/potential-match.vala"
				_tmp20_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp19_);
#line 337 "../folks/potential-match.vala"
				_tmp21_ = _tmp20_;
#line 337 "../folks/potential-match.vala"
				g_warning ("Invalid e-mail address when looking for potential " "match: %s", (const gchar*) _tmp21_);
#line 339 "../folks/potential-match.vala"
				email_split_a = (_vala_array_free (email_split_a, email_split_a_length1, (GDestroyNotify) g_free), NULL);
#line 339 "../folks/potential-match.vala"
				_g_object_unref0 (fd_a);
#line 339 "../folks/potential-match.vala"
				continue;
#line 1336 "potential-match.c"
			}
#line 342 "../folks/potential-match.vala"
			_tmp22_ = email_split_a;
#line 342 "../folks/potential-match.vala"
			_tmp22__length1 = email_split_a_length1;
#line 342 "../folks/potential-match.vala"
			_tmp23_ = _tmp22_[0];
#line 342 "../folks/potential-match.vala"
			_tmp25_ = _tmp24_ = g_strsplit_set (_tmp23_, FOLKS_POTENTIAL_MATCH__SEPARATORS, 0);
#line 342 "../folks/potential-match.vala"
			tokens_a = _tmp25_;
#line 342 "../folks/potential-match.vala"
			tokens_a_length1 = _vala_array_length (_tmp24_);
#line 342 "../folks/potential-match.vala"
			_tokens_a_size_ = tokens_a_length1;
#line 1352 "potential-match.c"
			{
				GeeIterator* _fd_b_it = NULL;
				GeeSet* _tmp26_;
				GeeIterator* _tmp27_;
#line 345 "../folks/potential-match.vala"
				_tmp26_ = set_b;
#line 345 "../folks/potential-match.vala"
				_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 345 "../folks/potential-match.vala"
				_fd_b_it = _tmp27_;
#line 345 "../folks/potential-match.vala"
				while (TRUE) {
#line 1365 "potential-match.c"
					GeeIterator* _tmp28_;
					FolksEmailFieldDetails* fd_b = NULL;
					GeeIterator* _tmp29_;
					gpointer _tmp30_;
					gchar** email_split_b = NULL;
					FolksEmailFieldDetails* _tmp31_;
					gconstpointer _tmp32_;
					gconstpointer _tmp33_;
					gchar** _tmp34_;
					gchar** _tmp35_;
					gint email_split_b_length1;
					gint _email_split_b_size_;
					gchar** _tmp36_;
					gint _tmp36__length1;
					FolksEmailFieldDetails* _tmp40_;
					gconstpointer _tmp41_;
					gconstpointer _tmp42_;
					FolksEmailFieldDetails* _tmp43_;
					gconstpointer _tmp44_;
					gconstpointer _tmp45_;
#line 345 "../folks/potential-match.vala"
					_tmp28_ = _fd_b_it;
#line 345 "../folks/potential-match.vala"
					if (!gee_iterator_next (_tmp28_)) {
#line 345 "../folks/potential-match.vala"
						break;
#line 1392 "potential-match.c"
					}
#line 345 "../folks/potential-match.vala"
					_tmp29_ = _fd_b_it;
#line 345 "../folks/potential-match.vala"
					_tmp30_ = gee_iterator_get (_tmp29_);
#line 345 "../folks/potential-match.vala"
					fd_b = (FolksEmailFieldDetails*) _tmp30_;
#line 347 "../folks/potential-match.vala"
					_tmp31_ = fd_b;
#line 347 "../folks/potential-match.vala"
					_tmp32_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp31_);
#line 347 "../folks/potential-match.vala"
					_tmp33_ = _tmp32_;
#line 347 "../folks/potential-match.vala"
					_tmp35_ = _tmp34_ = g_strsplit ((const gchar*) _tmp33_, "@", 0);
#line 347 "../folks/potential-match.vala"
					email_split_b = _tmp35_;
#line 347 "../folks/potential-match.vala"
					email_split_b_length1 = _vala_array_length (_tmp34_);
#line 347 "../folks/potential-match.vala"
					_email_split_b_size_ = email_split_b_length1;
#line 350 "../folks/potential-match.vala"
					_tmp36_ = email_split_b;
#line 350 "../folks/potential-match.vala"
					_tmp36__length1 = email_split_b_length1;
#line 350 "../folks/potential-match.vala"
					if (_tmp36__length1 < 2) {
#line 1420 "potential-match.c"
						FolksEmailFieldDetails* _tmp37_;
						gconstpointer _tmp38_;
						gconstpointer _tmp39_;
#line 352 "../folks/potential-match.vala"
						_tmp37_ = fd_b;
#line 352 "../folks/potential-match.vala"
						_tmp38_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp37_);
#line 352 "../folks/potential-match.vala"
						_tmp39_ = _tmp38_;
#line 352 "../folks/potential-match.vala"
						g_warning ("Invalid e-mail address when looking for " "potential match: %s", (const gchar*) _tmp39_);
#line 354 "../folks/potential-match.vala"
						email_split_b = (_vala_array_free (email_split_b, email_split_b_length1, (GDestroyNotify) g_free), NULL);
#line 354 "../folks/potential-match.vala"
						_g_object_unref0 (fd_b);
#line 354 "../folks/potential-match.vala"
						continue;
#line 1438 "potential-match.c"
					}
#line 357 "../folks/potential-match.vala"
					_tmp40_ = fd_a;
#line 357 "../folks/potential-match.vala"
					_tmp41_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp40_);
#line 357 "../folks/potential-match.vala"
					_tmp42_ = _tmp41_;
#line 357 "../folks/potential-match.vala"
					_tmp43_ = fd_b;
#line 357 "../folks/potential-match.vala"
					_tmp44_ = folks_abstract_field_details_get_value ((FolksAbstractFieldDetails*) _tmp43_);
#line 357 "../folks/potential-match.vala"
					_tmp45_ = _tmp44_;
#line 357 "../folks/potential-match.vala"
					if (g_strcmp0 ((const gchar*) _tmp42_, (const gchar*) _tmp45_) == 0) {
#line 1454 "potential-match.c"
						GeeSet* _tmp46_;
						gchar** _tmp47_;
						gint _tmp47__length1;
						const gchar* _tmp48_;
#line 359 "../folks/potential-match.vala"
						_tmp46_ = folks_potential_match_known_email_aliases;
#line 359 "../folks/potential-match.vala"
						_tmp47_ = email_split_a;
#line 359 "../folks/potential-match.vala"
						_tmp47__length1 = email_split_a_length1;
#line 359 "../folks/potential-match.vala"
						_tmp48_ = _tmp47_[0];
#line 359 "../folks/potential-match.vala"
						if (gee_collection_contains ((GeeCollection*) _tmp46_, _tmp48_) == TRUE) {
#line 362 "../folks/potential-match.vala"
							if (_result_ < FOLKS_MATCH_RESULT_HIGH) {
#line 364 "../folks/potential-match.vala"
								_result_ = FOLKS_MATCH_RESULT_LOW;
#line 1473 "potential-match.c"
							}
						} else {
#line 369 "../folks/potential-match.vala"
							result = FOLKS_MATCH_RESULT_HIGH;
#line 369 "../folks/potential-match.vala"
							email_split_b = (_vala_array_free (email_split_b, email_split_b_length1, (GDestroyNotify) g_free), NULL);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (fd_b);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (_fd_b_it);
#line 369 "../folks/potential-match.vala"
							tokens_a = (_vala_array_free (tokens_a, tokens_a_length1, (GDestroyNotify) g_free), NULL);
#line 369 "../folks/potential-match.vala"
							email_split_a = (_vala_array_free (email_split_a, email_split_a_length1, (GDestroyNotify) g_free), NULL);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (fd_a);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (_fd_a_it);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (set_b);
#line 369 "../folks/potential-match.vala"
							_g_object_unref0 (set_a);
#line 369 "../folks/potential-match.vala"
							return result;
#line 1498 "potential-match.c"
						}
					} else {
						gchar** tokens_b = NULL;
						gchar** _tmp49_;
						gint _tmp49__length1;
						const gchar* _tmp50_;
						gchar** _tmp51_;
						gchar** _tmp52_;
						gint tokens_b_length1;
						gint _tokens_b_size_;
						gchar** _tmp53_;
						gint _tmp53__length1;
						gchar** _tmp54_;
						gint _tmp54__length1;
#line 374 "../folks/potential-match.vala"
						_tmp49_ = email_split_b;
#line 374 "../folks/potential-match.vala"
						_tmp49__length1 = email_split_b_length1;
#line 374 "../folks/potential-match.vala"
						_tmp50_ = _tmp49_[0];
#line 374 "../folks/potential-match.vala"
						_tmp52_ = _tmp51_ = g_strsplit_set (_tmp50_, FOLKS_POTENTIAL_MATCH__SEPARATORS, 0);
#line 374 "../folks/potential-match.vala"
						tokens_b = _tmp52_;
#line 374 "../folks/potential-match.vala"
						tokens_b_length1 = _vala_array_length (_tmp51_);
#line 374 "../folks/potential-match.vala"
						_tokens_b_size_ = tokens_b_length1;
#line 378 "../folks/potential-match.vala"
						_tmp53_ = tokens_a;
#line 378 "../folks/potential-match.vala"
						_tmp53__length1 = tokens_a_length1;
#line 378 "../folks/potential-match.vala"
						_tmp54_ = tokens_b;
#line 378 "../folks/potential-match.vala"
						_tmp54__length1 = tokens_b_length1;
#line 378 "../folks/potential-match.vala"
						if (_folks_potential_match_check_initials_expansion (self, _tmp53_, (gint) _tmp53__length1, _tmp54_, (gint) _tmp54__length1)) {
#line 380 "../folks/potential-match.vala"
							_result_ = FOLKS_MATCH_RESULT_MEDIUM;
#line 1539 "potential-match.c"
						} else {
							gchar** _tmp55_;
							gint _tmp55__length1;
							gchar** _tmp56_;
							gint _tmp56__length1;
#line 386 "../folks/potential-match.vala"
							_tmp55_ = tokens_a;
#line 386 "../folks/potential-match.vala"
							_tmp55__length1 = tokens_a_length1;
#line 386 "../folks/potential-match.vala"
							_tmp56_ = tokens_b;
#line 386 "../folks/potential-match.vala"
							_tmp56__length1 = tokens_b_length1;
#line 386 "../folks/potential-match.vala"
							if (_folks_potential_match_match_tokens (self, _tmp55_, (gint) _tmp55__length1, _tmp56_, (gint) _tmp56__length1)) {
#line 388 "../folks/potential-match.vala"
								_result_ = FOLKS_MATCH_RESULT_MEDIUM;
#line 1557 "potential-match.c"
							}
						}
#line 357 "../folks/potential-match.vala"
						tokens_b = (_vala_array_free (tokens_b, tokens_b_length1, (GDestroyNotify) g_free), NULL);
#line 1562 "potential-match.c"
					}
#line 345 "../folks/potential-match.vala"
					email_split_b = (_vala_array_free (email_split_b, email_split_b_length1, (GDestroyNotify) g_free), NULL);
#line 345 "../folks/potential-match.vala"
					_g_object_unref0 (fd_b);
#line 1568 "potential-match.c"
				}
#line 345 "../folks/potential-match.vala"
				_g_object_unref0 (_fd_b_it);
#line 1572 "potential-match.c"
			}
#line 330 "../folks/potential-match.vala"
			tokens_a = (_vala_array_free (tokens_a, tokens_a_length1, (GDestroyNotify) g_free), NULL);
#line 330 "../folks/potential-match.vala"
			email_split_a = (_vala_array_free (email_split_a, email_split_a_length1, (GDestroyNotify) g_free), NULL);
#line 330 "../folks/potential-match.vala"
			_g_object_unref0 (fd_a);
#line 1580 "potential-match.c"
		}
#line 330 "../folks/potential-match.vala"
		_g_object_unref0 (_fd_a_it);
#line 1584 "potential-match.c"
	}
#line 394 "../folks/potential-match.vala"
	result = _result_;
#line 394 "../folks/potential-match.vala"
	_g_object_unref0 (set_b);
#line 394 "../folks/potential-match.vala"
	_g_object_unref0 (set_a);
#line 394 "../folks/potential-match.vala"
	return result;
#line 1594 "potential-match.c"
}

static gboolean
_folks_potential_match_check_initials_expansion (FolksPotentialMatch* self,
                                                 gchar** tokens_a,
                                                 gint tokens_a_length1,
                                                 gchar** tokens_b,
                                                 gint tokens_b_length1)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 400 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 402 "../folks/potential-match.vala"
	if (tokens_a_length1 > tokens_b_length1) {
#line 403 "../folks/potential-match.vala"
		_tmp0_ = tokens_b_length1 == 1;
#line 1612 "potential-match.c"
	} else {
#line 402 "../folks/potential-match.vala"
		_tmp0_ = FALSE;
#line 1616 "potential-match.c"
	}
#line 402 "../folks/potential-match.vala"
	if (_tmp0_) {
#line 1620 "potential-match.c"
		const gchar* _tmp1_;
#line 405 "../folks/potential-match.vala"
		_tmp1_ = tokens_b[0];
#line 405 "../folks/potential-match.vala"
		result = _folks_potential_match_do_check_initials_expansion (self, tokens_a, (gint) tokens_a_length1, _tmp1_);
#line 405 "../folks/potential-match.vala"
		return result;
#line 1628 "potential-match.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 407 "../folks/potential-match.vala"
		if (tokens_b_length1 > tokens_a_length1) {
#line 408 "../folks/potential-match.vala"
			_tmp2_ = tokens_a_length1 == 1;
#line 1635 "potential-match.c"
		} else {
#line 407 "../folks/potential-match.vala"
			_tmp2_ = FALSE;
#line 1639 "potential-match.c"
		}
#line 407 "../folks/potential-match.vala"
		if (_tmp2_) {
#line 1643 "potential-match.c"
			const gchar* _tmp3_;
#line 410 "../folks/potential-match.vala"
			_tmp3_ = tokens_a[0];
#line 410 "../folks/potential-match.vala"
			result = _folks_potential_match_do_check_initials_expansion (self, tokens_b, (gint) tokens_b_length1, _tmp3_);
#line 410 "../folks/potential-match.vala"
			return result;
#line 1651 "potential-match.c"
		}
	}
#line 412 "../folks/potential-match.vala"
	result = FALSE;
#line 412 "../folks/potential-match.vala"
	return result;
#line 1658 "potential-match.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1248 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1249 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1249 "glib-2.0.vapi"
	result = _tmp0_;
#line 1249 "glib-2.0.vapi"
	return result;
#line 1675 "potential-match.c"
}

static gboolean
_folks_potential_match_do_check_initials_expansion (FolksPotentialMatch* self,
                                                    gchar** expanded_name,
                                                    gint expanded_name_length1,
                                                    const gchar* initials)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 415 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 415 "../folks/potential-match.vala"
	g_return_val_if_fail (initials != NULL, FALSE);
#line 418 "../folks/potential-match.vala"
	_tmp0_ = strlen (initials);
#line 418 "../folks/potential-match.vala"
	_tmp1_ = _tmp0_;
#line 418 "../folks/potential-match.vala"
	if (expanded_name_length1 != _tmp1_) {
#line 419 "../folks/potential-match.vala"
		result = FALSE;
#line 419 "../folks/potential-match.vala"
		return result;
#line 1701 "potential-match.c"
	}
	{
		gint i = 0;
#line 421 "../folks/potential-match.vala"
		i = 0;
#line 1707 "potential-match.c"
		{
			gboolean _tmp2_ = FALSE;
#line 421 "../folks/potential-match.vala"
			_tmp2_ = TRUE;
#line 421 "../folks/potential-match.vala"
			while (TRUE) {
#line 1714 "potential-match.c"
				const gchar* _tmp4_;
#line 421 "../folks/potential-match.vala"
				if (!_tmp2_) {
#line 1718 "potential-match.c"
					gint _tmp3_;
#line 421 "../folks/potential-match.vala"
					_tmp3_ = i;
#line 421 "../folks/potential-match.vala"
					i = _tmp3_ + 1;
#line 1724 "potential-match.c"
				}
#line 421 "../folks/potential-match.vala"
				_tmp2_ = FALSE;
#line 421 "../folks/potential-match.vala"
				if (!(i < expanded_name_length1)) {
#line 421 "../folks/potential-match.vala"
					break;
#line 1732 "potential-match.c"
				}
#line 423 "../folks/potential-match.vala"
				_tmp4_ = expanded_name[i];
#line 423 "../folks/potential-match.vala"
				if (string_get (_tmp4_, (glong) 0) != string_get (initials, (glong) i)) {
#line 424 "../folks/potential-match.vala"
					result = FALSE;
#line 424 "../folks/potential-match.vala"
					return result;
#line 1742 "potential-match.c"
				}
			}
		}
	}
#line 427 "../folks/potential-match.vala"
	result = TRUE;
#line 427 "../folks/potential-match.vala"
	return result;
#line 1751 "potential-match.c"
}

static gboolean
_folks_potential_match_match_tokens (FolksPotentialMatch* self,
                                     gchar** tokens_a,
                                     gint tokens_a_length1,
                                     gchar** tokens_b,
                                     gint tokens_b_length1)
{
	gboolean result;
#line 433 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 437 "../folks/potential-match.vala"
	if (tokens_a_length1 > tokens_b_length1) {
#line 438 "../folks/potential-match.vala"
		result = _folks_potential_match_do_match_tokens (self, tokens_a, (gint) tokens_a_length1, tokens_b, (gint) tokens_b_length1);
#line 438 "../folks/potential-match.vala"
		return result;
#line 1770 "potential-match.c"
	} else {
#line 440 "../folks/potential-match.vala"
		result = _folks_potential_match_do_match_tokens (self, tokens_b, (gint) tokens_b_length1, tokens_a, (gint) tokens_a_length1);
#line 440 "../folks/potential-match.vala"
		return result;
#line 1776 "potential-match.c"
	}
}

static gboolean
_folks_potential_match_do_match_tokens (FolksPotentialMatch* self,
                                        gchar** bigger_set,
                                        gint bigger_set_length1,
                                        gchar** smaller_set,
                                        gint smaller_set_length1)
{
	gboolean result;
#line 443 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1790 "potential-match.c"
	{
		gint i = 0;
#line 445 "../folks/potential-match.vala"
		i = 0;
#line 1795 "potential-match.c"
		{
			gboolean _tmp0_ = FALSE;
#line 445 "../folks/potential-match.vala"
			_tmp0_ = TRUE;
#line 445 "../folks/potential-match.vala"
			while (TRUE) {
#line 445 "../folks/potential-match.vala"
				if (!_tmp0_) {
#line 1804 "potential-match.c"
					gint _tmp1_;
#line 445 "../folks/potential-match.vala"
					_tmp1_ = i;
#line 445 "../folks/potential-match.vala"
					i = _tmp1_ + 1;
#line 1810 "potential-match.c"
				}
#line 445 "../folks/potential-match.vala"
				_tmp0_ = FALSE;
#line 445 "../folks/potential-match.vala"
				if (!(i < smaller_set_length1)) {
#line 445 "../folks/potential-match.vala"
					break;
#line 1818 "potential-match.c"
				}
				{
					gint j = 0;
#line 447 "../folks/potential-match.vala"
					j = 0;
#line 1824 "potential-match.c"
					{
						gboolean _tmp2_ = FALSE;
#line 447 "../folks/potential-match.vala"
						_tmp2_ = TRUE;
#line 447 "../folks/potential-match.vala"
						while (TRUE) {
#line 1831 "potential-match.c"
							const gchar* _tmp4_;
							const gchar* _tmp5_;
#line 447 "../folks/potential-match.vala"
							if (!_tmp2_) {
#line 1836 "potential-match.c"
								gint _tmp3_;
#line 447 "../folks/potential-match.vala"
								_tmp3_ = j;
#line 447 "../folks/potential-match.vala"
								j = _tmp3_ + 1;
#line 1842 "potential-match.c"
							}
#line 447 "../folks/potential-match.vala"
							_tmp2_ = FALSE;
#line 447 "../folks/potential-match.vala"
							if (!(j < bigger_set_length1)) {
#line 447 "../folks/potential-match.vala"
								break;
#line 1850 "potential-match.c"
							}
#line 449 "../folks/potential-match.vala"
							_tmp4_ = smaller_set[i];
#line 449 "../folks/potential-match.vala"
							_tmp5_ = bigger_set[j];
#line 449 "../folks/potential-match.vala"
							if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 450 "../folks/potential-match.vala"
								result = TRUE;
#line 450 "../folks/potential-match.vala"
								return result;
#line 1862 "potential-match.c"
							}
						}
					}
				}
			}
		}
	}
#line 454 "../folks/potential-match.vala"
	result = FALSE;
#line 454 "../folks/potential-match.vala"
	return result;
#line 1874 "potential-match.c"
}

static FolksMatchResult
_folks_potential_match_inc_match_level (FolksPotentialMatch* self,
                                        FolksMatchResult current_level,
                                        gint times)
{
	FolksMatchResult ret = 0;
	FolksMatchResult result;
#line 457 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 460 "../folks/potential-match.vala"
	ret = current_level + times;
#line 461 "../folks/potential-match.vala"
	if (ret > FOLKS_MATCH_RESULT_MAX) {
#line 462 "../folks/potential-match.vala"
		ret = FOLKS_MATCH_RESULT_MAX;
#line 1892 "potential-match.c"
	}
#line 464 "../folks/potential-match.vala"
	result = ret;
#line 464 "../folks/potential-match.vala"
	return result;
#line 1898 "potential-match.c"
}

static gboolean
_folks_potential_match_look_alike_or_identical (FolksPotentialMatch* self,
                                                const gchar* a,
                                                const gchar* b,
                                                gboolean* exact)
{
	gboolean _vala_exact = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gunichar* a_stripped = NULL;
	gint _tmp3_ = 0;
	gunichar* _tmp4_;
	gint a_stripped_length1;
	gint _a_stripped_size_;
	gunichar* b_stripped = NULL;
	gint _tmp5_ = 0;
	gunichar* _tmp6_;
	gint b_stripped_length1;
	gint _b_stripped_size_;
	gdouble jaro_dist = 0.0;
	gunichar* _tmp7_;
	gint _tmp7__length1;
	gunichar* _tmp8_;
	gint _tmp8__length1;
	gboolean result;
#line 467 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 469 "../folks/potential-match.vala"
	_vala_exact = FALSE;
#line 470 "../folks/potential-match.vala"
	if (a == NULL) {
#line 470 "../folks/potential-match.vala"
		_tmp2_ = TRUE;
#line 1935 "potential-match.c"
	} else {
#line 470 "../folks/potential-match.vala"
		_tmp2_ = g_strcmp0 (a, "") == 0;
#line 1939 "potential-match.c"
	}
#line 470 "../folks/potential-match.vala"
	if (_tmp2_) {
#line 470 "../folks/potential-match.vala"
		_tmp1_ = TRUE;
#line 1945 "potential-match.c"
	} else {
#line 470 "../folks/potential-match.vala"
		_tmp1_ = b == NULL;
#line 1949 "potential-match.c"
	}
#line 470 "../folks/potential-match.vala"
	if (_tmp1_) {
#line 470 "../folks/potential-match.vala"
		_tmp0_ = TRUE;
#line 1955 "potential-match.c"
	} else {
#line 470 "../folks/potential-match.vala"
		_tmp0_ = g_strcmp0 (b, "") == 0;
#line 1959 "potential-match.c"
	}
#line 470 "../folks/potential-match.vala"
	if (_tmp0_) {
#line 472 "../folks/potential-match.vala"
		result = FALSE;
#line 472 "../folks/potential-match.vala"
		if (exact) {
#line 472 "../folks/potential-match.vala"
			*exact = _vala_exact;
#line 1969 "potential-match.c"
		}
#line 472 "../folks/potential-match.vala"
		return result;
#line 1973 "potential-match.c"
	}
#line 475 "../folks/potential-match.vala"
	g_return_val_if_fail (g_utf8_validate (a, (gssize) -1, NULL), FALSE);
#line 476 "../folks/potential-match.vala"
	g_return_val_if_fail (g_utf8_validate (b, (gssize) -1, NULL), FALSE);
#line 478 "../folks/potential-match.vala"
	_tmp4_ = _folks_potential_match_strip_string (self, (const gchar*) a, &_tmp3_);
#line 478 "../folks/potential-match.vala"
	a_stripped = _tmp4_;
#line 478 "../folks/potential-match.vala"
	a_stripped_length1 = _tmp3_;
#line 478 "../folks/potential-match.vala"
	_a_stripped_size_ = a_stripped_length1;
#line 479 "../folks/potential-match.vala"
	_tmp6_ = _folks_potential_match_strip_string (self, (const gchar*) b, &_tmp5_);
#line 479 "../folks/potential-match.vala"
	b_stripped = _tmp6_;
#line 479 "../folks/potential-match.vala"
	b_stripped_length1 = _tmp5_;
#line 479 "../folks/potential-match.vala"
	_b_stripped_size_ = b_stripped_length1;
#line 481 "../folks/potential-match.vala"
	_tmp7_ = a_stripped;
#line 481 "../folks/potential-match.vala"
	_tmp7__length1 = a_stripped_length1;
#line 481 "../folks/potential-match.vala"
	_tmp8_ = b_stripped;
#line 481 "../folks/potential-match.vala"
	_tmp8__length1 = b_stripped_length1;
#line 481 "../folks/potential-match.vala"
	jaro_dist = _folks_potential_match_jaro_dist (self, _tmp7_, (gint) _tmp7__length1, _tmp8_, (gint) _tmp8__length1);
#line 484 "../folks/potential-match.vala"
	if (jaro_dist == 1.0) {
#line 486 "../folks/potential-match.vala"
		_vala_exact = TRUE;
#line 487 "../folks/potential-match.vala"
		result = TRUE;
#line 487 "../folks/potential-match.vala"
		b_stripped = (g_free (b_stripped), NULL);
#line 487 "../folks/potential-match.vala"
		a_stripped = (g_free (a_stripped), NULL);
#line 487 "../folks/potential-match.vala"
		if (exact) {
#line 487 "../folks/potential-match.vala"
			*exact = _vala_exact;
#line 2019 "potential-match.c"
		}
#line 487 "../folks/potential-match.vala"
		return result;
#line 2023 "potential-match.c"
	}
#line 491 "../folks/potential-match.vala"
	result = jaro_dist >= folks_potential_match__DIST_THRESHOLD;
#line 491 "../folks/potential-match.vala"
	b_stripped = (g_free (b_stripped), NULL);
#line 491 "../folks/potential-match.vala"
	a_stripped = (g_free (a_stripped), NULL);
#line 491 "../folks/potential-match.vala"
	if (exact) {
#line 491 "../folks/potential-match.vala"
		*exact = _vala_exact;
#line 2035 "potential-match.c"
	}
#line 491 "../folks/potential-match.vala"
	return result;
#line 2039 "potential-match.c"
}

static gboolean
_folks_potential_match_look_alike (FolksPotentialMatch* self,
                                   const gchar* a,
                                   const gchar* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gunichar* a_stripped = NULL;
	gint _tmp3_ = 0;
	gunichar* _tmp4_;
	gint a_stripped_length1;
	gint _a_stripped_size_;
	gunichar* b_stripped = NULL;
	gint _tmp5_ = 0;
	gunichar* _tmp6_;
	gint b_stripped_length1;
	gint _b_stripped_size_;
	gunichar* _tmp7_;
	gint _tmp7__length1;
	gunichar* _tmp8_;
	gint _tmp8__length1;
	gboolean result;
#line 494 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 496 "../folks/potential-match.vala"
	if (a == NULL) {
#line 496 "../folks/potential-match.vala"
		_tmp2_ = TRUE;
#line 2071 "potential-match.c"
	} else {
#line 496 "../folks/potential-match.vala"
		_tmp2_ = g_strcmp0 (a, "") == 0;
#line 2075 "potential-match.c"
	}
#line 496 "../folks/potential-match.vala"
	if (_tmp2_) {
#line 496 "../folks/potential-match.vala"
		_tmp1_ = TRUE;
#line 2081 "potential-match.c"
	} else {
#line 496 "../folks/potential-match.vala"
		_tmp1_ = b == NULL;
#line 2085 "potential-match.c"
	}
#line 496 "../folks/potential-match.vala"
	if (_tmp1_) {
#line 496 "../folks/potential-match.vala"
		_tmp0_ = TRUE;
#line 2091 "potential-match.c"
	} else {
#line 496 "../folks/potential-match.vala"
		_tmp0_ = g_strcmp0 (b, "") == 0;
#line 2095 "potential-match.c"
	}
#line 496 "../folks/potential-match.vala"
	if (_tmp0_) {
#line 498 "../folks/potential-match.vala"
		result = FALSE;
#line 498 "../folks/potential-match.vala"
		return result;
#line 2103 "potential-match.c"
	}
#line 501 "../folks/potential-match.vala"
	g_return_val_if_fail (g_utf8_validate (a, (gssize) -1, NULL), FALSE);
#line 502 "../folks/potential-match.vala"
	g_return_val_if_fail (g_utf8_validate (b, (gssize) -1, NULL), FALSE);
#line 504 "../folks/potential-match.vala"
	_tmp4_ = _folks_potential_match_strip_string (self, (const gchar*) a, &_tmp3_);
#line 504 "../folks/potential-match.vala"
	a_stripped = _tmp4_;
#line 504 "../folks/potential-match.vala"
	a_stripped_length1 = _tmp3_;
#line 504 "../folks/potential-match.vala"
	_a_stripped_size_ = a_stripped_length1;
#line 505 "../folks/potential-match.vala"
	_tmp6_ = _folks_potential_match_strip_string (self, (const gchar*) b, &_tmp5_);
#line 505 "../folks/potential-match.vala"
	b_stripped = _tmp6_;
#line 505 "../folks/potential-match.vala"
	b_stripped_length1 = _tmp5_;
#line 505 "../folks/potential-match.vala"
	_b_stripped_size_ = b_stripped_length1;
#line 508 "../folks/potential-match.vala"
	_tmp7_ = a_stripped;
#line 508 "../folks/potential-match.vala"
	_tmp7__length1 = a_stripped_length1;
#line 508 "../folks/potential-match.vala"
	_tmp8_ = b_stripped;
#line 508 "../folks/potential-match.vala"
	_tmp8__length1 = b_stripped_length1;
#line 508 "../folks/potential-match.vala"
	result = _folks_potential_match_jaro_dist (self, _tmp7_, (gint) _tmp7__length1, _tmp8_, (gint) _tmp8__length1) >= folks_potential_match__DIST_THRESHOLD;
#line 508 "../folks/potential-match.vala"
	b_stripped = (g_free (b_stripped), NULL);
#line 508 "../folks/potential-match.vala"
	a_stripped = (g_free (a_stripped), NULL);
#line 508 "../folks/potential-match.vala"
	return result;
#line 2141 "potential-match.c"
}

static gdouble
_folks_potential_match_jaro_dist (FolksPotentialMatch* self,
                                  gunichar* s1,
                                  gint s1_length1,
                                  gunichar* s2,
                                  gint s2_length1)
{
	gdouble distance = 0.0;
	gint _tmp0_ = 0;
	gint max = 0;
	gint max_dist = 0;
	gdouble t = 0.0;
	gdouble m = 0.0;
	gdouble _tmp1_ = 0.0;
	gint _tmp2_;
	gdouble len_s1 = 0.0;
	gdouble len_s2 = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble c = 0.0;
	gdouble result;
#line 521 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 524 "../folks/potential-match.vala"
	if (s1_length1 > s2_length1) {
#line 524 "../folks/potential-match.vala"
		_tmp0_ = s1_length1;
#line 2171 "potential-match.c"
	} else {
#line 524 "../folks/potential-match.vala"
		_tmp0_ = s2_length1;
#line 2175 "potential-match.c"
	}
#line 524 "../folks/potential-match.vala"
	max = _tmp0_;
#line 525 "../folks/potential-match.vala"
	max_dist = (max / 2) - 1;
#line 527 "../folks/potential-match.vala"
	_tmp2_ = _folks_potential_match_matches (self, s1, (gint) s1_length1, s2, (gint) s2_length1, max_dist, &_tmp1_);
#line 527 "../folks/potential-match.vala"
	t = _tmp1_;
#line 527 "../folks/potential-match.vala"
	m = (gdouble) _tmp2_;
#line 528 "../folks/potential-match.vala"
	len_s1 = (gdouble) s1_length1;
#line 529 "../folks/potential-match.vala"
	len_s2 = (gdouble) s2_length1;
#line 530 "../folks/potential-match.vala"
	a = m / len_s1;
#line 531 "../folks/potential-match.vala"
	b = m / len_s2;
#line 532 "../folks/potential-match.vala"
	c = (gdouble) 0;
#line 534 "../folks/potential-match.vala"
	if (((gint) m) > 0) {
#line 535 "../folks/potential-match.vala"
		c = (m - t) / m;
#line 2201 "potential-match.c"
	}
#line 537 "../folks/potential-match.vala"
	distance = (1.0 / 3.0) * ((a + b) + c);
#line 539 "../folks/potential-match.vala"
	g_debug ("potential-match.vala:539: Jaro distance: %f (a = %f, b = %f, c = %f)", distance, a, b, c);
#line 541 "../folks/potential-match.vala"
	result = distance;
#line 541 "../folks/potential-match.vala"
	return result;
#line 2211 "potential-match.c"
}

/**
   * stripped_char:
   *
   * Returns a stripped version of @ch, removing any case, accentuation
   * mark, or any special mark on it.
   *
   * Copied from Empathy's libempathy-gtk/empathy-live-search.c.
   *
   * Copyright (C) 2010 Collabora Ltd.
   * Copyright (C) 2007-2010 Nokia Corporation.
   *
   * Authors: Felix Kaser <felix.kaser@collabora.co.uk>
   *          Xavier Claessens <xavier.claessens@collabora.co.uk>
   *          Claudio Saavedra <csaavedra@igalia.com>
   */
static gunichar
_folks_potential_match_stripped_char (FolksPotentialMatch* self,
                                      gunichar ch)
{
	gunichar retval[1] = {0};
	gunichar _tmp0_[1] = {0};
	GUnicodeType utype = 0;
	gunichar _tmp1_;
	gunichar result;
#line 559 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 561 "../folks/potential-match.vala"
	_tmp0_[0] = (gunichar) 0;
#line 561 "../folks/potential-match.vala"
	memcpy (retval, _tmp0_, 1 * sizeof (gunichar));
#line 562 "../folks/potential-match.vala"
	utype = g_unichar_type (ch);
#line 564 "../folks/potential-match.vala"
	switch (utype) {
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_CONTROL:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_FORMAT:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_UNASSIGNED:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_NON_SPACING_MARK:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_COMBINING_MARK:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_ENCLOSING_MARK:
#line 2260 "potential-match.c"
		{
#line 573 "../folks/potential-match.vala"
			break;
#line 2264 "potential-match.c"
		}
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_DECIMAL_NUMBER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_LETTER_NUMBER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_OTHER_NUMBER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_CONNECT_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_DASH_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_CLOSE_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_FINAL_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_INITIAL_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_OTHER_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_OPEN_PUNCTUATION:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_CURRENCY_SYMBOL:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_MODIFIER_SYMBOL:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_MATH_SYMBOL:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_OTHER_SYMBOL:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_LINE_SEPARATOR:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_PARAGRAPH_SEPARATOR:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_SPACE_SEPARATOR:
#line 2300 "potential-match.c"
		{
#line 592 "../folks/potential-match.vala"
			retval[0] = (gunichar) ' ';
#line 593 "../folks/potential-match.vala"
			break;
#line 2306 "potential-match.c"
		}
		default:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_PRIVATE_USE:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_SURROGATE:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_LOWERCASE_LETTER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_MODIFIER_LETTER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_OTHER_LETTER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_TITLECASE_LETTER:
#line 564 "../folks/potential-match.vala"
		case G_UNICODE_UPPERCASE_LETTER:
#line 2323 "potential-match.c"
		{
#line 602 "../folks/potential-match.vala"
			ch = g_unichar_tolower (ch);
#line 603 "../folks/potential-match.vala"
			g_unichar_fully_decompose (ch, FALSE, retval, (gint) 1);
#line 604 "../folks/potential-match.vala"
			break;
#line 2331 "potential-match.c"
		}
	}
#line 607 "../folks/potential-match.vala"
	_tmp1_ = retval[0];
#line 607 "../folks/potential-match.vala"
	result = _tmp1_;
#line 607 "../folks/potential-match.vala"
	return result;
#line 2340 "potential-match.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1267 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1268 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1269 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 2356 "potential-match.c"
		gchar* _tmp0_;
#line 1270 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1270 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1271 "glib-2.0.vapi"
		result = TRUE;
#line 1271 "glib-2.0.vapi"
		if (c) {
#line 1271 "glib-2.0.vapi"
			*c = _vala_c;
#line 2368 "potential-match.c"
		}
#line 1271 "glib-2.0.vapi"
		return result;
#line 2372 "potential-match.c"
	} else {
#line 1273 "glib-2.0.vapi"
		result = FALSE;
#line 1273 "glib-2.0.vapi"
		if (c) {
#line 1273 "glib-2.0.vapi"
			*c = _vala_c;
#line 2380 "potential-match.c"
		}
#line 1273 "glib-2.0.vapi"
		return result;
#line 2384 "potential-match.c"
	}
}

static gunichar*
_folks_potential_match_strip_string (FolksPotentialMatch* self,
                                     const gchar* s,
                                     gint* result_length1)
{
	gint next_idx = 0;
	guint write_idx = 0U;
	gunichar ch = 0U;
	gunichar* output = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gunichar* _tmp2_;
	gint output_length1;
	gint _output_size_;
	gunichar* _tmp8_;
	gint _tmp8__length1;
	gunichar* result;
#line 610 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 610 "../folks/potential-match.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 612 "../folks/potential-match.vala"
	next_idx = 0;
#line 613 "../folks/potential-match.vala"
	write_idx = (guint) 0;
#line 614 "../folks/potential-match.vala"
	ch = (gunichar) 0;
#line 615 "../folks/potential-match.vala"
	_tmp0_ = strlen (s);
#line 615 "../folks/potential-match.vala"
	_tmp1_ = _tmp0_;
#line 615 "../folks/potential-match.vala"
	_tmp2_ = g_new0 (gunichar, _tmp1_);
#line 615 "../folks/potential-match.vala"
	output = _tmp2_;
#line 615 "../folks/potential-match.vala"
	output_length1 = _tmp1_;
#line 615 "../folks/potential-match.vala"
	_output_size_ = output_length1;
#line 617 "../folks/potential-match.vala"
	while (TRUE) {
#line 2429 "potential-match.c"
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
#line 617 "../folks/potential-match.vala"
		_tmp4_ = string_get_next_char (s, &next_idx, &_tmp3_);
#line 617 "../folks/potential-match.vala"
		ch = _tmp3_;
#line 617 "../folks/potential-match.vala"
		if (!_tmp4_) {
#line 617 "../folks/potential-match.vala"
			break;
#line 2440 "potential-match.c"
		}
#line 619 "../folks/potential-match.vala"
		ch = _folks_potential_match_stripped_char (self, ch);
#line 620 "../folks/potential-match.vala"
		if (ch != ((gunichar) 0)) {
#line 2446 "potential-match.c"
			gunichar* _tmp5_;
			gint _tmp5__length1;
			guint _tmp6_;
			gunichar _tmp7_;
#line 622 "../folks/potential-match.vala"
			_tmp5_ = output;
#line 622 "../folks/potential-match.vala"
			_tmp5__length1 = output_length1;
#line 622 "../folks/potential-match.vala"
			_tmp6_ = write_idx;
#line 622 "../folks/potential-match.vala"
			write_idx = _tmp6_ + 1;
#line 622 "../folks/potential-match.vala"
			_tmp7_ = ch;
#line 622 "../folks/potential-match.vala"
			_tmp5_[_tmp6_] = _tmp7_;
#line 2463 "potential-match.c"
		}
	}
#line 626 "../folks/potential-match.vala"
	output_length1 = (gint) write_idx;
#line 627 "../folks/potential-match.vala"
	_tmp8_ = output;
#line 627 "../folks/potential-match.vala"
	_tmp8__length1 = output_length1;
#line 627 "../folks/potential-match.vala"
	if (result_length1) {
#line 627 "../folks/potential-match.vala"
		*result_length1 = _tmp8__length1;
#line 2476 "potential-match.c"
	}
#line 627 "../folks/potential-match.vala"
	result = _tmp8_;
#line 627 "../folks/potential-match.vala"
	return result;
#line 2482 "potential-match.c"
}

static gint
_folks_potential_match_matches (FolksPotentialMatch* self,
                                gunichar* s1,
                                gint s1_length1,
                                gunichar* s2,
                                gint s2_length1,
                                gint max_dist,
                                gdouble* t)
{
	gdouble _vala_t = 0.0;
	gint matches = 0;
	gint len_s1 = 0;
	gunichar look_for = 0U;
	gint result;
#line 632 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 634 "../folks/potential-match.vala"
	matches = 0;
#line 635 "../folks/potential-match.vala"
	_vala_t = 0.0;
#line 636 "../folks/potential-match.vala"
	len_s1 = s1_length1;
#line 638 "../folks/potential-match.vala"
	look_for = (gunichar) 0;
#line 2509 "potential-match.c"
	{
		guint idx = 0U;
#line 640 "../folks/potential-match.vala"
		idx = (guint) 0;
#line 2514 "potential-match.c"
		{
			gboolean _tmp0_ = FALSE;
#line 640 "../folks/potential-match.vala"
			_tmp0_ = TRUE;
#line 640 "../folks/potential-match.vala"
			while (TRUE) {
#line 2521 "potential-match.c"
				gboolean _tmp2_ = FALSE;
				gint contains = 0;
#line 640 "../folks/potential-match.vala"
				if (!_tmp0_) {
#line 2526 "potential-match.c"
					guint _tmp1_;
#line 640 "../folks/potential-match.vala"
					_tmp1_ = idx;
#line 640 "../folks/potential-match.vala"
					idx = _tmp1_ + 1;
#line 2532 "potential-match.c"
				}
#line 640 "../folks/potential-match.vala"
				_tmp0_ = FALSE;
#line 640 "../folks/potential-match.vala"
				if (idx < ((guint) len_s1)) {
#line 2538 "potential-match.c"
					gunichar _tmp3_;
#line 640 "../folks/potential-match.vala"
					_tmp3_ = s1[idx];
#line 640 "../folks/potential-match.vala"
					look_for = _tmp3_;
#line 640 "../folks/potential-match.vala"
					_tmp2_ = look_for != ((gunichar) 0);
#line 2546 "potential-match.c"
				} else {
#line 640 "../folks/potential-match.vala"
					_tmp2_ = FALSE;
#line 2550 "potential-match.c"
				}
#line 640 "../folks/potential-match.vala"
				if (!_tmp2_) {
#line 640 "../folks/potential-match.vala"
					break;
#line 2556 "potential-match.c"
				}
#line 642 "../folks/potential-match.vala"
				contains = _folks_potential_match_contains (self, s2, (gint) s2_length1, look_for, idx, (guint) max_dist);
#line 643 "../folks/potential-match.vala"
				if (contains >= 0) {
#line 2562 "potential-match.c"
					gint _tmp4_;
#line 645 "../folks/potential-match.vala"
					_tmp4_ = matches;
#line 645 "../folks/potential-match.vala"
					matches = _tmp4_ + 1;
#line 646 "../folks/potential-match.vala"
					if (contains > 0) {
#line 647 "../folks/potential-match.vala"
						_vala_t = _vala_t + 1.0;
#line 2572 "potential-match.c"
					}
				}
			}
		}
	}
#line 651 "../folks/potential-match.vala"
	g_debug ("potential-match.vala:651: %d matches and %f / 2 transpositions", matches, _vala_t);
#line 653 "../folks/potential-match.vala"
	_vala_t = _vala_t / 2.0;
#line 654 "../folks/potential-match.vala"
	result = matches;
#line 654 "../folks/potential-match.vala"
	if (t) {
#line 654 "../folks/potential-match.vala"
		*t = _vala_t;
#line 2588 "potential-match.c"
	}
#line 654 "../folks/potential-match.vala"
	return result;
#line 2592 "potential-match.c"
}

static gint
_folks_potential_match_contains (FolksPotentialMatch* self,
                                 gunichar* haystack,
                                 gint haystack_length1,
                                 gunichar c,
                                 guint pos,
                                 guint max_dist)
{
	gint haystack_len = 0;
	gboolean _tmp0_ = FALSE;
	guint idx = 0U;
	gunichar ch = 0U;
	gint result;
#line 665 "../folks/potential-match.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 667 "../folks/potential-match.vala"
	haystack_len = haystack_length1;
#line 669 "../folks/potential-match.vala"
	if (pos < ((guint) haystack_len)) {
#line 2614 "potential-match.c"
		gunichar _tmp1_;
#line 669 "../folks/potential-match.vala"
		_tmp1_ = haystack[pos];
#line 669 "../folks/potential-match.vala"
		_tmp0_ = _tmp1_ == c;
#line 2620 "potential-match.c"
	} else {
#line 669 "../folks/potential-match.vala"
		_tmp0_ = FALSE;
#line 2624 "potential-match.c"
	}
#line 669 "../folks/potential-match.vala"
	if (_tmp0_) {
#line 670 "../folks/potential-match.vala"
		result = 0;
#line 670 "../folks/potential-match.vala"
		return result;
#line 2632 "potential-match.c"
	}
#line 672 "../folks/potential-match.vala"
	idx = (guint) CLAMP (((gint) pos) - ((gint) max_dist), 0, haystack_len - 1);
#line 673 "../folks/potential-match.vala"
	ch = (gunichar) 0;
#line 675 "../folks/potential-match.vala"
	while (TRUE) {
#line 2640 "potential-match.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		guint _tmp5_;
#line 675 "../folks/potential-match.vala"
		if (idx < (pos + max_dist)) {
#line 675 "../folks/potential-match.vala"
			_tmp3_ = idx < ((guint) haystack_len);
#line 2648 "potential-match.c"
		} else {
#line 675 "../folks/potential-match.vala"
			_tmp3_ = FALSE;
#line 2652 "potential-match.c"
		}
#line 675 "../folks/potential-match.vala"
		if (_tmp3_) {
#line 2656 "potential-match.c"
			gunichar _tmp4_;
#line 676 "../folks/potential-match.vala"
			_tmp4_ = haystack[idx];
#line 676 "../folks/potential-match.vala"
			ch = _tmp4_;
#line 676 "../folks/potential-match.vala"
			_tmp2_ = ch != ((gunichar) 0);
#line 2664 "potential-match.c"
		} else {
#line 675 "../folks/potential-match.vala"
			_tmp2_ = FALSE;
#line 2668 "potential-match.c"
		}
#line 675 "../folks/potential-match.vala"
		if (!_tmp2_) {
#line 675 "../folks/potential-match.vala"
			break;
#line 2674 "potential-match.c"
		}
#line 678 "../folks/potential-match.vala"
		if (ch == c) {
#line 679 "../folks/potential-match.vala"
			result = abs (((gint) pos) - ((gint) idx));
#line 679 "../folks/potential-match.vala"
			return result;
#line 2682 "potential-match.c"
		}
#line 681 "../folks/potential-match.vala"
		_tmp5_ = idx;
#line 681 "../folks/potential-match.vala"
		idx = _tmp5_ + 1;
#line 2688 "potential-match.c"
	}
#line 684 "../folks/potential-match.vala"
	result = -1;
#line 684 "../folks/potential-match.vala"
	return result;
#line 2694 "potential-match.c"
}

static void
folks_potential_match_class_init (FolksPotentialMatchClass * klass,
                                  gpointer klass_data)
{
	FolksSmallSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
#line 93 "../folks/potential-match.vala"
	folks_potential_match_parent_class = g_type_class_peek_parent (klass);
#line 93 "../folks/potential-match.vala"
	g_type_class_adjust_private_offset (klass, &FolksPotentialMatch_private_offset);
#line 93 "../folks/potential-match.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_potential_match_finalize;
#line 104 "../folks/potential-match.vala"
	_tmp0_ = folks_small_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 104 "../folks/potential-match.vala"
	folks_potential_match_known_email_aliases = (GeeSet*) _tmp0_;
#line 111 "../folks/potential-match.vala"
	_tmp1_ = folks_potential_match_known_email_aliases;
#line 111 "../folks/potential-match.vala"
	gee_collection_add ((GeeCollection*) _tmp1_, "admin");
#line 112 "../folks/potential-match.vala"
	_tmp2_ = folks_potential_match_known_email_aliases;
#line 112 "../folks/potential-match.vala"
	gee_collection_add ((GeeCollection*) _tmp2_, "abuse");
#line 113 "../folks/potential-match.vala"
	_tmp3_ = folks_potential_match_known_email_aliases;
#line 113 "../folks/potential-match.vala"
	gee_collection_add ((GeeCollection*) _tmp3_, "webmaster");
#line 2727 "potential-match.c"
}

static void
folks_potential_match_instance_init (FolksPotentialMatch * self,
                                     gpointer klass)
{
#line 93 "../folks/potential-match.vala"
	self->priv = folks_potential_match_get_instance_private (self);
#line 2736 "potential-match.c"
}

static void
folks_potential_match_finalize (GObject * obj)
{
	FolksPotentialMatch * self;
#line 93 "../folks/potential-match.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_POTENTIAL_MATCH, FolksPotentialMatch);
#line 95 "../folks/potential-match.vala"
	_g_object_unref0 (self->priv->_individual_a);
#line 96 "../folks/potential-match.vala"
	_g_object_unref0 (self->priv->_individual_b);
#line 93 "../folks/potential-match.vala"
	G_OBJECT_CLASS (folks_potential_match_parent_class)->finalize (obj);
#line 2751 "potential-match.c"
}

/**
 * Match calculator for pairs of individuals.
 *
 * This provides functionality to explore the degree of a potential match
 * between two individuals. It compares the similarity of the individuals'
 * properties to determine how likely it is that the individuals represent the
 * same physical person.
 *
 * This can be used by folks clients to, for example, present suggestions of
 * pairs of individuals which should be linked by the user.
 *
 * @since 0.5.0
 */
static GType
folks_potential_match_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksPotentialMatchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_potential_match_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksPotentialMatch), 0, (GInstanceInitFunc) folks_potential_match_instance_init, NULL };
	GType folks_potential_match_type_id;
	folks_potential_match_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksPotentialMatch", &g_define_type_info, 0);
	FolksPotentialMatch_private_offset = g_type_add_instance_private (folks_potential_match_type_id, sizeof (FolksPotentialMatchPrivate));
	return folks_potential_match_type_id;
}

GType
folks_potential_match_get_type (void)
{
	static volatile gsize folks_potential_match_type_id__once = 0;
	if (g_once_init_enter (&folks_potential_match_type_id__once)) {
		GType folks_potential_match_type_id;
		folks_potential_match_type_id = folks_potential_match_get_type_once ();
		g_once_init_leave (&folks_potential_match_type_id__once, folks_potential_match_type_id);
	}
	return folks_potential_match_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

