/* presence-details.c generated by valac 0.56.16, the Vala compiler
 * generated from presence-details.vala, do not modify */

/*
 * Copyright (C) 2010-2011 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 */

#include "folks/folks.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static gint _folks_presence_details_type_availability (FolksPresenceType type);
static GType folks_presence_details_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * The possible presence states an object implementing {@link PresenceDetails}
 * could be in.
 *
 * These closely follow the
 * [[http://telepathy.freedesktop.org/spec/Connection_Interface_Simple_Presence.html#Connection_Presence_Type|SimplePresence]]
 * interface in the Telepathy specification.
 */
static GType
folks_presence_type_get_type_once (void)
{
	static const GEnumValue values[] = {{FOLKS_PRESENCE_TYPE_UNSET, "FOLKS_PRESENCE_TYPE_UNSET", "unset"}, {FOLKS_PRESENCE_TYPE_OFFLINE, "FOLKS_PRESENCE_TYPE_OFFLINE", "offline"}, {FOLKS_PRESENCE_TYPE_AVAILABLE, "FOLKS_PRESENCE_TYPE_AVAILABLE", "available"}, {FOLKS_PRESENCE_TYPE_AWAY, "FOLKS_PRESENCE_TYPE_AWAY", "away"}, {FOLKS_PRESENCE_TYPE_EXTENDED_AWAY, "FOLKS_PRESENCE_TYPE_EXTENDED_AWAY", "extended-away"}, {FOLKS_PRESENCE_TYPE_HIDDEN, "FOLKS_PRESENCE_TYPE_HIDDEN", "hidden"}, {FOLKS_PRESENCE_TYPE_BUSY, "FOLKS_PRESENCE_TYPE_BUSY", "busy"}, {FOLKS_PRESENCE_TYPE_UNKNOWN, "FOLKS_PRESENCE_TYPE_UNKNOWN", "unknown"}, {FOLKS_PRESENCE_TYPE_ERROR, "FOLKS_PRESENCE_TYPE_ERROR", "error"}, {0, NULL, NULL}};
	GType folks_presence_type_type_id;
	folks_presence_type_type_id = g_enum_register_static ("FolksPresenceType", values);
	return folks_presence_type_type_id;
}

GType
folks_presence_type_get_type (void)
{
	static volatile gsize folks_presence_type_type_id__once = 0;
	if (g_once_init_enter (&folks_presence_type_type_id__once)) {
		GType folks_presence_type_type_id;
		folks_presence_type_type_id = folks_presence_type_get_type_once ();
		g_once_init_leave (&folks_presence_type_type_id__once, folks_presence_type_type_id);
	}
	return folks_presence_type_type_id__once;
}

static gint
_folks_presence_details_type_availability (FolksPresenceType type)
{
	gint result;
#line 131 "../folks/presence-details.vala"
	switch (type) {
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_UNSET:
#line 82 "presence-details.c"
		{
#line 134 "../folks/presence-details.vala"
			result = 0;
#line 134 "../folks/presence-details.vala"
			return result;
#line 88 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_UNKNOWN:
#line 92 "presence-details.c"
		{
#line 136 "../folks/presence-details.vala"
			result = 1;
#line 136 "../folks/presence-details.vala"
			return result;
#line 98 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_ERROR:
#line 102 "presence-details.c"
		{
#line 138 "../folks/presence-details.vala"
			result = 2;
#line 138 "../folks/presence-details.vala"
			return result;
#line 108 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_OFFLINE:
#line 112 "presence-details.c"
		{
#line 140 "../folks/presence-details.vala"
			result = 3;
#line 140 "../folks/presence-details.vala"
			return result;
#line 118 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_HIDDEN:
#line 122 "presence-details.c"
		{
#line 142 "../folks/presence-details.vala"
			result = 4;
#line 142 "../folks/presence-details.vala"
			return result;
#line 128 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_EXTENDED_AWAY:
#line 132 "presence-details.c"
		{
#line 144 "../folks/presence-details.vala"
			result = 5;
#line 144 "../folks/presence-details.vala"
			return result;
#line 138 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_AWAY:
#line 142 "presence-details.c"
		{
#line 146 "../folks/presence-details.vala"
			result = 6;
#line 146 "../folks/presence-details.vala"
			return result;
#line 148 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_BUSY:
#line 152 "presence-details.c"
		{
#line 148 "../folks/presence-details.vala"
			result = 7;
#line 148 "../folks/presence-details.vala"
			return result;
#line 158 "presence-details.c"
		}
#line 131 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_AVAILABLE:
#line 162 "presence-details.c"
		{
#line 150 "../folks/presence-details.vala"
			result = 8;
#line 150 "../folks/presence-details.vala"
			return result;
#line 168 "presence-details.c"
		}
		default:
		{
#line 152 "../folks/presence-details.vala"
			result = 1;
#line 152 "../folks/presence-details.vala"
			return result;
#line 176 "presence-details.c"
		}
	}
}

/**
   * The default message for a presence type.
   *
   * @param type a {@link PresenceType} for which to retrieve a translated
   * display string
   * @return a default translated display string for the given
   * {@link PresenceType}
   * @since 0.7.1
   */
const gchar*
folks_presence_details_get_default_message_from_type (FolksPresenceType type)
{
	const gchar* result;
#line 167 "../folks/presence-details.vala"
	switch (type) {
#line 196 "presence-details.c"
		default:
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_UNKNOWN:
#line 200 "presence-details.c"
		{
#line 171 "../folks/presence-details.vala"
			result = _ ("Unknown status");
#line 171 "../folks/presence-details.vala"
			return result;
#line 206 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_OFFLINE:
#line 210 "presence-details.c"
		{
#line 173 "../folks/presence-details.vala"
			result = _ ("Offline");
#line 173 "../folks/presence-details.vala"
			return result;
#line 216 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_UNSET:
#line 220 "presence-details.c"
		{
#line 175 "../folks/presence-details.vala"
			result = "";
#line 175 "../folks/presence-details.vala"
			return result;
#line 226 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_ERROR:
#line 230 "presence-details.c"
		{
#line 177 "../folks/presence-details.vala"
			result = _ ("Error");
#line 177 "../folks/presence-details.vala"
			return result;
#line 236 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_AVAILABLE:
#line 240 "presence-details.c"
		{
#line 179 "../folks/presence-details.vala"
			result = _ ("Available");
#line 179 "../folks/presence-details.vala"
			return result;
#line 246 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_AWAY:
#line 250 "presence-details.c"
		{
#line 181 "../folks/presence-details.vala"
			result = _ ("Away");
#line 181 "../folks/presence-details.vala"
			return result;
#line 256 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_EXTENDED_AWAY:
#line 260 "presence-details.c"
		{
#line 183 "../folks/presence-details.vala"
			result = _ ("Extended away");
#line 183 "../folks/presence-details.vala"
			return result;
#line 266 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_BUSY:
#line 270 "presence-details.c"
		{
#line 185 "../folks/presence-details.vala"
			result = _ ("Busy");
#line 185 "../folks/presence-details.vala"
			return result;
#line 276 "presence-details.c"
		}
#line 167 "../folks/presence-details.vala"
		case FOLKS_PRESENCE_TYPE_HIDDEN:
#line 280 "presence-details.c"
		{
#line 187 "../folks/presence-details.vala"
			result = _ ("Hidden");
#line 187 "../folks/presence-details.vala"
			return result;
#line 286 "presence-details.c"
		}
	}
}

/**
   * Compare two {@link PresenceType}s.
   *
   * ``0`` will be returned if the types are equal, a positive number will be
   * returned if ``type_a`` is more available than ``type_b``, and a negative
   * number will be returned if the opposite is true.
   *
   * @param type_a the first {@link PresenceType} to compare
   * @param type_b the second {@link PresenceType} to compare
   * @return a number representing the similarity of the two types
   * @since 0.1.11
   */
gint
folks_presence_details_typecmp (FolksPresenceType type_a,
                                FolksPresenceType type_b)
{
	gint result;
#line 205 "../folks/presence-details.vala"
	result = _folks_presence_details_type_availability (type_a) - _folks_presence_details_type_availability (type_b);
#line 205 "../folks/presence-details.vala"
	return result;
#line 312 "presence-details.c"
}

/**
   * Whether the contact is online.
   *
   * This will be ``true`` if the contact's presence type is higher than
   * {@link PresenceType.OFFLINE}, as determined by
   * {@link PresenceDetails.typecmp}.
   *
   * @return ``true`` if the contact is online, ``false`` otherwise
   */
gboolean
folks_presence_details_is_online (FolksPresenceDetails* self)
{
	FolksPresenceType _tmp0_;
	FolksPresenceType _tmp1_;
	gboolean result;
#line 220 "../folks/presence-details.vala"
	_tmp0_ = folks_presence_details_get_presence_type (self);
#line 220 "../folks/presence-details.vala"
	_tmp1_ = _tmp0_;
#line 220 "../folks/presence-details.vala"
	result = folks_presence_details_typecmp (_tmp1_, FOLKS_PRESENCE_TYPE_OFFLINE) > 0;
#line 220 "../folks/presence-details.vala"
	return result;
#line 338 "presence-details.c"
}

FolksPresenceType
folks_presence_details_get_presence_type (FolksPresenceDetails* self)
{
	FolksPresenceDetailsIface* _iface_;
#line 91 "../folks/presence-details.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 91 "../folks/presence-details.vala"
	if (_iface_->get_presence_type) {
#line 91 "../folks/presence-details.vala"
		return _iface_->get_presence_type (self);
#line 353 "presence-details.c"
	}
#line 91 "../folks/presence-details.vala"
	return 0;
#line 357 "presence-details.c"
}

void
folks_presence_details_set_presence_type (FolksPresenceDetails* self,
                                          FolksPresenceType value)
{
	FolksPresenceDetailsIface* _iface_;
#line 91 "../folks/presence-details.vala"
	g_return_if_fail (self != NULL);
#line 91 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 91 "../folks/presence-details.vala"
	if (_iface_->set_presence_type) {
#line 91 "../folks/presence-details.vala"
		_iface_->set_presence_type (self, value);
#line 373 "presence-details.c"
	}
}

const gchar*
folks_presence_details_get_presence_message (FolksPresenceDetails* self)
{
	FolksPresenceDetailsIface* _iface_;
#line 101 "../folks/presence-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 101 "../folks/presence-details.vala"
	if (_iface_->get_presence_message) {
#line 101 "../folks/presence-details.vala"
		return _iface_->get_presence_message (self);
#line 389 "presence-details.c"
	}
#line 101 "../folks/presence-details.vala"
	return NULL;
#line 393 "presence-details.c"
}

void
folks_presence_details_set_presence_message (FolksPresenceDetails* self,
                                             const gchar* value)
{
	FolksPresenceDetailsIface* _iface_;
#line 101 "../folks/presence-details.vala"
	g_return_if_fail (self != NULL);
#line 101 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 101 "../folks/presence-details.vala"
	if (_iface_->set_presence_message) {
#line 101 "../folks/presence-details.vala"
		_iface_->set_presence_message (self, value);
#line 409 "presence-details.c"
	}
}

gchar**
folks_presence_details_get_client_types (FolksPresenceDetails* self,
                                         gint* result_length1)
{
	FolksPresenceDetailsIface* _iface_;
#line 113 "../folks/presence-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 113 "../folks/presence-details.vala"
	if (_iface_->get_client_types) {
#line 113 "../folks/presence-details.vala"
		return _iface_->get_client_types (self, result_length1);
#line 426 "presence-details.c"
	}
#line 113 "../folks/presence-details.vala"
	return NULL;
#line 430 "presence-details.c"
}

void
folks_presence_details_set_client_types (FolksPresenceDetails* self,
                                         gchar** value,
                                         gint value_length1)
{
	FolksPresenceDetailsIface* _iface_;
#line 113 "../folks/presence-details.vala"
	g_return_if_fail (self != NULL);
#line 113 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 113 "../folks/presence-details.vala"
	if (_iface_->set_client_types) {
#line 113 "../folks/presence-details.vala"
		_iface_->set_client_types (self, value, value_length1);
#line 447 "presence-details.c"
	}
}

const gchar*
folks_presence_details_get_presence_status (FolksPresenceDetails* self)
{
	FolksPresenceDetailsIface* _iface_;
#line 125 "../folks/presence-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 125 "../folks/presence-details.vala"
	if (_iface_->get_presence_status) {
#line 125 "../folks/presence-details.vala"
		return _iface_->get_presence_status (self);
#line 463 "presence-details.c"
	}
#line 125 "../folks/presence-details.vala"
	return NULL;
#line 467 "presence-details.c"
}

void
folks_presence_details_set_presence_status (FolksPresenceDetails* self,
                                            const gchar* value)
{
	FolksPresenceDetailsIface* _iface_;
#line 125 "../folks/presence-details.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/presence-details.vala"
	_iface_ = FOLKS_PRESENCE_DETAILS_GET_INTERFACE (self);
#line 125 "../folks/presence-details.vala"
	if (_iface_->set_presence_status) {
#line 125 "../folks/presence-details.vala"
		_iface_->set_presence_status (self, value);
#line 483 "presence-details.c"
	}
}

static void
folks_presence_details_default_init (FolksPresenceDetailsIface * iface,
                                     gpointer iface_data)
{
	/**
	   * The contact's presence type.
	   *
	   * Each contact can have one and only one presence type at any one time,
	   * representing their availability for communication. The default presence
	   * type is {@link PresenceType.UNSET}.
	   */
#line 80 "../folks/presence-details.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("presence-type", "presence-type", "presence-type", FOLKS_TYPE_PRESENCE_TYPE, FOLKS_PRESENCE_TYPE_UNSET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 500 "presence-details.c"
	/**
	   * The contact's presence message.
	   *
	   * This is a short message written by the contact to add detail to their
	   * presence type ({@link Folks.PresenceDetails.presence_type}). If the contact
	   * hasn't set a message, it will be an empty string.
	   */
#line 80 "../folks/presence-details.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("presence-message", "presence-message", "presence-message", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 510 "presence-details.c"
	/**
	   * The contact's client types.
	   *
	   * One can connect to instant messaging networks on a huge variety of devices,
	   * from PCs, to phones to consoles.
	   * The client types are represented in strings, using the values
	   * [[http://xmpp.org/registrar/disco-categories.html#client|documented by the XMPP registrar]]
	   *
	   * @since 0.9.5
	   */
#line 80 "../folks/presence-details.vala"
	g_object_interface_install_property (iface, g_param_spec_boxed ("client-types", "client-types", "client-types", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 523 "presence-details.c"
	/**
	   * The contact's detailed presence status.
	   *
	   * This is a more detailed representation of the contact's presence than
	   * {@link PresenceDetails.presence_type}. It may be empty, or one of a
	   * well-known set of strings, as defined in the Telepathy specification:
	   * [[http://telepathy.freedesktop.org/spec/Connection_Interface_Simple_Presence.html#description|Telepathy Specification]]
	   *
	   * @since 0.6.0
	   */
#line 80 "../folks/presence-details.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("presence-status", "presence-status", "presence-status", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 536 "presence-details.c"
}

/**
 * Interface exposing a {@link Persona}'s or {@link Individual}'s presence;
 * their current availability, such as for chatting.
 *
 * If the {@link Backend} providing the {@link Persona} doesn't support
 * presence, the {@link Persona}'s ``presence_type`` will be set to
 * {@link PresenceType.UNSET} and their ``presence_message`` will be an empty
 * string.
 */
static GType
folks_presence_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksPresenceDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_presence_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_presence_details_type_id;
	folks_presence_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksPresenceDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_presence_details_type_id, G_TYPE_OBJECT);
	return folks_presence_details_type_id;
}

GType
folks_presence_details_get_type (void)
{
	static volatile gsize folks_presence_details_type_id__once = 0;
	if (g_once_init_enter (&folks_presence_details_type_id__once)) {
		GType folks_presence_details_type_id;
		folks_presence_details_type_id = folks_presence_details_get_type_once ();
		g_once_init_leave (&folks_presence_details_type_id__once, folks_presence_details_type_id);
	}
	return folks_presence_details_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

