/* utils.c generated by valac 0.56.16, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Raul Gutierrez Segales <raul.gutierrez.segales@collabora.co.uk>
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 */

#include "folks/folks.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_UTILS_0_PROPERTY,
	FOLKS_UTILS_NUM_PROPERTIES
};
static GParamSpec* folks_utils_properties[FOLKS_UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer folks_utils_parent_class = NULL;

VALA_EXTERN gboolean _folks_utils_str_equal_safe (const gchar* a,
                                      const gchar* b);
static GType folks_utils_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gboolean
_folks_utils_str_equal_safe (const gchar* a,
                             const gchar* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 39 "../folks/utils.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 39 "../folks/utils.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 41 "../folks/utils.vala"
	if (g_strcmp0 (a, "") != 0) {
#line 41 "../folks/utils.vala"
		_tmp1_ = g_strcmp0 (b, "") != 0;
#line 73 "utils.c"
	} else {
#line 41 "../folks/utils.vala"
		_tmp1_ = FALSE;
#line 77 "utils.c"
	}
#line 41 "../folks/utils.vala"
	if (_tmp1_) {
#line 81 "utils.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 41 "../folks/utils.vala"
		_tmp2_ = g_utf8_strdown (a, (gssize) -1);
#line 41 "../folks/utils.vala"
		_tmp3_ = _tmp2_;
#line 41 "../folks/utils.vala"
		_tmp4_ = g_utf8_strdown (b, (gssize) -1);
#line 41 "../folks/utils.vala"
		_tmp5_ = _tmp4_;
#line 41 "../folks/utils.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp5_) == 0;
#line 41 "../folks/utils.vala"
		_g_free0 (_tmp5_);
#line 41 "../folks/utils.vala"
		_g_free0 (_tmp3_);
#line 100 "utils.c"
	} else {
#line 41 "../folks/utils.vala"
		_tmp0_ = FALSE;
#line 104 "utils.c"
	}
#line 41 "../folks/utils.vala"
	result = _tmp0_;
#line 41 "../folks/utils.vala"
	return result;
#line 110 "utils.c"
}

/**
   * Create a new utilities object.
   *
   * This method is useless and should never be used. It will be removed in a
   * future version in favour of making the Utils class into a nested namespace.
   *
   * @return a new utilities object
   * @since 0.6.0
   */
FolksUtils*
folks_utils_construct (GType object_type)
{
	FolksUtils * self = NULL;
#line 57 "../folks/utils.vala"
	self = (FolksUtils*) g_object_new (object_type, NULL);
#line 55 "../folks/utils.vala"
	return self;
#line 130 "utils.c"
}

FolksUtils*
folks_utils_new (void)
{
#line 55 "../folks/utils.vala"
	return folks_utils_construct (FOLKS_TYPE_UTILS);
#line 138 "utils.c"
}

/**
   * Check whether two multi-maps of strings to strings are equal. This performs
   * a deep check for equality, checking whether both maps are of the same size,
   * and that each key maps to the same set of values in both maps.
   *
   * @param a a multi-map to compare
   * @param b another multi-map to compare
   * @return ``true`` if the multi-maps are equal, ``false`` otherwise
   *
   * @since 0.6.0
   */
gboolean
folks_utils_multi_map_str_str_equal (GeeMultiMap* a,
                                     GeeMultiMap* b)
{
	gint a_size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint b_size = 0;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 71 "../folks/utils.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 71 "../folks/utils.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 75 "../folks/utils.vala"
	if (a == b) {
#line 76 "../folks/utils.vala"
		result = TRUE;
#line 76 "../folks/utils.vala"
		return result;
#line 174 "utils.c"
	}
#line 78 "../folks/utils.vala"
	_tmp0_ = gee_multi_map_get_size (a);
#line 78 "../folks/utils.vala"
	_tmp1_ = _tmp0_;
#line 78 "../folks/utils.vala"
	a_size = _tmp1_;
#line 79 "../folks/utils.vala"
	_tmp2_ = gee_multi_map_get_size (b);
#line 79 "../folks/utils.vala"
	_tmp3_ = _tmp2_;
#line 79 "../folks/utils.vala"
	b_size = _tmp3_;
#line 81 "../folks/utils.vala"
	if (a_size == 0) {
#line 81 "../folks/utils.vala"
		_tmp4_ = b_size == 0;
#line 192 "utils.c"
	} else {
#line 81 "../folks/utils.vala"
		_tmp4_ = FALSE;
#line 196 "utils.c"
	}
#line 81 "../folks/utils.vala"
	if (_tmp4_) {
#line 84 "../folks/utils.vala"
		result = TRUE;
#line 84 "../folks/utils.vala"
		return result;
#line 204 "utils.c"
	} else {
#line 86 "../folks/utils.vala"
		if (a_size == b_size) {
#line 208 "utils.c"
			{
				GeeIterator* _key_it = NULL;
				GeeSet* _tmp5_;
				GeeSet* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _tmp8_;
#line 88 "../folks/utils.vala"
				_tmp5_ = gee_multi_map_get_keys (a);
#line 88 "../folks/utils.vala"
				_tmp6_ = _tmp5_;
#line 88 "../folks/utils.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 88 "../folks/utils.vala"
				_tmp8_ = _tmp7_;
#line 88 "../folks/utils.vala"
				_g_object_unref0 (_tmp6_);
#line 88 "../folks/utils.vala"
				_key_it = _tmp8_;
#line 88 "../folks/utils.vala"
				while (TRUE) {
#line 229 "utils.c"
					GeeIterator* _tmp9_;
					gchar* key = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					const gchar* _tmp12_;
#line 88 "../folks/utils.vala"
					_tmp9_ = _key_it;
#line 88 "../folks/utils.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 88 "../folks/utils.vala"
						break;
#line 241 "utils.c"
					}
#line 88 "../folks/utils.vala"
					_tmp10_ = _key_it;
#line 88 "../folks/utils.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 88 "../folks/utils.vala"
					key = (gchar*) _tmp11_;
#line 90 "../folks/utils.vala"
					_tmp12_ = key;
#line 90 "../folks/utils.vala"
					if (gee_multi_map_contains (b, _tmp12_)) {
#line 253 "utils.c"
						GeeCollection* a_values = NULL;
						const gchar* _tmp13_;
						GeeCollection* _tmp14_;
						GeeCollection* b_values = NULL;
						const gchar* _tmp15_;
						GeeCollection* _tmp16_;
						GeeCollection* _tmp17_;
						gint _tmp18_;
						gint _tmp19_;
						GeeCollection* _tmp20_;
						gint _tmp21_;
						gint _tmp22_;
#line 92 "../folks/utils.vala"
						_tmp13_ = key;
#line 92 "../folks/utils.vala"
						_tmp14_ = gee_multi_map_get (a, _tmp13_);
#line 92 "../folks/utils.vala"
						a_values = _tmp14_;
#line 93 "../folks/utils.vala"
						_tmp15_ = key;
#line 93 "../folks/utils.vala"
						_tmp16_ = gee_multi_map_get (b, _tmp15_);
#line 93 "../folks/utils.vala"
						b_values = _tmp16_;
#line 94 "../folks/utils.vala"
						_tmp17_ = a_values;
#line 94 "../folks/utils.vala"
						_tmp18_ = gee_collection_get_size (_tmp17_);
#line 94 "../folks/utils.vala"
						_tmp19_ = _tmp18_;
#line 94 "../folks/utils.vala"
						_tmp20_ = b_values;
#line 94 "../folks/utils.vala"
						_tmp21_ = gee_collection_get_size (_tmp20_);
#line 94 "../folks/utils.vala"
						_tmp22_ = _tmp21_;
#line 94 "../folks/utils.vala"
						if (_tmp19_ != _tmp22_) {
#line 95 "../folks/utils.vala"
							result = FALSE;
#line 95 "../folks/utils.vala"
							_g_object_unref0 (b_values);
#line 95 "../folks/utils.vala"
							_g_object_unref0 (a_values);
#line 95 "../folks/utils.vala"
							_g_free0 (key);
#line 95 "../folks/utils.vala"
							_g_object_unref0 (_key_it);
#line 95 "../folks/utils.vala"
							return result;
#line 304 "utils.c"
						}
						{
							GeeIterator* _a_value_it = NULL;
							GeeCollection* _tmp23_;
							GeeIterator* _tmp24_;
#line 97 "../folks/utils.vala"
							_tmp23_ = a_values;
#line 97 "../folks/utils.vala"
							_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 97 "../folks/utils.vala"
							_a_value_it = _tmp24_;
#line 97 "../folks/utils.vala"
							while (TRUE) {
#line 318 "utils.c"
								GeeIterator* _tmp25_;
								gchar* a_value = NULL;
								GeeIterator* _tmp26_;
								gpointer _tmp27_;
								GeeCollection* _tmp28_;
								const gchar* _tmp29_;
#line 97 "../folks/utils.vala"
								_tmp25_ = _a_value_it;
#line 97 "../folks/utils.vala"
								if (!gee_iterator_next (_tmp25_)) {
#line 97 "../folks/utils.vala"
									break;
#line 331 "utils.c"
								}
#line 97 "../folks/utils.vala"
								_tmp26_ = _a_value_it;
#line 97 "../folks/utils.vala"
								_tmp27_ = gee_iterator_get (_tmp26_);
#line 97 "../folks/utils.vala"
								a_value = (gchar*) _tmp27_;
#line 99 "../folks/utils.vala"
								_tmp28_ = b_values;
#line 99 "../folks/utils.vala"
								_tmp29_ = a_value;
#line 99 "../folks/utils.vala"
								if (!gee_collection_contains (_tmp28_, _tmp29_)) {
#line 100 "../folks/utils.vala"
									result = FALSE;
#line 100 "../folks/utils.vala"
									_g_free0 (a_value);
#line 100 "../folks/utils.vala"
									_g_object_unref0 (_a_value_it);
#line 100 "../folks/utils.vala"
									_g_object_unref0 (b_values);
#line 100 "../folks/utils.vala"
									_g_object_unref0 (a_values);
#line 100 "../folks/utils.vala"
									_g_free0 (key);
#line 100 "../folks/utils.vala"
									_g_object_unref0 (_key_it);
#line 100 "../folks/utils.vala"
									return result;
#line 361 "utils.c"
								}
#line 97 "../folks/utils.vala"
								_g_free0 (a_value);
#line 365 "utils.c"
							}
#line 97 "../folks/utils.vala"
							_g_object_unref0 (_a_value_it);
#line 369 "utils.c"
						}
#line 90 "../folks/utils.vala"
						_g_object_unref0 (b_values);
#line 90 "../folks/utils.vala"
						_g_object_unref0 (a_values);
#line 375 "utils.c"
					} else {
#line 105 "../folks/utils.vala"
						result = FALSE;
#line 105 "../folks/utils.vala"
						_g_free0 (key);
#line 105 "../folks/utils.vala"
						_g_object_unref0 (_key_it);
#line 105 "../folks/utils.vala"
						return result;
#line 385 "utils.c"
					}
#line 88 "../folks/utils.vala"
					_g_free0 (key);
#line 389 "utils.c"
				}
#line 88 "../folks/utils.vala"
				_g_object_unref0 (_key_it);
#line 393 "utils.c"
			}
		} else {
#line 111 "../folks/utils.vala"
			result = FALSE;
#line 111 "../folks/utils.vala"
			return result;
#line 400 "utils.c"
		}
	}
#line 114 "../folks/utils.vala"
	result = TRUE;
#line 114 "../folks/utils.vala"
	return result;
#line 407 "utils.c"
}

/**
   * Check whether two multi-maps of strings to AbstractFieldDetails are equal.
   *
   * This performs a deep check for equality, checking whether both maps are of
   * the same size, and that each key maps to the same set of values in both
   * maps.
   *
   * @param a a multi-map to compare
   * @param b another multi-map to compare
   * @return ``true`` if the multi-maps are equal, ``false`` otherwise
   *
   * @since 0.6.0
   */
gboolean
folks_utils_multi_map_str_afd_equal (GeeMultiMap* a,
                                     GeeMultiMap* b)
{
	gint a_size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint b_size = 0;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 130 "../folks/utils.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 130 "../folks/utils.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 134 "../folks/utils.vala"
	if (a == b) {
#line 135 "../folks/utils.vala"
		result = TRUE;
#line 135 "../folks/utils.vala"
		return result;
#line 445 "utils.c"
	}
#line 137 "../folks/utils.vala"
	_tmp0_ = gee_multi_map_get_size (a);
#line 137 "../folks/utils.vala"
	_tmp1_ = _tmp0_;
#line 137 "../folks/utils.vala"
	a_size = _tmp1_;
#line 138 "../folks/utils.vala"
	_tmp2_ = gee_multi_map_get_size (b);
#line 138 "../folks/utils.vala"
	_tmp3_ = _tmp2_;
#line 138 "../folks/utils.vala"
	b_size = _tmp3_;
#line 140 "../folks/utils.vala"
	if (a_size == 0) {
#line 140 "../folks/utils.vala"
		_tmp4_ = b_size == 0;
#line 463 "utils.c"
	} else {
#line 140 "../folks/utils.vala"
		_tmp4_ = FALSE;
#line 467 "utils.c"
	}
#line 140 "../folks/utils.vala"
	if (_tmp4_) {
#line 143 "../folks/utils.vala"
		result = TRUE;
#line 143 "../folks/utils.vala"
		return result;
#line 475 "utils.c"
	} else {
#line 145 "../folks/utils.vala"
		if (a_size == b_size) {
#line 479 "utils.c"
			{
				GeeIterator* _key_it = NULL;
				GeeSet* _tmp5_;
				GeeSet* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _tmp8_;
#line 147 "../folks/utils.vala"
				_tmp5_ = gee_multi_map_get_keys (a);
#line 147 "../folks/utils.vala"
				_tmp6_ = _tmp5_;
#line 147 "../folks/utils.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 147 "../folks/utils.vala"
				_tmp8_ = _tmp7_;
#line 147 "../folks/utils.vala"
				_g_object_unref0 (_tmp6_);
#line 147 "../folks/utils.vala"
				_key_it = _tmp8_;
#line 147 "../folks/utils.vala"
				while (TRUE) {
#line 500 "utils.c"
					GeeIterator* _tmp9_;
					gchar* key = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					const gchar* _tmp12_;
#line 147 "../folks/utils.vala"
					_tmp9_ = _key_it;
#line 147 "../folks/utils.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 147 "../folks/utils.vala"
						break;
#line 512 "utils.c"
					}
#line 147 "../folks/utils.vala"
					_tmp10_ = _key_it;
#line 147 "../folks/utils.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 147 "../folks/utils.vala"
					key = (gchar*) _tmp11_;
#line 149 "../folks/utils.vala"
					_tmp12_ = key;
#line 149 "../folks/utils.vala"
					if (gee_multi_map_contains (b, _tmp12_)) {
#line 524 "utils.c"
						GeeCollection* a_values = NULL;
						const gchar* _tmp13_;
						GeeCollection* _tmp14_;
						GeeCollection* b_values = NULL;
						const gchar* _tmp15_;
						GeeCollection* _tmp16_;
						GeeCollection* _tmp17_;
						gint _tmp18_;
						gint _tmp19_;
						GeeCollection* _tmp20_;
						gint _tmp21_;
						gint _tmp22_;
#line 151 "../folks/utils.vala"
						_tmp13_ = key;
#line 151 "../folks/utils.vala"
						_tmp14_ = gee_multi_map_get (a, _tmp13_);
#line 151 "../folks/utils.vala"
						a_values = _tmp14_;
#line 152 "../folks/utils.vala"
						_tmp15_ = key;
#line 152 "../folks/utils.vala"
						_tmp16_ = gee_multi_map_get (b, _tmp15_);
#line 152 "../folks/utils.vala"
						b_values = _tmp16_;
#line 153 "../folks/utils.vala"
						_tmp17_ = a_values;
#line 153 "../folks/utils.vala"
						_tmp18_ = gee_collection_get_size (_tmp17_);
#line 153 "../folks/utils.vala"
						_tmp19_ = _tmp18_;
#line 153 "../folks/utils.vala"
						_tmp20_ = b_values;
#line 153 "../folks/utils.vala"
						_tmp21_ = gee_collection_get_size (_tmp20_);
#line 153 "../folks/utils.vala"
						_tmp22_ = _tmp21_;
#line 153 "../folks/utils.vala"
						if (_tmp19_ != _tmp22_) {
#line 154 "../folks/utils.vala"
							result = FALSE;
#line 154 "../folks/utils.vala"
							_g_object_unref0 (b_values);
#line 154 "../folks/utils.vala"
							_g_object_unref0 (a_values);
#line 154 "../folks/utils.vala"
							_g_free0 (key);
#line 154 "../folks/utils.vala"
							_g_object_unref0 (_key_it);
#line 154 "../folks/utils.vala"
							return result;
#line 575 "utils.c"
						}
						{
							GeeIterator* _a_value_it = NULL;
							GeeCollection* _tmp23_;
							GeeIterator* _tmp24_;
#line 156 "../folks/utils.vala"
							_tmp23_ = a_values;
#line 156 "../folks/utils.vala"
							_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 156 "../folks/utils.vala"
							_a_value_it = _tmp24_;
#line 156 "../folks/utils.vala"
							while (TRUE) {
#line 589 "utils.c"
								GeeIterator* _tmp25_;
								FolksAbstractFieldDetails* a_value = NULL;
								GeeIterator* _tmp26_;
								gpointer _tmp27_;
								GeeCollection* _tmp28_;
								FolksAbstractFieldDetails* _tmp29_;
#line 156 "../folks/utils.vala"
								_tmp25_ = _a_value_it;
#line 156 "../folks/utils.vala"
								if (!gee_iterator_next (_tmp25_)) {
#line 156 "../folks/utils.vala"
									break;
#line 602 "utils.c"
								}
#line 156 "../folks/utils.vala"
								_tmp26_ = _a_value_it;
#line 156 "../folks/utils.vala"
								_tmp27_ = gee_iterator_get (_tmp26_);
#line 156 "../folks/utils.vala"
								a_value = (FolksAbstractFieldDetails*) _tmp27_;
#line 158 "../folks/utils.vala"
								_tmp28_ = b_values;
#line 158 "../folks/utils.vala"
								_tmp29_ = a_value;
#line 158 "../folks/utils.vala"
								if (!gee_collection_contains (_tmp28_, _tmp29_)) {
#line 159 "../folks/utils.vala"
									result = FALSE;
#line 159 "../folks/utils.vala"
									_g_object_unref0 (a_value);
#line 159 "../folks/utils.vala"
									_g_object_unref0 (_a_value_it);
#line 159 "../folks/utils.vala"
									_g_object_unref0 (b_values);
#line 159 "../folks/utils.vala"
									_g_object_unref0 (a_values);
#line 159 "../folks/utils.vala"
									_g_free0 (key);
#line 159 "../folks/utils.vala"
									_g_object_unref0 (_key_it);
#line 159 "../folks/utils.vala"
									return result;
#line 632 "utils.c"
								}
#line 156 "../folks/utils.vala"
								_g_object_unref0 (a_value);
#line 636 "utils.c"
							}
#line 156 "../folks/utils.vala"
							_g_object_unref0 (_a_value_it);
#line 640 "utils.c"
						}
#line 149 "../folks/utils.vala"
						_g_object_unref0 (b_values);
#line 149 "../folks/utils.vala"
						_g_object_unref0 (a_values);
#line 646 "utils.c"
					} else {
#line 164 "../folks/utils.vala"
						result = FALSE;
#line 164 "../folks/utils.vala"
						_g_free0 (key);
#line 164 "../folks/utils.vala"
						_g_object_unref0 (_key_it);
#line 164 "../folks/utils.vala"
						return result;
#line 656 "utils.c"
					}
#line 147 "../folks/utils.vala"
					_g_free0 (key);
#line 660 "utils.c"
				}
#line 147 "../folks/utils.vala"
				_g_object_unref0 (_key_it);
#line 664 "utils.c"
			}
		} else {
#line 170 "../folks/utils.vala"
			result = FALSE;
#line 170 "../folks/utils.vala"
			return result;
#line 671 "utils.c"
		}
	}
#line 173 "../folks/utils.vala"
	result = TRUE;
#line 173 "../folks/utils.vala"
	return result;
#line 678 "utils.c"
}

/**
   * Check whether a set of strings to AbstractFieldDetails are equal.
   *
   * This performs a deep check for equality, checking whether both sets are of
   * the same size, and that each key maps to the same set of values in both
   * maps.
   *
   * @param a a set to compare
   * @param b another set to compare
   * @return ``true`` if the sets are equal, ``false`` otherwise
   *
   * @since 0.6.0
   */
gboolean
folks_utils_set_afd_equal (GeeSet* a,
                           GeeSet* b)
{
	gint a_size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint b_size = 0;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 189 "../folks/utils.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 189 "../folks/utils.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 193 "../folks/utils.vala"
	if (a == b) {
#line 194 "../folks/utils.vala"
		result = TRUE;
#line 194 "../folks/utils.vala"
		return result;
#line 716 "utils.c"
	}
#line 196 "../folks/utils.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) a);
#line 196 "../folks/utils.vala"
	_tmp1_ = _tmp0_;
#line 196 "../folks/utils.vala"
	a_size = _tmp1_;
#line 197 "../folks/utils.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) b);
#line 197 "../folks/utils.vala"
	_tmp3_ = _tmp2_;
#line 197 "../folks/utils.vala"
	b_size = _tmp3_;
#line 199 "../folks/utils.vala"
	if (a_size == 0) {
#line 199 "../folks/utils.vala"
		_tmp4_ = b_size == 0;
#line 734 "utils.c"
	} else {
#line 199 "../folks/utils.vala"
		_tmp4_ = FALSE;
#line 738 "utils.c"
	}
#line 199 "../folks/utils.vala"
	if (_tmp4_) {
#line 202 "../folks/utils.vala"
		result = TRUE;
#line 202 "../folks/utils.vala"
		return result;
#line 746 "utils.c"
	} else {
#line 204 "../folks/utils.vala"
		if (a_size == b_size) {
#line 750 "utils.c"
			{
				GeeIterator* _val_it = NULL;
				GeeIterator* _tmp5_;
#line 206 "../folks/utils.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) a);
#line 206 "../folks/utils.vala"
				_val_it = _tmp5_;
#line 206 "../folks/utils.vala"
				while (TRUE) {
#line 760 "utils.c"
					GeeIterator* _tmp6_;
					FolksAbstractFieldDetails* val = NULL;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					FolksAbstractFieldDetails* _tmp9_;
#line 206 "../folks/utils.vala"
					_tmp6_ = _val_it;
#line 206 "../folks/utils.vala"
					if (!gee_iterator_next (_tmp6_)) {
#line 206 "../folks/utils.vala"
						break;
#line 772 "utils.c"
					}
#line 206 "../folks/utils.vala"
					_tmp7_ = _val_it;
#line 206 "../folks/utils.vala"
					_tmp8_ = gee_iterator_get (_tmp7_);
#line 206 "../folks/utils.vala"
					val = (FolksAbstractFieldDetails*) _tmp8_;
#line 208 "../folks/utils.vala"
					_tmp9_ = val;
#line 208 "../folks/utils.vala"
					if (!gee_collection_contains ((GeeCollection*) b, _tmp9_)) {
#line 210 "../folks/utils.vala"
						result = FALSE;
#line 210 "../folks/utils.vala"
						_g_object_unref0 (val);
#line 210 "../folks/utils.vala"
						_g_object_unref0 (_val_it);
#line 210 "../folks/utils.vala"
						return result;
#line 792 "utils.c"
					}
#line 206 "../folks/utils.vala"
					_g_object_unref0 (val);
#line 796 "utils.c"
				}
#line 206 "../folks/utils.vala"
				_g_object_unref0 (_val_it);
#line 800 "utils.c"
			}
		} else {
#line 216 "../folks/utils.vala"
			result = FALSE;
#line 216 "../folks/utils.vala"
			return result;
#line 807 "utils.c"
		}
	}
#line 219 "../folks/utils.vala"
	result = TRUE;
#line 219 "../folks/utils.vala"
	return result;
#line 814 "utils.c"
}

/**
   * Check whether a set of AbstractFieldDetails with string values are equal.
   *
   * This performs a deep check for equality, checking whether both sets are of
   * the same size, and that each set has the same values using string compaction
   * instead of AbstractFieldDetails equal function
   *
   * @param a a set to compare
   * @param b another set to compare
   * @return ``true`` if the sets are equal, ``false`` otherwise
   *
   * @since 0.9.7
   */
gboolean
folks_utils_set_string_afd_equal (GeeSet* a,
                                  GeeSet* b)
{
	gint a_size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint b_size = 0;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 235 "../folks/utils.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 235 "../folks/utils.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 239 "../folks/utils.vala"
	if (a == b) {
#line 240 "../folks/utils.vala"
		result = TRUE;
#line 240 "../folks/utils.vala"
		return result;
#line 852 "utils.c"
	}
#line 242 "../folks/utils.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) a);
#line 242 "../folks/utils.vala"
	_tmp1_ = _tmp0_;
#line 242 "../folks/utils.vala"
	a_size = _tmp1_;
#line 243 "../folks/utils.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) b);
#line 243 "../folks/utils.vala"
	_tmp3_ = _tmp2_;
#line 243 "../folks/utils.vala"
	b_size = _tmp3_;
#line 245 "../folks/utils.vala"
	if (a_size == 0) {
#line 245 "../folks/utils.vala"
		_tmp4_ = b_size == 0;
#line 870 "utils.c"
	} else {
#line 245 "../folks/utils.vala"
		_tmp4_ = FALSE;
#line 874 "utils.c"
	}
#line 245 "../folks/utils.vala"
	if (_tmp4_) {
#line 248 "../folks/utils.vala"
		result = TRUE;
#line 248 "../folks/utils.vala"
		return result;
#line 882 "utils.c"
	} else {
#line 250 "../folks/utils.vala"
		if (a_size == b_size) {
#line 886 "utils.c"
			{
				GeeIterator* _a_val_it = NULL;
				GeeIterator* _tmp5_;
#line 252 "../folks/utils.vala"
				_tmp5_ = gee_iterable_iterator ((GeeIterable*) a);
#line 252 "../folks/utils.vala"
				_a_val_it = _tmp5_;
#line 252 "../folks/utils.vala"
				while (TRUE) {
#line 896 "utils.c"
					GeeIterator* _tmp6_;
					FolksAbstractFieldDetails* a_val = NULL;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					gboolean found = FALSE;
#line 252 "../folks/utils.vala"
					_tmp6_ = _a_val_it;
#line 252 "../folks/utils.vala"
					if (!gee_iterator_next (_tmp6_)) {
#line 252 "../folks/utils.vala"
						break;
#line 908 "utils.c"
					}
#line 252 "../folks/utils.vala"
					_tmp7_ = _a_val_it;
#line 252 "../folks/utils.vala"
					_tmp8_ = gee_iterator_get (_tmp7_);
#line 252 "../folks/utils.vala"
					a_val = (FolksAbstractFieldDetails*) _tmp8_;
#line 254 "../folks/utils.vala"
					found = FALSE;
#line 918 "utils.c"
					{
						GeeIterator* _b_val_it = NULL;
						GeeIterator* _tmp9_;
#line 255 "../folks/utils.vala"
						_tmp9_ = gee_iterable_iterator ((GeeIterable*) b);
#line 255 "../folks/utils.vala"
						_b_val_it = _tmp9_;
#line 255 "../folks/utils.vala"
						while (TRUE) {
#line 928 "utils.c"
							GeeIterator* _tmp10_;
							FolksAbstractFieldDetails* b_val = NULL;
							GeeIterator* _tmp11_;
							gpointer _tmp12_;
							gboolean _tmp13_ = FALSE;
							FolksAbstractFieldDetails* _tmp14_;
							FolksAbstractFieldDetails* _tmp15_;
#line 255 "../folks/utils.vala"
							_tmp10_ = _b_val_it;
#line 255 "../folks/utils.vala"
							if (!gee_iterator_next (_tmp10_)) {
#line 255 "../folks/utils.vala"
								break;
#line 942 "utils.c"
							}
#line 255 "../folks/utils.vala"
							_tmp11_ = _b_val_it;
#line 255 "../folks/utils.vala"
							_tmp12_ = gee_iterator_get (_tmp11_);
#line 255 "../folks/utils.vala"
							b_val = (FolksAbstractFieldDetails*) _tmp12_;
#line 257 "../folks/utils.vala"
							_tmp14_ = a_val;
#line 257 "../folks/utils.vala"
							_tmp15_ = b_val;
#line 257 "../folks/utils.vala"
							if (folks_abstract_field_details_parameters_equal (_tmp14_, _tmp15_)) {
#line 956 "utils.c"
								GEqualFunc _tmp16_;
								FolksAbstractFieldDetails* _tmp17_;
								gconstpointer _tmp18_;
								gconstpointer _tmp19_;
								FolksAbstractFieldDetails* _tmp20_;
								gconstpointer _tmp21_;
								gconstpointer _tmp22_;
#line 258 "../folks/utils.vala"
								_tmp16_ = g_str_equal;
#line 258 "../folks/utils.vala"
								_tmp17_ = a_val;
#line 258 "../folks/utils.vala"
								_tmp18_ = folks_abstract_field_details_get_value (_tmp17_);
#line 258 "../folks/utils.vala"
								_tmp19_ = _tmp18_;
#line 258 "../folks/utils.vala"
								_tmp20_ = b_val;
#line 258 "../folks/utils.vala"
								_tmp21_ = folks_abstract_field_details_get_value (_tmp20_);
#line 258 "../folks/utils.vala"
								_tmp22_ = _tmp21_;
#line 258 "../folks/utils.vala"
								_tmp13_ = _tmp16_ ((const gchar*) _tmp19_, (const gchar*) _tmp22_);
#line 980 "utils.c"
							} else {
#line 257 "../folks/utils.vala"
								_tmp13_ = FALSE;
#line 984 "utils.c"
							}
#line 257 "../folks/utils.vala"
							if (_tmp13_) {
#line 260 "../folks/utils.vala"
								found = TRUE;
#line 990 "utils.c"
							}
#line 255 "../folks/utils.vala"
							_g_object_unref0 (b_val);
#line 994 "utils.c"
						}
#line 255 "../folks/utils.vala"
						_g_object_unref0 (_b_val_it);
#line 998 "utils.c"
					}
#line 263 "../folks/utils.vala"
					if (!found) {
#line 265 "../folks/utils.vala"
						result = FALSE;
#line 265 "../folks/utils.vala"
						_g_object_unref0 (a_val);
#line 265 "../folks/utils.vala"
						_g_object_unref0 (_a_val_it);
#line 265 "../folks/utils.vala"
						return result;
#line 1010 "utils.c"
					}
#line 252 "../folks/utils.vala"
					_g_object_unref0 (a_val);
#line 1014 "utils.c"
				}
#line 252 "../folks/utils.vala"
				_g_object_unref0 (_a_val_it);
#line 1018 "utils.c"
			}
		} else {
#line 271 "../folks/utils.vala"
			result = FALSE;
#line 271 "../folks/utils.vala"
			return result;
#line 1025 "utils.c"
		}
	}
#line 274 "../folks/utils.vala"
	result = TRUE;
#line 274 "../folks/utils.vala"
	return result;
#line 1032 "utils.c"
}

static void
folks_utils_class_init (FolksUtilsClass * klass,
                        gpointer klass_data)
{
#line 37 "../folks/utils.vala"
	folks_utils_parent_class = g_type_class_peek_parent (klass);
#line 1041 "utils.c"
}

static void
folks_utils_instance_init (FolksUtils * self,
                           gpointer klass)
{
}

/**
 * Utility functions to simplify common patterns in Folks client code.
 *
 * These may be used by folks clients as well, and are part of folks' supported
 * stable API.
 *
 * @since 0.6.0
 */
static GType
folks_utils_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksUtils), 0, (GInstanceInitFunc) folks_utils_instance_init, NULL };
	GType folks_utils_type_id;
	folks_utils_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksUtils", &g_define_type_info, 0);
	return folks_utils_type_id;
}

GType
folks_utils_get_type (void)
{
	static volatile gsize folks_utils_type_id__once = 0;
	if (g_once_init_enter (&folks_utils_type_id__once)) {
		GType folks_utils_type_id;
		folks_utils_type_id = folks_utils_get_type_once ();
		g_once_init_leave (&folks_utils_type_id__once, folks_utils_type_id);
	}
	return folks_utils_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

