/* signal-manager.c generated by valac 0.56.16, the Vala compiler
 * generated from signal-manager.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FOLKS_INSPECT_TYPE_SIGNAL_MANAGER (folks_inspect_signal_manager_get_type ())
#define FOLKS_INSPECT_SIGNAL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FOLKS_INSPECT_TYPE_SIGNAL_MANAGER, FolksInspectSignalManager))
#define FOLKS_INSPECT_SIGNAL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FOLKS_INSPECT_TYPE_SIGNAL_MANAGER, FolksInspectSignalManagerClass))
#define FOLKS_INSPECT_IS_SIGNAL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FOLKS_INSPECT_TYPE_SIGNAL_MANAGER))
#define FOLKS_INSPECT_IS_SIGNAL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FOLKS_INSPECT_TYPE_SIGNAL_MANAGER))
#define FOLKS_INSPECT_SIGNAL_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FOLKS_INSPECT_TYPE_SIGNAL_MANAGER, FolksInspectSignalManagerClass))

typedef struct _FolksInspectSignalManager FolksInspectSignalManager;
typedef struct _FolksInspectSignalManagerClass FolksInspectSignalManagerClass;
typedef struct _FolksInspectSignalManagerPrivate FolksInspectSignalManagerPrivate;
enum  {
	FOLKS_INSPECT_SIGNAL_MANAGER_0_PROPERTY,
	FOLKS_INSPECT_SIGNAL_MANAGER_NUM_PROPERTIES
};
static GParamSpec* folks_inspect_signal_manager_properties[FOLKS_INSPECT_SIGNAL_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_closure_unref0(var) ((var == NULL) ? NULL : (var = (g_closure_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _FolksInspectSignalManager {
	GObject parent_instance;
	FolksInspectSignalManagerPrivate * priv;
};

struct _FolksInspectSignalManagerClass {
	GObjectClass parent_class;
};

struct _FolksInspectSignalManagerPrivate {
	GeeHashMap* signals_by_class_type;
	GeeHashMap* signals_by_class_instance;
};

static gint FolksInspectSignalManager_private_offset;
static gpointer folks_inspect_signal_manager_parent_class = NULL;

VALA_EXTERN GType folks_inspect_signal_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FolksInspectSignalManager, g_object_unref)
VALA_EXTERN FolksInspectSignalManager* folks_inspect_signal_manager_new (void);
VALA_EXTERN FolksInspectSignalManager* folks_inspect_signal_manager_construct (GType object_type);
VALA_EXTERN void folks_inspect_signal_manager_list_signals (FolksInspectSignalManager* self,
                                                GType class_type,
                                                GObject* class_instance);
VALA_EXTERN void folks_inspect_utils_print_line (const gchar* format,
                                     ...)  G_GNUC_PRINTF(1,2) ;
VALA_EXTERN void folks_inspect_utils_indent (void);
static void folks_inspect_signal_manager_list_signals_for_type (FolksInspectSignalManager* self,
                                                         GType type,
                                                         GeeHashMap* signal_id_map);
VALA_EXTERN void folks_inspect_utils_unindent (void);
VALA_EXTERN void folks_inspect_signal_manager_show_signal_details (FolksInspectSignalManager* self,
                                                       GType class_type,
                                                       const gchar* signal_name,
                                                       const gchar* detail_string);
static gchar* folks_inspect_signal_manager_signal_flags_to_string (GSignalFlags flags);
VALA_EXTERN guint folks_inspect_signal_manager_connect_to_signal (FolksInspectSignalManager* self,
                                                      GType class_type,
                                                      GObject* class_instance,
                                                      const gchar* signal_name,
                                                      const gchar* detail_string);
static gboolean folks_inspect_signal_manager_add_emission_hook (FolksInspectSignalManager* self,
                                                         GType class_type,
                                                         guint signal_id,
                                                         const gchar* detail_string);
static void folks_inspect_signal_manager_add_signal_handler (FolksInspectSignalManager* self,
                                                      GObject* class_instance,
                                                      guint signal_id,
                                                      const gchar* detail_string);
VALA_EXTERN guint folks_inspect_signal_manager_disconnect_from_signal (FolksInspectSignalManager* self,
                                                           GType class_type,
                                                           GObject* class_instance,
                                                           const gchar* signal_name,
                                                           const gchar* detail_string);
static gboolean folks_inspect_signal_manager_remove_emission_hook (FolksInspectSignalManager* self,
                                                            GType class_type,
                                                            guint signal_id);
static gboolean folks_inspect_signal_manager_remove_signal_handler (FolksInspectSignalManager* self,
                                                             GObject* class_instance,
                                                             guint signal_id);
static void folks_inspect_signal_manager_signal_meta_marshaller (GClosure* closure,
                                                          GValue** return_value,
                                                          GValue* param_values,
                                                          gint param_values_length1,
                                                          void* invocation_hint,
                                                          void* marshal_data);
static void _folks_inspect_signal_manager_signal_meta_marshaller_gclosure_marshal (GClosure* closure,
                                                                            GValue* return_value,
                                                                            guint n_param_values,
                                                                            GValue* param_values,
                                                                            void* invocation_hint,
                                                                            void* marshal_data);
static void _vala_GValue_free (GValue* self);
VALA_EXTERN gchar* folks_inspect_utils_transform_value_to_string (GValue* prop_value);
static gboolean folks_inspect_signal_manager_emission_hook_cb (FolksInspectSignalManager* self,
                                                        GSignalInvocationHint* hint,
                                                        GValue* param_values,
                                                        gint param_values_length1);
static gboolean _folks_inspect_signal_manager_emission_hook_cb_gsignal_emission_hook (GSignalInvocationHint* ihint,
                                                                               guint n_param_values,
                                                                               GValue* param_values,
                                                                               gpointer self);
static void folks_inspect_signal_manager_finalize (GObject * obj);
static GType folks_inspect_signal_manager_get_type_once (void);

static inline gpointer
folks_inspect_signal_manager_get_instance_private (FolksInspectSignalManager* self)
{
	return G_STRUCT_MEMBER_P (self, FolksInspectSignalManager_private_offset);
}

FolksInspectSignalManager*
folks_inspect_signal_manager_construct (GType object_type)
{
	FolksInspectSignalManager * self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 32 "../tools/inspect/signal-manager.vala"
	self = (FolksInspectSignalManager*) g_object_new (object_type, NULL);
#line 34 "../tools/inspect/signal-manager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_GTYPE, NULL, NULL, GEE_TYPE_HASH_MAP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 34 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (self->priv->signals_by_class_type);
#line 34 "../tools/inspect/signal-manager.vala"
	self->priv->signals_by_class_type = _tmp0_;
#line 36 "../tools/inspect/signal-manager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_HASH_MAP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 36 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (self->priv->signals_by_class_instance);
#line 36 "../tools/inspect/signal-manager.vala"
	self->priv->signals_by_class_instance = _tmp1_;
#line 32 "../tools/inspect/signal-manager.vala"
	return self;
#line 182 "signal-manager.c"
}

FolksInspectSignalManager*
folks_inspect_signal_manager_new (void)
{
#line 32 "../tools/inspect/signal-manager.vala"
	return folks_inspect_signal_manager_construct (FOLKS_INSPECT_TYPE_SIGNAL_MANAGER);
#line 190 "signal-manager.c"
}

void
folks_inspect_signal_manager_list_signals (FolksInspectSignalManager* self,
                                           GType class_type,
                                           GObject* class_instance)
{
#line 40 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (self != NULL);
#line 43 "../tools/inspect/signal-manager.vala"
	if (class_type != G_TYPE_INVALID) {
#line 202 "signal-manager.c"
		GeeHashMap* hook_ids = NULL;
		GeeHashMap* _tmp0_;
		gpointer _tmp1_;
		const gchar* _tmp2_;
		GeeHashMap* _tmp3_;
#line 47 "../tools/inspect/signal-manager.vala"
		_tmp0_ = self->priv->signals_by_class_type;
#line 47 "../tools/inspect/signal-manager.vala"
		_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) class_type));
#line 47 "../tools/inspect/signal-manager.vala"
		hook_ids = (GeeHashMap*) _tmp1_;
#line 50 "../tools/inspect/signal-manager.vala"
		_tmp2_ = g_type_name (class_type);
#line 50 "../tools/inspect/signal-manager.vala"
		folks_inspect_utils_print_line ("Signals on all instances of class type '%s':", _tmp2_);
#line 52 "../tools/inspect/signal-manager.vala"
		folks_inspect_utils_indent ();
#line 53 "../tools/inspect/signal-manager.vala"
		_tmp3_ = hook_ids;
#line 53 "../tools/inspect/signal-manager.vala"
		folks_inspect_signal_manager_list_signals_for_type (self, class_type, _tmp3_);
#line 54 "../tools/inspect/signal-manager.vala"
		folks_inspect_utils_unindent ();
#line 43 "../tools/inspect/signal-manager.vala"
		_g_object_unref0 (hook_ids);
#line 228 "signal-manager.c"
	} else {
#line 56 "../tools/inspect/signal-manager.vala"
		if (class_instance != NULL) {
#line 232 "signal-manager.c"
			GeeHashMap* signal_handler_ids = NULL;
			GeeHashMap* _tmp4_;
			gpointer _tmp5_;
			const gchar* _tmp6_;
			GeeHashMap* _tmp7_;
#line 59 "../tools/inspect/signal-manager.vala"
			_tmp4_ = self->priv->signals_by_class_instance;
#line 59 "../tools/inspect/signal-manager.vala"
			_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, class_instance);
#line 59 "../tools/inspect/signal-manager.vala"
			signal_handler_ids = (GeeHashMap*) _tmp5_;
#line 62 "../tools/inspect/signal-manager.vala"
			_tmp6_ = g_type_name (G_TYPE_FROM_INSTANCE (class_instance));
#line 62 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Signals on instance %p of class type '%s':", class_instance, _tmp6_);
#line 64 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_indent ();
#line 65 "../tools/inspect/signal-manager.vala"
			_tmp7_ = signal_handler_ids;
#line 65 "../tools/inspect/signal-manager.vala"
			folks_inspect_signal_manager_list_signals_for_type (self, G_TYPE_FROM_INSTANCE (class_instance), _tmp7_);
#line 67 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_unindent ();
#line 56 "../tools/inspect/signal-manager.vala"
			_g_object_unref0 (signal_handler_ids);
#line 258 "signal-manager.c"
		} else {
			GeeMapIterator* class_type_iter = NULL;
			GeeHashMap* _tmp8_;
			GeeMapIterator* _tmp9_;
			GeeMapIterator* class_instance_iter = NULL;
			GeeHashMap* _tmp24_;
			GeeMapIterator* _tmp25_;
#line 72 "../tools/inspect/signal-manager.vala"
			_tmp8_ = self->priv->signals_by_class_type;
#line 72 "../tools/inspect/signal-manager.vala"
			_tmp9_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp8_);
#line 72 "../tools/inspect/signal-manager.vala"
			class_type_iter = _tmp9_;
#line 75 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Connected signals on all instances of classes:");
#line 77 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_indent ();
#line 78 "../tools/inspect/signal-manager.vala"
			while (TRUE) {
#line 278 "signal-manager.c"
				GeeMapIterator* _tmp10_;
				GeeHashMap* hook_ids = NULL;
				GeeMapIterator* _tmp11_;
				gpointer _tmp12_;
				GeeMapIterator* hook_iter = NULL;
				GeeHashMap* _tmp13_;
				GeeMapIterator* _tmp14_;
				gchar* class_name = NULL;
				GeeMapIterator* _tmp15_;
				gpointer _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 78 "../tools/inspect/signal-manager.vala"
				_tmp10_ = class_type_iter;
#line 78 "../tools/inspect/signal-manager.vala"
				if (!(gee_map_iterator_next (_tmp10_) == TRUE)) {
#line 78 "../tools/inspect/signal-manager.vala"
					break;
#line 297 "signal-manager.c"
				}
#line 80 "../tools/inspect/signal-manager.vala"
				_tmp11_ = class_type_iter;
#line 80 "../tools/inspect/signal-manager.vala"
				_tmp12_ = gee_map_iterator_get_value (_tmp11_);
#line 80 "../tools/inspect/signal-manager.vala"
				hook_ids = (GeeHashMap*) _tmp12_;
#line 81 "../tools/inspect/signal-manager.vala"
				_tmp13_ = hook_ids;
#line 81 "../tools/inspect/signal-manager.vala"
				_tmp14_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp13_);
#line 81 "../tools/inspect/signal-manager.vala"
				hook_iter = _tmp14_;
#line 83 "../tools/inspect/signal-manager.vala"
				_tmp15_ = class_type_iter;
#line 83 "../tools/inspect/signal-manager.vala"
				_tmp16_ = gee_map_iterator_get_key (_tmp15_);
#line 83 "../tools/inspect/signal-manager.vala"
				_tmp17_ = g_type_name ((GType) ((gintptr) _tmp16_));
#line 83 "../tools/inspect/signal-manager.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 83 "../tools/inspect/signal-manager.vala"
				class_name = _tmp18_;
#line 84 "../tools/inspect/signal-manager.vala"
				while (TRUE) {
#line 323 "signal-manager.c"
					GeeMapIterator* _tmp19_;
					const gchar* _tmp20_;
					GeeMapIterator* _tmp21_;
					gpointer _tmp22_;
					const gchar* _tmp23_;
#line 84 "../tools/inspect/signal-manager.vala"
					_tmp19_ = hook_iter;
#line 84 "../tools/inspect/signal-manager.vala"
					if (!(gee_map_iterator_next (_tmp19_) == TRUE)) {
#line 84 "../tools/inspect/signal-manager.vala"
						break;
#line 335 "signal-manager.c"
					}
#line 86 "../tools/inspect/signal-manager.vala"
					_tmp20_ = class_name;
#line 86 "../tools/inspect/signal-manager.vala"
					_tmp21_ = hook_iter;
#line 86 "../tools/inspect/signal-manager.vala"
					_tmp22_ = gee_map_iterator_get_key (_tmp21_);
#line 86 "../tools/inspect/signal-manager.vala"
					_tmp23_ = g_signal_name ((guint) ((guintptr) _tmp22_));
#line 86 "../tools/inspect/signal-manager.vala"
					folks_inspect_utils_print_line ("%s::%s — connected", _tmp20_, _tmp23_);
#line 347 "signal-manager.c"
				}
#line 78 "../tools/inspect/signal-manager.vala"
				_g_free0 (class_name);
#line 78 "../tools/inspect/signal-manager.vala"
				_g_object_unref0 (hook_iter);
#line 78 "../tools/inspect/signal-manager.vala"
				_g_object_unref0 (hook_ids);
#line 355 "signal-manager.c"
			}
#line 90 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_unindent ();
#line 92 "../tools/inspect/signal-manager.vala"
			_tmp24_ = self->priv->signals_by_class_instance;
#line 92 "../tools/inspect/signal-manager.vala"
			_tmp25_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp24_);
#line 92 "../tools/inspect/signal-manager.vala"
			class_instance_iter = _tmp25_;
#line 95 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("%s", "Connected signals on specific instances of " "classes:");
#line 98 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_indent ();
#line 99 "../tools/inspect/signal-manager.vala"
			while (TRUE) {
#line 371 "signal-manager.c"
				GeeMapIterator* _tmp26_;
				GeeHashMap* signal_handler_ids = NULL;
				GeeMapIterator* _tmp27_;
				gpointer _tmp28_;
				GeeMapIterator* signal_handler_iter = NULL;
				GeeHashMap* _tmp29_;
				GeeMapIterator* _tmp30_;
				gchar* class_name = NULL;
				GeeMapIterator* _tmp31_;
				gpointer _tmp32_;
				GObject* _tmp33_;
				const gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
#line 99 "../tools/inspect/signal-manager.vala"
				_tmp26_ = class_instance_iter;
#line 99 "../tools/inspect/signal-manager.vala"
				if (!(gee_map_iterator_next (_tmp26_) == TRUE)) {
#line 99 "../tools/inspect/signal-manager.vala"
					break;
#line 392 "signal-manager.c"
				}
#line 101 "../tools/inspect/signal-manager.vala"
				_tmp27_ = class_instance_iter;
#line 101 "../tools/inspect/signal-manager.vala"
				_tmp28_ = gee_map_iterator_get_value (_tmp27_);
#line 101 "../tools/inspect/signal-manager.vala"
				signal_handler_ids = (GeeHashMap*) _tmp28_;
#line 103 "../tools/inspect/signal-manager.vala"
				_tmp29_ = signal_handler_ids;
#line 103 "../tools/inspect/signal-manager.vala"
				_tmp30_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp29_);
#line 103 "../tools/inspect/signal-manager.vala"
				signal_handler_iter = _tmp30_;
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp31_ = class_instance_iter;
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp32_ = gee_map_iterator_get_key (_tmp31_);
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp33_ = (GObject*) _tmp32_;
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp34_ = g_type_name (G_TYPE_FROM_INSTANCE (_tmp33_));
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp35_ = g_strdup (_tmp34_);
#line 106 "../tools/inspect/signal-manager.vala"
				_tmp36_ = _tmp35_;
#line 106 "../tools/inspect/signal-manager.vala"
				_g_object_unref0 (_tmp33_);
#line 106 "../tools/inspect/signal-manager.vala"
				class_name = _tmp36_;
#line 108 "../tools/inspect/signal-manager.vala"
				while (TRUE) {
#line 424 "signal-manager.c"
					GeeMapIterator* _tmp37_;
					const gchar* _tmp38_;
					GeeMapIterator* _tmp39_;
					gpointer _tmp40_;
					const gchar* _tmp41_;
#line 108 "../tools/inspect/signal-manager.vala"
					_tmp37_ = signal_handler_iter;
#line 108 "../tools/inspect/signal-manager.vala"
					if (!(gee_map_iterator_next (_tmp37_) == TRUE)) {
#line 108 "../tools/inspect/signal-manager.vala"
						break;
#line 436 "signal-manager.c"
					}
#line 110 "../tools/inspect/signal-manager.vala"
					_tmp38_ = class_name;
#line 110 "../tools/inspect/signal-manager.vala"
					_tmp39_ = signal_handler_iter;
#line 110 "../tools/inspect/signal-manager.vala"
					_tmp40_ = gee_map_iterator_get_key (_tmp39_);
#line 110 "../tools/inspect/signal-manager.vala"
					_tmp41_ = g_signal_name ((guint) ((guintptr) _tmp40_));
#line 110 "../tools/inspect/signal-manager.vala"
					folks_inspect_utils_print_line ("%s::%s — connected", _tmp38_, _tmp41_);
#line 448 "signal-manager.c"
				}
#line 99 "../tools/inspect/signal-manager.vala"
				_g_free0 (class_name);
#line 99 "../tools/inspect/signal-manager.vala"
				_g_object_unref0 (signal_handler_iter);
#line 99 "../tools/inspect/signal-manager.vala"
				_g_object_unref0 (signal_handler_ids);
#line 456 "signal-manager.c"
			}
#line 114 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_unindent ();
#line 56 "../tools/inspect/signal-manager.vala"
			_g_object_unref0 (class_instance_iter);
#line 56 "../tools/inspect/signal-manager.vala"
			_g_object_unref0 (class_type_iter);
#line 464 "signal-manager.c"
		}
	}
}

void
folks_inspect_signal_manager_show_signal_details (FolksInspectSignalManager* self,
                                                  GType class_type,
                                                  const gchar* signal_name,
                                                  const gchar* detail_string)
{
	guint signal_id = 0U;
	GSignalQuery query_info = {0};
	GSignalQuery _tmp1_ = {0};
	GSignalQuery _tmp2_;
	GSignalQuery _tmp3_;
	const gchar* _tmp4_;
	GSignalQuery _tmp5_;
	const gchar* _tmp6_;
	GSignalQuery _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GSignalQuery _tmp10_;
	const gchar* _tmp11_;
#line 118 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (self != NULL);
#line 122 "../tools/inspect/signal-manager.vala"
	signal_id = g_signal_lookup (signal_name, class_type);
#line 123 "../tools/inspect/signal-manager.vala"
	if (signal_id == ((guint) 0)) {
#line 494 "signal-manager.c"
		const gchar* _tmp0_;
#line 125 "../tools/inspect/signal-manager.vala"
		_tmp0_ = g_type_name (class_type);
#line 125 "../tools/inspect/signal-manager.vala"
		folks_inspect_utils_print_line ("Unrecognised signal name '%s' on class '%s'.", signal_name, _tmp0_);
#line 127 "../tools/inspect/signal-manager.vala"
		return;
#line 502 "signal-manager.c"
	}
#line 132 "../tools/inspect/signal-manager.vala"
	g_signal_query (signal_id, &_tmp1_);
#line 132 "../tools/inspect/signal-manager.vala"
	query_info = _tmp1_;
#line 135 "../tools/inspect/signal-manager.vala"
	_tmp2_ = query_info;
#line 135 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Signal ID        %u", _tmp2_.signal_id);
#line 136 "../tools/inspect/signal-manager.vala"
	_tmp3_ = query_info;
#line 136 "../tools/inspect/signal-manager.vala"
	_tmp4_ = _tmp3_.signal_name;
#line 136 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Signal name      %s", _tmp4_);
#line 137 "../tools/inspect/signal-manager.vala"
	_tmp5_ = query_info;
#line 137 "../tools/inspect/signal-manager.vala"
	_tmp6_ = g_type_name (_tmp5_.itype);
#line 137 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Emitting type    %s", _tmp6_);
#line 138 "../tools/inspect/signal-manager.vala"
	_tmp7_ = query_info;
#line 138 "../tools/inspect/signal-manager.vala"
	_tmp8_ = folks_inspect_signal_manager_signal_flags_to_string (_tmp7_.signal_flags);
#line 138 "../tools/inspect/signal-manager.vala"
	_tmp9_ = _tmp8_;
#line 138 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Signal flags     %s", _tmp9_);
#line 138 "../tools/inspect/signal-manager.vala"
	_g_free0 (_tmp9_);
#line 140 "../tools/inspect/signal-manager.vala"
	_tmp10_ = query_info;
#line 140 "../tools/inspect/signal-manager.vala"
	_tmp11_ = g_type_name (_tmp10_.return_type);
#line 140 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Return type      %s", _tmp11_);
#line 141 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Parameter types:");
#line 142 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_indent ();
#line 544 "signal-manager.c"
	{
		guint i = 0U;
#line 143 "../tools/inspect/signal-manager.vala"
		i = (guint) 0;
#line 549 "signal-manager.c"
		{
			gboolean _tmp12_ = FALSE;
#line 143 "../tools/inspect/signal-manager.vala"
			_tmp12_ = TRUE;
#line 143 "../tools/inspect/signal-manager.vala"
			while (TRUE) {
#line 556 "signal-manager.c"
				GSignalQuery _tmp14_;
				GSignalQuery _tmp15_;
				GType* _tmp16_;
				gint _tmp16__length1;
				GType _tmp17_;
				const gchar* _tmp18_;
#line 143 "../tools/inspect/signal-manager.vala"
				if (!_tmp12_) {
#line 565 "signal-manager.c"
					guint _tmp13_;
#line 143 "../tools/inspect/signal-manager.vala"
					_tmp13_ = i;
#line 143 "../tools/inspect/signal-manager.vala"
					i = _tmp13_ + 1;
#line 571 "signal-manager.c"
				}
#line 143 "../tools/inspect/signal-manager.vala"
				_tmp12_ = FALSE;
#line 143 "../tools/inspect/signal-manager.vala"
				_tmp14_ = query_info;
#line 143 "../tools/inspect/signal-manager.vala"
				if (!(i < _tmp14_.n_params)) {
#line 143 "../tools/inspect/signal-manager.vala"
					break;
#line 581 "signal-manager.c"
				}
#line 144 "../tools/inspect/signal-manager.vala"
				_tmp15_ = query_info;
#line 144 "../tools/inspect/signal-manager.vala"
				_tmp16_ = _tmp15_.param_types;
#line 144 "../tools/inspect/signal-manager.vala"
				_tmp16__length1 = _tmp15_.n_params;
#line 144 "../tools/inspect/signal-manager.vala"
				_tmp17_ = _tmp16_[i];
#line 144 "../tools/inspect/signal-manager.vala"
				_tmp18_ = g_type_name (_tmp17_);
#line 144 "../tools/inspect/signal-manager.vala"
				folks_inspect_utils_print_line ("%-4u  %s", i, _tmp18_);
#line 595 "signal-manager.c"
			}
		}
	}
#line 145 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_unindent ();
#line 601 "signal-manager.c"
}

guint
folks_inspect_signal_manager_connect_to_signal (FolksInspectSignalManager* self,
                                                GType class_type,
                                                GObject* class_instance,
                                                const gchar* signal_name,
                                                const gchar* detail_string)
{
	gboolean _tmp0_ = FALSE;
	guint result;
#line 148 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 154 "../tools/inspect/signal-manager.vala"
	if (class_type != G_TYPE_INVALID) {
#line 154 "../tools/inspect/signal-manager.vala"
		_tmp0_ = signal_name != NULL;
#line 619 "signal-manager.c"
	} else {
#line 154 "../tools/inspect/signal-manager.vala"
		_tmp0_ = FALSE;
#line 623 "signal-manager.c"
	}
#line 154 "../tools/inspect/signal-manager.vala"
	if (_tmp0_) {
#line 627 "signal-manager.c"
		guint signal_id = 0U;
#line 157 "../tools/inspect/signal-manager.vala"
		signal_id = g_signal_lookup (signal_name, class_type);
#line 158 "../tools/inspect/signal-manager.vala"
		if (signal_id == ((guint) 0)) {
#line 633 "signal-manager.c"
			const gchar* _tmp1_;
#line 160 "../tools/inspect/signal-manager.vala"
			_tmp1_ = g_type_name (class_type);
#line 160 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Unrecognised signal name '%s' on class '%s'.", signal_name, _tmp1_);
#line 162 "../tools/inspect/signal-manager.vala"
			result = (guint) 0;
#line 162 "../tools/inspect/signal-manager.vala"
			return result;
#line 643 "signal-manager.c"
		}
#line 165 "../tools/inspect/signal-manager.vala"
		if (folks_inspect_signal_manager_add_emission_hook (self, class_type, signal_id, detail_string) == FALSE) {
#line 647 "signal-manager.c"
			const gchar* _tmp2_;
#line 168 "../tools/inspect/signal-manager.vala"
			_tmp2_ = g_type_name (class_type);
#line 168 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Not allowed to connect to signal '%s' on " "class '%s'.", signal_name, _tmp2_);
#line 170 "../tools/inspect/signal-manager.vala"
			result = (guint) 0;
#line 170 "../tools/inspect/signal-manager.vala"
			return result;
#line 657 "signal-manager.c"
		}
#line 173 "../tools/inspect/signal-manager.vala"
		result = (guint) 1;
#line 173 "../tools/inspect/signal-manager.vala"
		return result;
#line 663 "signal-manager.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 175 "../tools/inspect/signal-manager.vala"
		if (class_type != G_TYPE_INVALID) {
#line 175 "../tools/inspect/signal-manager.vala"
			_tmp3_ = signal_name == NULL;
#line 670 "signal-manager.c"
		} else {
#line 175 "../tools/inspect/signal-manager.vala"
			_tmp3_ = FALSE;
#line 674 "signal-manager.c"
		}
#line 175 "../tools/inspect/signal-manager.vala"
		if (_tmp3_) {
#line 678 "signal-manager.c"
			guint* signal_ids = NULL;
			guint _tmp4_ = 0;
			guint* _tmp5_;
			gint signal_ids_length1;
			gint _signal_ids_size_;
			guint signal_count = 0U;
			guint* _tmp6_;
			gint _tmp6__length1;
#line 178 "../tools/inspect/signal-manager.vala"
			_tmp5_ = g_signal_list_ids (class_type, &_tmp4_);
#line 178 "../tools/inspect/signal-manager.vala"
			signal_ids = _tmp5_;
#line 178 "../tools/inspect/signal-manager.vala"
			signal_ids_length1 = _tmp4_;
#line 178 "../tools/inspect/signal-manager.vala"
			_signal_ids_size_ = signal_ids_length1;
#line 179 "../tools/inspect/signal-manager.vala"
			signal_count = (guint) 0;
#line 181 "../tools/inspect/signal-manager.vala"
			_tmp6_ = signal_ids;
#line 181 "../tools/inspect/signal-manager.vala"
			_tmp6__length1 = signal_ids_length1;
#line 701 "signal-manager.c"
			{
				guint* signal_id_collection = NULL;
				gint signal_id_collection_length1 = 0;
				gint _signal_id_collection_size_ = 0;
				gint signal_id_it = 0;
#line 181 "../tools/inspect/signal-manager.vala"
				signal_id_collection = _tmp6_;
#line 181 "../tools/inspect/signal-manager.vala"
				signal_id_collection_length1 = _tmp6__length1;
#line 181 "../tools/inspect/signal-manager.vala"
				for (signal_id_it = 0; signal_id_it < signal_id_collection_length1; signal_id_it = signal_id_it + 1) {
#line 713 "signal-manager.c"
					guint signal_id = 0U;
#line 181 "../tools/inspect/signal-manager.vala"
					signal_id = signal_id_collection[signal_id_it];
#line 717 "signal-manager.c"
					{
#line 183 "../tools/inspect/signal-manager.vala"
						if (folks_inspect_signal_manager_add_emission_hook (self, class_type, signal_id, NULL) == TRUE) {
#line 721 "signal-manager.c"
							guint _tmp7_;
#line 184 "../tools/inspect/signal-manager.vala"
							_tmp7_ = signal_count;
#line 184 "../tools/inspect/signal-manager.vala"
							signal_count = _tmp7_ + 1;
#line 727 "signal-manager.c"
						}
					}
				}
			}
#line 187 "../tools/inspect/signal-manager.vala"
			result = signal_count;
#line 187 "../tools/inspect/signal-manager.vala"
			signal_ids = (g_free (signal_ids), NULL);
#line 187 "../tools/inspect/signal-manager.vala"
			return result;
#line 738 "signal-manager.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 189 "../tools/inspect/signal-manager.vala"
			if (class_instance != NULL) {
#line 189 "../tools/inspect/signal-manager.vala"
				_tmp8_ = signal_name != NULL;
#line 745 "signal-manager.c"
			} else {
#line 189 "../tools/inspect/signal-manager.vala"
				_tmp8_ = FALSE;
#line 749 "signal-manager.c"
			}
#line 189 "../tools/inspect/signal-manager.vala"
			if (_tmp8_) {
#line 753 "signal-manager.c"
				guint signal_id = 0U;
#line 192 "../tools/inspect/signal-manager.vala"
				signal_id = g_signal_lookup (signal_name, G_TYPE_FROM_INSTANCE (class_instance));
#line 194 "../tools/inspect/signal-manager.vala"
				if (signal_id == ((guint) 0)) {
#line 759 "signal-manager.c"
					const gchar* _tmp9_;
#line 196 "../tools/inspect/signal-manager.vala"
					_tmp9_ = g_type_name (G_TYPE_FROM_INSTANCE (class_instance));
#line 196 "../tools/inspect/signal-manager.vala"
					folks_inspect_utils_print_line ("Unrecognised signal name '%s' on instance " "%p of class '%s'.", signal_name, class_instance, _tmp9_);
#line 199 "../tools/inspect/signal-manager.vala"
					result = (guint) 0;
#line 199 "../tools/inspect/signal-manager.vala"
					return result;
#line 769 "signal-manager.c"
				}
#line 202 "../tools/inspect/signal-manager.vala"
				folks_inspect_signal_manager_add_signal_handler (self, class_instance, signal_id, detail_string);
#line 204 "../tools/inspect/signal-manager.vala"
				result = (guint) 1;
#line 204 "../tools/inspect/signal-manager.vala"
				return result;
#line 777 "signal-manager.c"
			} else {
				gboolean _tmp10_ = FALSE;
#line 206 "../tools/inspect/signal-manager.vala"
				if (class_instance != NULL) {
#line 206 "../tools/inspect/signal-manager.vala"
					_tmp10_ = signal_name == NULL;
#line 784 "signal-manager.c"
				} else {
#line 206 "../tools/inspect/signal-manager.vala"
					_tmp10_ = FALSE;
#line 788 "signal-manager.c"
				}
#line 206 "../tools/inspect/signal-manager.vala"
				if (_tmp10_) {
#line 792 "signal-manager.c"
					guint* signal_ids = NULL;
					guint _tmp11_ = 0;
					guint* _tmp12_;
					gint signal_ids_length1;
					gint _signal_ids_size_;
					guint signal_count = 0U;
					guint* _tmp13_;
					gint _tmp13__length1;
#line 209 "../tools/inspect/signal-manager.vala"
					_tmp12_ = g_signal_list_ids (G_TYPE_FROM_INSTANCE (class_instance), &_tmp11_);
#line 209 "../tools/inspect/signal-manager.vala"
					signal_ids = _tmp12_;
#line 209 "../tools/inspect/signal-manager.vala"
					signal_ids_length1 = _tmp11_;
#line 209 "../tools/inspect/signal-manager.vala"
					_signal_ids_size_ = signal_ids_length1;
#line 210 "../tools/inspect/signal-manager.vala"
					signal_count = (guint) 0;
#line 212 "../tools/inspect/signal-manager.vala"
					_tmp13_ = signal_ids;
#line 212 "../tools/inspect/signal-manager.vala"
					_tmp13__length1 = signal_ids_length1;
#line 815 "signal-manager.c"
					{
						guint* signal_id_collection = NULL;
						gint signal_id_collection_length1 = 0;
						gint _signal_id_collection_size_ = 0;
						gint signal_id_it = 0;
#line 212 "../tools/inspect/signal-manager.vala"
						signal_id_collection = _tmp13_;
#line 212 "../tools/inspect/signal-manager.vala"
						signal_id_collection_length1 = _tmp13__length1;
#line 212 "../tools/inspect/signal-manager.vala"
						for (signal_id_it = 0; signal_id_it < signal_id_collection_length1; signal_id_it = signal_id_it + 1) {
#line 827 "signal-manager.c"
							guint signal_id = 0U;
#line 212 "../tools/inspect/signal-manager.vala"
							signal_id = signal_id_collection[signal_id_it];
#line 831 "signal-manager.c"
							{
								guint _tmp14_;
#line 214 "../tools/inspect/signal-manager.vala"
								_tmp14_ = signal_count;
#line 214 "../tools/inspect/signal-manager.vala"
								signal_count = _tmp14_ + 1;
#line 215 "../tools/inspect/signal-manager.vala"
								folks_inspect_signal_manager_add_signal_handler (self, class_instance, signal_id, NULL);
#line 840 "signal-manager.c"
							}
						}
					}
#line 218 "../tools/inspect/signal-manager.vala"
					result = signal_count;
#line 218 "../tools/inspect/signal-manager.vala"
					signal_ids = (g_free (signal_ids), NULL);
#line 218 "../tools/inspect/signal-manager.vala"
					return result;
#line 850 "signal-manager.c"
				}
			}
		}
	}
#line 221 "../tools/inspect/signal-manager.vala"
	g_assert_not_reached ();
#line 857 "signal-manager.c"
}

guint
folks_inspect_signal_manager_disconnect_from_signal (FolksInspectSignalManager* self,
                                                     GType class_type,
                                                     GObject* class_instance,
                                                     const gchar* signal_name,
                                                     const gchar* detail_string)
{
	gboolean _tmp0_ = FALSE;
	guint result;
#line 224 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 230 "../tools/inspect/signal-manager.vala"
	if (class_type != G_TYPE_INVALID) {
#line 230 "../tools/inspect/signal-manager.vala"
		_tmp0_ = signal_name != NULL;
#line 875 "signal-manager.c"
	} else {
#line 230 "../tools/inspect/signal-manager.vala"
		_tmp0_ = FALSE;
#line 879 "signal-manager.c"
	}
#line 230 "../tools/inspect/signal-manager.vala"
	if (_tmp0_) {
#line 883 "signal-manager.c"
		guint signal_id = 0U;
#line 233 "../tools/inspect/signal-manager.vala"
		signal_id = g_signal_lookup (signal_name, class_type);
#line 234 "../tools/inspect/signal-manager.vala"
		if (signal_id == ((guint) 0)) {
#line 889 "signal-manager.c"
			const gchar* _tmp1_;
#line 236 "../tools/inspect/signal-manager.vala"
			_tmp1_ = g_type_name (class_type);
#line 236 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Unrecognised signal name '%s' on class '%s'.", signal_name, _tmp1_);
#line 238 "../tools/inspect/signal-manager.vala"
			result = (guint) 0;
#line 238 "../tools/inspect/signal-manager.vala"
			return result;
#line 899 "signal-manager.c"
		}
#line 241 "../tools/inspect/signal-manager.vala"
		if (folks_inspect_signal_manager_remove_emission_hook (self, class_type, signal_id) == FALSE) {
#line 903 "signal-manager.c"
			const gchar* _tmp2_;
#line 243 "../tools/inspect/signal-manager.vala"
			_tmp2_ = g_type_name (class_type);
#line 243 "../tools/inspect/signal-manager.vala"
			folks_inspect_utils_print_line ("Could not remove hook for signal '%s' on " "class '%s'.", signal_name, _tmp2_);
#line 245 "../tools/inspect/signal-manager.vala"
			result = (guint) 0;
#line 245 "../tools/inspect/signal-manager.vala"
			return result;
#line 913 "signal-manager.c"
		}
#line 248 "../tools/inspect/signal-manager.vala"
		result = (guint) 1;
#line 248 "../tools/inspect/signal-manager.vala"
		return result;
#line 919 "signal-manager.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 250 "../tools/inspect/signal-manager.vala"
		if (class_type != G_TYPE_INVALID) {
#line 250 "../tools/inspect/signal-manager.vala"
			_tmp3_ = signal_name == NULL;
#line 926 "signal-manager.c"
		} else {
#line 250 "../tools/inspect/signal-manager.vala"
			_tmp3_ = FALSE;
#line 930 "signal-manager.c"
		}
#line 250 "../tools/inspect/signal-manager.vala"
		if (_tmp3_) {
#line 934 "signal-manager.c"
			guint* signal_ids = NULL;
			guint _tmp4_ = 0;
			guint* _tmp5_;
			gint signal_ids_length1;
			gint _signal_ids_size_;
			guint signal_count = 0U;
			guint* _tmp6_;
			gint _tmp6__length1;
#line 253 "../tools/inspect/signal-manager.vala"
			_tmp5_ = g_signal_list_ids (class_type, &_tmp4_);
#line 253 "../tools/inspect/signal-manager.vala"
			signal_ids = _tmp5_;
#line 253 "../tools/inspect/signal-manager.vala"
			signal_ids_length1 = _tmp4_;
#line 253 "../tools/inspect/signal-manager.vala"
			_signal_ids_size_ = signal_ids_length1;
#line 254 "../tools/inspect/signal-manager.vala"
			signal_count = (guint) 0;
#line 256 "../tools/inspect/signal-manager.vala"
			_tmp6_ = signal_ids;
#line 256 "../tools/inspect/signal-manager.vala"
			_tmp6__length1 = signal_ids_length1;
#line 957 "signal-manager.c"
			{
				guint* signal_id_collection = NULL;
				gint signal_id_collection_length1 = 0;
				gint _signal_id_collection_size_ = 0;
				gint signal_id_it = 0;
#line 256 "../tools/inspect/signal-manager.vala"
				signal_id_collection = _tmp6_;
#line 256 "../tools/inspect/signal-manager.vala"
				signal_id_collection_length1 = _tmp6__length1;
#line 256 "../tools/inspect/signal-manager.vala"
				for (signal_id_it = 0; signal_id_it < signal_id_collection_length1; signal_id_it = signal_id_it + 1) {
#line 969 "signal-manager.c"
					guint signal_id = 0U;
#line 256 "../tools/inspect/signal-manager.vala"
					signal_id = signal_id_collection[signal_id_it];
#line 973 "signal-manager.c"
					{
#line 258 "../tools/inspect/signal-manager.vala"
						if (folks_inspect_signal_manager_remove_emission_hook (self, class_type, signal_id) == TRUE) {
#line 977 "signal-manager.c"
							guint _tmp7_;
#line 259 "../tools/inspect/signal-manager.vala"
							_tmp7_ = signal_count;
#line 259 "../tools/inspect/signal-manager.vala"
							signal_count = _tmp7_ - 1;
#line 983 "signal-manager.c"
						}
					}
				}
			}
#line 262 "../tools/inspect/signal-manager.vala"
			result = signal_count;
#line 262 "../tools/inspect/signal-manager.vala"
			signal_ids = (g_free (signal_ids), NULL);
#line 262 "../tools/inspect/signal-manager.vala"
			return result;
#line 994 "signal-manager.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 264 "../tools/inspect/signal-manager.vala"
			if (class_instance != NULL) {
#line 264 "../tools/inspect/signal-manager.vala"
				_tmp8_ = signal_name != NULL;
#line 1001 "signal-manager.c"
			} else {
#line 264 "../tools/inspect/signal-manager.vala"
				_tmp8_ = FALSE;
#line 1005 "signal-manager.c"
			}
#line 264 "../tools/inspect/signal-manager.vala"
			if (_tmp8_) {
#line 1009 "signal-manager.c"
				guint signal_id = 0U;
#line 267 "../tools/inspect/signal-manager.vala"
				signal_id = g_signal_lookup (signal_name, G_TYPE_FROM_INSTANCE (class_instance));
#line 269 "../tools/inspect/signal-manager.vala"
				if (signal_id == ((guint) 0)) {
#line 1015 "signal-manager.c"
					const gchar* _tmp9_;
#line 271 "../tools/inspect/signal-manager.vala"
					_tmp9_ = g_type_name (G_TYPE_FROM_INSTANCE (class_instance));
#line 271 "../tools/inspect/signal-manager.vala"
					folks_inspect_utils_print_line ("Unrecognised signal name '%s' on instance " "%p of class '%s'.", signal_name, class_instance, _tmp9_);
#line 274 "../tools/inspect/signal-manager.vala"
					result = (guint) 0;
#line 274 "../tools/inspect/signal-manager.vala"
					return result;
#line 1025 "signal-manager.c"
				}
#line 277 "../tools/inspect/signal-manager.vala"
				folks_inspect_signal_manager_remove_signal_handler (self, class_instance, signal_id);
#line 279 "../tools/inspect/signal-manager.vala"
				result = (guint) 1;
#line 279 "../tools/inspect/signal-manager.vala"
				return result;
#line 1033 "signal-manager.c"
			} else {
				gboolean _tmp10_ = FALSE;
#line 281 "../tools/inspect/signal-manager.vala"
				if (class_instance != NULL) {
#line 281 "../tools/inspect/signal-manager.vala"
					_tmp10_ = signal_name == NULL;
#line 1040 "signal-manager.c"
				} else {
#line 281 "../tools/inspect/signal-manager.vala"
					_tmp10_ = FALSE;
#line 1044 "signal-manager.c"
				}
#line 281 "../tools/inspect/signal-manager.vala"
				if (_tmp10_) {
#line 1048 "signal-manager.c"
					guint* signal_ids = NULL;
					guint _tmp11_ = 0;
					guint* _tmp12_;
					gint signal_ids_length1;
					gint _signal_ids_size_;
					guint signal_count = 0U;
					guint* _tmp13_;
					gint _tmp13__length1;
#line 284 "../tools/inspect/signal-manager.vala"
					_tmp12_ = g_signal_list_ids (G_TYPE_FROM_INSTANCE (class_instance), &_tmp11_);
#line 284 "../tools/inspect/signal-manager.vala"
					signal_ids = _tmp12_;
#line 284 "../tools/inspect/signal-manager.vala"
					signal_ids_length1 = _tmp11_;
#line 284 "../tools/inspect/signal-manager.vala"
					_signal_ids_size_ = signal_ids_length1;
#line 285 "../tools/inspect/signal-manager.vala"
					signal_count = (guint) 0;
#line 287 "../tools/inspect/signal-manager.vala"
					_tmp13_ = signal_ids;
#line 287 "../tools/inspect/signal-manager.vala"
					_tmp13__length1 = signal_ids_length1;
#line 1071 "signal-manager.c"
					{
						guint* signal_id_collection = NULL;
						gint signal_id_collection_length1 = 0;
						gint _signal_id_collection_size_ = 0;
						gint signal_id_it = 0;
#line 287 "../tools/inspect/signal-manager.vala"
						signal_id_collection = _tmp13_;
#line 287 "../tools/inspect/signal-manager.vala"
						signal_id_collection_length1 = _tmp13__length1;
#line 287 "../tools/inspect/signal-manager.vala"
						for (signal_id_it = 0; signal_id_it < signal_id_collection_length1; signal_id_it = signal_id_it + 1) {
#line 1083 "signal-manager.c"
							guint signal_id = 0U;
#line 287 "../tools/inspect/signal-manager.vala"
							signal_id = signal_id_collection[signal_id_it];
#line 1087 "signal-manager.c"
							{
#line 289 "../tools/inspect/signal-manager.vala"
								if (folks_inspect_signal_manager_remove_signal_handler (self, class_instance, signal_id)) {
#line 1091 "signal-manager.c"
									guint _tmp14_;
#line 290 "../tools/inspect/signal-manager.vala"
									_tmp14_ = signal_count;
#line 290 "../tools/inspect/signal-manager.vala"
									signal_count = _tmp14_ - 1;
#line 1097 "signal-manager.c"
								}
							}
						}
					}
#line 293 "../tools/inspect/signal-manager.vala"
					result = signal_count;
#line 293 "../tools/inspect/signal-manager.vala"
					signal_ids = (g_free (signal_ids), NULL);
#line 293 "../tools/inspect/signal-manager.vala"
					return result;
#line 1108 "signal-manager.c"
				}
			}
		}
	}
#line 296 "../tools/inspect/signal-manager.vala"
	g_assert_not_reached ();
#line 1115 "signal-manager.c"
}

static void
folks_inspect_signal_manager_list_signals_for_type (FolksInspectSignalManager* self,
                                                    GType type,
                                                    GeeHashMap* signal_id_map)
{
	guint* signal_ids = NULL;
	guint _tmp0_ = 0;
	guint* _tmp1_;
	gint signal_ids_length1;
	gint _signal_ids_size_;
	guint* _tmp2_;
	gint _tmp2__length1;
	GType* interfaces = NULL;
	guint _tmp12_ = 0;
	GType* _tmp13_;
	gint interfaces_length1;
	gint _interfaces_size_;
	GType* _tmp14_;
	gint _tmp14__length1;
	GType parent_type = 0UL;
#line 299 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (self != NULL);
#line 302 "../tools/inspect/signal-manager.vala"
	_tmp1_ = g_signal_list_ids (type, &_tmp0_);
#line 302 "../tools/inspect/signal-manager.vala"
	signal_ids = _tmp1_;
#line 302 "../tools/inspect/signal-manager.vala"
	signal_ids_length1 = _tmp0_;
#line 302 "../tools/inspect/signal-manager.vala"
	_signal_ids_size_ = signal_ids_length1;
#line 305 "../tools/inspect/signal-manager.vala"
	_tmp2_ = signal_ids;
#line 305 "../tools/inspect/signal-manager.vala"
	_tmp2__length1 = signal_ids_length1;
#line 305 "../tools/inspect/signal-manager.vala"
	if (_tmp2_ != NULL) {
#line 1154 "signal-manager.c"
		gchar* type_name = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		guint* _tmp5_;
		gint _tmp5__length1;
#line 307 "../tools/inspect/signal-manager.vala"
		_tmp3_ = g_type_name (type);
#line 307 "../tools/inspect/signal-manager.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 307 "../tools/inspect/signal-manager.vala"
		type_name = _tmp4_;
#line 308 "../tools/inspect/signal-manager.vala"
		_tmp5_ = signal_ids;
#line 308 "../tools/inspect/signal-manager.vala"
		_tmp5__length1 = signal_ids_length1;
#line 1170 "signal-manager.c"
		{
			guint* signal_id_collection = NULL;
			gint signal_id_collection_length1 = 0;
			gint _signal_id_collection_size_ = 0;
			gint signal_id_it = 0;
#line 308 "../tools/inspect/signal-manager.vala"
			signal_id_collection = _tmp5_;
#line 308 "../tools/inspect/signal-manager.vala"
			signal_id_collection_length1 = _tmp5__length1;
#line 308 "../tools/inspect/signal-manager.vala"
			for (signal_id_it = 0; signal_id_it < signal_id_collection_length1; signal_id_it = signal_id_it + 1) {
#line 1182 "signal-manager.c"
				guint signal_id = 0U;
#line 308 "../tools/inspect/signal-manager.vala"
				signal_id = signal_id_collection[signal_id_it];
#line 1186 "signal-manager.c"
				{
					const gchar* signal_name = NULL;
					const gchar* _tmp6_;
					gboolean _tmp7_ = FALSE;
#line 310 "../tools/inspect/signal-manager.vala"
					_tmp6_ = g_signal_name (signal_id);
#line 310 "../tools/inspect/signal-manager.vala"
					signal_name = _tmp6_;
#line 312 "../tools/inspect/signal-manager.vala"
					if (signal_id_map != NULL) {
#line 313 "../tools/inspect/signal-manager.vala"
						_tmp7_ = gee_abstract_map_has_key ((GeeAbstractMap*) signal_id_map, (gpointer) ((guintptr) signal_id)) == TRUE;
#line 1199 "signal-manager.c"
					} else {
#line 312 "../tools/inspect/signal-manager.vala"
						_tmp7_ = FALSE;
#line 1203 "signal-manager.c"
					}
#line 312 "../tools/inspect/signal-manager.vala"
					if (_tmp7_) {
#line 1207 "signal-manager.c"
						const gchar* _tmp8_;
						const gchar* _tmp9_;
#line 315 "../tools/inspect/signal-manager.vala"
						_tmp8_ = type_name;
#line 315 "../tools/inspect/signal-manager.vala"
						_tmp9_ = signal_name;
#line 315 "../tools/inspect/signal-manager.vala"
						folks_inspect_utils_print_line ("%s::%s — connected", _tmp8_, _tmp9_);
#line 1216 "signal-manager.c"
					} else {
						const gchar* _tmp10_;
						const gchar* _tmp11_;
#line 320 "../tools/inspect/signal-manager.vala"
						_tmp10_ = type_name;
#line 320 "../tools/inspect/signal-manager.vala"
						_tmp11_ = signal_name;
#line 320 "../tools/inspect/signal-manager.vala"
						folks_inspect_utils_print_line ("%s::%s", _tmp10_, _tmp11_);
#line 1226 "signal-manager.c"
					}
				}
			}
		}
#line 305 "../tools/inspect/signal-manager.vala"
		_g_free0 (type_name);
#line 1233 "signal-manager.c"
	}
#line 327 "../tools/inspect/signal-manager.vala"
	_tmp13_ = g_type_interfaces (type, &_tmp12_);
#line 327 "../tools/inspect/signal-manager.vala"
	interfaces = _tmp13_;
#line 327 "../tools/inspect/signal-manager.vala"
	interfaces_length1 = _tmp12_;
#line 327 "../tools/inspect/signal-manager.vala"
	_interfaces_size_ = interfaces_length1;
#line 328 "../tools/inspect/signal-manager.vala"
	_tmp14_ = interfaces;
#line 328 "../tools/inspect/signal-manager.vala"
	_tmp14__length1 = interfaces_length1;
#line 1247 "signal-manager.c"
	{
		GType* interface_type_collection = NULL;
		gint interface_type_collection_length1 = 0;
		gint _interface_type_collection_size_ = 0;
		gint interface_type_it = 0;
#line 328 "../tools/inspect/signal-manager.vala"
		interface_type_collection = _tmp14_;
#line 328 "../tools/inspect/signal-manager.vala"
		interface_type_collection_length1 = _tmp14__length1;
#line 328 "../tools/inspect/signal-manager.vala"
		for (interface_type_it = 0; interface_type_it < interface_type_collection_length1; interface_type_it = interface_type_it + 1) {
#line 1259 "signal-manager.c"
			GType interface_type = 0UL;
#line 328 "../tools/inspect/signal-manager.vala"
			interface_type = interface_type_collection[interface_type_it];
#line 1263 "signal-manager.c"
			{
#line 329 "../tools/inspect/signal-manager.vala"
				folks_inspect_signal_manager_list_signals_for_type (self, interface_type, signal_id_map);
#line 1267 "signal-manager.c"
			}
		}
	}
#line 332 "../tools/inspect/signal-manager.vala"
	parent_type = g_type_parent (type);
#line 333 "../tools/inspect/signal-manager.vala"
	if (parent_type != G_TYPE_INVALID) {
#line 334 "../tools/inspect/signal-manager.vala"
		folks_inspect_signal_manager_list_signals_for_type (self, parent_type, signal_id_map);
#line 1277 "signal-manager.c"
	}
#line 299 "../tools/inspect/signal-manager.vala"
	interfaces = (g_free (interfaces), NULL);
#line 299 "../tools/inspect/signal-manager.vala"
	signal_ids = (g_free (signal_ids), NULL);
#line 1283 "signal-manager.c"
}

static void
_folks_inspect_signal_manager_signal_meta_marshaller_gclosure_marshal (GClosure* closure,
                                                                       GValue* return_value,
                                                                       guint n_param_values,
                                                                       GValue* param_values,
                                                                       void* invocation_hint,
                                                                       void* marshal_data)
{
#line 347 "../tools/inspect/signal-manager.vala"
	folks_inspect_signal_manager_signal_meta_marshaller (closure, return_value, param_values, n_param_values, invocation_hint, marshal_data);
#line 1296 "signal-manager.c"
}

static void
folks_inspect_signal_manager_add_signal_handler (FolksInspectSignalManager* self,
                                                 GObject* class_instance,
                                                 guint signal_id,
                                                 const gchar* detail_string)
{
	GClosure* closure = NULL;
	GClosure* _tmp0_;
	GClosure* _tmp1_;
	GQuark detail_quark = 0U;
	gulong signal_handler_id = 0UL;
	GClosure* _tmp2_;
	GeeHashMap* signal_handler_ids = NULL;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp9_;
#line 342 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (self != NULL);
#line 342 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (class_instance != NULL);
#line 346 "../tools/inspect/signal-manager.vala"
	_tmp0_ = g_closure_new_object ((gulong) sizeof (GClosure), (GObject*) self);
#line 346 "../tools/inspect/signal-manager.vala"
	closure = _tmp0_;
#line 347 "../tools/inspect/signal-manager.vala"
	_tmp1_ = closure;
#line 347 "../tools/inspect/signal-manager.vala"
	g_closure_set_meta_marshal (_tmp1_, NULL, _folks_inspect_signal_manager_signal_meta_marshaller_gclosure_marshal);
#line 349 "../tools/inspect/signal-manager.vala"
	detail_quark = (GQuark) 0;
#line 350 "../tools/inspect/signal-manager.vala"
	if (detail_string != NULL) {
#line 351 "../tools/inspect/signal-manager.vala"
		detail_quark = g_quark_try_string (detail_string);
#line 1334 "signal-manager.c"
	}
#line 353 "../tools/inspect/signal-manager.vala"
	_tmp2_ = closure;
#line 353 "../tools/inspect/signal-manager.vala"
	signal_handler_id = g_signal_connect_closure_by_id (class_instance, signal_id, detail_quark, _tmp2_, FALSE);
#line 357 "../tools/inspect/signal-manager.vala"
	_tmp3_ = self->priv->signals_by_class_instance;
#line 357 "../tools/inspect/signal-manager.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, class_instance);
#line 357 "../tools/inspect/signal-manager.vala"
	signal_handler_ids = (GeeHashMap*) _tmp4_;
#line 359 "../tools/inspect/signal-manager.vala"
	_tmp5_ = signal_handler_ids;
#line 359 "../tools/inspect/signal-manager.vala"
	if (_tmp5_ == NULL) {
#line 1350 "signal-manager.c"
		GeeHashMap* _tmp6_;
		GeeHashMap* _tmp7_;
		GeeHashMap* _tmp8_;
#line 361 "../tools/inspect/signal-manager.vala"
		_tmp6_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_ULONG, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 361 "../tools/inspect/signal-manager.vala"
		_g_object_unref0 (signal_handler_ids);
#line 361 "../tools/inspect/signal-manager.vala"
		signal_handler_ids = _tmp6_;
#line 362 "../tools/inspect/signal-manager.vala"
		_tmp7_ = self->priv->signals_by_class_instance;
#line 362 "../tools/inspect/signal-manager.vala"
		_tmp8_ = signal_handler_ids;
#line 362 "../tools/inspect/signal-manager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, class_instance, _tmp8_);
#line 1366 "signal-manager.c"
	}
#line 366 "../tools/inspect/signal-manager.vala"
	_tmp9_ = signal_handler_ids;
#line 366 "../tools/inspect/signal-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((guintptr) signal_id), (gpointer) ((guintptr) signal_handler_id));
#line 342 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (signal_handler_ids);
#line 342 "../tools/inspect/signal-manager.vala"
	_g_closure_unref0 (closure);
#line 1376 "signal-manager.c"
}

static gboolean
folks_inspect_signal_manager_remove_signal_handler (FolksInspectSignalManager* self,
                                                    GObject* class_instance,
                                                    guint signal_id)
{
	GeeHashMap* signal_handler_ids = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp3_;
	gulong signal_handler_id = 0UL;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_;
	GeeHashMap* _tmp7_;
	gboolean result;
#line 369 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 369 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (class_instance != NULL, FALSE);
#line 372 "../tools/inspect/signal-manager.vala"
	_tmp0_ = self->priv->signals_by_class_instance;
#line 372 "../tools/inspect/signal-manager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, class_instance);
#line 372 "../tools/inspect/signal-manager.vala"
	signal_handler_ids = (GeeHashMap*) _tmp1_;
#line 375 "../tools/inspect/signal-manager.vala"
	_tmp3_ = signal_handler_ids;
#line 375 "../tools/inspect/signal-manager.vala"
	if (_tmp3_ == NULL) {
#line 375 "../tools/inspect/signal-manager.vala"
		_tmp2_ = TRUE;
#line 1410 "signal-manager.c"
	} else {
		GeeHashMap* _tmp4_;
#line 376 "../tools/inspect/signal-manager.vala"
		_tmp4_ = signal_handler_ids;
#line 376 "../tools/inspect/signal-manager.vala"
		_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, (gpointer) ((guintptr) signal_id)) == FALSE;
#line 1417 "signal-manager.c"
	}
#line 375 "../tools/inspect/signal-manager.vala"
	if (_tmp2_) {
#line 378 "../tools/inspect/signal-manager.vala"
		result = FALSE;
#line 378 "../tools/inspect/signal-manager.vala"
		_g_object_unref0 (signal_handler_ids);
#line 378 "../tools/inspect/signal-manager.vala"
		return result;
#line 1427 "signal-manager.c"
	}
#line 381 "../tools/inspect/signal-manager.vala"
	_tmp5_ = signal_handler_ids;
#line 381 "../tools/inspect/signal-manager.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) signal_id));
#line 381 "../tools/inspect/signal-manager.vala"
	signal_handler_id = (gulong) ((guintptr) _tmp6_);
#line 382 "../tools/inspect/signal-manager.vala"
	g_signal_handler_disconnect (class_instance, signal_handler_id);
#line 383 "../tools/inspect/signal-manager.vala"
	_tmp7_ = signal_handler_ids;
#line 383 "../tools/inspect/signal-manager.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) signal_id), NULL);
#line 385 "../tools/inspect/signal-manager.vala"
	result = TRUE;
#line 385 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (signal_handler_ids);
#line 385 "../tools/inspect/signal-manager.vala"
	return result;
#line 1447 "signal-manager.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 397 "../tools/inspect/signal-manager.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 1455 "signal-manager.c"
}

static void
folks_inspect_signal_manager_signal_meta_marshaller (GClosure* closure,
                                                     GValue** return_value,
                                                     GValue* param_values,
                                                     gint param_values_length1,
                                                     void* invocation_hint,
                                                     void* marshal_data)
{
	GValue* _vala_return_value = NULL;
	GSignalInvocationHint* hint = NULL;
	GSignalQuery query_info = {0};
	GSignalInvocationHint* _tmp0_;
	GSignalQuery _tmp1_ = {0};
	GSignalQuery _tmp2_;
	const gchar* _tmp3_;
	GSignalQuery _tmp4_;
	const gchar* _tmp5_;
	guint i = 0U;
#line 388 "../tools/inspect/signal-manager.vala"
	g_return_if_fail (closure != NULL);
#line 394 "../tools/inspect/signal-manager.vala"
	hint = (GSignalInvocationHint*) invocation_hint;
#line 397 "../tools/inspect/signal-manager.vala"
	__vala_GValue_free0 (_vala_return_value);
#line 397 "../tools/inspect/signal-manager.vala"
	_vala_return_value = NULL;
#line 400 "../tools/inspect/signal-manager.vala"
	_tmp0_ = hint;
#line 400 "../tools/inspect/signal-manager.vala"
	g_signal_query ((*_tmp0_).signal_id, &_tmp1_);
#line 400 "../tools/inspect/signal-manager.vala"
	query_info = _tmp1_;
#line 402 "../tools/inspect/signal-manager.vala"
	_tmp2_ = query_info;
#line 402 "../tools/inspect/signal-manager.vala"
	_tmp3_ = g_type_name (_tmp2_.itype);
#line 402 "../tools/inspect/signal-manager.vala"
	_tmp4_ = query_info;
#line 402 "../tools/inspect/signal-manager.vala"
	_tmp5_ = _tmp4_.signal_name;
#line 402 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Signal '%s::%s' emitted with parameters:", _tmp3_, _tmp5_);
#line 405 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_indent ();
#line 406 "../tools/inspect/signal-manager.vala"
	i = (guint) 0;
#line 1504 "signal-manager.c"
	{
		GValue* param_value_collection = NULL;
		gint param_value_collection_length1 = 0;
		gint _param_value_collection_size_ = 0;
		gint param_value_it = 0;
#line 407 "../tools/inspect/signal-manager.vala"
		param_value_collection = param_values;
#line 407 "../tools/inspect/signal-manager.vala"
		param_value_collection_length1 = param_values_length1;
#line 407 "../tools/inspect/signal-manager.vala"
		for (param_value_it = 0; param_value_it < param_value_collection_length1; param_value_it = param_value_it + 1) {
#line 1516 "signal-manager.c"
			GValue _tmp6_;
			GValue _tmp7_ = {0};
			GValue param_value = {0};
#line 407 "../tools/inspect/signal-manager.vala"
			_tmp6_ = param_value_collection[param_value_it];
#line 407 "../tools/inspect/signal-manager.vala"
			if (G_IS_VALUE (&_tmp6_)) {
#line 407 "../tools/inspect/signal-manager.vala"
				g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
#line 407 "../tools/inspect/signal-manager.vala"
				g_value_copy (&_tmp6_, &_tmp7_);
#line 1528 "signal-manager.c"
			} else {
#line 407 "../tools/inspect/signal-manager.vala"
				_tmp7_ = _tmp6_;
#line 1532 "signal-manager.c"
			}
#line 407 "../tools/inspect/signal-manager.vala"
			param_value = _tmp7_;
#line 1536 "signal-manager.c"
			{
				guint _tmp8_;
				const gchar* _tmp9_;
				GValue _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 409 "../tools/inspect/signal-manager.vala"
				_tmp8_ = i;
#line 409 "../tools/inspect/signal-manager.vala"
				i = _tmp8_ + 1;
#line 409 "../tools/inspect/signal-manager.vala"
				_tmp9_ = g_type_name (G_VALUE_TYPE (&param_value));
#line 409 "../tools/inspect/signal-manager.vala"
				_tmp10_ = param_value;
#line 409 "../tools/inspect/signal-manager.vala"
				_tmp11_ = folks_inspect_utils_transform_value_to_string (&_tmp10_);
#line 409 "../tools/inspect/signal-manager.vala"
				_tmp12_ = _tmp11_;
#line 409 "../tools/inspect/signal-manager.vala"
				folks_inspect_utils_print_line ("%-4u  %-10s  %s", _tmp8_, _tmp9_, _tmp12_);
#line 409 "../tools/inspect/signal-manager.vala"
				_g_free0 (_tmp12_);
#line 407 "../tools/inspect/signal-manager.vala"
				G_IS_VALUE (&param_value) ? (g_value_unset (&param_value), NULL) : NULL;
#line 1561 "signal-manager.c"
			}
		}
	}
#line 412 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_unindent ();
#line 388 "../tools/inspect/signal-manager.vala"
	if (return_value) {
#line 388 "../tools/inspect/signal-manager.vala"
		*return_value = _vala_return_value;
#line 1571 "signal-manager.c"
	} else {
#line 388 "../tools/inspect/signal-manager.vala"
		__vala_GValue_free0 (_vala_return_value);
#line 1575 "signal-manager.c"
	}
}

static gboolean
_folks_inspect_signal_manager_emission_hook_cb_gsignal_emission_hook (GSignalInvocationHint* ihint,
                                                                      guint n_param_values,
                                                                      GValue* param_values,
                                                                      gpointer self)
{
	gboolean result;
	result = folks_inspect_signal_manager_emission_hook_cb ((FolksInspectSignalManager*) self, ihint, param_values, n_param_values);
#line 432 "../tools/inspect/signal-manager.vala"
	return result;
#line 1589 "signal-manager.c"
}

static gboolean
folks_inspect_signal_manager_add_emission_hook (FolksInspectSignalManager* self,
                                                GType class_type,
                                                guint signal_id,
                                                const gchar* detail_string)
{
	GQuark detail_quark = 0U;
	GSignalQuery query = {0};
	GSignalQuery _tmp0_ = {0};
	GSignalQuery _tmp1_;
	gulong hook_id = 0UL;
	GeeHashMap* hook_ids = NULL;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp8_;
	gboolean result;
#line 415 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 419 "../tools/inspect/signal-manager.vala"
	detail_quark = (GQuark) 0;
#line 420 "../tools/inspect/signal-manager.vala"
	if (detail_string != NULL) {
#line 421 "../tools/inspect/signal-manager.vala"
		detail_quark = g_quark_try_string (detail_string);
#line 1617 "signal-manager.c"
	}
#line 425 "../tools/inspect/signal-manager.vala"
	g_signal_query (signal_id, &_tmp0_);
#line 425 "../tools/inspect/signal-manager.vala"
	query = _tmp0_;
#line 429 "../tools/inspect/signal-manager.vala"
	_tmp1_ = query;
#line 429 "../tools/inspect/signal-manager.vala"
	if ((_tmp1_.signal_flags & G_SIGNAL_NO_HOOKS) != 0) {
#line 430 "../tools/inspect/signal-manager.vala"
		result = FALSE;
#line 430 "../tools/inspect/signal-manager.vala"
		return result;
#line 1631 "signal-manager.c"
	}
#line 432 "../tools/inspect/signal-manager.vala"
	hook_id = g_signal_add_emission_hook (signal_id, detail_quark, _folks_inspect_signal_manager_emission_hook_cb_gsignal_emission_hook, g_object_ref (self), g_object_unref);
#line 440 "../tools/inspect/signal-manager.vala"
	_tmp2_ = self->priv->signals_by_class_type;
#line 440 "../tools/inspect/signal-manager.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) class_type));
#line 440 "../tools/inspect/signal-manager.vala"
	hook_ids = (GeeHashMap*) _tmp3_;
#line 442 "../tools/inspect/signal-manager.vala"
	_tmp4_ = hook_ids;
#line 442 "../tools/inspect/signal-manager.vala"
	if (_tmp4_ == NULL) {
#line 1645 "signal-manager.c"
		GeeHashMap* _tmp5_;
		GeeHashMap* _tmp6_;
		GeeHashMap* _tmp7_;
#line 444 "../tools/inspect/signal-manager.vala"
		_tmp5_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_ULONG, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 444 "../tools/inspect/signal-manager.vala"
		_g_object_unref0 (hook_ids);
#line 444 "../tools/inspect/signal-manager.vala"
		hook_ids = _tmp5_;
#line 445 "../tools/inspect/signal-manager.vala"
		_tmp6_ = self->priv->signals_by_class_type;
#line 445 "../tools/inspect/signal-manager.vala"
		_tmp7_ = hook_ids;
#line 445 "../tools/inspect/signal-manager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) class_type), _tmp7_);
#line 1661 "signal-manager.c"
	}
#line 448 "../tools/inspect/signal-manager.vala"
	_tmp8_ = hook_ids;
#line 448 "../tools/inspect/signal-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, (gpointer) ((guintptr) signal_id), (gpointer) ((guintptr) hook_id));
#line 450 "../tools/inspect/signal-manager.vala"
	result = TRUE;
#line 450 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (hook_ids);
#line 450 "../tools/inspect/signal-manager.vala"
	return result;
#line 1673 "signal-manager.c"
}

static gboolean
folks_inspect_signal_manager_remove_emission_hook (FolksInspectSignalManager* self,
                                                   GType class_type,
                                                   guint signal_id)
{
	GeeHashMap* hook_ids = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	GeeHashMap* _tmp3_;
	gulong hook_id = 0UL;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_;
	GeeHashMap* _tmp7_;
	gboolean result;
#line 453 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 456 "../tools/inspect/signal-manager.vala"
	_tmp0_ = self->priv->signals_by_class_type;
#line 456 "../tools/inspect/signal-manager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) class_type));
#line 456 "../tools/inspect/signal-manager.vala"
	hook_ids = (GeeHashMap*) _tmp1_;
#line 459 "../tools/inspect/signal-manager.vala"
	_tmp3_ = hook_ids;
#line 459 "../tools/inspect/signal-manager.vala"
	if (_tmp3_ == NULL) {
#line 459 "../tools/inspect/signal-manager.vala"
		_tmp2_ = TRUE;
#line 1705 "signal-manager.c"
	} else {
		GeeHashMap* _tmp4_;
#line 459 "../tools/inspect/signal-manager.vala"
		_tmp4_ = hook_ids;
#line 459 "../tools/inspect/signal-manager.vala"
		_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, (gpointer) ((guintptr) signal_id)) == FALSE;
#line 1712 "signal-manager.c"
	}
#line 459 "../tools/inspect/signal-manager.vala"
	if (_tmp2_) {
#line 460 "../tools/inspect/signal-manager.vala"
		result = FALSE;
#line 460 "../tools/inspect/signal-manager.vala"
		_g_object_unref0 (hook_ids);
#line 460 "../tools/inspect/signal-manager.vala"
		return result;
#line 1722 "signal-manager.c"
	}
#line 462 "../tools/inspect/signal-manager.vala"
	_tmp5_ = hook_ids;
#line 462 "../tools/inspect/signal-manager.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) signal_id));
#line 462 "../tools/inspect/signal-manager.vala"
	hook_id = (gulong) ((guintptr) _tmp6_);
#line 463 "../tools/inspect/signal-manager.vala"
	g_signal_remove_emission_hook (signal_id, hook_id);
#line 464 "../tools/inspect/signal-manager.vala"
	_tmp7_ = hook_ids;
#line 464 "../tools/inspect/signal-manager.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, (gpointer) ((guintptr) signal_id), NULL);
#line 466 "../tools/inspect/signal-manager.vala"
	result = TRUE;
#line 466 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (hook_ids);
#line 466 "../tools/inspect/signal-manager.vala"
	return result;
#line 1742 "signal-manager.c"
}

static gboolean
folks_inspect_signal_manager_emission_hook_cb (FolksInspectSignalManager* self,
                                               GSignalInvocationHint* hint,
                                               GValue* param_values,
                                               gint param_values_length1)
{
	GSignalQuery query_info = {0};
	GSignalInvocationHint _tmp0_;
	GSignalQuery _tmp1_ = {0};
	GSignalQuery _tmp2_;
	const gchar* _tmp3_;
	GSignalQuery _tmp4_;
	const gchar* _tmp5_;
	guint i = 0U;
	gboolean result;
#line 469 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 469 "../tools/inspect/signal-manager.vala"
	g_return_val_if_fail (hint != NULL, FALSE);
#line 473 "../tools/inspect/signal-manager.vala"
	_tmp0_ = *hint;
#line 473 "../tools/inspect/signal-manager.vala"
	g_signal_query (_tmp0_.signal_id, &_tmp1_);
#line 473 "../tools/inspect/signal-manager.vala"
	query_info = _tmp1_;
#line 475 "../tools/inspect/signal-manager.vala"
	_tmp2_ = query_info;
#line 475 "../tools/inspect/signal-manager.vala"
	_tmp3_ = g_type_name (_tmp2_.itype);
#line 475 "../tools/inspect/signal-manager.vala"
	_tmp4_ = query_info;
#line 475 "../tools/inspect/signal-manager.vala"
	_tmp5_ = _tmp4_.signal_name;
#line 475 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_print_line ("Signal '%s::%s' emitted with parameters:", _tmp3_, _tmp5_);
#line 478 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_indent ();
#line 479 "../tools/inspect/signal-manager.vala"
	i = (guint) 0;
#line 1784 "signal-manager.c"
	{
		GValue* param_value_collection = NULL;
		gint param_value_collection_length1 = 0;
		gint _param_value_collection_size_ = 0;
		gint param_value_it = 0;
#line 480 "../tools/inspect/signal-manager.vala"
		param_value_collection = param_values;
#line 480 "../tools/inspect/signal-manager.vala"
		param_value_collection_length1 = param_values_length1;
#line 480 "../tools/inspect/signal-manager.vala"
		for (param_value_it = 0; param_value_it < param_value_collection_length1; param_value_it = param_value_it + 1) {
#line 1796 "signal-manager.c"
			GValue _tmp6_;
			GValue _tmp7_ = {0};
			GValue param_value = {0};
#line 480 "../tools/inspect/signal-manager.vala"
			_tmp6_ = param_value_collection[param_value_it];
#line 480 "../tools/inspect/signal-manager.vala"
			if (G_IS_VALUE (&_tmp6_)) {
#line 480 "../tools/inspect/signal-manager.vala"
				g_value_init (&_tmp7_, G_VALUE_TYPE (&_tmp6_));
#line 480 "../tools/inspect/signal-manager.vala"
				g_value_copy (&_tmp6_, &_tmp7_);
#line 1808 "signal-manager.c"
			} else {
#line 480 "../tools/inspect/signal-manager.vala"
				_tmp7_ = _tmp6_;
#line 1812 "signal-manager.c"
			}
#line 480 "../tools/inspect/signal-manager.vala"
			param_value = _tmp7_;
#line 1816 "signal-manager.c"
			{
				guint _tmp8_;
				const gchar* _tmp9_;
				GValue _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
#line 482 "../tools/inspect/signal-manager.vala"
				_tmp8_ = i;
#line 482 "../tools/inspect/signal-manager.vala"
				i = _tmp8_ + 1;
#line 482 "../tools/inspect/signal-manager.vala"
				_tmp9_ = g_type_name (G_VALUE_TYPE (&param_value));
#line 482 "../tools/inspect/signal-manager.vala"
				_tmp10_ = param_value;
#line 482 "../tools/inspect/signal-manager.vala"
				_tmp11_ = folks_inspect_utils_transform_value_to_string (&_tmp10_);
#line 482 "../tools/inspect/signal-manager.vala"
				_tmp12_ = _tmp11_;
#line 482 "../tools/inspect/signal-manager.vala"
				folks_inspect_utils_print_line ("%-4u  %-10s  %s", _tmp8_, _tmp9_, _tmp12_);
#line 482 "../tools/inspect/signal-manager.vala"
				_g_free0 (_tmp12_);
#line 480 "../tools/inspect/signal-manager.vala"
				G_IS_VALUE (&param_value) ? (g_value_unset (&param_value), NULL) : NULL;
#line 1841 "signal-manager.c"
			}
		}
	}
#line 485 "../tools/inspect/signal-manager.vala"
	folks_inspect_utils_unindent ();
#line 487 "../tools/inspect/signal-manager.vala"
	result = TRUE;
#line 487 "../tools/inspect/signal-manager.vala"
	return result;
#line 1851 "signal-manager.c"
}

static gchar*
folks_inspect_signal_manager_signal_flags_to_string (GSignalFlags flags)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 492 "../tools/inspect/signal-manager.vala"
	_tmp0_ = g_strdup ("");
#line 492 "../tools/inspect/signal-manager.vala"
	output = _tmp0_;
#line 494 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_RUN_FIRST) != 0) {
#line 1866 "signal-manager.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 495 "../tools/inspect/signal-manager.vala"
		_tmp1_ = output;
#line 495 "../tools/inspect/signal-manager.vala"
		_tmp2_ = g_strconcat (_tmp1_, "G_SIGNAL_RUN_FIRST", NULL);
#line 495 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 495 "../tools/inspect/signal-manager.vala"
		output = _tmp2_;
#line 1877 "signal-manager.c"
	}
#line 496 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_RUN_LAST) != 0) {
#line 1881 "signal-manager.c"
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 497 "../tools/inspect/signal-manager.vala"
		_tmp4_ = output;
#line 497 "../tools/inspect/signal-manager.vala"
		if (g_strcmp0 (_tmp4_, "") != 0) {
#line 497 "../tools/inspect/signal-manager.vala"
			_tmp3_ = " | ";
#line 1894 "signal-manager.c"
		} else {
#line 497 "../tools/inspect/signal-manager.vala"
			_tmp3_ = "";
#line 1898 "signal-manager.c"
		}
#line 497 "../tools/inspect/signal-manager.vala"
		_tmp5_ = output;
#line 497 "../tools/inspect/signal-manager.vala"
		_tmp6_ = g_strconcat (_tmp3_, "G_SIGNAL_RUN_LAST", NULL);
#line 497 "../tools/inspect/signal-manager.vala"
		_tmp7_ = _tmp6_;
#line 497 "../tools/inspect/signal-manager.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 497 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 497 "../tools/inspect/signal-manager.vala"
		output = _tmp8_;
#line 497 "../tools/inspect/signal-manager.vala"
		_g_free0 (_tmp7_);
#line 1914 "signal-manager.c"
	}
#line 498 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_RUN_CLEANUP) != 0) {
#line 1918 "signal-manager.c"
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 499 "../tools/inspect/signal-manager.vala"
		_tmp10_ = output;
#line 499 "../tools/inspect/signal-manager.vala"
		if (g_strcmp0 (_tmp10_, "") != 0) {
#line 499 "../tools/inspect/signal-manager.vala"
			_tmp9_ = " | ";
#line 1931 "signal-manager.c"
		} else {
#line 499 "../tools/inspect/signal-manager.vala"
			_tmp9_ = "";
#line 1935 "signal-manager.c"
		}
#line 499 "../tools/inspect/signal-manager.vala"
		_tmp11_ = output;
#line 499 "../tools/inspect/signal-manager.vala"
		_tmp12_ = g_strconcat (_tmp9_, "G_SIGNAL_RUN_CLEANUP", NULL);
#line 499 "../tools/inspect/signal-manager.vala"
		_tmp13_ = _tmp12_;
#line 499 "../tools/inspect/signal-manager.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 499 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 499 "../tools/inspect/signal-manager.vala"
		output = _tmp14_;
#line 499 "../tools/inspect/signal-manager.vala"
		_g_free0 (_tmp13_);
#line 1951 "signal-manager.c"
	}
#line 500 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_DETAILED) != 0) {
#line 1955 "signal-manager.c"
		const gchar* _tmp15_ = NULL;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 501 "../tools/inspect/signal-manager.vala"
		_tmp16_ = output;
#line 501 "../tools/inspect/signal-manager.vala"
		if (g_strcmp0 (_tmp16_, "") != 0) {
#line 501 "../tools/inspect/signal-manager.vala"
			_tmp15_ = " | ";
#line 1968 "signal-manager.c"
		} else {
#line 501 "../tools/inspect/signal-manager.vala"
			_tmp15_ = "";
#line 1972 "signal-manager.c"
		}
#line 501 "../tools/inspect/signal-manager.vala"
		_tmp17_ = output;
#line 501 "../tools/inspect/signal-manager.vala"
		_tmp18_ = g_strconcat (_tmp15_, "G_SIGNAL_DETAILED", NULL);
#line 501 "../tools/inspect/signal-manager.vala"
		_tmp19_ = _tmp18_;
#line 501 "../tools/inspect/signal-manager.vala"
		_tmp20_ = g_strconcat (_tmp17_, _tmp19_, NULL);
#line 501 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 501 "../tools/inspect/signal-manager.vala"
		output = _tmp20_;
#line 501 "../tools/inspect/signal-manager.vala"
		_g_free0 (_tmp19_);
#line 1988 "signal-manager.c"
	}
#line 502 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_ACTION) != 0) {
#line 1992 "signal-manager.c"
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 503 "../tools/inspect/signal-manager.vala"
		_tmp22_ = output;
#line 503 "../tools/inspect/signal-manager.vala"
		if (g_strcmp0 (_tmp22_, "") != 0) {
#line 503 "../tools/inspect/signal-manager.vala"
			_tmp21_ = " | ";
#line 2005 "signal-manager.c"
		} else {
#line 503 "../tools/inspect/signal-manager.vala"
			_tmp21_ = "";
#line 2009 "signal-manager.c"
		}
#line 503 "../tools/inspect/signal-manager.vala"
		_tmp23_ = output;
#line 503 "../tools/inspect/signal-manager.vala"
		_tmp24_ = g_strconcat (_tmp21_, "G_SIGNAL_ACTION", NULL);
#line 503 "../tools/inspect/signal-manager.vala"
		_tmp25_ = _tmp24_;
#line 503 "../tools/inspect/signal-manager.vala"
		_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 503 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 503 "../tools/inspect/signal-manager.vala"
		output = _tmp26_;
#line 503 "../tools/inspect/signal-manager.vala"
		_g_free0 (_tmp25_);
#line 2025 "signal-manager.c"
	}
#line 504 "../tools/inspect/signal-manager.vala"
	if ((flags & G_SIGNAL_NO_HOOKS) != 0) {
#line 2029 "signal-manager.c"
		const gchar* _tmp27_ = NULL;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 505 "../tools/inspect/signal-manager.vala"
		_tmp28_ = output;
#line 505 "../tools/inspect/signal-manager.vala"
		if (g_strcmp0 (_tmp28_, "") != 0) {
#line 505 "../tools/inspect/signal-manager.vala"
			_tmp27_ = " | ";
#line 2042 "signal-manager.c"
		} else {
#line 505 "../tools/inspect/signal-manager.vala"
			_tmp27_ = "";
#line 2046 "signal-manager.c"
		}
#line 505 "../tools/inspect/signal-manager.vala"
		_tmp29_ = output;
#line 505 "../tools/inspect/signal-manager.vala"
		_tmp30_ = g_strconcat (_tmp27_, "G_SIGNAL_NO_HOOKS", NULL);
#line 505 "../tools/inspect/signal-manager.vala"
		_tmp31_ = _tmp30_;
#line 505 "../tools/inspect/signal-manager.vala"
		_tmp32_ = g_strconcat (_tmp29_, _tmp31_, NULL);
#line 505 "../tools/inspect/signal-manager.vala"
		_g_free0 (output);
#line 505 "../tools/inspect/signal-manager.vala"
		output = _tmp32_;
#line 505 "../tools/inspect/signal-manager.vala"
		_g_free0 (_tmp31_);
#line 2062 "signal-manager.c"
	}
#line 507 "../tools/inspect/signal-manager.vala"
	result = output;
#line 507 "../tools/inspect/signal-manager.vala"
	return result;
#line 2068 "signal-manager.c"
}

static void
folks_inspect_signal_manager_class_init (FolksInspectSignalManagerClass * klass,
                                         gpointer klass_data)
{
#line 25 "../tools/inspect/signal-manager.vala"
	folks_inspect_signal_manager_parent_class = g_type_class_peek_parent (klass);
#line 25 "../tools/inspect/signal-manager.vala"
	g_type_class_adjust_private_offset (klass, &FolksInspectSignalManager_private_offset);
#line 25 "../tools/inspect/signal-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_inspect_signal_manager_finalize;
#line 2081 "signal-manager.c"
}

static void
folks_inspect_signal_manager_instance_init (FolksInspectSignalManager * self,
                                            gpointer klass)
{
#line 25 "../tools/inspect/signal-manager.vala"
	self->priv = folks_inspect_signal_manager_get_instance_private (self);
#line 2090 "signal-manager.c"
}

static void
folks_inspect_signal_manager_finalize (GObject * obj)
{
	FolksInspectSignalManager * self;
#line 25 "../tools/inspect/signal-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_INSPECT_TYPE_SIGNAL_MANAGER, FolksInspectSignalManager);
#line 28 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (self->priv->signals_by_class_type);
#line 30 "../tools/inspect/signal-manager.vala"
	_g_object_unref0 (self->priv->signals_by_class_instance);
#line 25 "../tools/inspect/signal-manager.vala"
	G_OBJECT_CLASS (folks_inspect_signal_manager_parent_class)->finalize (obj);
#line 2105 "signal-manager.c"
}

static GType
folks_inspect_signal_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksInspectSignalManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_inspect_signal_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksInspectSignalManager), 0, (GInstanceInitFunc) folks_inspect_signal_manager_instance_init, NULL };
	GType folks_inspect_signal_manager_type_id;
	folks_inspect_signal_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksInspectSignalManager", &g_define_type_info, 0);
	FolksInspectSignalManager_private_offset = g_type_add_instance_private (folks_inspect_signal_manager_type_id, sizeof (FolksInspectSignalManagerPrivate));
	return folks_inspect_signal_manager_type_id;
}

GType
folks_inspect_signal_manager_get_type (void)
{
	static volatile gsize folks_inspect_signal_manager_type_id__once = 0;
	if (g_once_init_enter (&folks_inspect_signal_manager_type_id__once)) {
		GType folks_inspect_signal_manager_type_id;
		folks_inspect_signal_manager_type_id = folks_inspect_signal_manager_get_type_once ();
		g_once_init_leave (&folks_inspect_signal_manager_type_id__once, folks_inspect_signal_manager_type_id);
	}
	return folks_inspect_signal_manager_type_id__once;
}

