/* individual-aggregator.c generated by valac 0.56.16, the Vala compiler
 * generated from individual-aggregator.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 * Copyright (C) 2012, 2013 Philip Withnall
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "folks/small-set.h"
#include <gio/gio.h>
#include "folks-internal.h"
#include <glib/gi18n-lib.h>
#include "folks/small-set-internal.h"
#include "config.h"

#define FOLKS_INDIVIDUAL_AGGREGATOR__FOLKS_GSETTINGS_SCHEMA "org.freedesktop.folks"
#define FOLKS_INDIVIDUAL_AGGREGATOR__PRIMARY_STORE_CONFIG_KEY "primary-store"
#define FOLKS_INDIVIDUAL_AGGREGATOR__QUIESCENT_TIMEOUT ((guint) 30)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_INDIVIDUAL_AGGREGATOR_0_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_IS_PREPARED_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_IS_QUIESCENT_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_PRIMARY_STORE_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY,
	FOLKS_INDIVIDUAL_AGGREGATOR_NUM_PROPERTIES
};
static GParamSpec* folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksIndividualAggregatorPrepareData FolksIndividualAggregatorPrepareData;
typedef struct _FolksIndividualAggregatorUnprepareData FolksIndividualAggregatorUnprepareData;
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _FolksIndividualAggregatorAddPersonaFromDetailsData FolksIndividualAggregatorAddPersonaFromDetailsData;
typedef struct _Block6Data Block6Data;
typedef struct _FolksIndividualAggregatorRemoveIndividualData FolksIndividualAggregatorRemoveIndividualData;
typedef struct _FolksIndividualAggregatorRemovePersonaData FolksIndividualAggregatorRemovePersonaData;
typedef struct _FolksIndividualAggregatorLinkPersonasData FolksIndividualAggregatorLinkPersonasData;
typedef struct _FolksIndividualAggregatorUnlinkIndividualData FolksIndividualAggregatorUnlinkIndividualData;
typedef struct _FolksIndividualAggregatorEnsureIndividualPropertyWriteableData FolksIndividualAggregatorEnsureIndividualPropertyWriteableData;
typedef struct _FolksIndividualAggregatorEnsurePersonasPropertyWriteableData FolksIndividualAggregatorEnsurePersonasPropertyWriteableData;
typedef struct _FolksIndividualAggregatorLookUpIndividualData FolksIndividualAggregatorLookUpIndividualData;
enum  {
	FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_SIGNAL,
	FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_DETAILED_SIGNAL,
	FOLKS_INDIVIDUAL_AGGREGATOR_NUM_SIGNALS
};
static guint folks_individual_aggregator_signals[FOLKS_INDIVIDUAL_AGGREGATOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

/**
 * Errors from {@link IndividualAggregator}s.
 */
struct _FolksIndividualAggregatorPrivate {
	FolksBackendStore* _backend_store;
	GeeHashMap* _stores;
	FolksPersonaStore* _primary_store;
	FolksSmallSet* _backends;
	GSettings* _primary_store_setting;
	GHashTable* _link_map;
	gboolean _linking_enabled;
	gboolean _is_prepared;
	gboolean _prepare_pending;
	FolksDebug* _debug;
	gchar* _configured_primary_store_type_id;
	gchar* _configured_primary_store_id;
	guint _non_quiescent_persona_store_count;
	guint _non_quiescent_backend_count;
	gboolean _is_quiescent;
	guint _quiescent_timeout_id;
	gboolean _user_configured_primary_store;
	GeeMap* _individuals;
	GeeMap* _individuals_ro;
	FolksIndividual* _user;
};

struct _FolksIndividualAggregatorPrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	gboolean _tmp1_;
	guint _tmp2_;
	FolksBackendStore* _tmp3_;
	GeeCollection* backends;
	FolksBackendStore* _tmp4_;
	GeeMap* _tmp5_;
	GeeMap* _tmp6_;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
	GeeIterator* _backend_it;
	GeeCollection* _tmp9_;
	GeeIterator* _tmp10_;
	GeeIterator* _tmp11_;
	FolksBackend* backend;
	GeeIterator* _tmp12_;
	gpointer _tmp13_;
	FolksBackendStore* _tmp14_;
	FolksBackend* _tmp15_;
	FolksBackendStore* _tmp16_;
	guint _tmp17_;
	GError* _inner_error1_;
	FolksInternalProfileBlock* _tmp18_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorUnprepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	gboolean _tmp0_;
	GeeIterator* _p_it;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeIterator* _tmp5_;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	FolksPersonaStore* p;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	FolksPersonaStore* _tmp10_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	FolksIndividualAggregator* self;
	gchar* store_id;
	FolksPersonaStore* store;
};

struct _Block3Data {
	int _ref_count_;
	FolksIndividualAggregator* self;
	FolksPersona* persona;
	GeeHashSet* candidate_inds;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	const gchar* prop_name;
};

struct _Block5Data {
	int _ref_count_;
	FolksIndividualAggregator* self;
	FolksIndividual* individual;
};

struct _FolksIndividualAggregatorAddPersonaFromDetailsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksIndividual* parent;
	FolksPersonaStore* persona_store;
	GHashTable* details;
	FolksPersona* result;
	FolksPersona* persona;
	GHashTable* details_copy;
	GHashTable* _tmp0_;
	FolksPersona* _tmp1_;
	GHashTable* _tmp2_;
	FolksPersona* _tmp3_;
	FolksPersona* _tmp4_;
	GError* e;
	GError* _tmp5_;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _tmp8_;
	gchar* full_id;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	GError* _tmp15_;
	const gchar* _tmp16_;
	GError* _tmp17_;
	gboolean _tmp18_;
	FolksPersona* _tmp19_;
	GeeSet* _tmp20_;
	GeeSet* _tmp21_;
	FolksPersona* _tmp22_;
	GError* _inner_error0_;
};

struct _Block6Data {
	int _ref_count_;
	FolksIndividualAggregator* self;
	GHashTable* retval;
};

struct _FolksIndividualAggregatorRemoveIndividualData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksIndividual* individual;
	FolksSmallSet* personas;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	FolksSmallSet* _tmp2_;
	FolksSmallSet* _persona_list;
	FolksSmallSet* _tmp3_;
	gint _persona_size;
	FolksSmallSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _persona_index;
	gint _tmp7_;
	gint _tmp8_;
	FolksPersona* persona;
	FolksSmallSet* _tmp9_;
	gconstpointer _tmp10_;
	FolksPersona* _tmp11_;
	FolksPersona* _tmp12_;
	FolksPersonaStore* _tmp13_;
	FolksPersonaStore* _tmp14_;
	FolksPersona* _tmp15_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorRemovePersonaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksPersona* persona;
	FolksPersonaStore* _tmp0_;
	FolksPersonaStore* _tmp1_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorLinkPersonasData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	GeeSet* personas;
	FolksPersonaStore* key_file_store;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	FolksPersonaStore* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeIterator* _p_it;
	GeeIterator* _tmp5_;
	GeeIterator* _tmp6_;
	FolksPersona* p;
	GeeIterator* _tmp7_;
	gpointer _tmp8_;
	FolksAntiLinkable* al;
	FolksPersona* _tmp9_;
	FolksAntiLinkable* _tmp10_;
	FolksAntiLinkable* _tmp11_;
	FolksAntiLinkable* _tmp12_;
	GError* _tmp13_;
	GHashTable* details;
	GHashTable* _tmp14_;
	FolksPersonaStore* _tmp15_;
	GHashTable* _tmp16_;
	FolksPersona* _tmp17_;
	FolksPersona* _tmp18_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorUnlinkIndividualData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksIndividual* individual;
	FolksPersonaStore* key_file_store;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	FolksSmallSet* individual_personas;
	GeeSet* _tmp6_;
	GeeSet* _tmp7_;
	FolksSmallSet* _tmp8_;
	FolksSmallSet* key_file_personas;
	FolksSmallSet* _tmp9_;
	FolksSmallSet* _p_list;
	FolksSmallSet* _tmp10_;
	gint _p_size;
	FolksSmallSet* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _p_index;
	gint _tmp14_;
	gint _tmp15_;
	FolksPersona* p;
	FolksSmallSet* _tmp16_;
	gconstpointer _tmp17_;
	FolksPersona* _tmp18_;
	FolksPersona* _tmp19_;
	FolksPersonaStore* _tmp20_;
	FolksPersonaStore* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	FolksSmallSet* _tmp24_;
	FolksPersona* _tmp25_;
	FolksSmallSet* _tmp26_;
	FolksPersona* _tmp27_;
	FolksPersona* _tmp28_;
	FolksPersonaStore* _tmp29_;
	FolksPersonaStore* _tmp30_;
	FolksPersona* _tmp31_;
	FolksSmallSet* _vala1__p_list;
	FolksSmallSet* _tmp32_;
	gint _vala1__p_size;
	FolksSmallSet* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	gint _vala1__p_index;
	gint _tmp36_;
	gint _tmp37_;
	FolksPersona* _vala1_p;
	FolksSmallSet* _tmp38_;
	gconstpointer _tmp39_;
	FolksPersona* _tmp40_;
	FolksAntiLinkable* al;
	FolksPersona* _tmp41_;
	FolksAntiLinkable* _tmp42_;
	FolksAntiLinkable* _tmp43_;
	FolksAntiLinkable* _tmp44_;
	FolksSmallSet* _tmp45_;
	FolksSmallSet* _pers_list;
	FolksSmallSet* _tmp46_;
	gint _pers_size;
	FolksSmallSet* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint _pers_index;
	gint _tmp50_;
	gint _tmp51_;
	FolksPersona* pers;
	FolksSmallSet* _tmp52_;
	gconstpointer _tmp53_;
	FolksPersona* _tmp54_;
	FolksPersona* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	FolksPersona* _tmp58_;
	FolksPersona* writeable_persona;
	FolksPersona* _tmp59_;
	FolksPersonaStore* _tmp60_;
	FolksSmallSet* personas;
	FolksSmallSet* _tmp61_;
	FolksSmallSet* _tmp62_;
	FolksPersona* _tmp63_;
	GHashTable* details;
	FolksSmallSet* _tmp64_;
	GHashTable* _tmp65_;
	FolksPersona* _tmp66_;
	FolksPersonaStore* _tmp67_;
	GHashTable* _tmp68_;
	FolksPersona* _tmp69_;
	FolksPersona* _tmp70_;
	FolksPersona* _tmp71_;
	FolksPersona* _tmp72_;
	FolksSmallSet* anti_link_personas;
	FolksSmallSet* _tmp73_;
	FolksSmallSet* _tmp74_;
	FolksSmallSet* _tmp75_;
	FolksPersona* _tmp76_;
	FolksAntiLinkable* _vala1_al;
	FolksPersona* _tmp77_;
	FolksAntiLinkable* _tmp78_;
	FolksAntiLinkable* _tmp79_;
	FolksAntiLinkable* _tmp80_;
	FolksSmallSet* _tmp81_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorEnsureIndividualPropertyWriteableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	FolksIndividual* individual;
	gchar* property_name;
	FolksPersona* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FolksPersona* p;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	FolksPersona* _tmp4_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorEnsurePersonasPropertyWriteableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	GeeSet* personas;
	gchar* property_name;
	FolksPersona* result;
	GeeIterator* _p1_it;
	GeeIterator* _tmp0_;
	GeeIterator* _tmp1_;
	FolksPersona* p1;
	GeeIterator* _tmp2_;
	gpointer _tmp3_;
	FolksPersona* _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	FolksPersona* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GHashTable* details;
	GHashTable* _tmp11_;
	FolksPersona* new_persona;
	gboolean _tmp12_;
	FolksPersonaStore* _tmp13_;
	FolksPersonaStore* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gint _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	FolksPersona* _tmp18_;
	FolksPersonaStore* _tmp19_;
	GHashTable* _tmp20_;
	FolksPersona* _tmp21_;
	FolksPersona* _tmp22_;
	FolksPersona* _tmp23_;
	GeeIterator* _s_it;
	GeeHashMap* _tmp24_;
	GeeCollection* _tmp25_;
	GeeCollection* _tmp26_;
	GeeCollection* _tmp27_;
	GeeIterator* _tmp28_;
	GeeIterator* _tmp29_;
	GeeIterator* _tmp30_;
	FolksPersonaStore* s;
	GeeIterator* _tmp31_;
	gpointer _tmp32_;
	gboolean _tmp33_;
	FolksPersonaStore* _tmp34_;
	FolksPersonaStore* _tmp35_;
	FolksPersonaStore* _tmp36_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	gint _tmp38_;
	gchar** _tmp39_;
	gint _tmp39__length1;
	FolksPersonaStore* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	FolksPersona* _tmp43_;
	FolksPersonaStore* _tmp44_;
	GHashTable* _tmp45_;
	FolksPersona* _tmp46_;
	FolksPersona* _tmp47_;
	gboolean _tmp48_;
	FolksPersona* _tmp49_;
	FolksPersonaStore* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	gchar* _tmp58_;
	const gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	GError* _tmp63_;
	GError* _tmp64_;
	FolksPersona* _tmp65_;
	GError* _tmp66_;
	FolksPersona* _tmp67_;
	FolksPersona* _tmp68_;
	GError* _inner_error0_;
};

struct _FolksIndividualAggregatorLookUpIndividualData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksIndividualAggregator* self;
	gchar* id;
	FolksIndividual* result;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GError* _inner_error0_;
};

static gint FolksIndividualAggregator_private_offset;
static gpointer folks_individual_aggregator_parent_class = NULL;
static FolksIndividualAggregator* folks_individual_aggregator__instance;
static FolksIndividualAggregator* folks_individual_aggregator__instance = NULL;

static void _folks_individual_aggregator_backend_available_cb (FolksIndividualAggregator* self,
                                                        FolksBackendStore* backend_store,
                                                        FolksBackend* backend);
static void __folks_individual_aggregator_backend_available_cb_folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                                               FolksBackend* backend,
                                                                                               gpointer self);
static void _folks_individual_aggregator_debug_print_status (FolksIndividualAggregator* self,
                                                      FolksDebug* debug);
static void __folks_individual_aggregator_debug_print_status_folks_debug_print_status (FolksDebug* _sender,
                                                                                gpointer self);
static void _folks_individual_aggregator_primary_store_setting_changed_cb (FolksIndividualAggregator* self,
                                                                    GSettings* settings,
                                                                    const gchar* key);
static void _folks_individual_aggregator_configure_primary_store (FolksIndividualAggregator* self,
                                                           const gchar* store_config_ids);
static gchar* _folks_individual_aggregator_get_store_full_id (FolksIndividualAggregator* self,
                                                       const gchar* type_id,
                                                       const gchar* id);
static void _folks_individual_aggregator_set_primary_store (FolksIndividualAggregator* self,
                                                     FolksPersonaStore* store);
static void folks_individual_aggregator_prepare_data_free (gpointer _data);
static gboolean folks_individual_aggregator_prepare_co (FolksIndividualAggregatorPrepareData* _data_);
static void folks_individual_aggregator_prepare_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void _folks_individual_aggregator_notify_if_is_quiescent (FolksIndividualAggregator* self);
static void folks_individual_aggregator_unprepare_data_free (gpointer _data);
static gboolean folks_individual_aggregator_unprepare_co (FolksIndividualAggregatorUnprepareData* _data_);
static void folks_individual_aggregator_unprepare_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void _folks_individual_aggregator_add_backend (FolksIndividualAggregator* self,
                                               FolksBackend* backend);
static void _folks_individual_aggregator_backend_persona_store_added_cb (FolksIndividualAggregator* self,
                                                                  FolksBackend* backend,
                                                                  FolksPersonaStore* store);
static void __folks_individual_aggregator_backend_persona_store_added_cb_folks_backend_persona_store_added (FolksBackend* _sender,
                                                                                                     FolksPersonaStore* store,
                                                                                                     gpointer self);
static void _folks_individual_aggregator_backend_persona_store_removed_cb (FolksIndividualAggregator* self,
                                                                    FolksBackend* backend,
                                                                    FolksPersonaStore* store);
static void __folks_individual_aggregator_backend_persona_store_removed_cb_folks_backend_persona_store_removed (FolksBackend* _sender,
                                                                                                         FolksPersonaStore* store,
                                                                                                         gpointer self);
static void _folks_individual_aggregator_backend_is_quiescent_changed_cb (FolksIndividualAggregator* self,
                                                                   GObject* obj,
                                                                   GParamSpec* pspec);
static void __folks_individual_aggregator_backend_is_quiescent_changed_cb_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self);
static gboolean _folks_individual_aggregator_quiescent_timeout_cb (FolksIndividualAggregator* self);
static gboolean __folks_individual_aggregator_quiescent_timeout_cb_gsource_func (gpointer self);
VALA_EXTERN void folks_persona_store_set_is_primary_store (FolksPersonaStore* self,
                                               gboolean value);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _folks_individual_aggregator_maybe_configure_as_primary (FolksIndividualAggregator* self,
                                                                  FolksPersonaStore* store);
static void _folks_individual_aggregator_personas_changed_cb (FolksIndividualAggregator* self,
                                                       FolksPersonaStore* store,
                                                       GeeSet* added,
                                                       GeeSet* removed,
                                                       const gchar* message,
                                                       FolksPersona* actor,
                                                       FolksGroupDetailsChangeReason reason);
static void __folks_individual_aggregator_personas_changed_cb_folks_persona_store_personas_changed (FolksPersonaStore* _sender,
                                                                                             GeeSet* added,
                                                                                             GeeSet* removed,
                                                                                             const gchar* message,
                                                                                             FolksPersona* actor,
                                                                                             FolksGroupDetailsChangeReason reason,
                                                                                             gpointer self);
static void _folks_individual_aggregator_is_primary_store_changed_cb (FolksIndividualAggregator* self,
                                                               GObject* object,
                                                               GParamSpec* pspec);
static void __folks_individual_aggregator_is_primary_store_changed_cb_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self);
static void _folks_individual_aggregator_persona_store_is_quiescent_changed_cb (FolksIndividualAggregator* self,
                                                                         GObject* obj,
                                                                         GParamSpec* pspec);
static void __folks_individual_aggregator_persona_store_is_quiescent_changed_cb_g_object_notify (GObject* _sender,
                                                                                          GParamSpec* pspec,
                                                                                          gpointer self);
static void _folks_individual_aggregator_persona_store_is_user_set_default_changed_cb (FolksIndividualAggregator* self,
                                                                                GObject* obj,
                                                                                GParamSpec* pspec);
static void __folks_individual_aggregator_persona_store_is_user_set_default_changed_cb_g_object_notify (GObject* _sender,
                                                                                                 GParamSpec* pspec,
                                                                                                 gpointer self);
static void __lambda69_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* _result_);
static void ___lambda69__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _folks_individual_aggregator_emit_individuals_changed (FolksIndividualAggregator* self,
                                                            GeeSet* added,
                                                            GeeSet* removed,
                                                            GeeMultiMap* changes,
                                                            const gchar* message,
                                                            FolksPersona* actor,
                                                            FolksGroupDetailsChangeReason reason);
static void _folks_individual_aggregator_connect_to_individual (FolksIndividualAggregator* self,
                                                         FolksIndividual* individual);
static void _folks_individual_aggregator_individual_removed_cb (FolksIndividualAggregator* self,
                                                         FolksIndividual* i,
                                                         FolksIndividual* replacement);
static void __folks_individual_aggregator_individual_removed_cb_folks_individual_removed (FolksIndividual* _sender,
                                                                                   FolksIndividual* replacement_individual,
                                                                                   gpointer self);
static void _folks_individual_aggregator_disconnect_from_individual (FolksIndividualAggregator* self,
                                                              FolksIndividual* individual);
static void _folks_individual_aggregator_add_personas (FolksIndividualAggregator* self,
                                                GeeSet* added,
                                                FolksIndividual** user,
                                                GeeHashMultiMap** individuals_changes);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _______lambda67_ (Block4Data* _data4_,
                       const gchar* l);
static void ________lambda67__folks_persona_linkable_property_callback (const gchar* link,
                                                                 gpointer self);
static void _folks_individual_aggregator_add_persona_to_link_map (FolksIndividualAggregator* self,
                                                           FolksPersona* persona,
                                                           FolksIndividual* individual);
static void _folks_individual_aggregator_remove_individual_from_link_map (FolksIndividualAggregator* self,
                                                                   FolksIndividual* individual);
static void _folks_individual_aggregator_persona_linkable_property_changed_cb (FolksIndividualAggregator* self,
                                                                        GObject* obj,
                                                                        GParamSpec* pspec);
static void _folks_individual_aggregator_persona_anti_links_changed_cb (FolksIndividualAggregator* self,
                                                                 GObject* obj,
                                                                 GParamSpec* pspec);
static void _folks_individual_aggregator_connect_to_persona (FolksIndividualAggregator* self,
                                                      FolksPersona* persona);
static void __folks_individual_aggregator_persona_linkable_property_changed_cb_g_object_notify (GObject* _sender,
                                                                                         GParamSpec* pspec,
                                                                                         gpointer self);
static void __folks_individual_aggregator_persona_anti_links_changed_cb_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self);
static void _folks_individual_aggregator_disconnect_from_persona (FolksIndividualAggregator* self,
                                                           FolksPersona* persona);
static void _folks_individual_aggregator_link_map_set (FolksIndividualAggregator* self,
                                                const gchar* key,
                                                FolksIndividual* individual);
static void _g_object_unref0_ (gpointer var);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _____lambda68_ (Block5Data* _data5_,
                     const gchar* l);
static void ______lambda68__folks_persona_linkable_property_callback (const gchar* link,
                                                               gpointer self);
static void folks_individual_aggregator_set_user (FolksIndividualAggregator* self,
                                           FolksIndividual* value);
VALA_EXTERN void folks_individual_replace (FolksIndividual* self,
                               FolksIndividual* replacement_individual);
static void folks_individual_aggregator_add_persona_from_details_data_free (gpointer _data);
static gboolean folks_individual_aggregator_add_persona_from_details_co (FolksIndividualAggregatorAddPersonaFromDetailsData* _data_);
static GHashTable* _folks_individual_aggregator_asv_copy (FolksIndividualAggregator* self,
                                                   GHashTable* asv);
static void folks_individual_aggregator_add_persona_from_details_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static void __lambda70_ (Block6Data* _data6_,
                  const gchar* k,
                  GValue* v);
static GValue* _g_value_dup (GValue* self);
static void ___lambda70__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void folks_individual_aggregator_remove_individual_data_free (gpointer _data);
static gboolean folks_individual_aggregator_remove_individual_co (FolksIndividualAggregatorRemoveIndividualData* _data_);
static void folks_individual_aggregator_remove_individual_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void folks_individual_aggregator_remove_persona_data_free (gpointer _data);
static gboolean folks_individual_aggregator_remove_persona_co (FolksIndividualAggregatorRemovePersonaData* _data_);
static void folks_individual_aggregator_remove_persona_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void folks_individual_aggregator_link_personas_data_free (gpointer _data);
static gboolean folks_individual_aggregator_link_personas_co (FolksIndividualAggregatorLinkPersonasData* _data_);
static void folks_individual_aggregator_link_personas_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static GHashTable* _folks_individual_aggregator_build_linking_details (FolksIndividualAggregator* self,
                                                                GeeSet* personas);
static guint _folks_abstract_field_details_hash_static_gee_hash_data_func (gconstpointer v,
                                                                    gpointer self);
static gboolean _folks_abstract_field_details_equal_static_gee_equal_data_func (gconstpointer a,
                                                                         gconstpointer b,
                                                                         gpointer self);
static void folks_individual_aggregator_unlink_individual_data_free (gpointer _data);
static gboolean folks_individual_aggregator_unlink_individual_co (FolksIndividualAggregatorUnlinkIndividualData* _data_);
static void folks_individual_aggregator_unlink_individual_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static gboolean _folks_individual_aggregator_is_anti_link_property_writeable (FolksIndividualAggregator* self,
                                                                       FolksPersona* persona);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void folks_individual_aggregator_ensure_individual_property_writeable_data_free (gpointer _data);
static gboolean folks_individual_aggregator_ensure_individual_property_writeable_co (FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_);
static void _folks_individual_aggregator_ensure_personas_property_writeable (FolksIndividualAggregator* self,
                                                                      GeeSet* personas,
                                                                      const gchar* property_name,
                                                                      GAsyncReadyCallback _callback_,
                                                                      gpointer _user_data_);
static FolksPersona* _folks_individual_aggregator_ensure_personas_property_writeable_finish (FolksIndividualAggregator* self,
                                                                                      GAsyncResult* _res_,
                                                                                      GError** error);
static void folks_individual_aggregator_ensure_individual_property_writeable_ready (GObject* source_object,
                                                                             GAsyncResult* _res_,
                                                                             gpointer _user_data_);
static void _folks_individual_aggregator_ensure_personas_property_writeable_data_free (gpointer _data);
static gboolean _folks_individual_aggregator_ensure_personas_property_writeable_co (FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_);
static void _folks_individual_aggregator_ensure_personas_property_writeable_ready (GObject* source_object,
                                                                            GAsyncResult* _res_,
                                                                            gpointer _user_data_);
static void folks_individual_aggregator_look_up_individual_data_free (gpointer _data);
static gboolean folks_individual_aggregator_look_up_individual_co (FolksIndividualAggregatorLookUpIndividualData* _data_);
static void folks_individual_aggregator_look_up_individual_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void folks_individual_aggregator_set_individuals (FolksIndividualAggregator* self,
                                                  GeeMap* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM (GClosure * closure,
                                                                     GValue * return_value,
                                                                     guint n_param_values,
                                                                     const GValue * param_values,
                                                                     gpointer invocation_hint,
                                                                     gpointer marshal_data);
static GObject * folks_individual_aggregator_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _g_ptr_array_unref0_ (gpointer var);
static void __folks_individual_aggregator_primary_store_setting_changed_cb_g_settings_changed (GSettings* _sender,
                                                                                        const gchar* key,
                                                                                        gpointer self);
static void folks_individual_aggregator_finalize (GObject * obj);
static GType folks_individual_aggregator_get_type_once (void);
static void _vala_folks_individual_aggregator_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_folks_individual_aggregator_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GQuark
folks_individual_aggregator_error_quark (void)
{
	return g_quark_from_static_string ("folks-individual-aggregator-error-quark");
}

static GType
folks_individual_aggregator_error_get_type_once (void)
{
	static const GEnumValue values[] = {{FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_ADD_FAILED, "FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_ADD_FAILED", "add-failed"}, {FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_NO_WRITEABLE_STORE, "FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_NO_WRITEABLE_STORE", "no-writeable-store"}, {FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_STORE_OFFLINE, "FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_STORE_OFFLINE", "store-offline"}, {FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_PROPERTY_NOT_WRITEABLE, "FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_PROPERTY_NOT_WRITEABLE", "property-not-writeable"}, {FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_NO_PRIMARY_STORE, "FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_NO_PRIMARY_STORE", "no-primary-store"}, {0, NULL, NULL}};
	GType folks_individual_aggregator_error_type_id;
	folks_individual_aggregator_error_type_id = g_enum_register_static ("FolksIndividualAggregatorError", values);
	return folks_individual_aggregator_error_type_id;
}

GType
folks_individual_aggregator_error_get_type (void)
{
	static volatile gsize folks_individual_aggregator_error_type_id__once = 0;
	if (g_once_init_enter (&folks_individual_aggregator_error_type_id__once)) {
		GType folks_individual_aggregator_error_type_id;
		folks_individual_aggregator_error_type_id = folks_individual_aggregator_error_get_type_once ();
		g_once_init_leave (&folks_individual_aggregator_error_type_id__once, folks_individual_aggregator_error_type_id);
	}
	return folks_individual_aggregator_error_type_id__once;
}

static inline gpointer
folks_individual_aggregator_get_instance_private (FolksIndividualAggregator* self)
{
	return G_STRUCT_MEMBER_P (self, FolksIndividualAggregator_private_offset);
}

static void
__folks_individual_aggregator_backend_available_cb_folks_backend_store_backend_available (FolksBackendStore* _sender,
                                                                                          FolksBackend* backend,
                                                                                          gpointer self)
{
#line 526 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_backend_available_cb ((FolksIndividualAggregator*) self, _sender, backend);
#line 875 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_debug_print_status_folks_debug_print_status (FolksDebug* _sender,
                                                                           gpointer self)
{
#line 529 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_debug_print_status ((FolksIndividualAggregator*) self, _sender);
#line 884 "individual-aggregator.c"
}

/**
   * Create or return the singleton {@link IndividualAggregator} class instance.
   * If the instance doesn't exist already, it will be created with the
   * default {@link BackendStore}.
   *
   * This function is thread-safe.
   *
   * @return Singleton {@link IndividualAggregator} instance
   * @since 0.9.5
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 350 "../folks/individual-aggregator.vala"
	return self ? g_object_ref (self) : NULL;
#line 902 "individual-aggregator.c"
}

FolksIndividualAggregator*
folks_individual_aggregator_dup (void)
{
	FolksIndividualAggregator* _retval = NULL;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividualAggregator* _tmp1_;
	FolksIndividualAggregator* retval = NULL;
	FolksIndividualAggregator* _tmp2_;
	FolksIndividualAggregator* result;
#line 350 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_individual_aggregator__instance;
#line 350 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 350 "../folks/individual-aggregator.vala"
	_retval = _tmp1_;
#line 353 "../folks/individual-aggregator.vala"
	_tmp2_ = _retval;
#line 353 "../folks/individual-aggregator.vala"
	if (_tmp2_ == NULL) {
#line 924 "individual-aggregator.c"
		FolksIndividualAggregator* _tmp3_;
		FolksIndividualAggregator* _tmp4_;
#line 356 "../folks/individual-aggregator.vala"
		_tmp3_ = folks_individual_aggregator_new ();
#line 356 "../folks/individual-aggregator.vala"
		_g_object_unref0 (retval);
#line 356 "../folks/individual-aggregator.vala"
		retval = _tmp3_;
#line 357 "../folks/individual-aggregator.vala"
		_tmp4_ = retval;
#line 357 "../folks/individual-aggregator.vala"
		folks_individual_aggregator__instance = _tmp4_;
#line 937 "individual-aggregator.c"
	} else {
		FolksIndividualAggregator* _tmp5_;
		FolksIndividualAggregator* _tmp6_;
#line 361 "../folks/individual-aggregator.vala"
		_tmp5_ = _retval;
#line 361 "../folks/individual-aggregator.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator));
#line 361 "../folks/individual-aggregator.vala"
		_g_object_unref0 (retval);
#line 361 "../folks/individual-aggregator.vala"
		retval = _tmp6_;
#line 949 "individual-aggregator.c"
	}
#line 364 "../folks/individual-aggregator.vala"
	result = retval;
#line 364 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_retval);
#line 364 "../folks/individual-aggregator.vala"
	return result;
#line 957 "individual-aggregator.c"
}

/**
   * Create a new IndividualAggregator.
   *
   * Clients should connect to the
   * {@link IndividualAggregator.individuals_changed} signal (or the
   * {@link IndividualAggregator.individuals_changed_detailed} signal), then
   * call {@link IndividualAggregator.prepare} to load the backends and start
   * aggregating individuals.
   *
   * An example of how to set up an IndividualAggregator:
   * {{{
   *   IndividualAggregator agg = new IndividualAggregator ();
   *   agg.individuals_changed_detailed.connect (individuals_changed_cb);
   *   agg.prepare ();
   * }}}
   *
   * Folks does not support having more than one IndividualAggregator
   * instantiated at the same time. So it's recommended to use
   * {@link IndividualAggregator.dup} instead.
   */
FolksIndividualAggregator*
folks_individual_aggregator_construct (GType object_type)
{
	FolksIndividualAggregator * self = NULL;
	FolksBackendStore* _tmp0_;
	FolksBackendStore* _tmp1_;
#line 391 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_backend_store_dup ();
#line 391 "../folks/individual-aggregator.vala"
	_tmp1_ = _tmp0_;
#line 391 "../folks/individual-aggregator.vala"
	self = (FolksIndividualAggregator*) g_object_new (object_type, "backend-store", _tmp1_, NULL);
#line 391 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp1_);
#line 389 "../folks/individual-aggregator.vala"
	return self;
#line 996 "individual-aggregator.c"
}

FolksIndividualAggregator*
folks_individual_aggregator_new (void)
{
#line 389 "../folks/individual-aggregator.vala"
	return folks_individual_aggregator_construct (FOLKS_TYPE_INDIVIDUAL_AGGREGATOR);
#line 1004 "individual-aggregator.c"
}

/**
   * Create or return the singleton {@link IndividualAggregator} class instance
   * with a custom {@link BackendStore}.
   * If the instance doesn't exist already, it will be created with
   * the given {@link BackendStore} rather than the default one.
   * If the instance already exists but is using another {@link BackendStore}
   * then a warning is raised and null is returned.
   *
   * This function is thread-safe.
   *
   * @param store the {@link BackendStore} to use instead of the default one.

   * @return Singleton {@link IndividualAggregator} instance, or null
   * @since 0.9.5
   */
FolksIndividualAggregator*
folks_individual_aggregator_dup_with_backend_store (FolksBackendStore* store)
{
	FolksIndividualAggregator* _retval = NULL;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividualAggregator* _tmp1_;
	FolksIndividualAggregator* retval = NULL;
	FolksIndividualAggregator* _tmp2_;
	FolksIndividualAggregator* result;
#line 409 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (store != NULL, NULL);
#line 411 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_individual_aggregator__instance;
#line 411 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 411 "../folks/individual-aggregator.vala"
	_retval = _tmp1_;
#line 414 "../folks/individual-aggregator.vala"
	_tmp2_ = _retval;
#line 414 "../folks/individual-aggregator.vala"
	if (_tmp2_ == NULL) {
#line 1043 "individual-aggregator.c"
		FolksIndividualAggregator* _tmp3_;
		FolksIndividualAggregator* _tmp4_;
#line 417 "../folks/individual-aggregator.vala"
		_tmp3_ = folks_individual_aggregator_new_with_backend_store (store);
#line 417 "../folks/individual-aggregator.vala"
		_g_object_unref0 (retval);
#line 417 "../folks/individual-aggregator.vala"
		retval = _tmp3_;
#line 418 "../folks/individual-aggregator.vala"
		_tmp4_ = retval;
#line 418 "../folks/individual-aggregator.vala"
		folks_individual_aggregator__instance = _tmp4_;
#line 1056 "individual-aggregator.c"
	} else {
		FolksIndividualAggregator* _tmp5_;
		FolksBackendStore* _tmp6_;
#line 420 "../folks/individual-aggregator.vala"
		_tmp5_ = _retval;
#line 420 "../folks/individual-aggregator.vala"
		_tmp6_ = _tmp5_->priv->_backend_store;
#line 420 "../folks/individual-aggregator.vala"
		if (_tmp6_ != store) {
#line 422 "../folks/individual-aggregator.vala"
			g_warning ("individual-aggregator.vala:422: An aggregator already exists using ano" \
"ther backend store");
#line 423 "../folks/individual-aggregator.vala"
			result = NULL;
#line 423 "../folks/individual-aggregator.vala"
			_g_object_unref0 (retval);
#line 423 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_retval);
#line 423 "../folks/individual-aggregator.vala"
			return result;
#line 1076 "individual-aggregator.c"
		} else {
			FolksIndividualAggregator* _tmp7_;
			FolksIndividualAggregator* _tmp8_;
#line 427 "../folks/individual-aggregator.vala"
			_tmp7_ = _retval;
#line 427 "../folks/individual-aggregator.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator));
#line 427 "../folks/individual-aggregator.vala"
			_g_object_unref0 (retval);
#line 427 "../folks/individual-aggregator.vala"
			retval = _tmp8_;
#line 1088 "individual-aggregator.c"
		}
	}
#line 430 "../folks/individual-aggregator.vala"
	result = retval;
#line 430 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_retval);
#line 430 "../folks/individual-aggregator.vala"
	return result;
#line 1097 "individual-aggregator.c"
}

/**
   * Create a new IndividualAggregator with a custom {@link BackendStore}.
   *
   * This behaves the same as the default constructor for
   * {@link IndividualAggregator}, but uses the given {@link BackendStore}
   * rather than the default one.
   *
   * @param store the {@link BackendStore} to use instead of the default one.
   *
   * @since 0.9.0
   */
FolksIndividualAggregator*
folks_individual_aggregator_construct_with_backend_store (GType object_type,
                                                          FolksBackendStore* store)
{
	FolksIndividualAggregator * self = NULL;
#line 446 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (store != NULL, NULL);
#line 448 "../folks/individual-aggregator.vala"
	self = (FolksIndividualAggregator*) g_object_new (object_type, "backend-store", store, NULL);
#line 446 "../folks/individual-aggregator.vala"
	return self;
#line 1122 "individual-aggregator.c"
}

FolksIndividualAggregator*
folks_individual_aggregator_new_with_backend_store (FolksBackendStore* store)
{
#line 446 "../folks/individual-aggregator.vala"
	return folks_individual_aggregator_construct_with_backend_store (FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, store);
#line 1130 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_primary_store_setting_changed_cb (FolksIndividualAggregator* self,
                                                               GSettings* settings,
                                                               const gchar* key)
{
	gchar* val = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 535 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 535 "../folks/individual-aggregator.vala"
	g_return_if_fail (settings != NULL);
#line 535 "../folks/individual-aggregator.vala"
	g_return_if_fail (key != NULL);
#line 538 "../folks/individual-aggregator.vala"
	_tmp0_ = g_settings_get_string (settings, key);
#line 538 "../folks/individual-aggregator.vala"
	val = _tmp0_;
#line 539 "../folks/individual-aggregator.vala"
	_tmp2_ = val;
#line 539 "../folks/individual-aggregator.vala"
	if (_tmp2_ != NULL) {
#line 1156 "individual-aggregator.c"
		const gchar* _tmp3_;
#line 539 "../folks/individual-aggregator.vala"
		_tmp3_ = val;
#line 539 "../folks/individual-aggregator.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 1162 "individual-aggregator.c"
	} else {
#line 539 "../folks/individual-aggregator.vala"
		_tmp1_ = FALSE;
#line 1166 "individual-aggregator.c"
	}
#line 539 "../folks/individual-aggregator.vala"
	if (_tmp1_) {
#line 1170 "individual-aggregator.c"
		const gchar* _tmp4_;
		gchar* store_full_id = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		GeeHashMap* _tmp8_;
		const gchar* _tmp9_;
#line 541 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:541: Setting primary store IDs from GSettin" \
"gs.");
#line 542 "../folks/individual-aggregator.vala"
		_tmp4_ = val;
#line 542 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_configure_primary_store (self, (const gchar*) _tmp4_);
#line 544 "../folks/individual-aggregator.vala"
		_tmp5_ = self->priv->_configured_primary_store_type_id;
#line 544 "../folks/individual-aggregator.vala"
		_tmp6_ = self->priv->_configured_primary_store_id;
#line 544 "../folks/individual-aggregator.vala"
		_tmp7_ = _folks_individual_aggregator_get_store_full_id (self, _tmp5_, _tmp6_);
#line 544 "../folks/individual-aggregator.vala"
		store_full_id = _tmp7_;
#line 547 "../folks/individual-aggregator.vala"
		_tmp8_ = self->priv->_stores;
#line 547 "../folks/individual-aggregator.vala"
		_tmp9_ = store_full_id;
#line 547 "../folks/individual-aggregator.vala"
		if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp8_, _tmp9_)) {
#line 1198 "individual-aggregator.c"
			FolksPersonaStore* selected_store = NULL;
			GeeHashMap* _tmp10_;
			const gchar* _tmp11_;
			gpointer _tmp12_;
			FolksPersonaStore* _tmp13_;
#line 549 "../folks/individual-aggregator.vala"
			_tmp10_ = self->priv->_stores;
#line 549 "../folks/individual-aggregator.vala"
			_tmp11_ = store_full_id;
#line 549 "../folks/individual-aggregator.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, _tmp11_);
#line 549 "../folks/individual-aggregator.vala"
			selected_store = (FolksPersonaStore*) _tmp12_;
#line 550 "../folks/individual-aggregator.vala"
			_tmp13_ = selected_store;
#line 550 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_set_primary_store (self, _tmp13_);
#line 547 "../folks/individual-aggregator.vala"
			_g_object_unref0 (selected_store);
#line 1218 "individual-aggregator.c"
		}
#line 539 "../folks/individual-aggregator.vala"
		_g_free0 (store_full_id);
#line 1222 "individual-aggregator.c"
	}
#line 535 "../folks/individual-aggregator.vala"
	_g_free0 (val);
#line 1226 "individual-aggregator.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1149 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1149 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1150 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1150 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1152 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1152 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1250 "individual-aggregator.c"
		gchar* _tmp2_;
#line 1153 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1153 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1153 "glib-2.0.vapi"
		return result;
#line 1258 "individual-aggregator.c"
	} else {
#line 1155 "glib-2.0.vapi"
		result = -1;
#line 1155 "glib-2.0.vapi"
		return result;
#line 1264 "individual-aggregator.c"
	}
}

static void
_folks_individual_aggregator_configure_primary_store (FolksIndividualAggregator* self,
                                                      const gchar* store_config_ids)
{
#line 555 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 555 "../folks/individual-aggregator.vala"
	g_return_if_fail (store_config_ids != NULL);
#line 557 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:557: _configure_primary_store to '%s'", store_config_ids);
#line 558 "../folks/individual-aggregator.vala"
	self->priv->_user_configured_primary_store = TRUE;
#line 560 "../folks/individual-aggregator.vala"
	if (string_index_of (store_config_ids, ":", 0) != -1) {
#line 1282 "individual-aggregator.c"
		gchar** ids = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint ids_length1;
		gint _ids_size_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 562 "../folks/individual-aggregator.vala"
		_tmp1_ = _tmp0_ = g_strsplit (store_config_ids, ":", 2);
#line 562 "../folks/individual-aggregator.vala"
		ids = _tmp1_;
#line 562 "../folks/individual-aggregator.vala"
		ids_length1 = _vala_array_length (_tmp0_);
#line 562 "../folks/individual-aggregator.vala"
		_ids_size_ = ids_length1;
#line 563 "../folks/individual-aggregator.vala"
		_tmp2_ = ids;
#line 563 "../folks/individual-aggregator.vala"
		_tmp2__length1 = ids_length1;
#line 563 "../folks/individual-aggregator.vala"
		_tmp3_ = _tmp2_[0];
#line 563 "../folks/individual-aggregator.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 563 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_type_id);
#line 563 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_type_id = _tmp4_;
#line 564 "../folks/individual-aggregator.vala"
		_tmp5_ = ids;
#line 564 "../folks/individual-aggregator.vala"
		_tmp5__length1 = ids_length1;
#line 564 "../folks/individual-aggregator.vala"
		_tmp6_ = _tmp5_[1];
#line 564 "../folks/individual-aggregator.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 564 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_id);
#line 564 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_id = _tmp7_;
#line 560 "../folks/individual-aggregator.vala"
		ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 1330 "individual-aggregator.c"
	} else {
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 568 "../folks/individual-aggregator.vala"
		_tmp8_ = g_strdup (store_config_ids);
#line 568 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_type_id);
#line 568 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_type_id = _tmp8_;
#line 569 "../folks/individual-aggregator.vala"
		_tmp9_ = g_strdup ("");
#line 569 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_id);
#line 569 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_id = _tmp9_;
#line 1346 "individual-aggregator.c"
	}
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5915 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5916 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5916 "glib-2.0.vapi"
	return result;
#line 1360 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_debug_print_status (FolksIndividualAggregator* self,
                                                 FolksDebug* debug)
{
#line 575 "../folks/individual-aggregator.vala"
	static const char domain[] = FOLKS_DEBUG_STATUS_LOG_DOMAIN;
#line 576 "../folks/individual-aggregator.vala"
	static const GLogLevelFlags level = G_LOG_LEVEL_INFO;
#line 1371 "individual-aggregator.c"
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	FolksPersonaStore* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GeeMap* _tmp12_;
	GeeMap* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GHashTable* _tmp72_;
	GHashTableIter iter = {0};
	GHashTable* _tmp73_;
	const gchar* link_key = NULL;
	GPtrArray* individuals = NULL;
#line 573 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 573 "../folks/individual-aggregator.vala"
	g_return_if_fail (debug != NULL);
#line 578 "../folks/individual-aggregator.vala"
	folks_debug_print_heading (debug, domain, level, "IndividualAggregator (%p)", self);
#line 584 "../folks/individual-aggregator.vala"
	if (self->priv->_linking_enabled) {
#line 584 "../folks/individual-aggregator.vala"
		_tmp0_ = "yes";
#line 1401 "individual-aggregator.c"
	} else {
#line 584 "../folks/individual-aggregator.vala"
		_tmp0_ = "no";
#line 1405 "individual-aggregator.c"
	}
#line 585 "../folks/individual-aggregator.vala"
	if (self->priv->_is_prepared) {
#line 585 "../folks/individual-aggregator.vala"
		_tmp1_ = "yes";
#line 1411 "individual-aggregator.c"
	} else {
#line 585 "../folks/individual-aggregator.vala"
		_tmp1_ = "no";
#line 1415 "individual-aggregator.c"
	}
#line 586 "../folks/individual-aggregator.vala"
	if (self->priv->_is_quiescent) {
#line 1419 "individual-aggregator.c"
		gchar* _tmp3_;
#line 587 "../folks/individual-aggregator.vala"
		_tmp3_ = g_strdup ("yes");
#line 587 "../folks/individual-aggregator.vala"
		_g_free0 (_tmp2_);
#line 587 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp3_;
#line 1427 "individual-aggregator.c"
	} else {
		gchar* _tmp4_;
#line 588 "../folks/individual-aggregator.vala"
		_tmp4_ = g_strdup_printf ("no (%u backends, %u persona stores left)", self->priv->_non_quiescent_backend_count, self->priv->_non_quiescent_persona_store_count);
#line 588 "../folks/individual-aggregator.vala"
		_g_free0 (_tmp2_);
#line 588 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp4_;
#line 1436 "individual-aggregator.c"
	}
#line 579 "../folks/individual-aggregator.vala"
	_tmp5_ = g_strdup_printf ("%u", ((GObject*) self)->ref_count);
#line 579 "../folks/individual-aggregator.vala"
	_tmp6_ = _tmp5_;
#line 579 "../folks/individual-aggregator.vala"
	_tmp7_ = self->priv->_primary_store;
#line 579 "../folks/individual-aggregator.vala"
	_tmp8_ = g_strdup_printf ("%p", _tmp7_);
#line 579 "../folks/individual-aggregator.vala"
	_tmp9_ = _tmp8_;
#line 579 "../folks/individual-aggregator.vala"
	_tmp10_ = self->priv->_configured_primary_store_type_id;
#line 579 "../folks/individual-aggregator.vala"
	_tmp11_ = self->priv->_configured_primary_store_id;
#line 579 "../folks/individual-aggregator.vala"
	folks_debug_print_key_value_pairs (debug, domain, level, "Ref. count", _tmp6_, "Primary store", _tmp9_, "Configured store type id", _tmp10_, "Configured store id", _tmp11_, "Linking enabled?", _tmp0_, "Prepared?", _tmp1_, "Quiescent?", _tmp2_, NULL);
#line 579 "../folks/individual-aggregator.vala"
	_g_free0 (_tmp9_);
#line 579 "../folks/individual-aggregator.vala"
	_g_free0 (_tmp6_);
#line 593 "../folks/individual-aggregator.vala"
	_tmp12_ = folks_individual_aggregator_get_individuals (self);
#line 593 "../folks/individual-aggregator.vala"
	_tmp13_ = _tmp12_;
#line 593 "../folks/individual-aggregator.vala"
	_tmp14_ = gee_map_get_size (_tmp13_);
#line 593 "../folks/individual-aggregator.vala"
	_tmp15_ = _tmp14_;
#line 593 "../folks/individual-aggregator.vala"
	folks_debug_print_line (debug, domain, level, "%u Individuals:", (guint) _tmp15_);
#line 595 "../folks/individual-aggregator.vala"
	folks_debug_indent (debug);
#line 1470 "individual-aggregator.c"
	{
		GeeIterator* _individual_it = NULL;
		GeeMap* _tmp16_;
		GeeMap* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeCollection* _tmp20_;
		GeeIterator* _tmp21_;
		GeeIterator* _tmp22_;
#line 597 "../folks/individual-aggregator.vala"
		_tmp16_ = folks_individual_aggregator_get_individuals (self);
#line 597 "../folks/individual-aggregator.vala"
		_tmp17_ = _tmp16_;
#line 597 "../folks/individual-aggregator.vala"
		_tmp18_ = gee_map_get_values (_tmp17_);
#line 597 "../folks/individual-aggregator.vala"
		_tmp19_ = _tmp18_;
#line 597 "../folks/individual-aggregator.vala"
		_tmp20_ = _tmp19_;
#line 597 "../folks/individual-aggregator.vala"
		_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 597 "../folks/individual-aggregator.vala"
		_tmp22_ = _tmp21_;
#line 597 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp20_);
#line 597 "../folks/individual-aggregator.vala"
		_individual_it = _tmp22_;
#line 597 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 1500 "individual-aggregator.c"
			GeeIterator* _tmp23_;
			FolksIndividual* individual = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			gchar* trust_level = NULL;
			FolksIndividual* _tmp26_;
			FolksTrustLevel _tmp27_;
			FolksTrustLevel _tmp28_;
			FolksIndividual* _tmp31_;
			const gchar* _tmp32_ = NULL;
			FolksIndividual* _tmp33_;
			gboolean _tmp34_;
			gboolean _tmp35_;
			FolksIndividual* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			FolksIndividual* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			FolksIndividual* _tmp43_;
			GeeSet* _tmp44_;
			GeeSet* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
#line 597 "../folks/individual-aggregator.vala"
			_tmp23_ = _individual_it;
#line 597 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp23_)) {
#line 597 "../folks/individual-aggregator.vala"
				break;
#line 1532 "individual-aggregator.c"
			}
#line 597 "../folks/individual-aggregator.vala"
			_tmp24_ = _individual_it;
#line 597 "../folks/individual-aggregator.vala"
			_tmp25_ = gee_iterator_get (_tmp24_);
#line 597 "../folks/individual-aggregator.vala"
			individual = (FolksIndividual*) _tmp25_;
#line 599 "../folks/individual-aggregator.vala"
			trust_level = NULL;
#line 601 "../folks/individual-aggregator.vala"
			_tmp26_ = individual;
#line 601 "../folks/individual-aggregator.vala"
			_tmp27_ = folks_individual_get_trust_level (_tmp26_);
#line 601 "../folks/individual-aggregator.vala"
			_tmp28_ = _tmp27_;
#line 601 "../folks/individual-aggregator.vala"
			switch (_tmp28_) {
#line 601 "../folks/individual-aggregator.vala"
				case FOLKS_TRUST_LEVEL_NONE:
#line 1552 "individual-aggregator.c"
				{
					gchar* _tmp29_;
#line 604 "../folks/individual-aggregator.vala"
					_tmp29_ = g_strdup ("none");
#line 604 "../folks/individual-aggregator.vala"
					_g_free0 (trust_level);
#line 604 "../folks/individual-aggregator.vala"
					trust_level = _tmp29_;
#line 605 "../folks/individual-aggregator.vala"
					break;
#line 1563 "individual-aggregator.c"
				}
#line 601 "../folks/individual-aggregator.vala"
				case FOLKS_TRUST_LEVEL_PERSONAS:
#line 1567 "individual-aggregator.c"
				{
					gchar* _tmp30_;
#line 607 "../folks/individual-aggregator.vala"
					_tmp30_ = g_strdup ("personas");
#line 607 "../folks/individual-aggregator.vala"
					_g_free0 (trust_level);
#line 607 "../folks/individual-aggregator.vala"
					trust_level = _tmp30_;
#line 608 "../folks/individual-aggregator.vala"
					break;
#line 1578 "individual-aggregator.c"
				}
				default:
				{
#line 610 "../folks/individual-aggregator.vala"
					g_assert_not_reached ();
#line 1584 "individual-aggregator.c"
				}
			}
#line 613 "../folks/individual-aggregator.vala"
			_tmp31_ = individual;
#line 613 "../folks/individual-aggregator.vala"
			folks_debug_print_heading (debug, domain, level, "Individual (%p)", _tmp31_);
#line 617 "../folks/individual-aggregator.vala"
			_tmp33_ = individual;
#line 617 "../folks/individual-aggregator.vala"
			_tmp34_ = folks_individual_get_is_user (_tmp33_);
#line 617 "../folks/individual-aggregator.vala"
			_tmp35_ = _tmp34_;
#line 617 "../folks/individual-aggregator.vala"
			if (_tmp35_) {
#line 617 "../folks/individual-aggregator.vala"
				_tmp32_ = "yes";
#line 1601 "individual-aggregator.c"
			} else {
#line 617 "../folks/individual-aggregator.vala"
				_tmp32_ = "no";
#line 1605 "individual-aggregator.c"
			}
#line 614 "../folks/individual-aggregator.vala"
			_tmp36_ = individual;
#line 614 "../folks/individual-aggregator.vala"
			_tmp37_ = g_strdup_printf ("%u", ((GObject*) _tmp36_)->ref_count);
#line 614 "../folks/individual-aggregator.vala"
			_tmp38_ = _tmp37_;
#line 614 "../folks/individual-aggregator.vala"
			_tmp39_ = individual;
#line 614 "../folks/individual-aggregator.vala"
			_tmp40_ = folks_individual_get_id (_tmp39_);
#line 614 "../folks/individual-aggregator.vala"
			_tmp41_ = _tmp40_;
#line 614 "../folks/individual-aggregator.vala"
			_tmp42_ = trust_level;
#line 614 "../folks/individual-aggregator.vala"
			folks_debug_print_key_value_pairs (debug, domain, level, "Ref. count", _tmp38_, "ID", _tmp41_, "User?", _tmp32_, "Trust level", _tmp42_, NULL);
#line 614 "../folks/individual-aggregator.vala"
			_g_free0 (_tmp38_);
#line 620 "../folks/individual-aggregator.vala"
			_tmp43_ = individual;
#line 620 "../folks/individual-aggregator.vala"
			_tmp44_ = folks_individual_get_personas (_tmp43_);
#line 620 "../folks/individual-aggregator.vala"
			_tmp45_ = _tmp44_;
#line 620 "../folks/individual-aggregator.vala"
			_tmp46_ = gee_collection_get_size ((GeeCollection*) _tmp45_);
#line 620 "../folks/individual-aggregator.vala"
			_tmp47_ = _tmp46_;
#line 620 "../folks/individual-aggregator.vala"
			folks_debug_print_line (debug, domain, level, "%u Personas:", (guint) _tmp47_);
#line 623 "../folks/individual-aggregator.vala"
			folks_debug_indent (debug);
#line 1639 "individual-aggregator.c"
			{
				GeeIterator* _persona_it = NULL;
				FolksIndividual* _tmp48_;
				GeeSet* _tmp49_;
				GeeSet* _tmp50_;
				GeeIterator* _tmp51_;
#line 625 "../folks/individual-aggregator.vala"
				_tmp48_ = individual;
#line 625 "../folks/individual-aggregator.vala"
				_tmp49_ = folks_individual_get_personas (_tmp48_);
#line 625 "../folks/individual-aggregator.vala"
				_tmp50_ = _tmp49_;
#line 625 "../folks/individual-aggregator.vala"
				_tmp51_ = gee_iterable_iterator ((GeeIterable*) _tmp50_);
#line 625 "../folks/individual-aggregator.vala"
				_persona_it = _tmp51_;
#line 625 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 1658 "individual-aggregator.c"
					GeeIterator* _tmp52_;
					FolksPersona* persona = NULL;
					GeeIterator* _tmp53_;
					gpointer _tmp54_;
					FolksPersona* _tmp55_;
					const gchar* _tmp56_ = NULL;
					FolksPersona* _tmp57_;
					gboolean _tmp58_;
					gboolean _tmp59_;
					FolksPersona* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					FolksPersona* _tmp63_;
					const gchar* _tmp64_;
					const gchar* _tmp65_;
					FolksPersona* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					FolksPersona* _tmp69_;
					const gchar* _tmp70_;
					const gchar* _tmp71_;
#line 625 "../folks/individual-aggregator.vala"
					_tmp52_ = _persona_it;
#line 625 "../folks/individual-aggregator.vala"
					if (!gee_iterator_next (_tmp52_)) {
#line 625 "../folks/individual-aggregator.vala"
						break;
#line 1686 "individual-aggregator.c"
					}
#line 625 "../folks/individual-aggregator.vala"
					_tmp53_ = _persona_it;
#line 625 "../folks/individual-aggregator.vala"
					_tmp54_ = gee_iterator_get (_tmp53_);
#line 625 "../folks/individual-aggregator.vala"
					persona = (FolksPersona*) _tmp54_;
#line 627 "../folks/individual-aggregator.vala"
					_tmp55_ = persona;
#line 627 "../folks/individual-aggregator.vala"
					folks_debug_print_heading (debug, domain, level, "Persona (%p)", _tmp55_);
#line 633 "../folks/individual-aggregator.vala"
					_tmp57_ = persona;
#line 633 "../folks/individual-aggregator.vala"
					_tmp58_ = folks_persona_get_is_user (_tmp57_);
#line 633 "../folks/individual-aggregator.vala"
					_tmp59_ = _tmp58_;
#line 633 "../folks/individual-aggregator.vala"
					if (_tmp59_) {
#line 633 "../folks/individual-aggregator.vala"
						_tmp56_ = "yes";
#line 1708 "individual-aggregator.c"
					} else {
#line 633 "../folks/individual-aggregator.vala"
						_tmp56_ = "no";
#line 1712 "individual-aggregator.c"
					}
#line 628 "../folks/individual-aggregator.vala"
					_tmp60_ = persona;
#line 628 "../folks/individual-aggregator.vala"
					_tmp61_ = g_strdup_printf ("%u", ((GObject*) _tmp60_)->ref_count);
#line 628 "../folks/individual-aggregator.vala"
					_tmp62_ = _tmp61_;
#line 628 "../folks/individual-aggregator.vala"
					_tmp63_ = persona;
#line 628 "../folks/individual-aggregator.vala"
					_tmp64_ = folks_persona_get_uid (_tmp63_);
#line 628 "../folks/individual-aggregator.vala"
					_tmp65_ = _tmp64_;
#line 628 "../folks/individual-aggregator.vala"
					_tmp66_ = persona;
#line 628 "../folks/individual-aggregator.vala"
					_tmp67_ = folks_persona_get_iid (_tmp66_);
#line 628 "../folks/individual-aggregator.vala"
					_tmp68_ = _tmp67_;
#line 628 "../folks/individual-aggregator.vala"
					_tmp69_ = persona;
#line 628 "../folks/individual-aggregator.vala"
					_tmp70_ = folks_persona_get_display_id (_tmp69_);
#line 628 "../folks/individual-aggregator.vala"
					_tmp71_ = _tmp70_;
#line 628 "../folks/individual-aggregator.vala"
					folks_debug_print_key_value_pairs (debug, domain, level, "Ref. count", _tmp62_, "UID", _tmp65_, "IID", _tmp68_, "Display ID", _tmp71_, "User?", _tmp56_, NULL);
#line 628 "../folks/individual-aggregator.vala"
					_g_free0 (_tmp62_);
#line 625 "../folks/individual-aggregator.vala"
					_g_object_unref0 (persona);
#line 1744 "individual-aggregator.c"
				}
#line 625 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_persona_it);
#line 1748 "individual-aggregator.c"
			}
#line 637 "../folks/individual-aggregator.vala"
			folks_debug_unindent (debug);
#line 597 "../folks/individual-aggregator.vala"
			_g_free0 (trust_level);
#line 597 "../folks/individual-aggregator.vala"
			_g_object_unref0 (individual);
#line 1756 "individual-aggregator.c"
		}
#line 597 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_individual_it);
#line 1760 "individual-aggregator.c"
	}
#line 640 "../folks/individual-aggregator.vala"
	folks_debug_unindent (debug);
#line 642 "../folks/individual-aggregator.vala"
	_tmp72_ = self->priv->_link_map;
#line 642 "../folks/individual-aggregator.vala"
	folks_debug_print_line (debug, domain, level, "%u keys in the link map:", g_hash_table_size (_tmp72_));
#line 644 "../folks/individual-aggregator.vala"
	folks_debug_indent (debug);
#line 646 "../folks/individual-aggregator.vala"
	_tmp73_ = self->priv->_link_map;
#line 646 "../folks/individual-aggregator.vala"
	g_hash_table_iter_init (&iter, _tmp73_);
#line 651 "../folks/individual-aggregator.vala"
	while (TRUE) {
#line 1776 "individual-aggregator.c"
		gconstpointer _tmp74_ = NULL;
		gconstpointer _tmp75_ = NULL;
		gboolean _tmp76_;
		const gchar* _tmp77_;
#line 651 "../folks/individual-aggregator.vala"
		_tmp76_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp74_), (gpointer*) (&_tmp75_));
#line 651 "../folks/individual-aggregator.vala"
		link_key = (const gchar*) _tmp74_;
#line 651 "../folks/individual-aggregator.vala"
		individuals = (GPtrArray*) _tmp75_;
#line 651 "../folks/individual-aggregator.vala"
		if (!_tmp76_) {
#line 651 "../folks/individual-aggregator.vala"
			break;
#line 1791 "individual-aggregator.c"
		}
#line 653 "../folks/individual-aggregator.vala"
		_tmp77_ = link_key;
#line 653 "../folks/individual-aggregator.vala"
		folks_debug_print_line (debug, domain, level, "%s → {", _tmp77_);
#line 654 "../folks/individual-aggregator.vala"
		folks_debug_indent (debug);
#line 1799 "individual-aggregator.c"
		{
			guint i = 0U;
#line 656 "../folks/individual-aggregator.vala"
			i = (guint) 0;
#line 1804 "individual-aggregator.c"
			{
				gboolean _tmp78_ = FALSE;
#line 656 "../folks/individual-aggregator.vala"
				_tmp78_ = TRUE;
#line 656 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 1811 "individual-aggregator.c"
					GPtrArray* _tmp80_;
					gint _tmp81_;
					gint _tmp82_;
					FolksIndividual* ind = NULL;
					GPtrArray* _tmp83_;
					gconstpointer _tmp84_;
					FolksIndividual* _tmp85_;
#line 656 "../folks/individual-aggregator.vala"
					if (!_tmp78_) {
#line 1821 "individual-aggregator.c"
						guint _tmp79_;
#line 656 "../folks/individual-aggregator.vala"
						_tmp79_ = i;
#line 656 "../folks/individual-aggregator.vala"
						i = _tmp79_ + 1;
#line 1827 "individual-aggregator.c"
					}
#line 656 "../folks/individual-aggregator.vala"
					_tmp78_ = FALSE;
#line 656 "../folks/individual-aggregator.vala"
					_tmp80_ = individuals;
#line 656 "../folks/individual-aggregator.vala"
					_tmp81_ = vala_g_ptr_array_get_length (_tmp80_);
#line 656 "../folks/individual-aggregator.vala"
					_tmp82_ = _tmp81_;
#line 656 "../folks/individual-aggregator.vala"
					if (!(i < ((guint) _tmp82_))) {
#line 656 "../folks/individual-aggregator.vala"
						break;
#line 1841 "individual-aggregator.c"
					}
#line 658 "../folks/individual-aggregator.vala"
					_tmp83_ = individuals;
#line 658 "../folks/individual-aggregator.vala"
					_tmp84_ = g_ptr_array_index (_tmp83_, i);
#line 658 "../folks/individual-aggregator.vala"
					ind = (FolksIndividual*) _tmp84_;
#line 660 "../folks/individual-aggregator.vala"
					_tmp85_ = ind;
#line 660 "../folks/individual-aggregator.vala"
					folks_debug_print_line (debug, domain, level, "%p", _tmp85_);
#line 1853 "individual-aggregator.c"
				}
			}
		}
#line 663 "../folks/individual-aggregator.vala"
		folks_debug_unindent (debug);
#line 664 "../folks/individual-aggregator.vala"
		folks_debug_print_line (debug, domain, level, "}");
#line 1861 "individual-aggregator.c"
	}
#line 667 "../folks/individual-aggregator.vala"
	folks_debug_unindent (debug);
#line 670 "../folks/individual-aggregator.vala"
	folks_debug_print_line (debug, domain, level, "%s", "");
#line 573 "../folks/individual-aggregator.vala"
	_g_free0 (_tmp2_);
#line 1869 "individual-aggregator.c"
}

static void
folks_individual_aggregator_prepare_data_free (gpointer _data)
{
	FolksIndividualAggregatorPrepareData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorPrepareData, _data_);
#line 1881 "individual-aggregator.c"
}

void
folks_individual_aggregator_prepare (FolksIndividualAggregator* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	FolksIndividualAggregatorPrepareData* _data_;
	FolksIndividualAggregator* _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorPrepareData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_prepare_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_prepare_co (_data_);
#line 1905 "individual-aggregator.c"
}

void
folks_individual_aggregator_prepare_finish (FolksIndividualAggregator* self,
                                            GAsyncResult* _res_,
                                            GError** error)
{
	FolksIndividualAggregatorPrepareData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 1920 "individual-aggregator.c"
	}
}

/**
   * Prepare the IndividualAggregator for use.
   *
   * This loads all the available backends and prepares them for use by the
   * IndividualAggregator. This should be called //after// connecting to the
   * {@link IndividualAggregator.individuals_changed} signal (or
   * {@link IndividualAggregator.individuals_changed_detailed} signal), or a
   * race condition could occur, with the signal being emitted before your code
   * has connected to them, and {@link Individual}s getting "lost" as a result.
   *
   * This function is guaranteed to be idempotent (since version 0.3.0).
   *
   * Concurrent calls to this function from different threads will block until
   * preparation has completed. However, concurrent calls to this function from
   * a single thread might not, i.e. the first call will block but subsequent
   * calls might return before the first one. (Though they will be safe in every
   * other respect.)
   *
   * @throws GLib.Error if preparing any of the backends failed — this error
   * will be passed through from {@link BackendStore.load_backends}
   *
   * @since 0.1.11
   */
static void
folks_individual_aggregator_prepare_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	FolksIndividualAggregatorPrepareData* _data_;
#line 732 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 732 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 732 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 732 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_prepare_co (_data_);
#line 1961 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_prepare_co (FolksIndividualAggregatorPrepareData* _data_)
{
#line 696 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 696 "../folks/individual-aggregator.vala"
		case 0:
#line 1971 "individual-aggregator.c"
		goto _state_0;
#line 696 "../folks/individual-aggregator.vala"
		case 1:
#line 1975 "individual-aggregator.c"
		goto _state_1;
		default:
#line 696 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 1980 "individual-aggregator.c"
	}
	_state_0:
#line 698 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing IndividualAggregator", NULL);
#line 698 "../folks/individual-aggregator.vala"
	_data_->profiling = _data_->_tmp0_;
#line 704 "../folks/individual-aggregator.vala"
	if (_data_->self->priv->_is_prepared) {
#line 704 "../folks/individual-aggregator.vala"
		_data_->_tmp1_ = TRUE;
#line 1991 "individual-aggregator.c"
	} else {
#line 704 "../folks/individual-aggregator.vala"
		_data_->_tmp1_ = _data_->self->priv->_prepare_pending;
#line 1995 "individual-aggregator.c"
	}
#line 704 "../folks/individual-aggregator.vala"
	if (_data_->_tmp1_) {
#line 706 "../folks/individual-aggregator.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 706 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 706 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 706 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 706 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2009 "individual-aggregator.c"
			}
		}
#line 706 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 706 "../folks/individual-aggregator.vala"
		return FALSE;
#line 2016 "individual-aggregator.c"
	}
	{
#line 711 "../folks/individual-aggregator.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 716 "../folks/individual-aggregator.vala"
		_data_->_tmp2_ = _data_->self->priv->_non_quiescent_backend_count;
#line 716 "../folks/individual-aggregator.vala"
		_data_->self->priv->_non_quiescent_backend_count = _data_->_tmp2_ + 1;
#line 718 "../folks/individual-aggregator.vala"
		_data_->_tmp3_ = _data_->self->priv->_backend_store;
#line 718 "../folks/individual-aggregator.vala"
		g_signal_connect_object (_data_->_tmp3_, "backend-available", (GCallback) __folks_individual_aggregator_backend_available_cb_folks_backend_store_backend_available, _data_->self, 0);
#line 724 "../folks/individual-aggregator.vala"
		_data_->_tmp4_ = _data_->self->priv->_backend_store;
#line 724 "../folks/individual-aggregator.vala"
		_data_->_tmp5_ = folks_backend_store_get_enabled_backends (_data_->_tmp4_);
#line 724 "../folks/individual-aggregator.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 724 "../folks/individual-aggregator.vala"
		_data_->_tmp7_ = gee_map_get_values (_data_->_tmp6_);
#line 724 "../folks/individual-aggregator.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 724 "../folks/individual-aggregator.vala"
		_data_->backends = _data_->_tmp8_;
#line 2041 "individual-aggregator.c"
		{
#line 725 "../folks/individual-aggregator.vala"
			_data_->_tmp9_ = _data_->backends;
#line 725 "../folks/individual-aggregator.vala"
			_data_->_tmp10_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp9_);
#line 725 "../folks/individual-aggregator.vala"
			_data_->_backend_it = _data_->_tmp10_;
#line 725 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 725 "../folks/individual-aggregator.vala"
				_data_->_tmp11_ = _data_->_backend_it;
#line 725 "../folks/individual-aggregator.vala"
				if (!gee_iterator_next (_data_->_tmp11_)) {
#line 725 "../folks/individual-aggregator.vala"
					break;
#line 2057 "individual-aggregator.c"
				}
#line 725 "../folks/individual-aggregator.vala"
				_data_->_tmp12_ = _data_->_backend_it;
#line 725 "../folks/individual-aggregator.vala"
				_data_->_tmp13_ = gee_iterator_get (_data_->_tmp12_);
#line 725 "../folks/individual-aggregator.vala"
				_data_->backend = (FolksBackend*) _data_->_tmp13_;
#line 727 "../folks/individual-aggregator.vala"
				_data_->_tmp14_ = _data_->self->priv->_backend_store;
#line 727 "../folks/individual-aggregator.vala"
				_data_->_tmp15_ = _data_->backend;
#line 727 "../folks/individual-aggregator.vala"
				_folks_individual_aggregator_backend_available_cb (_data_->self, _data_->_tmp14_, _data_->_tmp15_);
#line 725 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->backend);
#line 2073 "individual-aggregator.c"
			}
#line 725 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_backend_it);
#line 2077 "individual-aggregator.c"
		}
#line 732 "../folks/individual-aggregator.vala"
		_data_->_tmp16_ = _data_->self->priv->_backend_store;
#line 732 "../folks/individual-aggregator.vala"
		_data_->_state_ = 1;
#line 732 "../folks/individual-aggregator.vala"
		folks_backend_store_load_backends (_data_->_tmp16_, folks_individual_aggregator_prepare_ready, _data_);
#line 732 "../folks/individual-aggregator.vala"
		return FALSE;
#line 2087 "individual-aggregator.c"
		_state_1:
#line 732 "../folks/individual-aggregator.vala"
		folks_backend_store_load_backends_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 732 "../folks/individual-aggregator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 732 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->backends);
#line 2095 "individual-aggregator.c"
			goto __finally0;
		}
#line 734 "../folks/individual-aggregator.vala"
		_data_->_tmp17_ = _data_->self->priv->_non_quiescent_backend_count;
#line 734 "../folks/individual-aggregator.vala"
		_data_->self->priv->_non_quiescent_backend_count = _data_->_tmp17_ - 1;
#line 736 "../folks/individual-aggregator.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 737 "../folks/individual-aggregator.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 738 "../folks/individual-aggregator.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 744 "../folks/individual-aggregator.vala"
		if (_data_->self->priv->_is_quiescent == FALSE) {
#line 746 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_notify_if_is_quiescent (_data_->self);
#line 2112 "individual-aggregator.c"
		}
#line 709 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->backends);
#line 2116 "individual-aggregator.c"
	}
	__finally0:
	{
#line 751 "../folks/individual-aggregator.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 2122 "individual-aggregator.c"
	}
#line 709 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 709 "../folks/individual-aggregator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 709 "../folks/individual-aggregator.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 709 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 709 "../folks/individual-aggregator.vala"
		return FALSE;
#line 2134 "individual-aggregator.c"
	}
#line 754 "../folks/individual-aggregator.vala"
	_data_->_tmp18_ = _data_->profiling;
#line 754 "../folks/individual-aggregator.vala"
	_data_->profiling = NULL;
#line 754 "../folks/individual-aggregator.vala"
	folks_internal_profiling_end (_data_->_tmp18_);
#line 696 "../folks/individual-aggregator.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 696 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 696 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 696 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 696 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2152 "individual-aggregator.c"
		}
	}
#line 696 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 696 "../folks/individual-aggregator.vala"
	return FALSE;
#line 2159 "individual-aggregator.c"
}

static void
folks_individual_aggregator_unprepare_data_free (gpointer _data)
{
	FolksIndividualAggregatorUnprepareData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorUnprepareData, _data_);
#line 2171 "individual-aggregator.c"
}

void
folks_individual_aggregator_unprepare (FolksIndividualAggregator* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	FolksIndividualAggregatorUnprepareData* _data_;
	FolksIndividualAggregator* _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorUnprepareData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_unprepare_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_unprepare_co (_data_);
#line 2195 "individual-aggregator.c"
}

void
folks_individual_aggregator_unprepare_finish (FolksIndividualAggregator* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	FolksIndividualAggregatorUnprepareData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 2210 "individual-aggregator.c"
	}
}

/**
   * Clean up and release resources used by the aggregator.
   *
   * This will disconnect the aggregator cleanly from any resources it or its
   * persona stores are using. It is recommended to call this method before
   * finalising the individual aggregator, but calling it is not required. If
   * this method is not called then, for example, unsaved changes in backends
   * may not be flushed.
   *
   * Concurrent calls to this function from different threads will block until
   * preparation has completed. However, concurrent calls to this function from
   * a single thread might not, i.e. the first call will block but subsequent
   * calls might return before the first one. (Though they will be safe in every
   * other respect.)
   *
   * @since 0.7.3
   * @throws GLib.Error if unpreparing the backend-specific services failed —
   * this will be a backend-specific error
   */
static void
folks_individual_aggregator_unprepare_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	FolksIndividualAggregatorUnprepareData* _data_;
#line 788 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 788 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 788 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 788 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_unprepare_co (_data_);
#line 2247 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_unprepare_co (FolksIndividualAggregatorUnprepareData* _data_)
{
#line 776 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 776 "../folks/individual-aggregator.vala"
		case 0:
#line 2257 "individual-aggregator.c"
		goto _state_0;
#line 776 "../folks/individual-aggregator.vala"
		case 1:
#line 2261 "individual-aggregator.c"
		goto _state_1;
		default:
#line 776 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 2266 "individual-aggregator.c"
	}
	_state_0:
#line 778 "../folks/individual-aggregator.vala"
	if (!_data_->self->priv->_is_prepared) {
#line 778 "../folks/individual-aggregator.vala"
		_data_->_tmp0_ = TRUE;
#line 2273 "individual-aggregator.c"
	} else {
#line 778 "../folks/individual-aggregator.vala"
		_data_->_tmp0_ = _data_->self->priv->_prepare_pending;
#line 2277 "individual-aggregator.c"
	}
#line 778 "../folks/individual-aggregator.vala"
	if (_data_->_tmp0_) {
#line 780 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 780 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 780 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 780 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2289 "individual-aggregator.c"
			}
		}
#line 780 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 780 "../folks/individual-aggregator.vala"
		return FALSE;
#line 2296 "individual-aggregator.c"
	}
	{
		{
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp1_ = _data_->self->priv->_stores;
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp1_);
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp3_ = _data_->_tmp2_;
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp5_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp4_);
#line 786 "../folks/individual-aggregator.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 786 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_tmp4_);
#line 786 "../folks/individual-aggregator.vala"
			_data_->_p_it = _data_->_tmp6_;
#line 786 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 786 "../folks/individual-aggregator.vala"
				_data_->_tmp7_ = _data_->_p_it;
#line 786 "../folks/individual-aggregator.vala"
				if (!gee_iterator_next (_data_->_tmp7_)) {
#line 786 "../folks/individual-aggregator.vala"
					break;
#line 2324 "individual-aggregator.c"
				}
#line 786 "../folks/individual-aggregator.vala"
				_data_->_tmp8_ = _data_->_p_it;
#line 786 "../folks/individual-aggregator.vala"
				_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 786 "../folks/individual-aggregator.vala"
				_data_->p = (FolksPersonaStore*) _data_->_tmp9_;
#line 788 "../folks/individual-aggregator.vala"
				_data_->_tmp10_ = _data_->p;
#line 788 "../folks/individual-aggregator.vala"
				_data_->_state_ = 1;
#line 788 "../folks/individual-aggregator.vala"
				folks_persona_store_flush (_data_->_tmp10_, folks_individual_aggregator_unprepare_ready, _data_);
#line 788 "../folks/individual-aggregator.vala"
				return FALSE;
#line 2340 "individual-aggregator.c"
				_state_1:
#line 788 "../folks/individual-aggregator.vala"
				folks_persona_store_flush_finish (_data_->_tmp10_, _data_->_res_);
#line 786 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->p);
#line 2346 "individual-aggregator.c"
			}
#line 786 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_p_it);
#line 2350 "individual-aggregator.c"
		}
	}
	__finally0:
	{
#line 793 "../folks/individual-aggregator.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 2357 "individual-aggregator.c"
	}
#line 783 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 783 "../folks/individual-aggregator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 783 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 783 "../folks/individual-aggregator.vala"
		return FALSE;
#line 2367 "individual-aggregator.c"
	}
#line 776 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 776 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 776 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 776 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2377 "individual-aggregator.c"
		}
	}
#line 776 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 776 "../folks/individual-aggregator.vala"
	return FALSE;
#line 2384 "individual-aggregator.c"
}

/**
   * Get all matches for a given {@link Individual}.
   *
   * @param matchee the individual to find matches for
   * @param min_threshold the threshold for accepting a match
   * @return a map from matched individuals to the degree with which they match
   * ``matchee`` (which is guaranteed to at least equal ``min_threshold``);
   * if no matches could be found, an empty map is returned
   *
   * @since 0.5.1
   */
GeeMap*
folks_individual_aggregator_get_potential_matches (FolksIndividualAggregator* self,
                                                   FolksIndividual* matchee,
                                                   FolksMatchResult min_threshold)
{
	GeeHashMap* matches = NULL;
	GeeHashMap* _tmp0_;
	FolksPotentialMatch* matchObj = NULL;
	FolksPotentialMatch* _tmp1_;
	GeeMap* result;
#line 808 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 808 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (matchee != NULL, NULL);
#line 811 "../folks/individual-aggregator.vala"
	_tmp0_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_MATCH_RESULT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 811 "../folks/individual-aggregator.vala"
	matches = _tmp0_;
#line 813 "../folks/individual-aggregator.vala"
	_tmp1_ = folks_potential_match_new ();
#line 813 "../folks/individual-aggregator.vala"
	matchObj = _tmp1_;
#line 2420 "individual-aggregator.c"
	{
		GeeIterator* _i_it = NULL;
		GeeMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 815 "../folks/individual-aggregator.vala"
		_tmp2_ = self->priv->_individuals;
#line 815 "../folks/individual-aggregator.vala"
		_tmp3_ = gee_map_get_values (_tmp2_);
#line 815 "../folks/individual-aggregator.vala"
		_tmp4_ = _tmp3_;
#line 815 "../folks/individual-aggregator.vala"
		_tmp5_ = _tmp4_;
#line 815 "../folks/individual-aggregator.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 815 "../folks/individual-aggregator.vala"
		_tmp7_ = _tmp6_;
#line 815 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp5_);
#line 815 "../folks/individual-aggregator.vala"
		_i_it = _tmp7_;
#line 815 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2447 "individual-aggregator.c"
			GeeIterator* _tmp8_;
			FolksIndividual* i = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			FolksIndividual* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			FolksMatchResult _result_ = 0;
			FolksPotentialMatch* _tmp16_;
			FolksIndividual* _tmp17_;
#line 815 "../folks/individual-aggregator.vala"
			_tmp8_ = _i_it;
#line 815 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 815 "../folks/individual-aggregator.vala"
				break;
#line 2466 "individual-aggregator.c"
			}
#line 815 "../folks/individual-aggregator.vala"
			_tmp9_ = _i_it;
#line 815 "../folks/individual-aggregator.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 815 "../folks/individual-aggregator.vala"
			i = (FolksIndividual*) _tmp10_;
#line 817 "../folks/individual-aggregator.vala"
			_tmp11_ = i;
#line 817 "../folks/individual-aggregator.vala"
			_tmp12_ = folks_individual_get_id (_tmp11_);
#line 817 "../folks/individual-aggregator.vala"
			_tmp13_ = _tmp12_;
#line 817 "../folks/individual-aggregator.vala"
			_tmp14_ = folks_individual_get_id (matchee);
#line 817 "../folks/individual-aggregator.vala"
			_tmp15_ = _tmp14_;
#line 817 "../folks/individual-aggregator.vala"
			if (g_strcmp0 (_tmp13_, _tmp15_) == 0) {
#line 818 "../folks/individual-aggregator.vala"
				_g_object_unref0 (i);
#line 818 "../folks/individual-aggregator.vala"
				continue;
#line 2490 "individual-aggregator.c"
			}
#line 820 "../folks/individual-aggregator.vala"
			_tmp16_ = matchObj;
#line 820 "../folks/individual-aggregator.vala"
			_tmp17_ = i;
#line 820 "../folks/individual-aggregator.vala"
			_result_ = folks_potential_match_potential_match (_tmp16_, _tmp17_, matchee);
#line 821 "../folks/individual-aggregator.vala"
			if (_result_ >= min_threshold) {
#line 2500 "individual-aggregator.c"
				GeeHashMap* _tmp18_;
				FolksIndividual* _tmp19_;
#line 823 "../folks/individual-aggregator.vala"
				_tmp18_ = matches;
#line 823 "../folks/individual-aggregator.vala"
				_tmp19_ = i;
#line 823 "../folks/individual-aggregator.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, _tmp19_, (gpointer) ((gintptr) _result_));
#line 2509 "individual-aggregator.c"
			}
#line 815 "../folks/individual-aggregator.vala"
			_g_object_unref0 (i);
#line 2513 "individual-aggregator.c"
		}
#line 815 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_i_it);
#line 2517 "individual-aggregator.c"
	}
#line 827 "../folks/individual-aggregator.vala"
	result = (GeeMap*) matches;
#line 827 "../folks/individual-aggregator.vala"
	_g_object_unref0 (matchObj);
#line 827 "../folks/individual-aggregator.vala"
	return result;
#line 2525 "individual-aggregator.c"
}

/**
   * Get all combinations between all {@link Individual}s.
   *
   * @param min_threshold the threshold for accepting a match
   * @return a map from each individual in the aggregator to a map of the
   * other individuals in the aggregator which can be matched with that
   * individual, mapped to the degree with which they match the original
   * individual (which is guaranteed to at least equal ``min_threshold``)
   *
   * @since 0.5.1
   */
GeeMap*
folks_individual_aggregator_get_all_potential_matches (FolksIndividualAggregator* self,
                                                       FolksMatchResult min_threshold)
{
	GeeHashMap* matches = NULL;
	GeeHashMap* _tmp0_;
	FolksIndividual** individuals = NULL;
	GeeMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	gint _tmp5_ = 0;
	gpointer* _tmp6_;
	FolksIndividual** _tmp7_;
	gint _tmp7__length1;
	gint individuals_length1;
	gint _individuals_size_;
	FolksPotentialMatch* matchObj = NULL;
	FolksPotentialMatch* _tmp8_;
	GeeMap* result;
#line 841 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 845 "../folks/individual-aggregator.vala"
	_tmp0_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_HASH_MAP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 845 "../folks/individual-aggregator.vala"
	matches = _tmp0_;
#line 847 "../folks/individual-aggregator.vala"
	_tmp1_ = self->priv->_individuals;
#line 847 "../folks/individual-aggregator.vala"
	_tmp2_ = gee_map_get_values (_tmp1_);
#line 847 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 847 "../folks/individual-aggregator.vala"
	_tmp4_ = _tmp3_;
#line 847 "../folks/individual-aggregator.vala"
	_tmp6_ = gee_collection_to_array (_tmp4_, &_tmp5_);
#line 847 "../folks/individual-aggregator.vala"
	_tmp7_ = _tmp6_;
#line 847 "../folks/individual-aggregator.vala"
	_tmp7__length1 = _tmp5_;
#line 847 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp4_);
#line 847 "../folks/individual-aggregator.vala"
	individuals = _tmp7_;
#line 847 "../folks/individual-aggregator.vala"
	individuals_length1 = _tmp7__length1;
#line 847 "../folks/individual-aggregator.vala"
	_individuals_size_ = individuals_length1;
#line 848 "../folks/individual-aggregator.vala"
	_tmp8_ = folks_potential_match_new ();
#line 848 "../folks/individual-aggregator.vala"
	matchObj = _tmp8_;
#line 2591 "individual-aggregator.c"
	{
		gint i = 0;
#line 850 "../folks/individual-aggregator.vala"
		i = 0;
#line 2596 "individual-aggregator.c"
		{
			gboolean _tmp9_ = FALSE;
#line 850 "../folks/individual-aggregator.vala"
			_tmp9_ = TRUE;
#line 850 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 2603 "individual-aggregator.c"
				FolksIndividual** _tmp11_;
				gint _tmp11__length1;
				FolksIndividual* a = NULL;
				FolksIndividual** _tmp12_;
				gint _tmp12__length1;
				FolksIndividual* _tmp13_;
				FolksIndividual* _tmp14_;
				GeeHashMap* _matches_a = NULL;
				GeeHashMap* _tmp15_;
				FolksIndividual* _tmp16_;
				gpointer _tmp17_;
				GeeHashMap* matches_a = NULL;
				GeeHashMap* _tmp18_;
#line 850 "../folks/individual-aggregator.vala"
				if (!_tmp9_) {
#line 2619 "individual-aggregator.c"
					gint _tmp10_;
#line 850 "../folks/individual-aggregator.vala"
					_tmp10_ = i;
#line 850 "../folks/individual-aggregator.vala"
					i = _tmp10_ + 1;
#line 2625 "individual-aggregator.c"
				}
#line 850 "../folks/individual-aggregator.vala"
				_tmp9_ = FALSE;
#line 850 "../folks/individual-aggregator.vala"
				_tmp11_ = individuals;
#line 850 "../folks/individual-aggregator.vala"
				_tmp11__length1 = individuals_length1;
#line 850 "../folks/individual-aggregator.vala"
				if (!(i < _tmp11__length1)) {
#line 850 "../folks/individual-aggregator.vala"
					break;
#line 2637 "individual-aggregator.c"
				}
#line 852 "../folks/individual-aggregator.vala"
				_tmp12_ = individuals;
#line 852 "../folks/individual-aggregator.vala"
				_tmp12__length1 = individuals_length1;
#line 852 "../folks/individual-aggregator.vala"
				_tmp13_ = _tmp12_[i];
#line 852 "../folks/individual-aggregator.vala"
				_tmp14_ = _g_object_ref0 (_tmp13_);
#line 852 "../folks/individual-aggregator.vala"
				a = _tmp14_;
#line 854 "../folks/individual-aggregator.vala"
				_tmp15_ = matches;
#line 854 "../folks/individual-aggregator.vala"
				_tmp16_ = a;
#line 854 "../folks/individual-aggregator.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp15_, _tmp16_);
#line 854 "../folks/individual-aggregator.vala"
				_matches_a = (GeeHashMap*) _tmp17_;
#line 856 "../folks/individual-aggregator.vala"
				_tmp18_ = _matches_a;
#line 856 "../folks/individual-aggregator.vala"
				if (_tmp18_ == NULL) {
#line 2661 "individual-aggregator.c"
					GeeHashMap* _tmp19_;
					GeeHashMap* _tmp20_;
					FolksIndividual* _tmp21_;
					GeeHashMap* _tmp22_;
#line 858 "../folks/individual-aggregator.vala"
					_tmp19_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_MATCH_RESULT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 858 "../folks/individual-aggregator.vala"
					_g_object_unref0 (matches_a);
#line 858 "../folks/individual-aggregator.vala"
					matches_a = _tmp19_;
#line 859 "../folks/individual-aggregator.vala"
					_tmp20_ = matches;
#line 859 "../folks/individual-aggregator.vala"
					_tmp21_ = a;
#line 859 "../folks/individual-aggregator.vala"
					_tmp22_ = matches_a;
#line 859 "../folks/individual-aggregator.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp20_, _tmp21_, _tmp22_);
#line 2680 "individual-aggregator.c"
				} else {
					GeeHashMap* _tmp23_;
					GeeHashMap* _tmp24_;
#line 863 "../folks/individual-aggregator.vala"
					_tmp23_ = _matches_a;
#line 863 "../folks/individual-aggregator.vala"
					_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_HASH_MAP, GeeHashMap));
#line 863 "../folks/individual-aggregator.vala"
					_g_object_unref0 (matches_a);
#line 863 "../folks/individual-aggregator.vala"
					matches_a = _tmp24_;
#line 2692 "individual-aggregator.c"
				}
				{
					gint f = 0;
#line 866 "../folks/individual-aggregator.vala"
					f = i + 1;
#line 2698 "individual-aggregator.c"
					{
						gboolean _tmp25_ = FALSE;
#line 866 "../folks/individual-aggregator.vala"
						_tmp25_ = TRUE;
#line 866 "../folks/individual-aggregator.vala"
						while (TRUE) {
#line 2705 "individual-aggregator.c"
							FolksIndividual** _tmp27_;
							gint _tmp27__length1;
							FolksIndividual* b = NULL;
							FolksIndividual** _tmp28_;
							gint _tmp28__length1;
							FolksIndividual* _tmp29_;
							FolksIndividual* _tmp30_;
							GeeHashMap* _matches_b = NULL;
							GeeHashMap* _tmp31_;
							FolksIndividual* _tmp32_;
							gpointer _tmp33_;
							GeeHashMap* matches_b = NULL;
							GeeHashMap* _tmp34_;
							FolksMatchResult _result_ = 0;
							FolksPotentialMatch* _tmp41_;
							FolksIndividual* _tmp42_;
							FolksIndividual* _tmp43_;
#line 866 "../folks/individual-aggregator.vala"
							if (!_tmp25_) {
#line 2725 "individual-aggregator.c"
								gint _tmp26_;
#line 866 "../folks/individual-aggregator.vala"
								_tmp26_ = f;
#line 866 "../folks/individual-aggregator.vala"
								f = _tmp26_ + 1;
#line 2731 "individual-aggregator.c"
							}
#line 866 "../folks/individual-aggregator.vala"
							_tmp25_ = FALSE;
#line 866 "../folks/individual-aggregator.vala"
							_tmp27_ = individuals;
#line 866 "../folks/individual-aggregator.vala"
							_tmp27__length1 = individuals_length1;
#line 866 "../folks/individual-aggregator.vala"
							if (!(f < _tmp27__length1)) {
#line 866 "../folks/individual-aggregator.vala"
								break;
#line 2743 "individual-aggregator.c"
							}
#line 868 "../folks/individual-aggregator.vala"
							_tmp28_ = individuals;
#line 868 "../folks/individual-aggregator.vala"
							_tmp28__length1 = individuals_length1;
#line 868 "../folks/individual-aggregator.vala"
							_tmp29_ = _tmp28_[f];
#line 868 "../folks/individual-aggregator.vala"
							_tmp30_ = _g_object_ref0 (_tmp29_);
#line 868 "../folks/individual-aggregator.vala"
							b = _tmp30_;
#line 870 "../folks/individual-aggregator.vala"
							_tmp31_ = matches;
#line 870 "../folks/individual-aggregator.vala"
							_tmp32_ = b;
#line 870 "../folks/individual-aggregator.vala"
							_tmp33_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, _tmp32_);
#line 870 "../folks/individual-aggregator.vala"
							_matches_b = (GeeHashMap*) _tmp33_;
#line 872 "../folks/individual-aggregator.vala"
							_tmp34_ = _matches_b;
#line 872 "../folks/individual-aggregator.vala"
							if (_tmp34_ == NULL) {
#line 2767 "individual-aggregator.c"
								GeeHashMap* _tmp35_;
								GeeHashMap* _tmp36_;
								FolksIndividual* _tmp37_;
								GeeHashMap* _tmp38_;
#line 874 "../folks/individual-aggregator.vala"
								_tmp35_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_MATCH_RESULT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 874 "../folks/individual-aggregator.vala"
								_g_object_unref0 (matches_b);
#line 874 "../folks/individual-aggregator.vala"
								matches_b = _tmp35_;
#line 875 "../folks/individual-aggregator.vala"
								_tmp36_ = matches;
#line 875 "../folks/individual-aggregator.vala"
								_tmp37_ = b;
#line 875 "../folks/individual-aggregator.vala"
								_tmp38_ = matches_b;
#line 875 "../folks/individual-aggregator.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, _tmp37_, _tmp38_);
#line 2786 "individual-aggregator.c"
							} else {
								GeeHashMap* _tmp39_;
								GeeHashMap* _tmp40_;
#line 879 "../folks/individual-aggregator.vala"
								_tmp39_ = _matches_b;
#line 879 "../folks/individual-aggregator.vala"
								_tmp40_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_HASH_MAP, GeeHashMap));
#line 879 "../folks/individual-aggregator.vala"
								_g_object_unref0 (matches_b);
#line 879 "../folks/individual-aggregator.vala"
								matches_b = _tmp40_;
#line 2798 "individual-aggregator.c"
							}
#line 882 "../folks/individual-aggregator.vala"
							_tmp41_ = matchObj;
#line 882 "../folks/individual-aggregator.vala"
							_tmp42_ = a;
#line 882 "../folks/individual-aggregator.vala"
							_tmp43_ = b;
#line 882 "../folks/individual-aggregator.vala"
							_result_ = folks_potential_match_potential_match (_tmp41_, _tmp42_, _tmp43_);
#line 884 "../folks/individual-aggregator.vala"
							if (_result_ >= min_threshold) {
#line 2810 "individual-aggregator.c"
								GeeHashMap* _tmp44_;
								FolksIndividual* _tmp45_;
								GeeHashMap* _tmp46_;
								FolksIndividual* _tmp47_;
#line 886 "../folks/individual-aggregator.vala"
								_tmp44_ = matches_a;
#line 886 "../folks/individual-aggregator.vala"
								_tmp45_ = b;
#line 886 "../folks/individual-aggregator.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp44_, _tmp45_, (gpointer) ((gintptr) _result_));
#line 887 "../folks/individual-aggregator.vala"
								_tmp46_ = matches_b;
#line 887 "../folks/individual-aggregator.vala"
								_tmp47_ = a;
#line 887 "../folks/individual-aggregator.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp46_, _tmp47_, (gpointer) ((gintptr) _result_));
#line 2827 "individual-aggregator.c"
							}
#line 866 "../folks/individual-aggregator.vala"
							_g_object_unref0 (matches_b);
#line 866 "../folks/individual-aggregator.vala"
							_g_object_unref0 (_matches_b);
#line 866 "../folks/individual-aggregator.vala"
							_g_object_unref0 (b);
#line 2835 "individual-aggregator.c"
						}
					}
				}
#line 850 "../folks/individual-aggregator.vala"
				_g_object_unref0 (matches_a);
#line 850 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_matches_a);
#line 850 "../folks/individual-aggregator.vala"
				_g_object_unref0 (a);
#line 2845 "individual-aggregator.c"
			}
		}
	}
#line 892 "../folks/individual-aggregator.vala"
	result = (GeeMap*) matches;
#line 892 "../folks/individual-aggregator.vala"
	_g_object_unref0 (matchObj);
#line 892 "../folks/individual-aggregator.vala"
	individuals = (_vala_array_free (individuals, individuals_length1, (GDestroyNotify) g_object_unref), NULL);
#line 892 "../folks/individual-aggregator.vala"
	return result;
#line 2857 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_backend_persona_store_added_cb_folks_backend_persona_store_added (FolksBackend* _sender,
                                                                                                FolksPersonaStore* store,
                                                                                                gpointer self)
{
#line 901 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_backend_persona_store_added_cb ((FolksIndividualAggregator*) self, _sender, store);
#line 2867 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_backend_persona_store_removed_cb_folks_backend_persona_store_removed (FolksBackend* _sender,
                                                                                                    FolksPersonaStore* store,
                                                                                                    gpointer self)
{
#line 903 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_backend_persona_store_removed_cb ((FolksIndividualAggregator*) self, _sender, store);
#line 2877 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_backend_is_quiescent_changed_cb_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self)
{
#line 905 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_backend_is_quiescent_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 2887 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_add_backend (FolksIndividualAggregator* self,
                                          FolksBackend* backend)
{
	FolksSmallSet* _tmp0_;
#line 895 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 895 "../folks/individual-aggregator.vala"
	g_return_if_fail (backend != NULL);
#line 897 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_backends;
#line 897 "../folks/individual-aggregator.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, backend)) {
#line 2903 "individual-aggregator.c"
		FolksSmallSet* _tmp1_;
		FolksPersonaStore** stores = NULL;
		GeeMap* _tmp2_;
		GeeMap* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		gint _tmp7_ = 0;
		gpointer* _tmp8_;
		FolksPersonaStore** _tmp9_;
		gint _tmp9__length1;
		gint stores_length1;
		gint _stores_size_;
		FolksPersonaStore** _tmp10_;
		gint _tmp10__length1;
#line 899 "../folks/individual-aggregator.vala"
		_tmp1_ = self->priv->_backends;
#line 899 "../folks/individual-aggregator.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, backend);
#line 901 "../folks/individual-aggregator.vala"
		g_signal_connect_object (backend, "persona-store-added", (GCallback) __folks_individual_aggregator_backend_persona_store_added_cb_folks_backend_persona_store_added, self, 0);
#line 903 "../folks/individual-aggregator.vala"
		g_signal_connect_object (backend, "persona-store-removed", (GCallback) __folks_individual_aggregator_backend_persona_store_removed_cb_folks_backend_persona_store_removed, self, 0);
#line 905 "../folks/individual-aggregator.vala"
		g_signal_connect_object ((GObject*) backend, "notify::is-quiescent", (GCallback) __folks_individual_aggregator_backend_is_quiescent_changed_cb_g_object_notify, self, 0);
#line 911 "../folks/individual-aggregator.vala"
		_tmp2_ = folks_backend_get_persona_stores (backend);
#line 911 "../folks/individual-aggregator.vala"
		_tmp3_ = _tmp2_;
#line 911 "../folks/individual-aggregator.vala"
		_tmp4_ = gee_map_get_values (_tmp3_);
#line 911 "../folks/individual-aggregator.vala"
		_tmp5_ = _tmp4_;
#line 911 "../folks/individual-aggregator.vala"
		_tmp6_ = _tmp5_;
#line 911 "../folks/individual-aggregator.vala"
		_tmp8_ = gee_collection_to_array (_tmp6_, &_tmp7_);
#line 911 "../folks/individual-aggregator.vala"
		_tmp9_ = _tmp8_;
#line 911 "../folks/individual-aggregator.vala"
		_tmp9__length1 = _tmp7_;
#line 911 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp6_);
#line 911 "../folks/individual-aggregator.vala"
		stores = _tmp9_;
#line 911 "../folks/individual-aggregator.vala"
		stores_length1 = _tmp9__length1;
#line 911 "../folks/individual-aggregator.vala"
		_stores_size_ = stores_length1;
#line 912 "../folks/individual-aggregator.vala"
		_tmp10_ = stores;
#line 912 "../folks/individual-aggregator.vala"
		_tmp10__length1 = stores_length1;
#line 2957 "individual-aggregator.c"
		{
			FolksPersonaStore** persona_store_collection = NULL;
			gint persona_store_collection_length1 = 0;
			gint _persona_store_collection_size_ = 0;
			gint persona_store_it = 0;
#line 912 "../folks/individual-aggregator.vala"
			persona_store_collection = _tmp10_;
#line 912 "../folks/individual-aggregator.vala"
			persona_store_collection_length1 = _tmp10__length1;
#line 912 "../folks/individual-aggregator.vala"
			for (persona_store_it = 0; persona_store_it < persona_store_collection_length1; persona_store_it = persona_store_it + 1) {
#line 2969 "individual-aggregator.c"
				FolksPersonaStore* _tmp11_;
				FolksPersonaStore* persona_store = NULL;
#line 912 "../folks/individual-aggregator.vala"
				_tmp11_ = _g_object_ref0 (persona_store_collection[persona_store_it]);
#line 912 "../folks/individual-aggregator.vala"
				persona_store = _tmp11_;
#line 2976 "individual-aggregator.c"
				{
					FolksPersonaStore* _tmp12_;
#line 914 "../folks/individual-aggregator.vala"
					_tmp12_ = persona_store;
#line 914 "../folks/individual-aggregator.vala"
					_folks_individual_aggregator_backend_persona_store_added_cb (self, backend, _tmp12_);
#line 912 "../folks/individual-aggregator.vala"
					_g_object_unref0 (persona_store);
#line 2985 "individual-aggregator.c"
				}
			}
		}
#line 897 "../folks/individual-aggregator.vala"
		stores = (_vala_array_free (stores, stores_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2991 "individual-aggregator.c"
	}
}

static gboolean
__folks_individual_aggregator_quiescent_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = _folks_individual_aggregator_quiescent_timeout_cb ((FolksIndividualAggregator*) self);
#line 935 "../folks/individual-aggregator.vala"
	return result;
#line 3002 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_backend_available_cb (FolksIndividualAggregator* self,
                                                   FolksBackendStore* backend_store,
                                                   FolksBackend* backend)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 919 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 919 "../folks/individual-aggregator.vala"
	g_return_if_fail (backend_store != NULL);
#line 919 "../folks/individual-aggregator.vala"
	g_return_if_fail (backend != NULL);
#line 927 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_backend_get_is_quiescent (backend);
#line 927 "../folks/individual-aggregator.vala"
	_tmp1_ = _tmp0_;
#line 927 "../folks/individual-aggregator.vala"
	if (_tmp1_ == FALSE) {
#line 3024 "individual-aggregator.c"
		guint _tmp2_;
#line 929 "../folks/individual-aggregator.vala"
		_tmp2_ = self->priv->_non_quiescent_backend_count;
#line 929 "../folks/individual-aggregator.vala"
		self->priv->_non_quiescent_backend_count = _tmp2_ + 1;
#line 933 "../folks/individual-aggregator.vala"
		if (self->priv->_quiescent_timeout_id == ((guint) 0)) {
#line 935 "../folks/individual-aggregator.vala"
			self->priv->_quiescent_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, FOLKS_INDIVIDUAL_AGGREGATOR__QUIESCENT_TIMEOUT, __folks_individual_aggregator_quiescent_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 3034 "individual-aggregator.c"
		}
	}
#line 941 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_add_backend (self, backend);
#line 3039 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_set_primary_store (FolksIndividualAggregator* self,
                                                FolksPersonaStore* store)
{
	FolksPersonaStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 944 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 944 "../folks/individual-aggregator.vala"
	g_return_if_fail (store != NULL);
#line 946 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:946: _set_primary_store()");
#line 948 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_primary_store;
#line 948 "../folks/individual-aggregator.vala"
	if (_tmp0_ == store) {
#line 949 "../folks/individual-aggregator.vala"
		return;
#line 3062 "individual-aggregator.c"
	}
#line 957 "../folks/individual-aggregator.vala"
	_tmp1_ = folks_persona_store_get_type_id (store);
#line 957 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp1_;
#line 957 "../folks/individual-aggregator.vala"
	_tmp3_ = self->priv->_configured_primary_store_type_id;
#line 957 "../folks/individual-aggregator.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 3072 "individual-aggregator.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 959 "../folks/individual-aggregator.vala"
		_tmp6_ = folks_persona_store_get_type_id (store);
#line 959 "../folks/individual-aggregator.vala"
		_tmp7_ = _tmp6_;
#line 959 "../folks/individual-aggregator.vala"
		if (g_strcmp0 (_tmp7_, "eds") != 0) {
#line 3083 "individual-aggregator.c"
			const gchar* _tmp8_;
#line 960 "../folks/individual-aggregator.vala"
			_tmp8_ = self->priv->_configured_primary_store_id;
#line 960 "../folks/individual-aggregator.vala"
			_tmp5_ = g_strcmp0 (_tmp8_, "") == 0;
#line 3089 "individual-aggregator.c"
		} else {
#line 959 "../folks/individual-aggregator.vala"
			_tmp5_ = FALSE;
#line 3093 "individual-aggregator.c"
		}
#line 959 "../folks/individual-aggregator.vala"
		if (_tmp5_) {
#line 959 "../folks/individual-aggregator.vala"
			_tmp4_ = TRUE;
#line 3099 "individual-aggregator.c"
		} else {
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 961 "../folks/individual-aggregator.vala"
			_tmp9_ = self->priv->_configured_primary_store_id;
#line 961 "../folks/individual-aggregator.vala"
			_tmp10_ = folks_persona_store_get_id (store);
#line 961 "../folks/individual-aggregator.vala"
			_tmp11_ = _tmp10_;
#line 961 "../folks/individual-aggregator.vala"
			_tmp4_ = g_strcmp0 (_tmp9_, _tmp11_) == 0;
#line 3112 "individual-aggregator.c"
		}
#line 959 "../folks/individual-aggregator.vala"
		if (_tmp4_) {
#line 3116 "individual-aggregator.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			FolksPersonaStore* previous_store = NULL;
			FolksPersonaStore* _tmp16_;
			FolksPersonaStore* _tmp17_;
			FolksPersonaStore* _tmp18_;
			FolksPersonaStore* _tmp21_;
#line 963 "../folks/individual-aggregator.vala"
			_tmp12_ = folks_persona_store_get_type_id (store);
#line 963 "../folks/individual-aggregator.vala"
			_tmp13_ = _tmp12_;
#line 963 "../folks/individual-aggregator.vala"
			_tmp14_ = folks_persona_store_get_id (store);
#line 963 "../folks/individual-aggregator.vala"
			_tmp15_ = _tmp14_;
#line 963 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:963: Setting primary store to %p (type ID: " \
"%s, ID: %s)", store, _tmp13_, _tmp15_);
#line 966 "../folks/individual-aggregator.vala"
			_tmp16_ = self->priv->_primary_store;
#line 966 "../folks/individual-aggregator.vala"
			_tmp17_ = _g_object_ref0 (_tmp16_);
#line 966 "../folks/individual-aggregator.vala"
			previous_store = _tmp17_;
#line 967 "../folks/individual-aggregator.vala"
			self->priv->_primary_store = store;
#line 969 "../folks/individual-aggregator.vala"
			g_object_freeze_notify ((GObject*) store);
#line 970 "../folks/individual-aggregator.vala"
			_tmp18_ = previous_store;
#line 970 "../folks/individual-aggregator.vala"
			if (_tmp18_ != NULL) {
#line 3150 "individual-aggregator.c"
				FolksPersonaStore* _tmp19_;
				FolksPersonaStore* _tmp20_;
#line 972 "../folks/individual-aggregator.vala"
				_tmp19_ = previous_store;
#line 972 "../folks/individual-aggregator.vala"
				g_object_freeze_notify ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore));
#line 973 "../folks/individual-aggregator.vala"
				_tmp20_ = previous_store;
#line 973 "../folks/individual-aggregator.vala"
				folks_persona_store_set_is_primary_store (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore), FALSE);
#line 3161 "individual-aggregator.c"
			}
#line 975 "../folks/individual-aggregator.vala"
			folks_persona_store_set_is_primary_store (store, TRUE);
#line 976 "../folks/individual-aggregator.vala"
			_tmp21_ = previous_store;
#line 976 "../folks/individual-aggregator.vala"
			if (_tmp21_ != NULL) {
#line 3169 "individual-aggregator.c"
				FolksPersonaStore* _tmp22_;
#line 977 "../folks/individual-aggregator.vala"
				_tmp22_ = previous_store;
#line 977 "../folks/individual-aggregator.vala"
				g_object_thaw_notify ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore));
#line 3175 "individual-aggregator.c"
			}
#line 978 "../folks/individual-aggregator.vala"
			g_object_thaw_notify ((GObject*) store);
#line 980 "../folks/individual-aggregator.vala"
			g_object_notify ((GObject*) self, "primary-store");
#line 959 "../folks/individual-aggregator.vala"
			_g_object_unref0 (previous_store);
#line 3183 "individual-aggregator.c"
		}
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 985 "../folks/individual-aggregator.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 985 "../folks/individual-aggregator.vala"
	return _data2_;
#line 3195 "individual-aggregator.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 985 "../folks/individual-aggregator.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 3205 "individual-aggregator.c"
		FolksIndividualAggregator* self;
#line 985 "../folks/individual-aggregator.vala"
		self = _data2_->self;
#line 985 "../folks/individual-aggregator.vala"
		_g_free0 (_data2_->store_id);
#line 985 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data2_->store);
#line 985 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self);
#line 985 "../folks/individual-aggregator.vala"
		g_slice_free (Block2Data, _data2_);
#line 3217 "individual-aggregator.c"
	}
}

static void
__folks_individual_aggregator_personas_changed_cb_folks_persona_store_personas_changed (FolksPersonaStore* _sender,
                                                                                        GeeSet* added,
                                                                                        GeeSet* removed,
                                                                                        const gchar* message,
                                                                                        FolksPersona* actor,
                                                                                        FolksGroupDetailsChangeReason reason,
                                                                                        gpointer self)
{
#line 997 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_personas_changed_cb ((FolksIndividualAggregator*) self, _sender, added, removed, message, actor, reason);
#line 3232 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_is_primary_store_changed_cb_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self)
{
#line 998 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_is_primary_store_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 3242 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_persona_store_is_quiescent_changed_cb_g_object_notify (GObject* _sender,
                                                                                     GParamSpec* pspec,
                                                                                     gpointer self)
{
#line 1000 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_persona_store_is_quiescent_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 3252 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_persona_store_is_user_set_default_changed_cb_g_object_notify (GObject* _sender,
                                                                                            GParamSpec* pspec,
                                                                                            gpointer self)
{
#line 1002 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_persona_store_is_user_set_default_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 3262 "individual-aggregator.c"
}

static void
__lambda69_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* _result_)
{
	FolksIndividualAggregator* self;
	GError* _inner_error0_ = NULL;
#line 1042 "../folks/individual-aggregator.vala"
	self = _data2_->self;
#line 1042 "../folks/individual-aggregator.vala"
	g_return_if_fail (_result_ != NULL);
#line 3276 "individual-aggregator.c"
	{
#line 1046 "../folks/individual-aggregator.vala"
		folks_persona_store_prepare_finish (_data2_->store, _result_, &_inner_error0_);
#line 1046 "../folks/individual-aggregator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3282 "individual-aggregator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1044 "../folks/individual-aggregator.vala"
		e = _inner_error0_;
#line 1044 "../folks/individual-aggregator.vala"
		_inner_error0_ = NULL;
#line 1052 "../folks/individual-aggregator.vala"
		_tmp0_ = _data2_->store_id;
#line 1052 "../folks/individual-aggregator.vala"
		_tmp1_ = e;
#line 1052 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp1_->message;
#line 1052 "../folks/individual-aggregator.vala"
		g_warning (_ ("Error preparing persona store ‘%s’: %s"), _tmp0_, _tmp2_);
#line 1044 "../folks/individual-aggregator.vala"
		_g_error_free0 (e);
#line 3307 "individual-aggregator.c"
	}
	__finally0:
#line 1044 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1044 "../folks/individual-aggregator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1044 "../folks/individual-aggregator.vala"
		g_clear_error (&_inner_error0_);
#line 1044 "../folks/individual-aggregator.vala"
		return;
#line 3318 "individual-aggregator.c"
	}
}

static void
___lambda69__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 1042 "../folks/individual-aggregator.vala"
	__lambda69_ (self, source_object, res);
#line 1042 "../folks/individual-aggregator.vala"
	block2_data_unref (self);
#line 3331 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_backend_persona_store_added_cb (FolksIndividualAggregator* self,
                                                             FolksBackend* backend,
                                                             FolksPersonaStore* store)
{
	Block2Data* _data2_;
	FolksPersonaStore* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GeeHashMap* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	GeeMap* _tmp15_;
	GeeMap* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
#line 985 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 985 "../folks/individual-aggregator.vala"
	g_return_if_fail (backend != NULL);
#line 985 "../folks/individual-aggregator.vala"
	g_return_if_fail (store != NULL);
#line 985 "../folks/individual-aggregator.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 985 "../folks/individual-aggregator.vala"
	_data2_->_ref_count_ = 1;
#line 985 "../folks/individual-aggregator.vala"
	_data2_->self = g_object_ref (self);
#line 985 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (store);
#line 985 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data2_->store);
#line 985 "../folks/individual-aggregator.vala"
	_data2_->store = _tmp0_;
#line 988 "../folks/individual-aggregator.vala"
	_tmp1_ = folks_backend_get_name (backend);
#line 988 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp1_;
#line 988 "../folks/individual-aggregator.vala"
	_tmp3_ = folks_persona_store_get_id (_data2_->store);
#line 988 "../folks/individual-aggregator.vala"
	_tmp4_ = _tmp3_;
#line 988 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:988: _backend_persona_store_added_cb(): bac" \
"kend: %s, store: %s (%p)", _tmp2_, _tmp4_, _data2_->store);
#line 991 "../folks/individual-aggregator.vala"
	_tmp5_ = folks_persona_store_get_type_id (_data2_->store);
#line 991 "../folks/individual-aggregator.vala"
	_tmp6_ = _tmp5_;
#line 991 "../folks/individual-aggregator.vala"
	_tmp7_ = folks_persona_store_get_id (_data2_->store);
#line 991 "../folks/individual-aggregator.vala"
	_tmp8_ = _tmp7_;
#line 991 "../folks/individual-aggregator.vala"
	_tmp9_ = _folks_individual_aggregator_get_store_full_id (self, _tmp6_, _tmp8_);
#line 991 "../folks/individual-aggregator.vala"
	_data2_->store_id = _tmp9_;
#line 993 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_maybe_configure_as_primary (self, _data2_->store);
#line 994 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_set_primary_store (self, _data2_->store);
#line 996 "../folks/individual-aggregator.vala"
	_tmp10_ = self->priv->_stores;
#line 996 "../folks/individual-aggregator.vala"
	_tmp11_ = _data2_->store_id;
#line 996 "../folks/individual-aggregator.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, _data2_->store);
#line 997 "../folks/individual-aggregator.vala"
	g_signal_connect_object (_data2_->store, "personas-changed", (GCallback) __folks_individual_aggregator_personas_changed_cb_folks_persona_store_personas_changed, self, 0);
#line 998 "../folks/individual-aggregator.vala"
	g_signal_connect_object ((GObject*) _data2_->store, "notify::is-primary-store", (GCallback) __folks_individual_aggregator_is_primary_store_changed_cb_g_object_notify, self, 0);
#line 1000 "../folks/individual-aggregator.vala"
	g_signal_connect_object ((GObject*) _data2_->store, "notify::is-quiescent", (GCallback) __folks_individual_aggregator_persona_store_is_quiescent_changed_cb_g_object_notify, self, 0);
#line 1002 "../folks/individual-aggregator.vala"
	g_signal_connect_object ((GObject*) _data2_->store, "notify::is-user-set-default", (GCallback) __folks_individual_aggregator_persona_store_is_user_set_default_changed_cb_g_object_notify, self, 0);
#line 1010 "../folks/individual-aggregator.vala"
	_tmp12_ = folks_persona_store_get_is_quiescent (_data2_->store);
#line 1010 "../folks/individual-aggregator.vala"
	_tmp13_ = _tmp12_;
#line 1010 "../folks/individual-aggregator.vala"
	if (_tmp13_ == FALSE) {
#line 3422 "individual-aggregator.c"
		guint _tmp14_;
#line 1012 "../folks/individual-aggregator.vala"
		_tmp14_ = self->priv->_non_quiescent_persona_store_count;
#line 1012 "../folks/individual-aggregator.vala"
		self->priv->_non_quiescent_persona_store_count = _tmp14_ + 1;
#line 1016 "../folks/individual-aggregator.vala"
		if (self->priv->_quiescent_timeout_id == ((guint) 0)) {
#line 1018 "../folks/individual-aggregator.vala"
			self->priv->_quiescent_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, FOLKS_INDIVIDUAL_AGGREGATOR__QUIESCENT_TIMEOUT, __folks_individual_aggregator_quiescent_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 3432 "individual-aggregator.c"
		}
	}
#line 1027 "../folks/individual-aggregator.vala"
	_tmp15_ = folks_persona_store_get_personas (_data2_->store);
#line 1027 "../folks/individual-aggregator.vala"
	_tmp16_ = _tmp15_;
#line 1027 "../folks/individual-aggregator.vala"
	_tmp17_ = gee_map_get_size (_tmp16_);
#line 1027 "../folks/individual-aggregator.vala"
	_tmp18_ = _tmp17_;
#line 1027 "../folks/individual-aggregator.vala"
	if (_tmp18_ > 0) {
#line 3445 "individual-aggregator.c"
		GeeHashSet* persona_set = NULL;
		GeeHashSet* _tmp19_;
		GeeHashSet* _tmp32_;
		FolksSmallSet* _tmp33_;
		FolksSmallSet* _tmp34_;
#line 1029 "../folks/individual-aggregator.vala"
		_tmp19_ = gee_hash_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1029 "../folks/individual-aggregator.vala"
		persona_set = _tmp19_;
#line 3455 "individual-aggregator.c"
		{
			GeeIterator* _p_it = NULL;
			GeeMap* _tmp20_;
			GeeMap* _tmp21_;
			GeeCollection* _tmp22_;
			GeeCollection* _tmp23_;
			GeeCollection* _tmp24_;
			GeeIterator* _tmp25_;
			GeeIterator* _tmp26_;
#line 1030 "../folks/individual-aggregator.vala"
			_tmp20_ = folks_persona_store_get_personas (_data2_->store);
#line 1030 "../folks/individual-aggregator.vala"
			_tmp21_ = _tmp20_;
#line 1030 "../folks/individual-aggregator.vala"
			_tmp22_ = gee_map_get_values (_tmp21_);
#line 1030 "../folks/individual-aggregator.vala"
			_tmp23_ = _tmp22_;
#line 1030 "../folks/individual-aggregator.vala"
			_tmp24_ = _tmp23_;
#line 1030 "../folks/individual-aggregator.vala"
			_tmp25_ = gee_iterable_iterator ((GeeIterable*) _tmp24_);
#line 1030 "../folks/individual-aggregator.vala"
			_tmp26_ = _tmp25_;
#line 1030 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_tmp24_);
#line 1030 "../folks/individual-aggregator.vala"
			_p_it = _tmp26_;
#line 1030 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 3485 "individual-aggregator.c"
				GeeIterator* _tmp27_;
				FolksPersona* p = NULL;
				GeeIterator* _tmp28_;
				gpointer _tmp29_;
				GeeHashSet* _tmp30_;
				FolksPersona* _tmp31_;
#line 1030 "../folks/individual-aggregator.vala"
				_tmp27_ = _p_it;
#line 1030 "../folks/individual-aggregator.vala"
				if (!gee_iterator_next (_tmp27_)) {
#line 1030 "../folks/individual-aggregator.vala"
					break;
#line 3498 "individual-aggregator.c"
				}
#line 1030 "../folks/individual-aggregator.vala"
				_tmp28_ = _p_it;
#line 1030 "../folks/individual-aggregator.vala"
				_tmp29_ = gee_iterator_get (_tmp28_);
#line 1030 "../folks/individual-aggregator.vala"
				p = (FolksPersona*) _tmp29_;
#line 1032 "../folks/individual-aggregator.vala"
				_tmp30_ = persona_set;
#line 1032 "../folks/individual-aggregator.vala"
				_tmp31_ = p;
#line 1032 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 1030 "../folks/individual-aggregator.vala"
				_g_object_unref0 (p);
#line 3514 "individual-aggregator.c"
			}
#line 1030 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_p_it);
#line 3518 "individual-aggregator.c"
		}
#line 1035 "../folks/individual-aggregator.vala"
		_tmp32_ = persona_set;
#line 1035 "../folks/individual-aggregator.vala"
		_tmp33_ = folks_small_set_empty (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1035 "../folks/individual-aggregator.vala"
		_tmp34_ = _tmp33_;
#line 1035 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_personas_changed_cb (self, _data2_->store, (GeeSet*) _tmp32_, (GeeSet*) _tmp34_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1035 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp34_);
#line 1027 "../folks/individual-aggregator.vala"
		_g_object_unref0 (persona_set);
#line 3532 "individual-aggregator.c"
	}
#line 1042 "../folks/individual-aggregator.vala"
	folks_persona_store_prepare (_data2_->store, ___lambda69__gasync_ready_callback, block2_data_ref (_data2_));
#line 985 "../folks/individual-aggregator.vala"
	block2_data_unref (_data2_);
#line 985 "../folks/individual-aggregator.vala"
	_data2_ = NULL;
#line 3540 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_backend_persona_store_removed_cb (FolksIndividualAggregator* self,
                                                               FolksBackend* backend,
                                                               FolksPersonaStore* store)
{
	guint _tmp0_;
	guint _tmp1_;
	GQuark _tmp2_;
	guint _tmp3_;
	GQuark _tmp4_;
	guint _tmp5_;
	GQuark _tmp6_;
	gboolean _tmp7_ = FALSE;
	GeeHashSet* removed_personas = NULL;
	GeeHashSet* _tmp11_;
	GeeMapIterator* iter = NULL;
	GeeMap* _tmp12_;
	GeeMap* _tmp13_;
	GeeMapIterator* _tmp14_;
	FolksSmallSet* _tmp20_;
	FolksSmallSet* _tmp21_;
	GeeHashSet* _tmp22_;
	FolksPersonaStore* _tmp23_;
	GeeHashMap* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
#line 1058 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../folks/individual-aggregator.vala"
	g_return_if_fail (backend != NULL);
#line 1058 "../folks/individual-aggregator.vala"
	g_return_if_fail (store != NULL);
#line 1061 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("personas-changed", FOLKS_TYPE_PERSONA_STORE, &_tmp0_, NULL, FALSE);
#line 1061 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched (store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __folks_individual_aggregator_personas_changed_cb_folks_persona_store_personas_changed, self);
#line 1062 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("notify::is-quiescent", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
#line 1062 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched ((GObject*) store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) __folks_individual_aggregator_persona_store_is_quiescent_changed_cb_g_object_notify, self);
#line 1064 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("notify::is-primary-store", G_TYPE_OBJECT, &_tmp3_, &_tmp4_, TRUE);
#line 1064 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched ((GObject*) store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, _tmp4_, NULL, (GCallback) __folks_individual_aggregator_is_primary_store_changed_cb_g_object_notify, self);
#line 1066 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("notify::is-user-set-default", G_TYPE_OBJECT, &_tmp5_, &_tmp6_, TRUE);
#line 1066 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched ((GObject*) store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, _tmp6_, NULL, (GCallback) __folks_individual_aggregator_persona_store_is_user_set_default_changed_cb_g_object_notify, self);
#line 1071 "../folks/individual-aggregator.vala"
	if (self->priv->_is_quiescent == FALSE) {
#line 3597 "individual-aggregator.c"
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 1071 "../folks/individual-aggregator.vala"
		_tmp8_ = folks_persona_store_get_is_quiescent (store);
#line 1071 "../folks/individual-aggregator.vala"
		_tmp9_ = _tmp8_;
#line 1071 "../folks/individual-aggregator.vala"
		_tmp7_ = _tmp9_ == FALSE;
#line 3606 "individual-aggregator.c"
	} else {
#line 1071 "../folks/individual-aggregator.vala"
		_tmp7_ = FALSE;
#line 3610 "individual-aggregator.c"
	}
#line 1071 "../folks/individual-aggregator.vala"
	if (_tmp7_) {
#line 3614 "individual-aggregator.c"
		guint _tmp10_;
#line 1073 "../folks/individual-aggregator.vala"
		_tmp10_ = self->priv->_non_quiescent_persona_store_count;
#line 1073 "../folks/individual-aggregator.vala"
		self->priv->_non_quiescent_persona_store_count = _tmp10_ - 1;
#line 1074 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_notify_if_is_quiescent (self);
#line 3622 "individual-aggregator.c"
	}
#line 1086 "../folks/individual-aggregator.vala"
	_tmp11_ = gee_hash_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1086 "../folks/individual-aggregator.vala"
	removed_personas = _tmp11_;
#line 1087 "../folks/individual-aggregator.vala"
	_tmp12_ = folks_persona_store_get_personas (store);
#line 1087 "../folks/individual-aggregator.vala"
	_tmp13_ = _tmp12_;
#line 1087 "../folks/individual-aggregator.vala"
	_tmp14_ = gee_map_map_iterator (_tmp13_);
#line 1087 "../folks/individual-aggregator.vala"
	iter = _tmp14_;
#line 1089 "../folks/individual-aggregator.vala"
	while (TRUE) {
#line 3638 "individual-aggregator.c"
		GeeMapIterator* _tmp15_;
		GeeHashSet* _tmp16_;
		GeeMapIterator* _tmp17_;
		gpointer _tmp18_;
		FolksPersona* _tmp19_;
#line 1089 "../folks/individual-aggregator.vala"
		_tmp15_ = iter;
#line 1089 "../folks/individual-aggregator.vala"
		if (!(gee_map_iterator_next (_tmp15_) == TRUE)) {
#line 1089 "../folks/individual-aggregator.vala"
			break;
#line 3650 "individual-aggregator.c"
		}
#line 1091 "../folks/individual-aggregator.vala"
		_tmp16_ = removed_personas;
#line 1091 "../folks/individual-aggregator.vala"
		_tmp17_ = iter;
#line 1091 "../folks/individual-aggregator.vala"
		_tmp18_ = gee_map_iterator_get_value (_tmp17_);
#line 1091 "../folks/individual-aggregator.vala"
		_tmp19_ = (FolksPersona*) _tmp18_;
#line 1091 "../folks/individual-aggregator.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp19_);
#line 1091 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp19_);
#line 3664 "individual-aggregator.c"
	}
#line 1093 "../folks/individual-aggregator.vala"
	_tmp20_ = folks_small_set_empty (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1093 "../folks/individual-aggregator.vala"
	_tmp21_ = _tmp20_;
#line 1093 "../folks/individual-aggregator.vala"
	_tmp22_ = removed_personas;
#line 1093 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_personas_changed_cb (self, store, (GeeSet*) _tmp21_, (GeeSet*) _tmp22_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1093 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp21_);
#line 1096 "../folks/individual-aggregator.vala"
	_tmp23_ = self->priv->_primary_store;
#line 1096 "../folks/individual-aggregator.vala"
	if (_tmp23_ == store) {
#line 3680 "individual-aggregator.c"
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
#line 1098 "../folks/individual-aggregator.vala"
		_tmp24_ = folks_persona_store_get_type_id (store);
#line 1098 "../folks/individual-aggregator.vala"
		_tmp25_ = _tmp24_;
#line 1098 "../folks/individual-aggregator.vala"
		_tmp26_ = folks_persona_store_get_id (store);
#line 1098 "../folks/individual-aggregator.vala"
		_tmp27_ = _tmp26_;
#line 1098 "../folks/individual-aggregator.vala"
		g_debug ("Unsetting primary store as store %p (type ID: %s, ID: %s) " "has been removed", store, _tmp25_, _tmp27_);
#line 1100 "../folks/individual-aggregator.vala"
		self->priv->_primary_store = NULL;
#line 1101 "../folks/individual-aggregator.vala"
		g_object_notify ((GObject*) self, "primary-store");
#line 3699 "individual-aggregator.c"
	}
#line 1103 "../folks/individual-aggregator.vala"
	_tmp28_ = self->priv->_stores;
#line 1103 "../folks/individual-aggregator.vala"
	_tmp29_ = folks_persona_store_get_type_id (store);
#line 1103 "../folks/individual-aggregator.vala"
	_tmp30_ = _tmp29_;
#line 1103 "../folks/individual-aggregator.vala"
	_tmp31_ = folks_persona_store_get_id (store);
#line 1103 "../folks/individual-aggregator.vala"
	_tmp32_ = _tmp31_;
#line 1103 "../folks/individual-aggregator.vala"
	_tmp33_ = _folks_individual_aggregator_get_store_full_id (self, _tmp30_, _tmp32_);
#line 1103 "../folks/individual-aggregator.vala"
	_tmp34_ = _tmp33_;
#line 1103 "../folks/individual-aggregator.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp28_, _tmp34_, NULL);
#line 1103 "../folks/individual-aggregator.vala"
	_g_free0 (_tmp34_);
#line 1058 "../folks/individual-aggregator.vala"
	_g_object_unref0 (iter);
#line 1058 "../folks/individual-aggregator.vala"
	_g_object_unref0 (removed_personas);
#line 3723 "individual-aggregator.c"
}

static gchar*
_folks_individual_aggregator_get_store_full_id (FolksIndividualAggregator* self,
                                                const gchar* type_id,
                                                const gchar* id)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 1106 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1106 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (type_id != NULL, NULL);
#line 1106 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1108 "../folks/individual-aggregator.vala"
	_tmp0_ = g_strconcat (type_id, ":", NULL);
#line 1108 "../folks/individual-aggregator.vala"
	_tmp1_ = _tmp0_;
#line 1108 "../folks/individual-aggregator.vala"
	_tmp2_ = g_strconcat (_tmp1_, id, NULL);
#line 1108 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 1108 "../folks/individual-aggregator.vala"
	_g_free0 (_tmp1_);
#line 1108 "../folks/individual-aggregator.vala"
	result = _tmp3_;
#line 1108 "../folks/individual-aggregator.vala"
	return result;
#line 3756 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_emit_individuals_changed (FolksIndividualAggregator* self,
                                                       GeeSet* added,
                                                       GeeSet* removed,
                                                       GeeMultiMap* changes,
                                                       const gchar* message,
                                                       FolksPersona* actor,
                                                       FolksGroupDetailsChangeReason reason)
{
	GeeSet* _added = NULL;
	GeeSet* _removed = NULL;
	GeeMultiMap* _changes = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GeeSet* _tmp11_ = NULL;
	GeeSet* _tmp14_;
	GeeSet* _tmp15_ = NULL;
	GeeSet* _tmp18_;
	FolksDebug* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	GeeSet* _tmp70_;
	GeeSet* _tmp71_;
	GeeSet* _tmp72_;
	GeeSet* _tmp73_;
	GeeSet* _tmp74_;
	GeeSet* _tmp75_;
	GeeSet* _tmp76_;
	GeeSet* _tmp77_;
	GeeMultiMap* _tmp78_;
#line 1114 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1125 "../folks/individual-aggregator.vala"
	if (added == NULL) {
#line 1125 "../folks/individual-aggregator.vala"
		_tmp2_ = TRUE;
#line 3796 "individual-aggregator.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 1125 "../folks/individual-aggregator.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_SET, GeeSet));
#line 1125 "../folks/individual-aggregator.vala"
		_tmp4_ = _tmp3_;
#line 1125 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp4_ == 0;
#line 3806 "individual-aggregator.c"
	}
#line 1125 "../folks/individual-aggregator.vala"
	if (_tmp2_) {
#line 3810 "individual-aggregator.c"
		gboolean _tmp5_ = FALSE;
#line 1126 "../folks/individual-aggregator.vala"
		if (removed == NULL) {
#line 1126 "../folks/individual-aggregator.vala"
			_tmp5_ = TRUE;
#line 3816 "individual-aggregator.c"
		} else {
			gint _tmp6_;
			gint _tmp7_;
#line 1126 "../folks/individual-aggregator.vala"
			_tmp6_ = gee_collection_get_size ((GeeCollection*) G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_SET, GeeSet));
#line 1126 "../folks/individual-aggregator.vala"
			_tmp7_ = _tmp6_;
#line 1126 "../folks/individual-aggregator.vala"
			_tmp5_ = _tmp7_ == 0;
#line 3826 "individual-aggregator.c"
		}
#line 1126 "../folks/individual-aggregator.vala"
		_tmp1_ = _tmp5_;
#line 3830 "individual-aggregator.c"
	} else {
#line 1125 "../folks/individual-aggregator.vala"
		_tmp1_ = FALSE;
#line 3834 "individual-aggregator.c"
	}
#line 1125 "../folks/individual-aggregator.vala"
	if (_tmp1_) {
#line 3838 "individual-aggregator.c"
		gboolean _tmp8_ = FALSE;
#line 1127 "../folks/individual-aggregator.vala"
		if (changes == NULL) {
#line 1127 "../folks/individual-aggregator.vala"
			_tmp8_ = TRUE;
#line 3844 "individual-aggregator.c"
		} else {
			gint _tmp9_;
			gint _tmp10_;
#line 1127 "../folks/individual-aggregator.vala"
			_tmp9_ = gee_multi_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (changes, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 1127 "../folks/individual-aggregator.vala"
			_tmp10_ = _tmp9_;
#line 1127 "../folks/individual-aggregator.vala"
			_tmp8_ = _tmp10_ == 0;
#line 3854 "individual-aggregator.c"
		}
#line 1127 "../folks/individual-aggregator.vala"
		_tmp0_ = _tmp8_;
#line 3858 "individual-aggregator.c"
	} else {
#line 1125 "../folks/individual-aggregator.vala"
		_tmp0_ = FALSE;
#line 3862 "individual-aggregator.c"
	}
#line 1125 "../folks/individual-aggregator.vala"
	if (_tmp0_) {
#line 1130 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_changes);
#line 1130 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_removed);
#line 1130 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_added);
#line 1130 "../folks/individual-aggregator.vala"
		return;
#line 3874 "individual-aggregator.c"
	}
#line 1133 "../folks/individual-aggregator.vala"
	folks_internal_profiling_point ("%s", "emitting " "IndividualAggregator::individuals-changed");
#line 1136 "../folks/individual-aggregator.vala"
	if (added != NULL) {
#line 3880 "individual-aggregator.c"
		GeeSet* _tmp12_;
#line 1136 "../folks/individual-aggregator.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_SET, GeeSet));
#line 1136 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp11_);
#line 1136 "../folks/individual-aggregator.vala"
		_tmp11_ = _tmp12_;
#line 3888 "individual-aggregator.c"
	} else {
		FolksSmallSet* _tmp13_;
#line 1136 "../folks/individual-aggregator.vala"
		_tmp13_ = folks_small_set_empty (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1136 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp11_);
#line 1136 "../folks/individual-aggregator.vala"
		_tmp11_ = (GeeSet*) _tmp13_;
#line 3897 "individual-aggregator.c"
	}
#line 1136 "../folks/individual-aggregator.vala"
	_tmp14_ = _g_object_ref0 (_tmp11_);
#line 1136 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_added);
#line 1136 "../folks/individual-aggregator.vala"
	_added = _tmp14_;
#line 1137 "../folks/individual-aggregator.vala"
	if (removed != NULL) {
#line 3907 "individual-aggregator.c"
		GeeSet* _tmp16_;
#line 1137 "../folks/individual-aggregator.vala"
		_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_SET, GeeSet));
#line 1137 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp15_);
#line 1137 "../folks/individual-aggregator.vala"
		_tmp15_ = _tmp16_;
#line 3915 "individual-aggregator.c"
	} else {
		FolksSmallSet* _tmp17_;
#line 1137 "../folks/individual-aggregator.vala"
		_tmp17_ = folks_small_set_empty (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
#line 1137 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_tmp15_);
#line 1137 "../folks/individual-aggregator.vala"
		_tmp15_ = (GeeSet*) _tmp17_;
#line 3924 "individual-aggregator.c"
	}
#line 1137 "../folks/individual-aggregator.vala"
	_tmp18_ = _g_object_ref0 (_tmp15_);
#line 1137 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_removed);
#line 1137 "../folks/individual-aggregator.vala"
	_removed = _tmp18_;
#line 1139 "../folks/individual-aggregator.vala"
	if (changes != NULL) {
#line 3934 "individual-aggregator.c"
		GeeMultiMap* _tmp19_;
#line 1141 "../folks/individual-aggregator.vala"
		_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (changes, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 1141 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_changes);
#line 1141 "../folks/individual-aggregator.vala"
		_changes = _tmp19_;
#line 3942 "individual-aggregator.c"
	} else {
		GeeHashMultiMap* _tmp20_;
#line 1145 "../folks/individual-aggregator.vala"
		_tmp20_ = gee_hash_multi_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1145 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_changes);
#line 1145 "../folks/individual-aggregator.vala"
		_changes = (GeeMultiMap*) _tmp20_;
#line 3951 "individual-aggregator.c"
	}
#line 1149 "../folks/individual-aggregator.vala"
	_tmp21_ = self->priv->_debug;
#line 1149 "../folks/individual-aggregator.vala"
	_tmp22_ = folks_debug_get_debug_output_enabled (_tmp21_);
#line 1149 "../folks/individual-aggregator.vala"
	_tmp23_ = _tmp22_;
#line 1149 "../folks/individual-aggregator.vala"
	if (_tmp23_ == TRUE) {
#line 3961 "individual-aggregator.c"
		GeeMultiMap* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		GeeMapIterator* iter = NULL;
		GeeMultiMap* _tmp27_;
		GeeMapIterator* _tmp28_;
#line 1151 "../folks/individual-aggregator.vala"
		_tmp24_ = _changes;
#line 1151 "../folks/individual-aggregator.vala"
		_tmp25_ = gee_multi_map_get_size (_tmp24_);
#line 1151 "../folks/individual-aggregator.vala"
		_tmp26_ = _tmp25_;
#line 1151 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1151: Emitting individuals-changed-detailed" \
" with %u mappings:", (guint) _tmp26_);
#line 1154 "../folks/individual-aggregator.vala"
		_tmp27_ = _changes;
#line 1154 "../folks/individual-aggregator.vala"
		_tmp28_ = gee_multi_map_map_iterator (_tmp27_);
#line 1154 "../folks/individual-aggregator.vala"
		iter = _tmp28_;
#line 1156 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 3984 "individual-aggregator.c"
			GeeMapIterator* _tmp29_;
			FolksIndividual* removed_ind = NULL;
			GeeMapIterator* _tmp30_;
			gpointer _tmp31_;
			FolksIndividual* added_ind = NULL;
			GeeMapIterator* _tmp32_;
			gpointer _tmp33_;
			const gchar* _tmp34_ = NULL;
			FolksIndividual* _tmp35_;
			const gchar* _tmp39_ = NULL;
			FolksIndividual* _tmp40_;
			FolksIndividual* _tmp44_;
			FolksIndividual* _tmp45_;
			FolksIndividual* _tmp46_;
			FolksIndividual* _tmp58_;
#line 1156 "../folks/individual-aggregator.vala"
			_tmp29_ = iter;
#line 1156 "../folks/individual-aggregator.vala"
			if (!gee_map_iterator_next (_tmp29_)) {
#line 1156 "../folks/individual-aggregator.vala"
				break;
#line 4006 "individual-aggregator.c"
			}
#line 1158 "../folks/individual-aggregator.vala"
			_tmp30_ = iter;
#line 1158 "../folks/individual-aggregator.vala"
			_tmp31_ = gee_map_iterator_get_key (_tmp30_);
#line 1158 "../folks/individual-aggregator.vala"
			removed_ind = (FolksIndividual*) _tmp31_;
#line 1159 "../folks/individual-aggregator.vala"
			_tmp32_ = iter;
#line 1159 "../folks/individual-aggregator.vala"
			_tmp33_ = gee_map_iterator_get_value (_tmp32_);
#line 1159 "../folks/individual-aggregator.vala"
			added_ind = (FolksIndividual*) _tmp33_;
#line 1162 "../folks/individual-aggregator.vala"
			_tmp35_ = removed_ind;
#line 1162 "../folks/individual-aggregator.vala"
			if (_tmp35_ != NULL) {
#line 4024 "individual-aggregator.c"
				FolksIndividual* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
#line 1162 "../folks/individual-aggregator.vala"
				_tmp36_ = removed_ind;
#line 1162 "../folks/individual-aggregator.vala"
				_tmp37_ = folks_individual_get_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1162 "../folks/individual-aggregator.vala"
				_tmp38_ = _tmp37_;
#line 1162 "../folks/individual-aggregator.vala"
				_tmp34_ = _tmp38_;
#line 4036 "individual-aggregator.c"
			} else {
#line 1162 "../folks/individual-aggregator.vala"
				_tmp34_ = "";
#line 4040 "individual-aggregator.c"
			}
#line 1164 "../folks/individual-aggregator.vala"
			_tmp40_ = added_ind;
#line 1164 "../folks/individual-aggregator.vala"
			if (_tmp40_ != NULL) {
#line 4046 "individual-aggregator.c"
				FolksIndividual* _tmp41_;
				const gchar* _tmp42_;
				const gchar* _tmp43_;
#line 1164 "../folks/individual-aggregator.vala"
				_tmp41_ = added_ind;
#line 1164 "../folks/individual-aggregator.vala"
				_tmp42_ = folks_individual_get_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1164 "../folks/individual-aggregator.vala"
				_tmp43_ = _tmp42_;
#line 1164 "../folks/individual-aggregator.vala"
				_tmp39_ = _tmp43_;
#line 4058 "individual-aggregator.c"
			} else {
#line 1164 "../folks/individual-aggregator.vala"
				_tmp39_ = "";
#line 4062 "individual-aggregator.c"
			}
#line 1161 "../folks/individual-aggregator.vala"
			_tmp44_ = removed_ind;
#line 1161 "../folks/individual-aggregator.vala"
			_tmp45_ = added_ind;
#line 1161 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1161:     %s (%p) → %s (%p)", _tmp34_, _tmp44_, _tmp39_, _tmp45_);
#line 1166 "../folks/individual-aggregator.vala"
			_tmp46_ = removed_ind;
#line 1166 "../folks/individual-aggregator.vala"
			if (_tmp46_ != NULL) {
#line 1168 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:1168:       Removed individual's personas:");
#line 4076 "individual-aggregator.c"
				{
					GeeIterator* _p_it = NULL;
					FolksIndividual* _tmp47_;
					GeeSet* _tmp48_;
					GeeSet* _tmp49_;
					GeeIterator* _tmp50_;
#line 1170 "../folks/individual-aggregator.vala"
					_tmp47_ = removed_ind;
#line 1170 "../folks/individual-aggregator.vala"
					_tmp48_ = folks_individual_get_personas (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1170 "../folks/individual-aggregator.vala"
					_tmp49_ = _tmp48_;
#line 1170 "../folks/individual-aggregator.vala"
					_tmp50_ = gee_iterable_iterator ((GeeIterable*) _tmp49_);
#line 1170 "../folks/individual-aggregator.vala"
					_p_it = _tmp50_;
#line 1170 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 4095 "individual-aggregator.c"
						GeeIterator* _tmp51_;
						FolksPersona* p = NULL;
						GeeIterator* _tmp52_;
						gpointer _tmp53_;
						FolksPersona* _tmp54_;
						const gchar* _tmp55_;
						const gchar* _tmp56_;
						FolksPersona* _tmp57_;
#line 1170 "../folks/individual-aggregator.vala"
						_tmp51_ = _p_it;
#line 1170 "../folks/individual-aggregator.vala"
						if (!gee_iterator_next (_tmp51_)) {
#line 1170 "../folks/individual-aggregator.vala"
							break;
#line 4110 "individual-aggregator.c"
						}
#line 1170 "../folks/individual-aggregator.vala"
						_tmp52_ = _p_it;
#line 1170 "../folks/individual-aggregator.vala"
						_tmp53_ = gee_iterator_get (_tmp52_);
#line 1170 "../folks/individual-aggregator.vala"
						p = (FolksPersona*) _tmp53_;
#line 1172 "../folks/individual-aggregator.vala"
						_tmp54_ = p;
#line 1172 "../folks/individual-aggregator.vala"
						_tmp55_ = folks_persona_get_uid (_tmp54_);
#line 1172 "../folks/individual-aggregator.vala"
						_tmp56_ = _tmp55_;
#line 1172 "../folks/individual-aggregator.vala"
						_tmp57_ = p;
#line 1172 "../folks/individual-aggregator.vala"
						g_debug ("individual-aggregator.vala:1172:         %s (%p)", _tmp56_, _tmp57_);
#line 1170 "../folks/individual-aggregator.vala"
						_g_object_unref0 (p);
#line 4130 "individual-aggregator.c"
					}
#line 1170 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_p_it);
#line 4134 "individual-aggregator.c"
				}
			}
#line 1176 "../folks/individual-aggregator.vala"
			_tmp58_ = added_ind;
#line 1176 "../folks/individual-aggregator.vala"
			if (_tmp58_ != NULL) {
#line 1178 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:1178:       Added individual's personas:");
#line 4143 "individual-aggregator.c"
				{
					GeeIterator* _p_it = NULL;
					FolksIndividual* _tmp59_;
					GeeSet* _tmp60_;
					GeeSet* _tmp61_;
					GeeIterator* _tmp62_;
#line 1180 "../folks/individual-aggregator.vala"
					_tmp59_ = added_ind;
#line 1180 "../folks/individual-aggregator.vala"
					_tmp60_ = folks_individual_get_personas (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1180 "../folks/individual-aggregator.vala"
					_tmp61_ = _tmp60_;
#line 1180 "../folks/individual-aggregator.vala"
					_tmp62_ = gee_iterable_iterator ((GeeIterable*) _tmp61_);
#line 1180 "../folks/individual-aggregator.vala"
					_p_it = _tmp62_;
#line 1180 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 4162 "individual-aggregator.c"
						GeeIterator* _tmp63_;
						FolksPersona* p = NULL;
						GeeIterator* _tmp64_;
						gpointer _tmp65_;
						FolksPersona* _tmp66_;
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						FolksPersona* _tmp69_;
#line 1180 "../folks/individual-aggregator.vala"
						_tmp63_ = _p_it;
#line 1180 "../folks/individual-aggregator.vala"
						if (!gee_iterator_next (_tmp63_)) {
#line 1180 "../folks/individual-aggregator.vala"
							break;
#line 4177 "individual-aggregator.c"
						}
#line 1180 "../folks/individual-aggregator.vala"
						_tmp64_ = _p_it;
#line 1180 "../folks/individual-aggregator.vala"
						_tmp65_ = gee_iterator_get (_tmp64_);
#line 1180 "../folks/individual-aggregator.vala"
						p = (FolksPersona*) _tmp65_;
#line 1182 "../folks/individual-aggregator.vala"
						_tmp66_ = p;
#line 1182 "../folks/individual-aggregator.vala"
						_tmp67_ = folks_persona_get_uid (_tmp66_);
#line 1182 "../folks/individual-aggregator.vala"
						_tmp68_ = _tmp67_;
#line 1182 "../folks/individual-aggregator.vala"
						_tmp69_ = p;
#line 1182 "../folks/individual-aggregator.vala"
						g_debug ("individual-aggregator.vala:1182:         %s (%p)", _tmp68_, _tmp69_);
#line 1180 "../folks/individual-aggregator.vala"
						_g_object_unref0 (p);
#line 4197 "individual-aggregator.c"
					}
#line 1180 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_p_it);
#line 4201 "individual-aggregator.c"
				}
			}
#line 1156 "../folks/individual-aggregator.vala"
			_g_object_unref0 (added_ind);
#line 1156 "../folks/individual-aggregator.vala"
			_g_object_unref0 (removed_ind);
#line 4208 "individual-aggregator.c"
		}
#line 1149 "../folks/individual-aggregator.vala"
		_g_object_unref0 (iter);
#line 4212 "individual-aggregator.c"
	}
#line 1188 "../folks/individual-aggregator.vala"
	_tmp70_ = _added;
#line 1188 "../folks/individual-aggregator.vala"
	_tmp71_ = gee_set_get_read_only_view (_tmp70_);
#line 1188 "../folks/individual-aggregator.vala"
	_tmp72_ = _tmp71_;
#line 1188 "../folks/individual-aggregator.vala"
	_tmp73_ = _tmp72_;
#line 1188 "../folks/individual-aggregator.vala"
	_tmp74_ = _removed;
#line 1188 "../folks/individual-aggregator.vala"
	_tmp75_ = gee_set_get_read_only_view (_tmp74_);
#line 1188 "../folks/individual-aggregator.vala"
	_tmp76_ = _tmp75_;
#line 1188 "../folks/individual-aggregator.vala"
	_tmp77_ = _tmp76_;
#line 1188 "../folks/individual-aggregator.vala"
	g_signal_emit (self, folks_individual_aggregator_signals[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_SIGNAL], 0, _tmp73_, _tmp77_, message, actor, reason);
#line 1188 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp77_);
#line 1188 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp73_);
#line 1190 "../folks/individual-aggregator.vala"
	_tmp78_ = _changes;
#line 1190 "../folks/individual-aggregator.vala"
	g_signal_emit (self, folks_individual_aggregator_signals[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_DETAILED_SIGNAL], 0, _tmp78_);
#line 1114 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp15_);
#line 1114 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp11_);
#line 1114 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_changes);
#line 1114 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_removed);
#line 1114 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_added);
#line 4250 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_individual_removed_cb_folks_individual_removed (FolksIndividual* _sender,
                                                                              FolksIndividual* replacement_individual,
                                                                              gpointer self)
{
#line 1195 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_individual_removed_cb ((FolksIndividualAggregator*) self, _sender, replacement_individual);
#line 4260 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_connect_to_individual (FolksIndividualAggregator* self,
                                                    FolksIndividual* individual)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 1193 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1193 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 1195 "../folks/individual-aggregator.vala"
	g_signal_connect_object (individual, "removed", (GCallback) __folks_individual_aggregator_individual_removed_cb_folks_individual_removed, self, 0);
#line 1196 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_individuals;
#line 1196 "../folks/individual-aggregator.vala"
	_tmp1_ = folks_individual_get_id (individual);
#line 1196 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp1_;
#line 1196 "../folks/individual-aggregator.vala"
	gee_map_set (_tmp0_, _tmp2_, individual);
#line 4284 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_disconnect_from_individual (FolksIndividualAggregator* self,
                                                         FolksIndividual* individual)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	guint _tmp3_;
#line 1199 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1199 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 1201 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_individuals;
#line 1201 "../folks/individual-aggregator.vala"
	_tmp1_ = folks_individual_get_id (individual);
#line 1201 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp1_;
#line 1201 "../folks/individual-aggregator.vala"
	gee_map_unset (_tmp0_, _tmp2_, NULL);
#line 1202 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("removed", FOLKS_TYPE_INDIVIDUAL, &_tmp3_, NULL, FALSE);
#line 1202 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched (individual, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) __folks_individual_aggregator_individual_removed_cb_folks_individual_removed, self);
#line 4311 "individual-aggregator.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 1208 "../folks/individual-aggregator.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 1208 "../folks/individual-aggregator.vala"
	return _data3_;
#line 4321 "individual-aggregator.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 1208 "../folks/individual-aggregator.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 4331 "individual-aggregator.c"
		FolksIndividualAggregator* self;
#line 1208 "../folks/individual-aggregator.vala"
		self = _data3_->self;
#line 1208 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data3_->candidate_inds);
#line 1208 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data3_->persona);
#line 1208 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self);
#line 1208 "../folks/individual-aggregator.vala"
		g_slice_free (Block3Data, _data3_);
#line 4343 "individual-aggregator.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 1267 "../folks/individual-aggregator.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 1267 "../folks/individual-aggregator.vala"
	return _data4_;
#line 4354 "individual-aggregator.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 1267 "../folks/individual-aggregator.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4364 "individual-aggregator.c"
		FolksIndividualAggregator* self;
#line 1267 "../folks/individual-aggregator.vala"
		self = _data4_->_data3_->self;
#line 1267 "../folks/individual-aggregator.vala"
		block3_data_unref (_data4_->_data3_);
#line 1267 "../folks/individual-aggregator.vala"
		_data4_->_data3_ = NULL;
#line 1267 "../folks/individual-aggregator.vala"
		g_slice_free (Block4Data, _data4_);
#line 4374 "individual-aggregator.c"
	}
}

static void
_______lambda67_ (Block4Data* _data4_,
                  const gchar* l)
{
	Block3Data* _data3_;
	FolksIndividualAggregator* self;
	const gchar* prop_linking_value = NULL;
	GPtrArray* candidates = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	gconstpointer _tmp2_;
	GPtrArray* _tmp3_;
#line 1288 "../folks/individual-aggregator.vala"
	_data3_ = _data4_->_data3_;
#line 1288 "../folks/individual-aggregator.vala"
	self = _data3_->self;
#line 1288 "../folks/individual-aggregator.vala"
	g_return_if_fail (l != NULL);
#line 1290 "../folks/individual-aggregator.vala"
	prop_linking_value = l;
#line 1291 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_link_map;
#line 1291 "../folks/individual-aggregator.vala"
	_tmp1_ = prop_linking_value;
#line 1291 "../folks/individual-aggregator.vala"
	_tmp2_ = g_hash_table_lookup (_tmp0_, _tmp1_);
#line 1291 "../folks/individual-aggregator.vala"
	candidates = (GPtrArray*) _tmp2_;
#line 1294 "../folks/individual-aggregator.vala"
	_tmp3_ = candidates;
#line 1294 "../folks/individual-aggregator.vala"
	if (_tmp3_ != NULL) {
#line 4410 "individual-aggregator.c"
		{
			guint i = 0U;
#line 1296 "../folks/individual-aggregator.vala"
			i = (guint) 0;
#line 4415 "individual-aggregator.c"
			{
				gboolean _tmp4_ = FALSE;
#line 1296 "../folks/individual-aggregator.vala"
				_tmp4_ = TRUE;
#line 1296 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 4422 "individual-aggregator.c"
					GPtrArray* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
					FolksIndividual* candidate_ind = NULL;
					GPtrArray* _tmp9_;
					gconstpointer _tmp10_;
					FolksIndividual* _tmp11_;
					gboolean _tmp12_ = FALSE;
					gboolean _tmp13_ = FALSE;
					FolksIndividual* _tmp14_;
					FolksTrustLevel _tmp15_;
					FolksTrustLevel _tmp16_;
#line 1296 "../folks/individual-aggregator.vala"
					if (!_tmp4_) {
#line 4437 "individual-aggregator.c"
						guint _tmp5_;
#line 1296 "../folks/individual-aggregator.vala"
						_tmp5_ = i;
#line 1296 "../folks/individual-aggregator.vala"
						i = _tmp5_ + 1;
#line 4443 "individual-aggregator.c"
					}
#line 1296 "../folks/individual-aggregator.vala"
					_tmp4_ = FALSE;
#line 1296 "../folks/individual-aggregator.vala"
					_tmp6_ = candidates;
#line 1296 "../folks/individual-aggregator.vala"
					_tmp7_ = vala_g_ptr_array_get_length ((GPtrArray*) _tmp6_);
#line 1296 "../folks/individual-aggregator.vala"
					_tmp8_ = _tmp7_;
#line 1296 "../folks/individual-aggregator.vala"
					if (!(i < ((guint) _tmp8_))) {
#line 1296 "../folks/individual-aggregator.vala"
						break;
#line 4457 "individual-aggregator.c"
					}
#line 1298 "../folks/individual-aggregator.vala"
					_tmp9_ = candidates;
#line 1298 "../folks/individual-aggregator.vala"
					_tmp10_ = g_ptr_array_index ((GPtrArray*) _tmp9_, i);
#line 1298 "../folks/individual-aggregator.vala"
					_tmp11_ = _g_object_ref0 ((FolksIndividual*) _tmp10_);
#line 1298 "../folks/individual-aggregator.vala"
					candidate_ind = _tmp11_;
#line 1300 "../folks/individual-aggregator.vala"
					_tmp14_ = candidate_ind;
#line 1300 "../folks/individual-aggregator.vala"
					_tmp15_ = folks_individual_get_trust_level (_tmp14_);
#line 1300 "../folks/individual-aggregator.vala"
					_tmp16_ = _tmp15_;
#line 1300 "../folks/individual-aggregator.vala"
					if (_tmp16_ != FOLKS_TRUST_LEVEL_NONE) {
#line 4475 "individual-aggregator.c"
						FolksIndividual* _tmp17_;
						FolksPersona* _tmp18_;
#line 1302 "../folks/individual-aggregator.vala"
						_tmp17_ = candidate_ind;
#line 1302 "../folks/individual-aggregator.vala"
						_tmp18_ = _data3_->persona;
#line 1302 "../folks/individual-aggregator.vala"
						_tmp13_ = folks_individual_has_anti_link_with_persona (_tmp17_, _tmp18_) == FALSE;
#line 4484 "individual-aggregator.c"
					} else {
#line 1300 "../folks/individual-aggregator.vala"
						_tmp13_ = FALSE;
#line 4488 "individual-aggregator.c"
					}
#line 1300 "../folks/individual-aggregator.vala"
					if (_tmp13_) {
#line 4492 "individual-aggregator.c"
						GeeHashSet* _tmp19_;
						FolksIndividual* _tmp20_;
#line 1305 "../folks/individual-aggregator.vala"
						_tmp19_ = _data3_->candidate_inds;
#line 1305 "../folks/individual-aggregator.vala"
						_tmp20_ = candidate_ind;
#line 1305 "../folks/individual-aggregator.vala"
						_tmp12_ = gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 4501 "individual-aggregator.c"
					} else {
#line 1300 "../folks/individual-aggregator.vala"
						_tmp12_ = FALSE;
#line 4505 "individual-aggregator.c"
					}
#line 1300 "../folks/individual-aggregator.vala"
					if (_tmp12_) {
#line 4509 "individual-aggregator.c"
						FolksIndividual* _tmp21_;
						const gchar* _tmp22_;
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						const gchar* _tmp25_;
#line 1307 "../folks/individual-aggregator.vala"
						_tmp21_ = candidate_ind;
#line 1307 "../folks/individual-aggregator.vala"
						_tmp22_ = folks_individual_get_id (_tmp21_);
#line 1307 "../folks/individual-aggregator.vala"
						_tmp23_ = _tmp22_;
#line 1307 "../folks/individual-aggregator.vala"
						_tmp24_ = _data4_->prop_name;
#line 1307 "../folks/individual-aggregator.vala"
						_tmp25_ = prop_linking_value;
#line 1307 "../folks/individual-aggregator.vala"
						g_debug ("    Found candidate individual '%s'" " by linkable property '%s' = '%s'.", _tmp23_, _tmp24_, _tmp25_);
#line 4527 "individual-aggregator.c"
					}
#line 1296 "../folks/individual-aggregator.vala"
					_g_object_unref0 (candidate_ind);
#line 4531 "individual-aggregator.c"
				}
			}
		}
	}
}

static void
________lambda67__folks_persona_linkable_property_callback (const gchar* link,
                                                            gpointer self)
{
#line 1288 "../folks/individual-aggregator.vala"
	_______lambda67_ (self, link);
#line 4544 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_add_personas (FolksIndividualAggregator* self,
                                           GeeSet* added,
                                           FolksIndividual** user,
                                           GeeHashMultiMap** individuals_changes)
{
#line 1205 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1205 "../folks/individual-aggregator.vala"
	g_return_if_fail (added != NULL);
#line 1205 "../folks/individual-aggregator.vala"
	g_return_if_fail (*individuals_changes != NULL);
#line 4559 "individual-aggregator.c"
	{
		GeeIterator* _persona_it = NULL;
		GeeIterator* _tmp0_;
#line 1208 "../folks/individual-aggregator.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) added);
#line 1208 "../folks/individual-aggregator.vala"
		_persona_it = _tmp0_;
#line 1208 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 4569 "individual-aggregator.c"
			Block3Data* _data3_;
			GeeIterator* _tmp1_;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			FolksPersonaStoreTrust trust_level = 0;
			FolksPersona* _tmp4_;
			FolksPersonaStore* _tmp5_;
			FolksPersonaStore* _tmp6_;
			FolksPersonaStoreTrust _tmp7_;
			FolksPersonaStoreTrust _tmp8_;
			GeeHashSet* _tmp9_;
			GeeHashSet* final_personas = NULL;
			GeeHashSet* _tmp10_;
			FolksPersona* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			FolksPersona* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp27_ = FALSE;
			gboolean _tmp56_ = FALSE;
			GeeHashSet* _tmp76_;
			FolksPersona* _tmp77_;
			gboolean _tmp78_ = FALSE;
			gboolean _tmp82_ = FALSE;
			GeeHashSet* _tmp83_;
			gint _tmp84_;
			gint _tmp85_;
			FolksIndividual* final_individual = NULL;
			GeeHashSet* _tmp95_;
			FolksIndividual* _tmp96_;
			FolksIndividual* _tmp97_;
			const gchar* _tmp98_;
			const gchar* _tmp99_;
			FolksIndividual* _tmp100_;
			guint num_mappings_added = 0U;
			FolksIndividual* _tmp148_;
			gboolean _tmp149_;
			gboolean _tmp150_;
#line 1208 "../folks/individual-aggregator.vala"
			_data3_ = g_slice_new0 (Block3Data);
#line 1208 "../folks/individual-aggregator.vala"
			_data3_->_ref_count_ = 1;
#line 1208 "../folks/individual-aggregator.vala"
			_data3_->self = g_object_ref (self);
#line 1208 "../folks/individual-aggregator.vala"
			_tmp1_ = _persona_it;
#line 1208 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 1208 "../folks/individual-aggregator.vala"
				block3_data_unref (_data3_);
#line 1208 "../folks/individual-aggregator.vala"
				_data3_ = NULL;
#line 1208 "../folks/individual-aggregator.vala"
				break;
#line 4628 "individual-aggregator.c"
			}
#line 1208 "../folks/individual-aggregator.vala"
			_tmp2_ = _persona_it;
#line 1208 "../folks/individual-aggregator.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 1208 "../folks/individual-aggregator.vala"
			_data3_->persona = (FolksPersona*) _tmp3_;
#line 1210 "../folks/individual-aggregator.vala"
			_tmp4_ = _data3_->persona;
#line 1210 "../folks/individual-aggregator.vala"
			_tmp5_ = folks_persona_get_store (_tmp4_);
#line 1210 "../folks/individual-aggregator.vala"
			_tmp6_ = _tmp5_;
#line 1210 "../folks/individual-aggregator.vala"
			_tmp7_ = folks_persona_store_get_trust_level (_tmp6_);
#line 1210 "../folks/individual-aggregator.vala"
			_tmp8_ = _tmp7_;
#line 1210 "../folks/individual-aggregator.vala"
			trust_level = _tmp8_;
#line 1220 "../folks/individual-aggregator.vala"
			_tmp9_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1220 "../folks/individual-aggregator.vala"
			_data3_->candidate_inds = _tmp9_;
#line 1222 "../folks/individual-aggregator.vala"
			_tmp10_ = gee_hash_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1222 "../folks/individual-aggregator.vala"
			final_personas = _tmp10_;
#line 1224 "../folks/individual-aggregator.vala"
			_tmp11_ = _data3_->persona;
#line 1224 "../folks/individual-aggregator.vala"
			_tmp12_ = folks_persona_get_uid (_tmp11_);
#line 1224 "../folks/individual-aggregator.vala"
			_tmp13_ = _tmp12_;
#line 1224 "../folks/individual-aggregator.vala"
			_tmp14_ = _data3_->persona;
#line 1224 "../folks/individual-aggregator.vala"
			_tmp15_ = folks_persona_get_iid (_tmp14_);
#line 1224 "../folks/individual-aggregator.vala"
			_tmp16_ = _tmp15_;
#line 1224 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1224: Aggregating persona '%s' on '%s'.", _tmp13_, _tmp16_);
#line 1228 "../folks/individual-aggregator.vala"
			if (self->priv->_linking_enabled == TRUE) {
#line 4672 "individual-aggregator.c"
				FolksPersona* _tmp20_;
				gboolean _tmp21_;
				gboolean _tmp22_;
#line 1229 "../folks/individual-aggregator.vala"
				_tmp20_ = _data3_->persona;
#line 1229 "../folks/individual-aggregator.vala"
				_tmp21_ = folks_persona_get_is_user (_tmp20_);
#line 1229 "../folks/individual-aggregator.vala"
				_tmp22_ = _tmp21_;
#line 1229 "../folks/individual-aggregator.vala"
				_tmp19_ = _tmp22_ == TRUE;
#line 4684 "individual-aggregator.c"
			} else {
#line 1228 "../folks/individual-aggregator.vala"
				_tmp19_ = FALSE;
#line 4688 "individual-aggregator.c"
			}
#line 1228 "../folks/individual-aggregator.vala"
			if (_tmp19_) {
#line 1229 "../folks/individual-aggregator.vala"
				_tmp18_ = (*user) != NULL;
#line 4694 "individual-aggregator.c"
			} else {
#line 1228 "../folks/individual-aggregator.vala"
				_tmp18_ = FALSE;
#line 4698 "individual-aggregator.c"
			}
#line 1228 "../folks/individual-aggregator.vala"
			if (_tmp18_) {
#line 4702 "individual-aggregator.c"
				FolksPersona* _tmp23_;
#line 1230 "../folks/individual-aggregator.vala"
				_tmp23_ = _data3_->persona;
#line 1230 "../folks/individual-aggregator.vala"
				_tmp17_ = folks_individual_has_anti_link_with_persona (G_TYPE_CHECK_INSTANCE_CAST (*user, FOLKS_TYPE_INDIVIDUAL, FolksIndividual), _tmp23_) == FALSE;
#line 4708 "individual-aggregator.c"
			} else {
#line 1228 "../folks/individual-aggregator.vala"
				_tmp17_ = FALSE;
#line 4712 "individual-aggregator.c"
			}
#line 1228 "../folks/individual-aggregator.vala"
			if (_tmp17_) {
#line 4716 "individual-aggregator.c"
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				GeeHashSet* _tmp26_;
#line 1232 "../folks/individual-aggregator.vala"
				_tmp24_ = folks_individual_get_id (G_TYPE_CHECK_INSTANCE_CAST (*user, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1232 "../folks/individual-aggregator.vala"
				_tmp25_ = _tmp24_;
#line 1232 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:1232:     Found candidate individual '%s' a" \
"s user.", _tmp25_);
#line 1234 "../folks/individual-aggregator.vala"
				_tmp26_ = _data3_->candidate_inds;
#line 1234 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, G_TYPE_CHECK_INSTANCE_CAST (*user, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 4730 "individual-aggregator.c"
			}
#line 1239 "../folks/individual-aggregator.vala"
			if (self->priv->_linking_enabled == TRUE) {
#line 1240 "../folks/individual-aggregator.vala"
				_tmp27_ = trust_level != FOLKS_PERSONA_STORE_TRUST_NONE;
#line 4736 "individual-aggregator.c"
			} else {
#line 1239 "../folks/individual-aggregator.vala"
				_tmp27_ = FALSE;
#line 4740 "individual-aggregator.c"
			}
#line 1239 "../folks/individual-aggregator.vala"
			if (_tmp27_) {
#line 4744 "individual-aggregator.c"
				GPtrArray* candidates = NULL;
				GHashTable* _tmp28_;
				FolksPersona* _tmp29_;
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				gconstpointer _tmp32_;
				GPtrArray* _tmp33_;
#line 1242 "../folks/individual-aggregator.vala"
				_tmp28_ = self->priv->_link_map;
#line 1242 "../folks/individual-aggregator.vala"
				_tmp29_ = _data3_->persona;
#line 1242 "../folks/individual-aggregator.vala"
				_tmp30_ = folks_persona_get_iid (_tmp29_);
#line 1242 "../folks/individual-aggregator.vala"
				_tmp31_ = _tmp30_;
#line 1242 "../folks/individual-aggregator.vala"
				_tmp32_ = g_hash_table_lookup (_tmp28_, _tmp31_);
#line 1242 "../folks/individual-aggregator.vala"
				candidates = (GPtrArray*) _tmp32_;
#line 1244 "../folks/individual-aggregator.vala"
				_tmp33_ = candidates;
#line 1244 "../folks/individual-aggregator.vala"
				if (_tmp33_ != NULL) {
#line 4768 "individual-aggregator.c"
					{
						guint i = 0U;
#line 1246 "../folks/individual-aggregator.vala"
						i = (guint) 0;
#line 4773 "individual-aggregator.c"
						{
							gboolean _tmp34_ = FALSE;
#line 1246 "../folks/individual-aggregator.vala"
							_tmp34_ = TRUE;
#line 1246 "../folks/individual-aggregator.vala"
							while (TRUE) {
#line 4780 "individual-aggregator.c"
								GPtrArray* _tmp36_;
								gint _tmp37_;
								gint _tmp38_;
								FolksIndividual* candidate_ind = NULL;
								GPtrArray* _tmp39_;
								gconstpointer _tmp40_;
								gboolean _tmp41_ = FALSE;
								gboolean _tmp42_ = FALSE;
								FolksIndividual* _tmp43_;
								FolksTrustLevel _tmp44_;
								FolksTrustLevel _tmp45_;
#line 1246 "../folks/individual-aggregator.vala"
								if (!_tmp34_) {
#line 4794 "individual-aggregator.c"
									guint _tmp35_;
#line 1246 "../folks/individual-aggregator.vala"
									_tmp35_ = i;
#line 1246 "../folks/individual-aggregator.vala"
									i = _tmp35_ + 1;
#line 4800 "individual-aggregator.c"
								}
#line 1246 "../folks/individual-aggregator.vala"
								_tmp34_ = FALSE;
#line 1246 "../folks/individual-aggregator.vala"
								_tmp36_ = candidates;
#line 1246 "../folks/individual-aggregator.vala"
								_tmp37_ = vala_g_ptr_array_get_length ((GPtrArray*) _tmp36_);
#line 1246 "../folks/individual-aggregator.vala"
								_tmp38_ = _tmp37_;
#line 1246 "../folks/individual-aggregator.vala"
								if (!(i < ((guint) _tmp38_))) {
#line 1246 "../folks/individual-aggregator.vala"
									break;
#line 4814 "individual-aggregator.c"
								}
#line 1248 "../folks/individual-aggregator.vala"
								_tmp39_ = candidates;
#line 1248 "../folks/individual-aggregator.vala"
								_tmp40_ = g_ptr_array_index ((GPtrArray*) _tmp39_, i);
#line 1248 "../folks/individual-aggregator.vala"
								candidate_ind = (FolksIndividual*) _tmp40_;
#line 1250 "../folks/individual-aggregator.vala"
								_tmp43_ = candidate_ind;
#line 1250 "../folks/individual-aggregator.vala"
								_tmp44_ = folks_individual_get_trust_level (_tmp43_);
#line 1250 "../folks/individual-aggregator.vala"
								_tmp45_ = _tmp44_;
#line 1250 "../folks/individual-aggregator.vala"
								if (_tmp45_ != FOLKS_TRUST_LEVEL_NONE) {
#line 4830 "individual-aggregator.c"
									FolksIndividual* _tmp46_;
									FolksPersona* _tmp47_;
#line 1251 "../folks/individual-aggregator.vala"
									_tmp46_ = candidate_ind;
#line 1251 "../folks/individual-aggregator.vala"
									_tmp47_ = _data3_->persona;
#line 1251 "../folks/individual-aggregator.vala"
									_tmp42_ = folks_individual_has_anti_link_with_persona (_tmp46_, _tmp47_) == FALSE;
#line 4839 "individual-aggregator.c"
								} else {
#line 1250 "../folks/individual-aggregator.vala"
									_tmp42_ = FALSE;
#line 4843 "individual-aggregator.c"
								}
#line 1250 "../folks/individual-aggregator.vala"
								if (_tmp42_) {
#line 4847 "individual-aggregator.c"
									GeeHashSet* _tmp48_;
									FolksIndividual* _tmp49_;
#line 1253 "../folks/individual-aggregator.vala"
									_tmp48_ = _data3_->candidate_inds;
#line 1253 "../folks/individual-aggregator.vala"
									_tmp49_ = candidate_ind;
#line 1253 "../folks/individual-aggregator.vala"
									_tmp41_ = gee_abstract_collection_add ((GeeAbstractCollection*) _tmp48_, _tmp49_);
#line 4856 "individual-aggregator.c"
								} else {
#line 1250 "../folks/individual-aggregator.vala"
									_tmp41_ = FALSE;
#line 4860 "individual-aggregator.c"
								}
#line 1250 "../folks/individual-aggregator.vala"
								if (_tmp41_) {
#line 4864 "individual-aggregator.c"
									FolksIndividual* _tmp50_;
									const gchar* _tmp51_;
									const gchar* _tmp52_;
									FolksPersona* _tmp53_;
									const gchar* _tmp54_;
									const gchar* _tmp55_;
#line 1255 "../folks/individual-aggregator.vala"
									_tmp50_ = candidate_ind;
#line 1255 "../folks/individual-aggregator.vala"
									_tmp51_ = folks_individual_get_id (_tmp50_);
#line 1255 "../folks/individual-aggregator.vala"
									_tmp52_ = _tmp51_;
#line 1255 "../folks/individual-aggregator.vala"
									_tmp53_ = _data3_->persona;
#line 1255 "../folks/individual-aggregator.vala"
									_tmp54_ = folks_persona_get_iid (_tmp53_);
#line 1255 "../folks/individual-aggregator.vala"
									_tmp55_ = _tmp54_;
#line 1255 "../folks/individual-aggregator.vala"
									g_debug ("    Found candidate individual '%s' by " "IID '%s'.", _tmp52_, _tmp55_);
#line 4885 "individual-aggregator.c"
								}
							}
						}
					}
				}
			}
#line 1262 "../folks/individual-aggregator.vala"
			if (self->priv->_linking_enabled == TRUE) {
#line 4894 "individual-aggregator.c"
				FolksPersona* _tmp57_;
				FolksPersonaStore* _tmp58_;
				FolksPersonaStore* _tmp59_;
				FolksPersonaStoreTrust _tmp60_;
				FolksPersonaStoreTrust _tmp61_;
#line 1263 "../folks/individual-aggregator.vala"
				_tmp57_ = _data3_->persona;
#line 1263 "../folks/individual-aggregator.vala"
				_tmp58_ = folks_persona_get_store (_tmp57_);
#line 1263 "../folks/individual-aggregator.vala"
				_tmp59_ = _tmp58_;
#line 1263 "../folks/individual-aggregator.vala"
				_tmp60_ = folks_persona_store_get_trust_level (_tmp59_);
#line 1263 "../folks/individual-aggregator.vala"
				_tmp61_ = _tmp60_;
#line 1263 "../folks/individual-aggregator.vala"
				_tmp56_ = _tmp61_ == FOLKS_PERSONA_STORE_TRUST_FULL;
#line 4912 "individual-aggregator.c"
			} else {
#line 1262 "../folks/individual-aggregator.vala"
				_tmp56_ = FALSE;
#line 4916 "individual-aggregator.c"
			}
#line 1262 "../folks/individual-aggregator.vala"
			if (_tmp56_) {
#line 4920 "individual-aggregator.c"
				FolksPersona* _tmp62_;
				gchar** _tmp63_;
				gint _tmp63__length1;
				gint _tmp64_ = 0;
				gchar** _tmp65_;
				gint _tmp65__length1;
#line 1267 "../folks/individual-aggregator.vala"
				_tmp62_ = _data3_->persona;
#line 1267 "../folks/individual-aggregator.vala"
				_tmp63_ = folks_persona_get_linkable_properties (_tmp62_, &_tmp64_);
#line 1267 "../folks/individual-aggregator.vala"
				_tmp63__length1 = _tmp64_;
#line 1267 "../folks/individual-aggregator.vala"
				_tmp65_ = _tmp63_;
#line 1267 "../folks/individual-aggregator.vala"
				_tmp65__length1 = _tmp63__length1;
#line 4937 "individual-aggregator.c"
				{
					gchar** foo_collection = NULL;
					gint foo_collection_length1 = 0;
					gint _foo_collection_size_ = 0;
					gint foo_it = 0;
#line 1267 "../folks/individual-aggregator.vala"
					foo_collection = _tmp65_;
#line 1267 "../folks/individual-aggregator.vala"
					foo_collection_length1 = _tmp65__length1;
#line 1267 "../folks/individual-aggregator.vala"
					for (foo_it = 0; foo_it < foo_collection_length1; foo_it = foo_it + 1) {
#line 4949 "individual-aggregator.c"
						const gchar* foo = NULL;
#line 1267 "../folks/individual-aggregator.vala"
						foo = foo_collection[foo_it];
#line 4953 "individual-aggregator.c"
						{
							Block4Data* _data4_;
							const gchar* _tmp66_;
							const gchar* _tmp67_;
							GObjectClass* pclass = NULL;
							FolksPersona* _tmp68_;
							GObjectClass* _tmp69_;
							GObjectClass* _tmp70_;
							const gchar* _tmp71_;
							GParamSpec* _tmp72_;
							FolksPersona* _tmp74_;
							const gchar* _tmp75_;
#line 1267 "../folks/individual-aggregator.vala"
							_data4_ = g_slice_new0 (Block4Data);
#line 1267 "../folks/individual-aggregator.vala"
							_data4_->_ref_count_ = 1;
#line 1267 "../folks/individual-aggregator.vala"
							_data4_->_data3_ = block3_data_ref (_data3_);
#line 1270 "../folks/individual-aggregator.vala"
							_tmp66_ = foo;
#line 1270 "../folks/individual-aggregator.vala"
							if (_tmp66_ == NULL) {
#line 1271 "../folks/individual-aggregator.vala"
								block4_data_unref (_data4_);
#line 1271 "../folks/individual-aggregator.vala"
								_data4_ = NULL;
#line 1271 "../folks/individual-aggregator.vala"
								continue;
#line 4982 "individual-aggregator.c"
							}
#line 1276 "../folks/individual-aggregator.vala"
							_tmp67_ = foo;
#line 1276 "../folks/individual-aggregator.vala"
							_data4_->prop_name = _tmp67_;
#line 1278 "../folks/individual-aggregator.vala"
							_tmp68_ = _data3_->persona;
#line 1278 "../folks/individual-aggregator.vala"
							_tmp69_ = G_OBJECT_GET_CLASS ((GObject*) _tmp68_);
#line 1278 "../folks/individual-aggregator.vala"
							pclass = _tmp69_;
#line 1279 "../folks/individual-aggregator.vala"
							_tmp70_ = pclass;
#line 1279 "../folks/individual-aggregator.vala"
							_tmp71_ = _data4_->prop_name;
#line 1279 "../folks/individual-aggregator.vala"
							_tmp72_ = g_object_class_find_property (_tmp70_, _tmp71_);
#line 1279 "../folks/individual-aggregator.vala"
							if (_tmp72_ == NULL) {
#line 5002 "individual-aggregator.c"
								const gchar* _tmp73_;
#line 1281 "../folks/individual-aggregator.vala"
								_tmp73_ = _data4_->prop_name;
#line 1281 "../folks/individual-aggregator.vala"
								g_warning (_ ("Unknown property ‘%s’ in linkable property list."), _tmp73_);
#line 1285 "../folks/individual-aggregator.vala"
								block4_data_unref (_data4_);
#line 1285 "../folks/individual-aggregator.vala"
								_data4_ = NULL;
#line 1285 "../folks/individual-aggregator.vala"
								continue;
#line 5014 "individual-aggregator.c"
							}
#line 1288 "../folks/individual-aggregator.vala"
							_tmp74_ = _data3_->persona;
#line 1288 "../folks/individual-aggregator.vala"
							_tmp75_ = _data4_->prop_name;
#line 1288 "../folks/individual-aggregator.vala"
							folks_persona_linkable_property_to_links (_tmp74_, _tmp75_, ________lambda67__folks_persona_linkable_property_callback, _data4_);
#line 1267 "../folks/individual-aggregator.vala"
							block4_data_unref (_data4_);
#line 1267 "../folks/individual-aggregator.vala"
							_data4_ = NULL;
#line 5026 "individual-aggregator.c"
						}
					}
				}
			}
#line 1319 "../folks/individual-aggregator.vala"
			_tmp76_ = final_personas;
#line 1319 "../folks/individual-aggregator.vala"
			_tmp77_ = _data3_->persona;
#line 1319 "../folks/individual-aggregator.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp76_, _tmp77_);
#line 1321 "../folks/individual-aggregator.vala"
			if (self->priv->_linking_enabled == TRUE) {
#line 1321 "../folks/individual-aggregator.vala"
				_tmp78_ = TRUE;
#line 5041 "individual-aggregator.c"
			} else {
				GeeHashSet* _tmp79_;
				gint _tmp80_;
				gint _tmp81_;
#line 1321 "../folks/individual-aggregator.vala"
				_tmp79_ = _data3_->candidate_inds;
#line 1321 "../folks/individual-aggregator.vala"
				_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp79_);
#line 1321 "../folks/individual-aggregator.vala"
				_tmp81_ = _tmp80_;
#line 1321 "../folks/individual-aggregator.vala"
				_tmp78_ = _tmp81_ == 0;
#line 5054 "individual-aggregator.c"
			}
#line 1321 "../folks/individual-aggregator.vala"
			_vala_assert (_tmp78_, "this._linking_enabled == true || candidate_inds.size == 0");
#line 1322 "../folks/individual-aggregator.vala"
			_tmp83_ = _data3_->candidate_inds;
#line 1322 "../folks/individual-aggregator.vala"
			_tmp84_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp83_);
#line 1322 "../folks/individual-aggregator.vala"
			_tmp85_ = _tmp84_;
#line 1322 "../folks/individual-aggregator.vala"
			if (_tmp85_ > 0) {
#line 1322 "../folks/individual-aggregator.vala"
				_tmp82_ = self->priv->_linking_enabled == TRUE;
#line 5068 "individual-aggregator.c"
			} else {
#line 1322 "../folks/individual-aggregator.vala"
				_tmp82_ = FALSE;
#line 5072 "individual-aggregator.c"
			}
#line 1322 "../folks/individual-aggregator.vala"
			if (_tmp82_) {
#line 5076 "individual-aggregator.c"
				{
					GeeIterator* _individual_it = NULL;
					GeeHashSet* _tmp86_;
					GeeIterator* _tmp87_;
#line 1329 "../folks/individual-aggregator.vala"
					_tmp86_ = _data3_->candidate_inds;
#line 1329 "../folks/individual-aggregator.vala"
					_tmp87_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp86_);
#line 1329 "../folks/individual-aggregator.vala"
					_individual_it = _tmp87_;
#line 1329 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 5089 "individual-aggregator.c"
						GeeIterator* _tmp88_;
						FolksIndividual* individual = NULL;
						GeeIterator* _tmp89_;
						gpointer _tmp90_;
						GeeHashSet* _tmp91_;
						FolksIndividual* _tmp92_;
						GeeSet* _tmp93_;
						GeeSet* _tmp94_;
#line 1329 "../folks/individual-aggregator.vala"
						_tmp88_ = _individual_it;
#line 1329 "../folks/individual-aggregator.vala"
						if (!gee_iterator_next (_tmp88_)) {
#line 1329 "../folks/individual-aggregator.vala"
							break;
#line 5104 "individual-aggregator.c"
						}
#line 1329 "../folks/individual-aggregator.vala"
						_tmp89_ = _individual_it;
#line 1329 "../folks/individual-aggregator.vala"
						_tmp90_ = gee_iterator_get (_tmp89_);
#line 1329 "../folks/individual-aggregator.vala"
						individual = (FolksIndividual*) _tmp90_;
#line 1331 "../folks/individual-aggregator.vala"
						_tmp91_ = final_personas;
#line 1331 "../folks/individual-aggregator.vala"
						_tmp92_ = individual;
#line 1331 "../folks/individual-aggregator.vala"
						_tmp93_ = folks_individual_get_personas (_tmp92_);
#line 1331 "../folks/individual-aggregator.vala"
						_tmp94_ = _tmp93_;
#line 1331 "../folks/individual-aggregator.vala"
						gee_collection_add_all ((GeeCollection*) _tmp91_, (GeeCollection*) _tmp94_);
#line 1329 "../folks/individual-aggregator.vala"
						_g_object_unref0 (individual);
#line 5124 "individual-aggregator.c"
					}
#line 1329 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_individual_it);
#line 5128 "individual-aggregator.c"
				}
			} else {
#line 1334 "../folks/individual-aggregator.vala"
				if (!self->priv->_linking_enabled) {
#line 1336 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:1336:     Linking disabled.");
#line 5135 "individual-aggregator.c"
				} else {
#line 1340 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:1340:     Did not find any candidate indivi" \
"duals.");
#line 5139 "individual-aggregator.c"
				}
			}
#line 1344 "../folks/individual-aggregator.vala"
			_tmp95_ = final_personas;
#line 1344 "../folks/individual-aggregator.vala"
			_tmp96_ = folks_individual_new ((GeeSet*) _tmp95_);
#line 1344 "../folks/individual-aggregator.vala"
			final_individual = _tmp96_;
#line 1345 "../folks/individual-aggregator.vala"
			_tmp97_ = final_individual;
#line 1345 "../folks/individual-aggregator.vala"
			_tmp98_ = folks_individual_get_id (_tmp97_);
#line 1345 "../folks/individual-aggregator.vala"
			_tmp99_ = _tmp98_;
#line 1345 "../folks/individual-aggregator.vala"
			_tmp100_ = final_individual;
#line 1345 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1345:     Created new individual '%s' (%p) " \
"with personas:", _tmp99_, _tmp100_);
#line 5158 "individual-aggregator.c"
			{
				GeeIterator* _p_it = NULL;
				GeeHashSet* _tmp101_;
				GeeIterator* _tmp102_;
#line 1347 "../folks/individual-aggregator.vala"
				_tmp101_ = final_personas;
#line 1347 "../folks/individual-aggregator.vala"
				_tmp102_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp101_);
#line 1347 "../folks/individual-aggregator.vala"
				_p_it = _tmp102_;
#line 1347 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 5171 "individual-aggregator.c"
					GeeIterator* _tmp103_;
					FolksPersona* p = NULL;
					GeeIterator* _tmp104_;
					gpointer _tmp105_;
					FolksPersona* _tmp106_;
					const gchar* _tmp107_;
					const gchar* _tmp108_;
					FolksPersona* _tmp109_;
					FolksPersona* _tmp110_;
					FolksIndividual* _tmp111_;
#line 1347 "../folks/individual-aggregator.vala"
					_tmp103_ = _p_it;
#line 1347 "../folks/individual-aggregator.vala"
					if (!gee_iterator_next (_tmp103_)) {
#line 1347 "../folks/individual-aggregator.vala"
						break;
#line 5188 "individual-aggregator.c"
					}
#line 1347 "../folks/individual-aggregator.vala"
					_tmp104_ = _p_it;
#line 1347 "../folks/individual-aggregator.vala"
					_tmp105_ = gee_iterator_get (_tmp104_);
#line 1347 "../folks/individual-aggregator.vala"
					p = (FolksPersona*) _tmp105_;
#line 1349 "../folks/individual-aggregator.vala"
					_tmp106_ = p;
#line 1349 "../folks/individual-aggregator.vala"
					_tmp107_ = folks_persona_get_uid (_tmp106_);
#line 1349 "../folks/individual-aggregator.vala"
					_tmp108_ = _tmp107_;
#line 1349 "../folks/individual-aggregator.vala"
					_tmp109_ = p;
#line 1349 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:1349:         %s (%p)", _tmp108_, _tmp109_);
#line 1350 "../folks/individual-aggregator.vala"
					_tmp110_ = p;
#line 1350 "../folks/individual-aggregator.vala"
					_tmp111_ = final_individual;
#line 1350 "../folks/individual-aggregator.vala"
					_folks_individual_aggregator_add_persona_to_link_map (self, _tmp110_, _tmp111_);
#line 1347 "../folks/individual-aggregator.vala"
					_g_object_unref0 (p);
#line 5214 "individual-aggregator.c"
				}
#line 1347 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_p_it);
#line 5218 "individual-aggregator.c"
			}
#line 1353 "../folks/individual-aggregator.vala"
			num_mappings_added = (guint) 0;
#line 5222 "individual-aggregator.c"
			{
				GeeIterator* _i_it = NULL;
				GeeHashSet* _tmp112_;
				GeeIterator* _tmp113_;
#line 1355 "../folks/individual-aggregator.vala"
				_tmp112_ = _data3_->candidate_inds;
#line 1355 "../folks/individual-aggregator.vala"
				_tmp113_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp112_);
#line 1355 "../folks/individual-aggregator.vala"
				_i_it = _tmp113_;
#line 1355 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 5235 "individual-aggregator.c"
					GeeIterator* _tmp114_;
					FolksIndividual* i = NULL;
					GeeIterator* _tmp115_;
					gpointer _tmp116_;
					FolksIndividual* _tmp117_;
					GeeHashSet* transitive_updates = NULL;
					GeeHashSet* _tmp118_;
					GeeMapIterator* iter = NULL;
					GeeMapIterator* _tmp119_;
					GeeHashSet* _tmp141_;
					gint _tmp142_;
					gint _tmp143_;
#line 1355 "../folks/individual-aggregator.vala"
					_tmp114_ = _i_it;
#line 1355 "../folks/individual-aggregator.vala"
					if (!gee_iterator_next (_tmp114_)) {
#line 1355 "../folks/individual-aggregator.vala"
						break;
#line 5254 "individual-aggregator.c"
					}
#line 1355 "../folks/individual-aggregator.vala"
					_tmp115_ = _i_it;
#line 1355 "../folks/individual-aggregator.vala"
					_tmp116_ = gee_iterator_get (_tmp115_);
#line 1355 "../folks/individual-aggregator.vala"
					i = (FolksIndividual*) _tmp116_;
#line 1358 "../folks/individual-aggregator.vala"
					_tmp117_ = i;
#line 1358 "../folks/individual-aggregator.vala"
					_folks_individual_aggregator_remove_individual_from_link_map (self, _tmp117_);
#line 1363 "../folks/individual-aggregator.vala"
					_tmp118_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1363 "../folks/individual-aggregator.vala"
					transitive_updates = _tmp118_;
#line 1365 "../folks/individual-aggregator.vala"
					_tmp119_ = gee_multi_map_map_iterator ((GeeMultiMap*) (*individuals_changes));
#line 1365 "../folks/individual-aggregator.vala"
					iter = _tmp119_;
#line 1367 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 5276 "individual-aggregator.c"
						GeeMapIterator* _tmp120_;
						FolksIndividual* _tmp121_;
						GeeMapIterator* _tmp122_;
						gpointer _tmp123_;
						FolksIndividual* _tmp124_;
						gboolean _tmp125_;
#line 1367 "../folks/individual-aggregator.vala"
						_tmp120_ = iter;
#line 1367 "../folks/individual-aggregator.vala"
						if (!gee_map_iterator_next (_tmp120_)) {
#line 1367 "../folks/individual-aggregator.vala"
							break;
#line 5289 "individual-aggregator.c"
						}
#line 1369 "../folks/individual-aggregator.vala"
						_tmp121_ = i;
#line 1369 "../folks/individual-aggregator.vala"
						_tmp122_ = iter;
#line 1369 "../folks/individual-aggregator.vala"
						_tmp123_ = gee_map_iterator_get_value (_tmp122_);
#line 1369 "../folks/individual-aggregator.vala"
						_tmp124_ = (FolksIndividual*) _tmp123_;
#line 1369 "../folks/individual-aggregator.vala"
						_tmp125_ = _tmp121_ == _tmp124_;
#line 1369 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_tmp124_);
#line 1369 "../folks/individual-aggregator.vala"
						if (_tmp125_) {
#line 5305 "individual-aggregator.c"
							GeeHashSet* _tmp126_;
							GeeMapIterator* _tmp127_;
							gpointer _tmp128_;
							FolksIndividual* _tmp129_;
#line 1371 "../folks/individual-aggregator.vala"
							_tmp126_ = transitive_updates;
#line 1371 "../folks/individual-aggregator.vala"
							_tmp127_ = iter;
#line 1371 "../folks/individual-aggregator.vala"
							_tmp128_ = gee_map_iterator_get_key (_tmp127_);
#line 1371 "../folks/individual-aggregator.vala"
							_tmp129_ = (FolksIndividual*) _tmp128_;
#line 1371 "../folks/individual-aggregator.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp126_, _tmp129_);
#line 1371 "../folks/individual-aggregator.vala"
							_g_object_unref0 (_tmp129_);
#line 5322 "individual-aggregator.c"
						}
					}
					{
						GeeIterator* _k_it = NULL;
						GeeHashSet* _tmp130_;
						GeeIterator* _tmp131_;
#line 1375 "../folks/individual-aggregator.vala"
						_tmp130_ = transitive_updates;
#line 1375 "../folks/individual-aggregator.vala"
						_tmp131_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp130_);
#line 1375 "../folks/individual-aggregator.vala"
						_k_it = _tmp131_;
#line 1375 "../folks/individual-aggregator.vala"
						while (TRUE) {
#line 5337 "individual-aggregator.c"
							GeeIterator* _tmp132_;
							FolksIndividual* k = NULL;
							GeeIterator* _tmp133_;
							gpointer _tmp134_;
							FolksIndividual* _tmp135_;
							FolksIndividual* _tmp136_;
							FolksIndividual* _tmp137_;
#line 1375 "../folks/individual-aggregator.vala"
							_tmp132_ = _k_it;
#line 1375 "../folks/individual-aggregator.vala"
							if (!gee_iterator_next (_tmp132_)) {
#line 1375 "../folks/individual-aggregator.vala"
								break;
#line 5351 "individual-aggregator.c"
							}
#line 1375 "../folks/individual-aggregator.vala"
							_tmp133_ = _k_it;
#line 1375 "../folks/individual-aggregator.vala"
							_tmp134_ = gee_iterator_get (_tmp133_);
#line 1375 "../folks/individual-aggregator.vala"
							k = (FolksIndividual*) _tmp134_;
#line 1377 "../folks/individual-aggregator.vala"
							_tmp135_ = k;
#line 1377 "../folks/individual-aggregator.vala"
							_tmp136_ = i;
#line 1377 "../folks/individual-aggregator.vala"
							_vala_assert (gee_multi_map_remove ((GeeMultiMap*) (*individuals_changes), _tmp135_, _tmp136_) == TRUE, "individuals_changes.remove (k, i) == true");
#line 1383 "../folks/individual-aggregator.vala"
							_tmp137_ = k;
#line 1383 "../folks/individual-aggregator.vala"
							if (_tmp137_ != NULL) {
#line 5369 "individual-aggregator.c"
								FolksIndividual* _tmp138_;
								FolksIndividual* _tmp139_;
								guint _tmp140_;
#line 1385 "../folks/individual-aggregator.vala"
								_tmp138_ = k;
#line 1385 "../folks/individual-aggregator.vala"
								_tmp139_ = final_individual;
#line 1385 "../folks/individual-aggregator.vala"
								gee_multi_map_set ((GeeMultiMap*) (*individuals_changes), _tmp138_, _tmp139_);
#line 1386 "../folks/individual-aggregator.vala"
								_tmp140_ = num_mappings_added;
#line 1386 "../folks/individual-aggregator.vala"
								num_mappings_added = _tmp140_ + 1;
#line 5383 "individual-aggregator.c"
							}
#line 1375 "../folks/individual-aggregator.vala"
							_g_object_unref0 (k);
#line 5387 "individual-aggregator.c"
						}
#line 1375 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_k_it);
#line 5391 "individual-aggregator.c"
					}
#line 1394 "../folks/individual-aggregator.vala"
					_tmp141_ = transitive_updates;
#line 1394 "../folks/individual-aggregator.vala"
					_tmp142_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp141_);
#line 1394 "../folks/individual-aggregator.vala"
					_tmp143_ = _tmp142_;
#line 1394 "../folks/individual-aggregator.vala"
					if (_tmp143_ == 0) {
#line 5401 "individual-aggregator.c"
						FolksIndividual* _tmp144_;
						FolksIndividual* _tmp145_;
						guint _tmp146_;
#line 1396 "../folks/individual-aggregator.vala"
						_tmp144_ = i;
#line 1396 "../folks/individual-aggregator.vala"
						_tmp145_ = final_individual;
#line 1396 "../folks/individual-aggregator.vala"
						gee_multi_map_set ((GeeMultiMap*) (*individuals_changes), _tmp144_, _tmp145_);
#line 1397 "../folks/individual-aggregator.vala"
						_tmp146_ = num_mappings_added;
#line 1397 "../folks/individual-aggregator.vala"
						num_mappings_added = _tmp146_ + 1;
#line 5415 "individual-aggregator.c"
					}
#line 1355 "../folks/individual-aggregator.vala"
					_g_object_unref0 (iter);
#line 1355 "../folks/individual-aggregator.vala"
					_g_object_unref0 (transitive_updates);
#line 1355 "../folks/individual-aggregator.vala"
					_g_object_unref0 (i);
#line 5423 "individual-aggregator.c"
				}
#line 1355 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_i_it);
#line 5427 "individual-aggregator.c"
			}
#line 1404 "../folks/individual-aggregator.vala"
			if (num_mappings_added == ((guint) 0)) {
#line 5431 "individual-aggregator.c"
				FolksIndividual* _tmp147_;
#line 1406 "../folks/individual-aggregator.vala"
				_tmp147_ = final_individual;
#line 1406 "../folks/individual-aggregator.vala"
				gee_multi_map_set ((GeeMultiMap*) (*individuals_changes), NULL, _tmp147_);
#line 5437 "individual-aggregator.c"
			}
#line 1410 "../folks/individual-aggregator.vala"
			_tmp148_ = final_individual;
#line 1410 "../folks/individual-aggregator.vala"
			_tmp149_ = folks_individual_get_is_user (_tmp148_);
#line 1410 "../folks/individual-aggregator.vala"
			_tmp150_ = _tmp149_;
#line 1410 "../folks/individual-aggregator.vala"
			if (_tmp150_ == TRUE) {
#line 5447 "individual-aggregator.c"
				FolksIndividual* _tmp151_;
				FolksIndividual* _tmp152_;
#line 1411 "../folks/individual-aggregator.vala"
				_tmp151_ = final_individual;
#line 1411 "../folks/individual-aggregator.vala"
				_tmp152_ = _g_object_ref0 (_tmp151_);
#line 1411 "../folks/individual-aggregator.vala"
				_g_object_unref0 (*user);
#line 1411 "../folks/individual-aggregator.vala"
				*user = _tmp152_;
#line 5458 "individual-aggregator.c"
			}
#line 1208 "../folks/individual-aggregator.vala"
			_g_object_unref0 (final_individual);
#line 1208 "../folks/individual-aggregator.vala"
			_g_object_unref0 (final_personas);
#line 1208 "../folks/individual-aggregator.vala"
			block3_data_unref (_data3_);
#line 1208 "../folks/individual-aggregator.vala"
			_data3_ = NULL;
#line 5468 "individual-aggregator.c"
		}
#line 1208 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_persona_it);
#line 5472 "individual-aggregator.c"
	}
}

static void
_folks_individual_aggregator_persona_linkable_property_changed_cb (FolksIndividualAggregator* self,
                                                                   GObject* obj,
                                                                   GParamSpec* pspec)
{
	FolksPersona* persona = NULL;
	const gchar* _tmp0_ = NULL;
	FolksPersona* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	FolksPersona* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	FolksPersona* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	FolksSmallSet* persona_set = NULL;
	FolksSmallSet* _tmp11_;
	FolksSmallSet* _tmp12_;
	FolksPersona* _tmp13_;
	FolksPersona* _tmp14_;
	FolksPersonaStore* _tmp15_;
	FolksPersonaStore* _tmp16_;
	FolksSmallSet* _tmp17_;
	FolksSmallSet* _tmp18_;
#line 1415 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1415 "../folks/individual-aggregator.vala"
	g_return_if_fail (obj != NULL);
#line 1415 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1419 "../folks/individual-aggregator.vala"
	if (self->priv->_linking_enabled == FALSE) {
#line 1421 "../folks/individual-aggregator.vala"
		return;
#line 5512 "individual-aggregator.c"
	}
#line 1428 "../folks/individual-aggregator.vala"
	persona = G_TYPE_CHECK_INSTANCE_CAST (FOLKS_IS_PERSONA (obj) ? ((FolksPersona*) obj) : NULL, FOLKS_TYPE_PERSONA, FolksPersona);
#line 1432 "../folks/individual-aggregator.vala"
	_tmp1_ = persona;
#line 1432 "../folks/individual-aggregator.vala"
	_tmp2_ = folks_persona_get_is_user (_tmp1_);
#line 1432 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 1432 "../folks/individual-aggregator.vala"
	if (_tmp3_) {
#line 1432 "../folks/individual-aggregator.vala"
		_tmp0_ = "yes";
#line 5526 "individual-aggregator.c"
	} else {
#line 1432 "../folks/individual-aggregator.vala"
		_tmp0_ = "no";
#line 5530 "individual-aggregator.c"
	}
#line 1430 "../folks/individual-aggregator.vala"
	_tmp4_ = pspec->name;
#line 1430 "../folks/individual-aggregator.vala"
	_tmp5_ = persona;
#line 1430 "../folks/individual-aggregator.vala"
	_tmp6_ = folks_persona_get_uid (_tmp5_);
#line 1430 "../folks/individual-aggregator.vala"
	_tmp7_ = _tmp6_;
#line 1430 "../folks/individual-aggregator.vala"
	_tmp8_ = persona;
#line 1430 "../folks/individual-aggregator.vala"
	_tmp9_ = folks_persona_get_iid (_tmp8_);
#line 1430 "../folks/individual-aggregator.vala"
	_tmp10_ = _tmp9_;
#line 1430 "../folks/individual-aggregator.vala"
	g_debug ("Linkable property '%s' changed for persona '%s' " "(is user: %s, IID: %s).", _tmp4_, _tmp7_, _tmp0_, _tmp10_);
#line 1434 "../folks/individual-aggregator.vala"
	_tmp11_ = folks_small_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1434 "../folks/individual-aggregator.vala"
	persona_set = _tmp11_;
#line 1435 "../folks/individual-aggregator.vala"
	_tmp12_ = persona_set;
#line 1435 "../folks/individual-aggregator.vala"
	_tmp13_ = persona;
#line 1435 "../folks/individual-aggregator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 1437 "../folks/individual-aggregator.vala"
	_tmp14_ = persona;
#line 1437 "../folks/individual-aggregator.vala"
	_tmp15_ = folks_persona_get_store (_tmp14_);
#line 1437 "../folks/individual-aggregator.vala"
	_tmp16_ = _tmp15_;
#line 1437 "../folks/individual-aggregator.vala"
	_tmp17_ = persona_set;
#line 1437 "../folks/individual-aggregator.vala"
	_tmp18_ = persona_set;
#line 1437 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_personas_changed_cb (self, _tmp16_, (GeeSet*) _tmp17_, (GeeSet*) _tmp18_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1415 "../folks/individual-aggregator.vala"
	_g_object_unref0 (persona_set);
#line 5572 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_persona_anti_links_changed_cb (FolksIndividualAggregator* self,
                                                            GObject* obj,
                                                            GParamSpec* pspec)
{
	FolksPersona* persona = NULL;
	const gchar* _tmp0_ = NULL;
	FolksPersona* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	FolksPersona* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	FolksPersona* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	FolksSmallSet* persona_set = NULL;
	FolksSmallSet* _tmp10_;
	FolksPersona* _tmp11_;
	FolksPersona* _tmp12_;
	FolksPersonaStore* _tmp13_;
	FolksPersonaStore* _tmp14_;
#line 1441 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1441 "../folks/individual-aggregator.vala"
	g_return_if_fail (obj != NULL);
#line 1441 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1443 "../folks/individual-aggregator.vala"
	persona = FOLKS_IS_PERSONA (obj) ? ((FolksPersona*) obj) : NULL;
#line 1450 "../folks/individual-aggregator.vala"
	_tmp1_ = persona;
#line 1450 "../folks/individual-aggregator.vala"
	_tmp2_ = folks_persona_get_is_user (_tmp1_);
#line 1450 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 1450 "../folks/individual-aggregator.vala"
	if (_tmp3_) {
#line 1450 "../folks/individual-aggregator.vala"
		_tmp0_ = "yes";
#line 5615 "individual-aggregator.c"
	} else {
#line 1450 "../folks/individual-aggregator.vala"
		_tmp0_ = "no";
#line 5619 "individual-aggregator.c"
	}
#line 1449 "../folks/individual-aggregator.vala"
	_tmp4_ = persona;
#line 1449 "../folks/individual-aggregator.vala"
	_tmp5_ = folks_persona_get_uid (_tmp4_);
#line 1449 "../folks/individual-aggregator.vala"
	_tmp6_ = _tmp5_;
#line 1449 "../folks/individual-aggregator.vala"
	_tmp7_ = persona;
#line 1449 "../folks/individual-aggregator.vala"
	_tmp8_ = folks_persona_get_iid (_tmp7_);
#line 1449 "../folks/individual-aggregator.vala"
	_tmp9_ = _tmp8_;
#line 1449 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1449: Anti-links changed for persona '%s' (" \
"is user: %s, IID: %s).", _tmp6_, _tmp0_, _tmp9_);
#line 1452 "../folks/individual-aggregator.vala"
	_tmp10_ = folks_small_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1452 "../folks/individual-aggregator.vala"
	persona_set = _tmp10_;
#line 1453 "../folks/individual-aggregator.vala"
	_tmp11_ = persona;
#line 1453 "../folks/individual-aggregator.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) persona_set, _tmp11_);
#line 1455 "../folks/individual-aggregator.vala"
	_tmp12_ = persona;
#line 1455 "../folks/individual-aggregator.vala"
	_tmp13_ = folks_persona_get_store (_tmp12_);
#line 1455 "../folks/individual-aggregator.vala"
	_tmp14_ = _tmp13_;
#line 1455 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_personas_changed_cb (self, _tmp14_, (GeeSet*) persona_set, (GeeSet*) persona_set, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1441 "../folks/individual-aggregator.vala"
	_g_object_unref0 (persona_set);
#line 5653 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_persona_linkable_property_changed_cb_g_object_notify (GObject* _sender,
                                                                                    GParamSpec* pspec,
                                                                                    gpointer self)
{
#line 1467 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_persona_linkable_property_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 5663 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_persona_anti_links_changed_cb_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self)
{
#line 1474 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_persona_anti_links_changed_cb ((FolksIndividualAggregator*) self, _sender, pspec);
#line 5673 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_connect_to_persona (FolksIndividualAggregator* self,
                                                 FolksPersona* persona)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	FolksAntiLinkable* al = NULL;
	FolksAntiLinkable* _tmp6_;
#line 1459 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1459 "../folks/individual-aggregator.vala"
	g_return_if_fail (persona != NULL);
#line 1461 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_persona_get_linkable_properties (persona, &_tmp1_);
#line 1461 "../folks/individual-aggregator.vala"
	_tmp0__length1 = _tmp1_;
#line 1461 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp0_;
#line 1461 "../folks/individual-aggregator.vala"
	_tmp2__length1 = _tmp0__length1;
#line 5699 "individual-aggregator.c"
	{
		gchar** prop_name_collection = NULL;
		gint prop_name_collection_length1 = 0;
		gint _prop_name_collection_size_ = 0;
		gint prop_name_it = 0;
#line 1461 "../folks/individual-aggregator.vala"
		prop_name_collection = _tmp2_;
#line 1461 "../folks/individual-aggregator.vala"
		prop_name_collection_length1 = _tmp2__length1;
#line 1461 "../folks/individual-aggregator.vala"
		for (prop_name_it = 0; prop_name_it < prop_name_collection_length1; prop_name_it = prop_name_it + 1) {
#line 5711 "individual-aggregator.c"
			const gchar* prop_name = NULL;
#line 1461 "../folks/individual-aggregator.vala"
			prop_name = prop_name_collection[prop_name_it];
#line 5715 "individual-aggregator.c"
			{
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				gchar* _tmp5_;
#line 1464 "../folks/individual-aggregator.vala"
				_tmp3_ = prop_name;
#line 1464 "../folks/individual-aggregator.vala"
				if (_tmp3_ == NULL) {
#line 1465 "../folks/individual-aggregator.vala"
					continue;
#line 5726 "individual-aggregator.c"
				}
#line 1467 "../folks/individual-aggregator.vala"
				_tmp4_ = prop_name;
#line 1467 "../folks/individual-aggregator.vala"
				_tmp5_ = g_strconcat ("notify::", _tmp4_, NULL);
#line 1467 "../folks/individual-aggregator.vala"
				g_signal_connect_object ((GObject*) persona, _tmp5_, (GCallback) __folks_individual_aggregator_persona_linkable_property_changed_cb_g_object_notify, self, 0);
#line 1467 "../folks/individual-aggregator.vala"
				_g_free0 (_tmp5_);
#line 5736 "individual-aggregator.c"
			}
		}
	}
#line 1471 "../folks/individual-aggregator.vala"
	al = FOLKS_IS_ANTI_LINKABLE (persona) ? ((FolksAntiLinkable*) persona) : NULL;
#line 1472 "../folks/individual-aggregator.vala"
	_tmp6_ = al;
#line 1472 "../folks/individual-aggregator.vala"
	if (_tmp6_ != NULL) {
#line 5746 "individual-aggregator.c"
		FolksAntiLinkable* _tmp7_;
#line 1474 "../folks/individual-aggregator.vala"
		_tmp7_ = al;
#line 1474 "../folks/individual-aggregator.vala"
		g_signal_connect_object ((GObject*) _tmp7_, "notify::anti-links", (GCallback) __folks_individual_aggregator_persona_anti_links_changed_cb_g_object_notify, self, 0);
#line 5752 "individual-aggregator.c"
	}
}

static void
_folks_individual_aggregator_disconnect_from_persona (FolksIndividualAggregator* self,
                                                      FolksPersona* persona)
{
	FolksAntiLinkable* al = NULL;
	FolksAntiLinkable* _tmp0_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 1478 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1478 "../folks/individual-aggregator.vala"
	g_return_if_fail (persona != NULL);
#line 1480 "../folks/individual-aggregator.vala"
	al = FOLKS_IS_ANTI_LINKABLE (persona) ? ((FolksAntiLinkable*) persona) : NULL;
#line 1481 "../folks/individual-aggregator.vala"
	_tmp0_ = al;
#line 1481 "../folks/individual-aggregator.vala"
	if (_tmp0_ != NULL) {
#line 5777 "individual-aggregator.c"
		FolksAntiLinkable* _tmp1_;
		guint _tmp2_;
		GQuark _tmp3_;
#line 1483 "../folks/individual-aggregator.vala"
		_tmp1_ = al;
#line 1483 "../folks/individual-aggregator.vala"
		g_signal_parse_name ("notify::anti-links", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
#line 1483 "../folks/individual-aggregator.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) __folks_individual_aggregator_persona_anti_links_changed_cb_g_object_notify, self);
#line 5787 "individual-aggregator.c"
	}
#line 1487 "../folks/individual-aggregator.vala"
	_tmp4_ = folks_persona_get_linkable_properties (persona, &_tmp5_);
#line 1487 "../folks/individual-aggregator.vala"
	_tmp4__length1 = _tmp5_;
#line 1487 "../folks/individual-aggregator.vala"
	_tmp6_ = _tmp4_;
#line 1487 "../folks/individual-aggregator.vala"
	_tmp6__length1 = _tmp4__length1;
#line 5797 "individual-aggregator.c"
	{
		gchar** prop_name_collection = NULL;
		gint prop_name_collection_length1 = 0;
		gint _prop_name_collection_size_ = 0;
		gint prop_name_it = 0;
#line 1487 "../folks/individual-aggregator.vala"
		prop_name_collection = _tmp6_;
#line 1487 "../folks/individual-aggregator.vala"
		prop_name_collection_length1 = _tmp6__length1;
#line 1487 "../folks/individual-aggregator.vala"
		for (prop_name_it = 0; prop_name_it < prop_name_collection_length1; prop_name_it = prop_name_it + 1) {
#line 5809 "individual-aggregator.c"
			const gchar* prop_name = NULL;
#line 1487 "../folks/individual-aggregator.vala"
			prop_name = prop_name_collection[prop_name_it];
#line 5813 "individual-aggregator.c"
			{
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				guint _tmp10_;
				GQuark _tmp11_;
#line 1490 "../folks/individual-aggregator.vala"
				_tmp7_ = prop_name;
#line 1490 "../folks/individual-aggregator.vala"
				if (_tmp7_ == NULL) {
#line 1491 "../folks/individual-aggregator.vala"
					continue;
#line 5826 "individual-aggregator.c"
				}
#line 1493 "../folks/individual-aggregator.vala"
				_tmp8_ = prop_name;
#line 1493 "../folks/individual-aggregator.vala"
				_tmp9_ = g_strconcat ("notify::", _tmp8_, NULL);
#line 1493 "../folks/individual-aggregator.vala"
				g_signal_parse_name (_tmp9_, G_TYPE_OBJECT, &_tmp10_, &_tmp11_, TRUE);
#line 1493 "../folks/individual-aggregator.vala"
				g_signal_handlers_disconnect_matched ((GObject*) persona, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, _tmp11_, NULL, (GCallback) __folks_individual_aggregator_persona_linkable_property_changed_cb_g_object_notify, self);
#line 1493 "../folks/individual-aggregator.vala"
				_g_free0 (_tmp9_);
#line 5838 "individual-aggregator.c"
			}
		}
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 1509 "../folks/individual-aggregator.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 5849 "individual-aggregator.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 1510 "../folks/individual-aggregator.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 5857 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_link_map_set (FolksIndividualAggregator* self,
                                           const gchar* key,
                                           FolksIndividual* individual)
{
	GPtrArray* inds = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp17_;
	FolksIndividual* _tmp18_;
#line 1503 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1503 "../folks/individual-aggregator.vala"
	g_return_if_fail (key != NULL);
#line 1503 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 1505 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_link_map;
#line 1505 "../folks/individual-aggregator.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, key);
#line 1505 "../folks/individual-aggregator.vala"
	inds = (GPtrArray*) _tmp1_;
#line 1507 "../folks/individual-aggregator.vala"
	_tmp2_ = inds;
#line 1507 "../folks/individual-aggregator.vala"
	if (_tmp2_ == NULL) {
#line 5887 "individual-aggregator.c"
		GPtrArray* new_inds = NULL;
		GPtrArray* _tmp3_;
		GHashTable* _tmp4_;
		gchar* _tmp5_;
		GPtrArray* _tmp6_;
		GPtrArray* _tmp7_;
		GPtrArray* _tmp8_;
		FolksIndividual* _tmp9_;
#line 1509 "../folks/individual-aggregator.vala"
		_tmp3_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 1509 "../folks/individual-aggregator.vala"
		new_inds = _tmp3_;
#line 1510 "../folks/individual-aggregator.vala"
		_tmp4_ = self->priv->_link_map;
#line 1510 "../folks/individual-aggregator.vala"
		_tmp5_ = g_strdup (key);
#line 1510 "../folks/individual-aggregator.vala"
		_tmp6_ = new_inds;
#line 1510 "../folks/individual-aggregator.vala"
		_tmp7_ = _g_ptr_array_ref0 (_tmp6_);
#line 1510 "../folks/individual-aggregator.vala"
		g_hash_table_insert (_tmp4_, _tmp5_, _tmp7_);
#line 1511 "../folks/individual-aggregator.vala"
		_tmp8_ = new_inds;
#line 1511 "../folks/individual-aggregator.vala"
		_tmp9_ = _g_object_ref0 (individual);
#line 1511 "../folks/individual-aggregator.vala"
		g_ptr_array_add (_tmp8_, _tmp9_);
#line 1512 "../folks/individual-aggregator.vala"
		_g_ptr_array_unref0 (new_inds);
#line 1512 "../folks/individual-aggregator.vala"
		return;
#line 5920 "individual-aggregator.c"
	}
	{
		guint i = 0U;
#line 1515 "../folks/individual-aggregator.vala"
		i = (guint) 0;
#line 5926 "individual-aggregator.c"
		{
			gboolean _tmp10_ = FALSE;
#line 1515 "../folks/individual-aggregator.vala"
			_tmp10_ = TRUE;
#line 1515 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 5933 "individual-aggregator.c"
				GPtrArray* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				GPtrArray* _tmp15_;
				gconstpointer _tmp16_;
#line 1515 "../folks/individual-aggregator.vala"
				if (!_tmp10_) {
#line 5941 "individual-aggregator.c"
					guint _tmp11_;
#line 1515 "../folks/individual-aggregator.vala"
					_tmp11_ = i;
#line 1515 "../folks/individual-aggregator.vala"
					i = _tmp11_ + 1;
#line 5947 "individual-aggregator.c"
				}
#line 1515 "../folks/individual-aggregator.vala"
				_tmp10_ = FALSE;
#line 1515 "../folks/individual-aggregator.vala"
				_tmp12_ = inds;
#line 1515 "../folks/individual-aggregator.vala"
				_tmp13_ = vala_g_ptr_array_get_length ((GPtrArray*) _tmp12_);
#line 1515 "../folks/individual-aggregator.vala"
				_tmp14_ = _tmp13_;
#line 1515 "../folks/individual-aggregator.vala"
				if (!(i < ((guint) _tmp14_))) {
#line 1515 "../folks/individual-aggregator.vala"
					break;
#line 5961 "individual-aggregator.c"
				}
#line 1517 "../folks/individual-aggregator.vala"
				_tmp15_ = inds;
#line 1517 "../folks/individual-aggregator.vala"
				_tmp16_ = g_ptr_array_index ((GPtrArray*) _tmp15_, i);
#line 1517 "../folks/individual-aggregator.vala"
				if (((FolksIndividual*) _tmp16_) == individual) {
#line 1518 "../folks/individual-aggregator.vala"
					return;
#line 5971 "individual-aggregator.c"
				}
			}
		}
	}
#line 1521 "../folks/individual-aggregator.vala"
	_tmp17_ = inds;
#line 1521 "../folks/individual-aggregator.vala"
	_tmp18_ = _g_object_ref0 (individual);
#line 1521 "../folks/individual-aggregator.vala"
	g_ptr_array_add ((GPtrArray*) _tmp17_, _tmp18_);
#line 5982 "individual-aggregator.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 1524 "../folks/individual-aggregator.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 1524 "../folks/individual-aggregator.vala"
	return _data5_;
#line 5992 "individual-aggregator.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 1524 "../folks/individual-aggregator.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 6002 "individual-aggregator.c"
		FolksIndividualAggregator* self;
#line 1524 "../folks/individual-aggregator.vala"
		self = _data5_->self;
#line 1524 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data5_->individual);
#line 1524 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self);
#line 1524 "../folks/individual-aggregator.vala"
		g_slice_free (Block5Data, _data5_);
#line 6012 "individual-aggregator.c"
	}
}

static void
_____lambda68_ (Block5Data* _data5_,
                const gchar* l)
{
	FolksIndividualAggregator* self;
	const gchar* prop_linking_value = NULL;
#line 1561 "../folks/individual-aggregator.vala"
	self = _data5_->self;
#line 1561 "../folks/individual-aggregator.vala"
	g_return_if_fail (l != NULL);
#line 1563 "../folks/individual-aggregator.vala"
	prop_linking_value = l;
#line 1565 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1565:             %s", prop_linking_value);
#line 1566 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_link_map_set (self, prop_linking_value, _data5_->individual);
#line 6032 "individual-aggregator.c"
}

static void
______lambda68__folks_persona_linkable_property_callback (const gchar* link,
                                                          gpointer self)
{
#line 1561 "../folks/individual-aggregator.vala"
	_____lambda68_ (self, link);
#line 6041 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_add_persona_to_link_map (FolksIndividualAggregator* self,
                                                      FolksPersona* persona,
                                                      FolksIndividual* individual)
{
	Block5Data* _data5_;
	FolksIndividual* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	FolksPersonaStore* _tmp12_;
	FolksPersonaStore* _tmp13_;
	FolksPersonaStoreTrust _tmp14_;
	FolksPersonaStoreTrust _tmp15_;
#line 1524 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1524 "../folks/individual-aggregator.vala"
	g_return_if_fail (persona != NULL);
#line 1524 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 1524 "../folks/individual-aggregator.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 1524 "../folks/individual-aggregator.vala"
	_data5_->_ref_count_ = 1;
#line 1524 "../folks/individual-aggregator.vala"
	_data5_->self = g_object_ref (self);
#line 1524 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (individual);
#line 1524 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data5_->individual);
#line 1524 "../folks/individual-aggregator.vala"
	_data5_->individual = _tmp0_;
#line 1527 "../folks/individual-aggregator.vala"
	_tmp2_ = folks_persona_get_is_user (persona);
#line 1527 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 1527 "../folks/individual-aggregator.vala"
	if (_tmp3_) {
#line 1527 "../folks/individual-aggregator.vala"
		_tmp1_ = "yes";
#line 6092 "individual-aggregator.c"
	} else {
#line 1527 "../folks/individual-aggregator.vala"
		_tmp1_ = "no";
#line 6096 "individual-aggregator.c"
	}
#line 1526 "../folks/individual-aggregator.vala"
	_tmp4_ = folks_persona_get_uid (persona);
#line 1526 "../folks/individual-aggregator.vala"
	_tmp5_ = _tmp4_;
#line 1526 "../folks/individual-aggregator.vala"
	_tmp6_ = folks_persona_get_iid (persona);
#line 1526 "../folks/individual-aggregator.vala"
	_tmp7_ = _tmp6_;
#line 1526 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1526: Connecting to Persona: %s (is user: %" \
"s, IID: %s)", _tmp5_, _tmp1_, _tmp7_);
#line 1528 "../folks/individual-aggregator.vala"
	_tmp8_ = folks_individual_get_id (_data5_->individual);
#line 1528 "../folks/individual-aggregator.vala"
	_tmp9_ = _tmp8_;
#line 1528 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1528:     Mapping to Individual: %s", _tmp9_);
#line 1533 "../folks/individual-aggregator.vala"
	_tmp10_ = folks_persona_get_iid (persona);
#line 1533 "../folks/individual-aggregator.vala"
	_tmp11_ = _tmp10_;
#line 1533 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_link_map_set (self, _tmp11_, _data5_->individual);
#line 1537 "../folks/individual-aggregator.vala"
	_tmp12_ = folks_persona_get_store (persona);
#line 1537 "../folks/individual-aggregator.vala"
	_tmp13_ = _tmp12_;
#line 1537 "../folks/individual-aggregator.vala"
	_tmp14_ = folks_persona_store_get_trust_level (_tmp13_);
#line 1537 "../folks/individual-aggregator.vala"
	_tmp15_ = _tmp14_;
#line 1537 "../folks/individual-aggregator.vala"
	if (_tmp15_ == FOLKS_PERSONA_STORE_TRUST_FULL) {
#line 6130 "individual-aggregator.c"
		gchar** _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_ = 0;
		gchar** _tmp18_;
		gint _tmp18__length1;
#line 1539 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1539:     Inserting links:");
#line 1543 "../folks/individual-aggregator.vala"
		_tmp16_ = folks_persona_get_linkable_properties (persona, &_tmp17_);
#line 1543 "../folks/individual-aggregator.vala"
		_tmp16__length1 = _tmp17_;
#line 1543 "../folks/individual-aggregator.vala"
		_tmp18_ = _tmp16_;
#line 1543 "../folks/individual-aggregator.vala"
		_tmp18__length1 = _tmp16__length1;
#line 6146 "individual-aggregator.c"
		{
			gchar** prop_name_collection = NULL;
			gint prop_name_collection_length1 = 0;
			gint _prop_name_collection_size_ = 0;
			gint prop_name_it = 0;
#line 1543 "../folks/individual-aggregator.vala"
			prop_name_collection = _tmp18_;
#line 1543 "../folks/individual-aggregator.vala"
			prop_name_collection_length1 = _tmp18__length1;
#line 1543 "../folks/individual-aggregator.vala"
			for (prop_name_it = 0; prop_name_it < prop_name_collection_length1; prop_name_it = prop_name_it + 1) {
#line 6158 "individual-aggregator.c"
				const gchar* prop_name = NULL;
#line 1543 "../folks/individual-aggregator.vala"
				prop_name = prop_name_collection[prop_name_it];
#line 6162 "individual-aggregator.c"
				{
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					GObjectClass* pclass = NULL;
					GObjectClass* _tmp21_;
					GObjectClass* _tmp22_;
					const gchar* _tmp23_;
					GParamSpec* _tmp24_;
					const gchar* _tmp26_;
#line 1546 "../folks/individual-aggregator.vala"
					_tmp19_ = prop_name;
#line 1546 "../folks/individual-aggregator.vala"
					if (_tmp19_ == NULL) {
#line 1547 "../folks/individual-aggregator.vala"
						continue;
#line 6178 "individual-aggregator.c"
					}
#line 1549 "../folks/individual-aggregator.vala"
					_tmp20_ = prop_name;
#line 1549 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:1549:         %s", _tmp20_);
#line 1551 "../folks/individual-aggregator.vala"
					_tmp21_ = G_OBJECT_GET_CLASS ((GObject*) persona);
#line 1551 "../folks/individual-aggregator.vala"
					pclass = _tmp21_;
#line 1552 "../folks/individual-aggregator.vala"
					_tmp22_ = pclass;
#line 1552 "../folks/individual-aggregator.vala"
					_tmp23_ = prop_name;
#line 1552 "../folks/individual-aggregator.vala"
					_tmp24_ = g_object_class_find_property (_tmp22_, _tmp23_);
#line 1552 "../folks/individual-aggregator.vala"
					if (_tmp24_ == NULL) {
#line 6196 "individual-aggregator.c"
						const gchar* _tmp25_;
#line 1554 "../folks/individual-aggregator.vala"
						_tmp25_ = prop_name;
#line 1554 "../folks/individual-aggregator.vala"
						g_warning (_ ("Unknown property ‘%s’ in linkable property list."), _tmp25_);
#line 1558 "../folks/individual-aggregator.vala"
						continue;
#line 6204 "individual-aggregator.c"
					}
#line 1561 "../folks/individual-aggregator.vala"
					_tmp26_ = prop_name;
#line 1561 "../folks/individual-aggregator.vala"
					folks_persona_linkable_property_to_links (persona, _tmp26_, ______lambda68__folks_persona_linkable_property_callback, _data5_);
#line 6210 "individual-aggregator.c"
				}
			}
		}
	}
#line 1524 "../folks/individual-aggregator.vala"
	block5_data_unref (_data5_);
#line 1524 "../folks/individual-aggregator.vala"
	_data5_ = NULL;
#line 6219 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_remove_individual_from_link_map (FolksIndividualAggregator* self,
                                                              FolksIndividual* individual)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_;
	const gchar* link_key = NULL;
	GPtrArray* inds = NULL;
#line 1578 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1578 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 1580 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_individual_get_id (individual);
#line 1580 "../folks/individual-aggregator.vala"
	_tmp1_ = _tmp0_;
#line 1580 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1580: Removing Individual '%s' from the lin" \
"k map.", _tmp1_);
#line 1582 "../folks/individual-aggregator.vala"
	_tmp2_ = self->priv->_link_map;
#line 1582 "../folks/individual-aggregator.vala"
	g_hash_table_iter_init (&iter, _tmp2_);
#line 1587 "../folks/individual-aggregator.vala"
	while (TRUE) {
#line 6248 "individual-aggregator.c"
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_;
#line 1587 "../folks/individual-aggregator.vala"
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
#line 1587 "../folks/individual-aggregator.vala"
		link_key = (const gchar*) _tmp3_;
#line 1587 "../folks/individual-aggregator.vala"
		inds = (GPtrArray*) _tmp4_;
#line 1587 "../folks/individual-aggregator.vala"
		if (!_tmp5_) {
#line 1587 "../folks/individual-aggregator.vala"
			break;
#line 6262 "individual-aggregator.c"
		}
		{
			guint i = 0U;
#line 1589 "../folks/individual-aggregator.vala"
			i = (guint) 0;
#line 6268 "individual-aggregator.c"
			{
				gboolean _tmp6_ = FALSE;
#line 1589 "../folks/individual-aggregator.vala"
				_tmp6_ = TRUE;
#line 1589 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 6275 "individual-aggregator.c"
					GPtrArray* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					GPtrArray* _tmp11_;
					gconstpointer _tmp12_;
#line 1589 "../folks/individual-aggregator.vala"
					if (!_tmp6_) {
#line 6283 "individual-aggregator.c"
						guint _tmp7_;
#line 1589 "../folks/individual-aggregator.vala"
						_tmp7_ = i;
#line 1589 "../folks/individual-aggregator.vala"
						i = _tmp7_ + 1;
#line 6289 "individual-aggregator.c"
					}
#line 1589 "../folks/individual-aggregator.vala"
					_tmp6_ = FALSE;
#line 1589 "../folks/individual-aggregator.vala"
					_tmp8_ = inds;
#line 1589 "../folks/individual-aggregator.vala"
					_tmp9_ = vala_g_ptr_array_get_length (_tmp8_);
#line 1589 "../folks/individual-aggregator.vala"
					_tmp10_ = _tmp9_;
#line 1589 "../folks/individual-aggregator.vala"
					if (!(i < ((guint) _tmp10_))) {
#line 1589 "../folks/individual-aggregator.vala"
						break;
#line 6303 "individual-aggregator.c"
					}
#line 1591 "../folks/individual-aggregator.vala"
					_tmp11_ = inds;
#line 1591 "../folks/individual-aggregator.vala"
					_tmp12_ = g_ptr_array_index (_tmp11_, i);
#line 1591 "../folks/individual-aggregator.vala"
					if (((FolksIndividual*) _tmp12_) == individual) {
#line 6311 "individual-aggregator.c"
						const gchar* _tmp13_;
						const gchar* _tmp14_;
						const gchar* _tmp15_;
						GPtrArray* _tmp16_;
						GPtrArray* _tmp17_;
						gint _tmp18_;
						gint _tmp19_;
#line 1593 "../folks/individual-aggregator.vala"
						_tmp13_ = link_key;
#line 1593 "../folks/individual-aggregator.vala"
						_tmp14_ = folks_individual_get_id (individual);
#line 1593 "../folks/individual-aggregator.vala"
						_tmp15_ = _tmp14_;
#line 1593 "../folks/individual-aggregator.vala"
						g_debug ("individual-aggregator.vala:1593:     %s → %s (%p)", _tmp13_, _tmp15_, individual);
#line 1596 "../folks/individual-aggregator.vala"
						_tmp16_ = inds;
#line 1596 "../folks/individual-aggregator.vala"
						g_ptr_array_remove_index_fast (_tmp16_, i);
#line 1598 "../folks/individual-aggregator.vala"
						_tmp17_ = inds;
#line 1598 "../folks/individual-aggregator.vala"
						_tmp18_ = vala_g_ptr_array_get_length (_tmp17_);
#line 1598 "../folks/individual-aggregator.vala"
						_tmp19_ = _tmp18_;
#line 1598 "../folks/individual-aggregator.vala"
						if (_tmp19_ == 0) {
#line 1599 "../folks/individual-aggregator.vala"
							g_hash_table_iter_remove (&iter);
#line 6341 "individual-aggregator.c"
						}
#line 1603 "../folks/individual-aggregator.vala"
						break;
#line 6345 "individual-aggregator.c"
					}
				}
			}
		}
	}
}

static void
_folks_individual_aggregator_personas_changed_cb (FolksIndividualAggregator* self,
                                                  FolksPersonaStore* store,
                                                  GeeSet* added,
                                                  GeeSet* removed,
                                                  const gchar* message,
                                                  FolksPersona* actor,
                                                  FolksGroupDetailsChangeReason reason)
{
	GeeHashSet* removed_individuals = NULL;
	GeeHashSet* _tmp0_;
	GeeHashMultiMap* individuals_changes = NULL;
	GeeHashMultiMap* _tmp1_;
	GeeHashSet* relinked_personas = NULL;
	GeeHashSet* _tmp2_;
	GeeHashMap* replaced_individuals = NULL;
	GeeHashMap* _tmp3_;
	FolksIndividual* user = NULL;
	FolksIndividual* _tmp4_;
	FolksIndividual* _tmp5_;
	gint _tmp71_;
	gint _tmp72_;
	GeeHashSet* _tmp88_;
	FolksIndividual* _tmp116_;
	GeeHashMultiMap* _tmp117_;
	gint _tmp118_;
	gint _tmp119_;
	GeeMapIterator* iter2 = NULL;
	GeeHashMap* _tmp147_;
	GeeMapIterator* _tmp148_;
	FolksDebug* _tmp164_;
	gboolean _tmp165_;
	gboolean _tmp166_;
#line 1609 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1609 "../folks/individual-aggregator.vala"
	g_return_if_fail (store != NULL);
#line 1609 "../folks/individual-aggregator.vala"
	g_return_if_fail (added != NULL);
#line 1609 "../folks/individual-aggregator.vala"
	g_return_if_fail (removed != NULL);
#line 1616 "../folks/individual-aggregator.vala"
	_tmp0_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1616 "../folks/individual-aggregator.vala"
	removed_individuals = _tmp0_;
#line 1617 "../folks/individual-aggregator.vala"
	_tmp1_ = gee_hash_multi_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1617 "../folks/individual-aggregator.vala"
	individuals_changes = _tmp1_;
#line 1618 "../folks/individual-aggregator.vala"
	_tmp2_ = gee_hash_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1618 "../folks/individual-aggregator.vala"
	relinked_personas = _tmp2_;
#line 1619 "../folks/individual-aggregator.vala"
	_tmp3_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1619 "../folks/individual-aggregator.vala"
	replaced_individuals = _tmp3_;
#line 1624 "../folks/individual-aggregator.vala"
	_tmp4_ = self->priv->_user;
#line 1624 "../folks/individual-aggregator.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1624 "../folks/individual-aggregator.vala"
	user = _tmp5_;
#line 1626 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1626: Removing Personas:");
#line 6418 "individual-aggregator.c"
	{
		GeeIterator* _persona_it = NULL;
		GeeIterator* _tmp6_;
#line 1628 "../folks/individual-aggregator.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) removed);
#line 1628 "../folks/individual-aggregator.vala"
		_persona_it = _tmp6_;
#line 1628 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 6428 "individual-aggregator.c"
			GeeIterator* _tmp7_;
			FolksPersona* persona = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			const gchar* _tmp10_ = NULL;
			FolksPersona* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			FolksPersona* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			FolksPersona* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			FolksIndividual* ind = NULL;
			FolksPersona* _tmp20_;
			FolksIndividual* _tmp21_;
			FolksIndividual* _tmp22_;
			FolksIndividual* _tmp23_;
			FolksPersona* _tmp26_;
#line 1628 "../folks/individual-aggregator.vala"
			_tmp7_ = _persona_it;
#line 1628 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 1628 "../folks/individual-aggregator.vala"
				break;
#line 6455 "individual-aggregator.c"
			}
#line 1628 "../folks/individual-aggregator.vala"
			_tmp8_ = _persona_it;
#line 1628 "../folks/individual-aggregator.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1628 "../folks/individual-aggregator.vala"
			persona = (FolksPersona*) _tmp9_;
#line 1631 "../folks/individual-aggregator.vala"
			_tmp11_ = persona;
#line 1631 "../folks/individual-aggregator.vala"
			_tmp12_ = folks_persona_get_is_user (_tmp11_);
#line 1631 "../folks/individual-aggregator.vala"
			_tmp13_ = _tmp12_;
#line 1631 "../folks/individual-aggregator.vala"
			if (_tmp13_) {
#line 1631 "../folks/individual-aggregator.vala"
				_tmp10_ = "yes";
#line 6473 "individual-aggregator.c"
			} else {
#line 1631 "../folks/individual-aggregator.vala"
				_tmp10_ = "no";
#line 6477 "individual-aggregator.c"
			}
#line 1630 "../folks/individual-aggregator.vala"
			_tmp14_ = persona;
#line 1630 "../folks/individual-aggregator.vala"
			_tmp15_ = folks_persona_get_uid (_tmp14_);
#line 1630 "../folks/individual-aggregator.vala"
			_tmp16_ = _tmp15_;
#line 1630 "../folks/individual-aggregator.vala"
			_tmp17_ = persona;
#line 1630 "../folks/individual-aggregator.vala"
			_tmp18_ = folks_persona_get_iid (_tmp17_);
#line 1630 "../folks/individual-aggregator.vala"
			_tmp19_ = _tmp18_;
#line 1630 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1630:     %s (is user: %s, IID: %s)", _tmp16_, _tmp10_, _tmp19_);
#line 1636 "../folks/individual-aggregator.vala"
			_tmp20_ = persona;
#line 1636 "../folks/individual-aggregator.vala"
			_tmp21_ = folks_persona_get_individual (_tmp20_);
#line 1636 "../folks/individual-aggregator.vala"
			_tmp22_ = _tmp21_;
#line 1636 "../folks/individual-aggregator.vala"
			ind = _tmp22_;
#line 1637 "../folks/individual-aggregator.vala"
			_tmp23_ = ind;
#line 1637 "../folks/individual-aggregator.vala"
			if (_tmp23_ != NULL) {
#line 6505 "individual-aggregator.c"
				GeeHashSet* _tmp24_;
				FolksIndividual* _tmp25_;
#line 1639 "../folks/individual-aggregator.vala"
				_tmp24_ = removed_individuals;
#line 1639 "../folks/individual-aggregator.vala"
				_tmp25_ = ind;
#line 1639 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 6514 "individual-aggregator.c"
			}
#line 1644 "../folks/individual-aggregator.vala"
			_tmp26_ = persona;
#line 1644 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_disconnect_from_persona (self, _tmp26_);
#line 1628 "../folks/individual-aggregator.vala"
			_g_object_unref0 (persona);
#line 6522 "individual-aggregator.c"
		}
#line 1628 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_persona_it);
#line 6526 "individual-aggregator.c"
	}
#line 1654 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1654: Removing Individuals due to removed l" \
"inks:");
#line 6530 "individual-aggregator.c"
	{
		GeeIterator* _individual_it = NULL;
		GeeHashSet* _tmp27_;
		GeeIterator* _tmp28_;
#line 1655 "../folks/individual-aggregator.vala"
		_tmp27_ = removed_individuals;
#line 1655 "../folks/individual-aggregator.vala"
		_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
#line 1655 "../folks/individual-aggregator.vala"
		_individual_it = _tmp28_;
#line 1655 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 6543 "individual-aggregator.c"
			GeeIterator* _tmp29_;
			FolksIndividual* individual = NULL;
			GeeIterator* _tmp30_;
			gpointer _tmp31_;
			GeeMap* _tmp32_;
			FolksIndividual* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			FolksIndividual* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			FolksIndividual* _tmp52_;
			FolksIndividual* _tmp53_;
			FolksIndividual* _tmp54_;
			FolksIndividual* _tmp55_;
#line 1655 "../folks/individual-aggregator.vala"
			_tmp29_ = _individual_it;
#line 1655 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp29_)) {
#line 1655 "../folks/individual-aggregator.vala"
				break;
#line 6565 "individual-aggregator.c"
			}
#line 1655 "../folks/individual-aggregator.vala"
			_tmp30_ = _individual_it;
#line 1655 "../folks/individual-aggregator.vala"
			_tmp31_ = gee_iterator_get (_tmp30_);
#line 1655 "../folks/individual-aggregator.vala"
			individual = (FolksIndividual*) _tmp31_;
#line 1658 "../folks/individual-aggregator.vala"
			_tmp32_ = self->priv->_individuals;
#line 1658 "../folks/individual-aggregator.vala"
			_tmp33_ = individual;
#line 1658 "../folks/individual-aggregator.vala"
			_tmp34_ = folks_individual_get_id (_tmp33_);
#line 1658 "../folks/individual-aggregator.vala"
			_tmp35_ = _tmp34_;
#line 1658 "../folks/individual-aggregator.vala"
			if (gee_map_has_key (_tmp32_, _tmp35_) == FALSE) {
#line 1659 "../folks/individual-aggregator.vala"
				_g_object_unref0 (individual);
#line 1659 "../folks/individual-aggregator.vala"
				continue;
#line 6587 "individual-aggregator.c"
			}
#line 1661 "../folks/individual-aggregator.vala"
			_tmp36_ = individual;
#line 1661 "../folks/individual-aggregator.vala"
			_tmp37_ = folks_individual_get_id (_tmp36_);
#line 1661 "../folks/individual-aggregator.vala"
			_tmp38_ = _tmp37_;
#line 1661 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1661:     %s", _tmp38_);
#line 6597 "individual-aggregator.c"
			{
				GeeIterator* _persona_it = NULL;
				FolksIndividual* _tmp39_;
				GeeSet* _tmp40_;
				GeeSet* _tmp41_;
				GeeIterator* _tmp42_;
#line 1665 "../folks/individual-aggregator.vala"
				_tmp39_ = individual;
#line 1665 "../folks/individual-aggregator.vala"
				_tmp40_ = folks_individual_get_personas (_tmp39_);
#line 1665 "../folks/individual-aggregator.vala"
				_tmp41_ = _tmp40_;
#line 1665 "../folks/individual-aggregator.vala"
				_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
#line 1665 "../folks/individual-aggregator.vala"
				_persona_it = _tmp42_;
#line 1665 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 6616 "individual-aggregator.c"
					GeeIterator* _tmp43_;
					FolksPersona* persona = NULL;
					GeeIterator* _tmp44_;
					gpointer _tmp45_;
					gboolean _tmp46_ = FALSE;
					FolksPersona* _tmp47_;
					GeeHashSet* _tmp50_;
					FolksPersona* _tmp51_;
#line 1665 "../folks/individual-aggregator.vala"
					_tmp43_ = _persona_it;
#line 1665 "../folks/individual-aggregator.vala"
					if (!gee_iterator_next (_tmp43_)) {
#line 1665 "../folks/individual-aggregator.vala"
						break;
#line 6631 "individual-aggregator.c"
					}
#line 1665 "../folks/individual-aggregator.vala"
					_tmp44_ = _persona_it;
#line 1665 "../folks/individual-aggregator.vala"
					_tmp45_ = gee_iterator_get (_tmp44_);
#line 1665 "../folks/individual-aggregator.vala"
					persona = (FolksPersona*) _tmp45_;
#line 1667 "../folks/individual-aggregator.vala"
					_tmp47_ = persona;
#line 1667 "../folks/individual-aggregator.vala"
					if (gee_collection_contains ((GeeCollection*) removed, _tmp47_) == TRUE) {
#line 1667 "../folks/individual-aggregator.vala"
						_tmp46_ = TRUE;
#line 6645 "individual-aggregator.c"
					} else {
						GeeHashSet* _tmp48_;
						FolksPersona* _tmp49_;
#line 1668 "../folks/individual-aggregator.vala"
						_tmp48_ = relinked_personas;
#line 1668 "../folks/individual-aggregator.vala"
						_tmp49_ = persona;
#line 1668 "../folks/individual-aggregator.vala"
						_tmp46_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp48_, _tmp49_) == TRUE;
#line 6655 "individual-aggregator.c"
					}
#line 1667 "../folks/individual-aggregator.vala"
					if (_tmp46_) {
#line 1669 "../folks/individual-aggregator.vala"
						_g_object_unref0 (persona);
#line 1669 "../folks/individual-aggregator.vala"
						continue;
#line 6663 "individual-aggregator.c"
					}
#line 1671 "../folks/individual-aggregator.vala"
					_tmp50_ = relinked_personas;
#line 1671 "../folks/individual-aggregator.vala"
					_tmp51_ = persona;
#line 1671 "../folks/individual-aggregator.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, _tmp51_);
#line 1665 "../folks/individual-aggregator.vala"
					_g_object_unref0 (persona);
#line 6673 "individual-aggregator.c"
				}
#line 1665 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_persona_it);
#line 6677 "individual-aggregator.c"
			}
#line 1674 "../folks/individual-aggregator.vala"
			_tmp52_ = user;
#line 1674 "../folks/individual-aggregator.vala"
			_tmp53_ = individual;
#line 1674 "../folks/individual-aggregator.vala"
			if (_tmp52_ == _tmp53_) {
#line 1675 "../folks/individual-aggregator.vala"
				_g_object_unref0 (user);
#line 1675 "../folks/individual-aggregator.vala"
				user = NULL;
#line 6689 "individual-aggregator.c"
			}
#line 1677 "../folks/individual-aggregator.vala"
			_tmp54_ = individual;
#line 1677 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_disconnect_from_individual (self, _tmp54_);
#line 1680 "../folks/individual-aggregator.vala"
			_tmp55_ = individual;
#line 1680 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_remove_individual_from_link_map (self, _tmp55_);
#line 1655 "../folks/individual-aggregator.vala"
			_g_object_unref0 (individual);
#line 6701 "individual-aggregator.c"
		}
#line 1655 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_individual_it);
#line 6705 "individual-aggregator.c"
	}
#line 1683 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1683: Adding Personas:");
#line 6709 "individual-aggregator.c"
	{
		GeeIterator* _persona_it = NULL;
		GeeIterator* _tmp56_;
#line 1684 "../folks/individual-aggregator.vala"
		_tmp56_ = gee_iterable_iterator ((GeeIterable*) added);
#line 1684 "../folks/individual-aggregator.vala"
		_persona_it = _tmp56_;
#line 1684 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 6719 "individual-aggregator.c"
			GeeIterator* _tmp57_;
			FolksPersona* persona = NULL;
			GeeIterator* _tmp58_;
			gpointer _tmp59_;
			const gchar* _tmp60_ = NULL;
			FolksPersona* _tmp61_;
			gboolean _tmp62_;
			gboolean _tmp63_;
			FolksPersona* _tmp64_;
			const gchar* _tmp65_;
			const gchar* _tmp66_;
			FolksPersona* _tmp67_;
			const gchar* _tmp68_;
			const gchar* _tmp69_;
			FolksPersona* _tmp70_;
#line 1684 "../folks/individual-aggregator.vala"
			_tmp57_ = _persona_it;
#line 1684 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp57_)) {
#line 1684 "../folks/individual-aggregator.vala"
				break;
#line 6741 "individual-aggregator.c"
			}
#line 1684 "../folks/individual-aggregator.vala"
			_tmp58_ = _persona_it;
#line 1684 "../folks/individual-aggregator.vala"
			_tmp59_ = gee_iterator_get (_tmp58_);
#line 1684 "../folks/individual-aggregator.vala"
			persona = (FolksPersona*) _tmp59_;
#line 1687 "../folks/individual-aggregator.vala"
			_tmp61_ = persona;
#line 1687 "../folks/individual-aggregator.vala"
			_tmp62_ = folks_persona_get_is_user (_tmp61_);
#line 1687 "../folks/individual-aggregator.vala"
			_tmp63_ = _tmp62_;
#line 1687 "../folks/individual-aggregator.vala"
			if (_tmp63_) {
#line 1687 "../folks/individual-aggregator.vala"
				_tmp60_ = "yes";
#line 6759 "individual-aggregator.c"
			} else {
#line 1687 "../folks/individual-aggregator.vala"
				_tmp60_ = "no";
#line 6763 "individual-aggregator.c"
			}
#line 1686 "../folks/individual-aggregator.vala"
			_tmp64_ = persona;
#line 1686 "../folks/individual-aggregator.vala"
			_tmp65_ = folks_persona_get_uid (_tmp64_);
#line 1686 "../folks/individual-aggregator.vala"
			_tmp66_ = _tmp65_;
#line 1686 "../folks/individual-aggregator.vala"
			_tmp67_ = persona;
#line 1686 "../folks/individual-aggregator.vala"
			_tmp68_ = folks_persona_get_iid (_tmp67_);
#line 1686 "../folks/individual-aggregator.vala"
			_tmp69_ = _tmp68_;
#line 1686 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1686:     %s (is user: %s, IID: %s)", _tmp66_, _tmp60_, _tmp69_);
#line 1691 "../folks/individual-aggregator.vala"
			_tmp70_ = persona;
#line 1691 "../folks/individual-aggregator.vala"
			_folks_individual_aggregator_connect_to_persona (self, _tmp70_);
#line 1684 "../folks/individual-aggregator.vala"
			_g_object_unref0 (persona);
#line 6785 "individual-aggregator.c"
		}
#line 1684 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_persona_it);
#line 6789 "individual-aggregator.c"
	}
#line 1694 "../folks/individual-aggregator.vala"
	_tmp71_ = gee_collection_get_size ((GeeCollection*) added);
#line 1694 "../folks/individual-aggregator.vala"
	_tmp72_ = _tmp71_;
#line 1694 "../folks/individual-aggregator.vala"
	if (_tmp72_ > 0) {
#line 1696 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_add_personas (self, added, &user, &individuals_changes);
#line 6799 "individual-aggregator.c"
	}
#line 1699 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1699: Relinking Personas:");
#line 6803 "individual-aggregator.c"
	{
		GeeIterator* _persona_it = NULL;
		GeeHashSet* _tmp73_;
		GeeIterator* _tmp74_;
#line 1700 "../folks/individual-aggregator.vala"
		_tmp73_ = relinked_personas;
#line 1700 "../folks/individual-aggregator.vala"
		_tmp74_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp73_);
#line 1700 "../folks/individual-aggregator.vala"
		_persona_it = _tmp74_;
#line 1700 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 6816 "individual-aggregator.c"
			GeeIterator* _tmp75_;
			FolksPersona* persona = NULL;
			GeeIterator* _tmp76_;
			gpointer _tmp77_;
			const gchar* _tmp78_ = NULL;
			FolksPersona* _tmp79_;
			gboolean _tmp80_;
			gboolean _tmp81_;
			FolksPersona* _tmp82_;
			const gchar* _tmp83_;
			const gchar* _tmp84_;
			FolksPersona* _tmp85_;
			const gchar* _tmp86_;
			const gchar* _tmp87_;
#line 1700 "../folks/individual-aggregator.vala"
			_tmp75_ = _persona_it;
#line 1700 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp75_)) {
#line 1700 "../folks/individual-aggregator.vala"
				break;
#line 6837 "individual-aggregator.c"
			}
#line 1700 "../folks/individual-aggregator.vala"
			_tmp76_ = _persona_it;
#line 1700 "../folks/individual-aggregator.vala"
			_tmp77_ = gee_iterator_get (_tmp76_);
#line 1700 "../folks/individual-aggregator.vala"
			persona = (FolksPersona*) _tmp77_;
#line 1703 "../folks/individual-aggregator.vala"
			_tmp79_ = persona;
#line 1703 "../folks/individual-aggregator.vala"
			_tmp80_ = folks_persona_get_is_user (_tmp79_);
#line 1703 "../folks/individual-aggregator.vala"
			_tmp81_ = _tmp80_;
#line 1703 "../folks/individual-aggregator.vala"
			if (_tmp81_) {
#line 1703 "../folks/individual-aggregator.vala"
				_tmp78_ = "yes";
#line 6855 "individual-aggregator.c"
			} else {
#line 1703 "../folks/individual-aggregator.vala"
				_tmp78_ = "no";
#line 6859 "individual-aggregator.c"
			}
#line 1702 "../folks/individual-aggregator.vala"
			_tmp82_ = persona;
#line 1702 "../folks/individual-aggregator.vala"
			_tmp83_ = folks_persona_get_uid (_tmp82_);
#line 1702 "../folks/individual-aggregator.vala"
			_tmp84_ = _tmp83_;
#line 1702 "../folks/individual-aggregator.vala"
			_tmp85_ = persona;
#line 1702 "../folks/individual-aggregator.vala"
			_tmp86_ = folks_persona_get_iid (_tmp85_);
#line 1702 "../folks/individual-aggregator.vala"
			_tmp87_ = _tmp86_;
#line 1702 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:1702:     %s (is user: %s, IID: %s)", _tmp84_, _tmp78_, _tmp87_);
#line 1700 "../folks/individual-aggregator.vala"
			_g_object_unref0 (persona);
#line 6877 "individual-aggregator.c"
		}
#line 1700 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_persona_it);
#line 6881 "individual-aggregator.c"
	}
#line 1706 "../folks/individual-aggregator.vala"
	_tmp88_ = relinked_personas;
#line 1706 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_add_personas (self, (GeeSet*) _tmp88_, &user, &individuals_changes);
#line 6887 "individual-aggregator.c"
	{
		GeeIterator* _individual_it = NULL;
		GeeHashSet* _tmp89_;
		GeeIterator* _tmp90_;
#line 1710 "../folks/individual-aggregator.vala"
		_tmp89_ = removed_individuals;
#line 1710 "../folks/individual-aggregator.vala"
		_tmp90_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp89_);
#line 1710 "../folks/individual-aggregator.vala"
		_individual_it = _tmp90_;
#line 1710 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 6900 "individual-aggregator.c"
			GeeIterator* _tmp91_;
			FolksIndividual* individual = NULL;
			GeeIterator* _tmp92_;
			gpointer _tmp93_;
			gboolean added_mapping = FALSE;
			FolksIndividual* _tmp115_;
#line 1710 "../folks/individual-aggregator.vala"
			_tmp91_ = _individual_it;
#line 1710 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp91_)) {
#line 1710 "../folks/individual-aggregator.vala"
				break;
#line 6913 "individual-aggregator.c"
			}
#line 1710 "../folks/individual-aggregator.vala"
			_tmp92_ = _individual_it;
#line 1710 "../folks/individual-aggregator.vala"
			_tmp93_ = gee_iterator_get (_tmp92_);
#line 1710 "../folks/individual-aggregator.vala"
			individual = (FolksIndividual*) _tmp93_;
#line 1712 "../folks/individual-aggregator.vala"
			added_mapping = FALSE;
#line 6923 "individual-aggregator.c"
			{
				GeeIterator* _persona_it = NULL;
				FolksIndividual* _tmp94_;
				GeeSet* _tmp95_;
				GeeSet* _tmp96_;
				GeeIterator* _tmp97_;
#line 1714 "../folks/individual-aggregator.vala"
				_tmp94_ = individual;
#line 1714 "../folks/individual-aggregator.vala"
				_tmp95_ = folks_individual_get_personas (_tmp94_);
#line 1714 "../folks/individual-aggregator.vala"
				_tmp96_ = _tmp95_;
#line 1714 "../folks/individual-aggregator.vala"
				_tmp97_ = gee_iterable_iterator ((GeeIterable*) _tmp96_);
#line 1714 "../folks/individual-aggregator.vala"
				_persona_it = _tmp97_;
#line 1714 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 6942 "individual-aggregator.c"
					GeeIterator* _tmp98_;
					FolksPersona* persona = NULL;
					GeeIterator* _tmp99_;
					gpointer _tmp100_;
					gboolean _tmp101_ = FALSE;
					FolksPersona* _tmp102_;
#line 1714 "../folks/individual-aggregator.vala"
					_tmp98_ = _persona_it;
#line 1714 "../folks/individual-aggregator.vala"
					if (!gee_iterator_next (_tmp98_)) {
#line 1714 "../folks/individual-aggregator.vala"
						break;
#line 6955 "individual-aggregator.c"
					}
#line 1714 "../folks/individual-aggregator.vala"
					_tmp99_ = _persona_it;
#line 1714 "../folks/individual-aggregator.vala"
					_tmp100_ = gee_iterator_get (_tmp99_);
#line 1714 "../folks/individual-aggregator.vala"
					persona = (FolksPersona*) _tmp100_;
#line 1716 "../folks/individual-aggregator.vala"
					_tmp102_ = persona;
#line 1716 "../folks/individual-aggregator.vala"
					if (!gee_collection_contains ((GeeCollection*) removed, _tmp102_)) {
#line 1716 "../folks/individual-aggregator.vala"
						_tmp101_ = TRUE;
#line 6969 "individual-aggregator.c"
					} else {
						FolksPersona* _tmp103_;
#line 1716 "../folks/individual-aggregator.vala"
						_tmp103_ = persona;
#line 1716 "../folks/individual-aggregator.vala"
						_tmp101_ = gee_collection_contains ((GeeCollection*) added, _tmp103_);
#line 6976 "individual-aggregator.c"
					}
#line 1716 "../folks/individual-aggregator.vala"
					if (_tmp101_) {
#line 6980 "individual-aggregator.c"
						GeeHashMultiMap* _tmp104_;
						FolksPersona* _tmp105_;
						FolksIndividual* _tmp106_;
						FolksIndividual* _tmp107_;
						GeeHashMultiMap* _tmp108_;
						FolksIndividual* _tmp109_;
						FolksPersona* _tmp110_;
						FolksIndividual* _tmp111_;
						FolksIndividual* _tmp112_;
#line 1718 "../folks/individual-aggregator.vala"
						_tmp104_ = individuals_changes;
#line 1718 "../folks/individual-aggregator.vala"
						_tmp105_ = persona;
#line 1718 "../folks/individual-aggregator.vala"
						_tmp106_ = folks_persona_get_individual (_tmp105_);
#line 1718 "../folks/individual-aggregator.vala"
						_tmp107_ = _tmp106_;
#line 1718 "../folks/individual-aggregator.vala"
						gee_multi_map_remove ((GeeMultiMap*) _tmp104_, NULL, _tmp107_);
#line 1719 "../folks/individual-aggregator.vala"
						_tmp108_ = individuals_changes;
#line 1719 "../folks/individual-aggregator.vala"
						_tmp109_ = individual;
#line 1719 "../folks/individual-aggregator.vala"
						_tmp110_ = persona;
#line 1719 "../folks/individual-aggregator.vala"
						_tmp111_ = folks_persona_get_individual (_tmp110_);
#line 1719 "../folks/individual-aggregator.vala"
						_tmp112_ = _tmp111_;
#line 1719 "../folks/individual-aggregator.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp108_, _tmp109_, _tmp112_);
#line 1720 "../folks/individual-aggregator.vala"
						added_mapping = TRUE;
#line 7014 "individual-aggregator.c"
					}
#line 1714 "../folks/individual-aggregator.vala"
					_g_object_unref0 (persona);
#line 7018 "individual-aggregator.c"
				}
#line 1714 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_persona_it);
#line 7022 "individual-aggregator.c"
			}
#line 1725 "../folks/individual-aggregator.vala"
			if (added_mapping == FALSE) {
#line 7026 "individual-aggregator.c"
				GeeHashMultiMap* _tmp113_;
				FolksIndividual* _tmp114_;
#line 1727 "../folks/individual-aggregator.vala"
				_tmp113_ = individuals_changes;
#line 1727 "../folks/individual-aggregator.vala"
				_tmp114_ = individual;
#line 1727 "../folks/individual-aggregator.vala"
				gee_multi_map_set ((GeeMultiMap*) _tmp113_, _tmp114_, NULL);
#line 7035 "individual-aggregator.c"
			}
#line 1730 "../folks/individual-aggregator.vala"
			_tmp115_ = individual;
#line 1730 "../folks/individual-aggregator.vala"
			folks_individual_set_personas (_tmp115_, NULL);
#line 1710 "../folks/individual-aggregator.vala"
			_g_object_unref0 (individual);
#line 7043 "individual-aggregator.c"
		}
#line 1710 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_individual_it);
#line 7047 "individual-aggregator.c"
	}
#line 1734 "../folks/individual-aggregator.vala"
	_tmp116_ = user;
#line 1734 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_set_user (self, _tmp116_);
#line 1738 "../folks/individual-aggregator.vala"
	_tmp117_ = individuals_changes;
#line 1738 "../folks/individual-aggregator.vala"
	_tmp118_ = gee_multi_map_get_size ((GeeMultiMap*) _tmp117_);
#line 1738 "../folks/individual-aggregator.vala"
	_tmp119_ = _tmp118_;
#line 1738 "../folks/individual-aggregator.vala"
	if (_tmp119_ > 0) {
#line 7061 "individual-aggregator.c"
		GeeHashSet* added_individuals = NULL;
		GeeHashSet* _tmp120_;
		GeeMapIterator* iter1 = NULL;
		GeeHashMultiMap* _tmp121_;
		GeeMapIterator* _tmp122_;
		GeeHashSet* _tmp144_;
		GeeHashSet* _tmp145_;
		GeeHashMultiMap* _tmp146_;
#line 1740 "../folks/individual-aggregator.vala"
		_tmp120_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1740 "../folks/individual-aggregator.vala"
		added_individuals = _tmp120_;
#line 1745 "../folks/individual-aggregator.vala"
		_tmp121_ = individuals_changes;
#line 1745 "../folks/individual-aggregator.vala"
		_tmp122_ = gee_multi_map_map_iterator ((GeeMultiMap*) _tmp121_);
#line 1745 "../folks/individual-aggregator.vala"
		iter1 = _tmp122_;
#line 1747 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 7082 "individual-aggregator.c"
			GeeMapIterator* _tmp123_;
			FolksIndividual* old_ind = NULL;
			GeeMapIterator* _tmp124_;
			gpointer _tmp125_;
			FolksIndividual* new_ind = NULL;
			GeeMapIterator* _tmp126_;
			gpointer _tmp127_;
			gboolean _tmp128_ = FALSE;
			FolksIndividual* _tmp129_;
			FolksIndividual* _tmp131_;
			FolksIndividual* _tmp134_;
			gboolean _tmp138_ = FALSE;
			FolksIndividual* _tmp139_;
#line 1747 "../folks/individual-aggregator.vala"
			_tmp123_ = iter1;
#line 1747 "../folks/individual-aggregator.vala"
			if (!gee_map_iterator_next (_tmp123_)) {
#line 1747 "../folks/individual-aggregator.vala"
				break;
#line 7102 "individual-aggregator.c"
			}
#line 1749 "../folks/individual-aggregator.vala"
			_tmp124_ = iter1;
#line 1749 "../folks/individual-aggregator.vala"
			_tmp125_ = gee_map_iterator_get_key (_tmp124_);
#line 1749 "../folks/individual-aggregator.vala"
			old_ind = (FolksIndividual*) _tmp125_;
#line 1750 "../folks/individual-aggregator.vala"
			_tmp126_ = iter1;
#line 1750 "../folks/individual-aggregator.vala"
			_tmp127_ = gee_map_iterator_get_value (_tmp126_);
#line 1750 "../folks/individual-aggregator.vala"
			new_ind = (FolksIndividual*) _tmp127_;
#line 1752 "../folks/individual-aggregator.vala"
			_tmp129_ = old_ind;
#line 1752 "../folks/individual-aggregator.vala"
			if (_tmp129_ != NULL) {
#line 1752 "../folks/individual-aggregator.vala"
				_tmp128_ = TRUE;
#line 7122 "individual-aggregator.c"
			} else {
				FolksIndividual* _tmp130_;
#line 1752 "../folks/individual-aggregator.vala"
				_tmp130_ = new_ind;
#line 1752 "../folks/individual-aggregator.vala"
				_tmp128_ = _tmp130_ != NULL;
#line 7129 "individual-aggregator.c"
			}
#line 1752 "../folks/individual-aggregator.vala"
			_vala_assert (_tmp128_, "old_ind != null || new_ind != null");
#line 1754 "../folks/individual-aggregator.vala"
			_tmp131_ = old_ind;
#line 1754 "../folks/individual-aggregator.vala"
			if (_tmp131_ != NULL) {
#line 7137 "individual-aggregator.c"
				GeeHashSet* _tmp132_;
				FolksIndividual* _tmp133_;
#line 1756 "../folks/individual-aggregator.vala"
				_tmp132_ = removed_individuals;
#line 1756 "../folks/individual-aggregator.vala"
				_tmp133_ = old_ind;
#line 1756 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp132_, G_TYPE_CHECK_INSTANCE_CAST (_tmp133_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 7146 "individual-aggregator.c"
			}
#line 1759 "../folks/individual-aggregator.vala"
			_tmp134_ = new_ind;
#line 1759 "../folks/individual-aggregator.vala"
			if (_tmp134_ != NULL) {
#line 7152 "individual-aggregator.c"
				GeeHashSet* _tmp135_;
				FolksIndividual* _tmp136_;
				FolksIndividual* _tmp137_;
#line 1761 "../folks/individual-aggregator.vala"
				_tmp135_ = added_individuals;
#line 1761 "../folks/individual-aggregator.vala"
				_tmp136_ = new_ind;
#line 1761 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp135_, G_TYPE_CHECK_INSTANCE_CAST (_tmp136_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1762 "../folks/individual-aggregator.vala"
				_tmp137_ = new_ind;
#line 1762 "../folks/individual-aggregator.vala"
				_folks_individual_aggregator_connect_to_individual (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp137_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 7166 "individual-aggregator.c"
			}
#line 1765 "../folks/individual-aggregator.vala"
			_tmp139_ = old_ind;
#line 1765 "../folks/individual-aggregator.vala"
			if (_tmp139_ != NULL) {
#line 7172 "individual-aggregator.c"
				FolksIndividual* _tmp140_;
#line 1765 "../folks/individual-aggregator.vala"
				_tmp140_ = new_ind;
#line 1765 "../folks/individual-aggregator.vala"
				_tmp138_ = _tmp140_ != NULL;
#line 7178 "individual-aggregator.c"
			} else {
#line 1765 "../folks/individual-aggregator.vala"
				_tmp138_ = FALSE;
#line 7182 "individual-aggregator.c"
			}
#line 1765 "../folks/individual-aggregator.vala"
			if (_tmp138_) {
#line 7186 "individual-aggregator.c"
				GeeHashMap* _tmp141_;
				FolksIndividual* _tmp142_;
				FolksIndividual* _tmp143_;
#line 1767 "../folks/individual-aggregator.vala"
				_tmp141_ = replaced_individuals;
#line 1767 "../folks/individual-aggregator.vala"
				_tmp142_ = old_ind;
#line 1767 "../folks/individual-aggregator.vala"
				_tmp143_ = new_ind;
#line 1767 "../folks/individual-aggregator.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp141_, G_TYPE_CHECK_INSTANCE_CAST (_tmp142_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual), G_TYPE_CHECK_INSTANCE_CAST (_tmp143_, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 7198 "individual-aggregator.c"
			}
#line 1747 "../folks/individual-aggregator.vala"
			_g_object_unref0 (new_ind);
#line 1747 "../folks/individual-aggregator.vala"
			_g_object_unref0 (old_ind);
#line 7204 "individual-aggregator.c"
		}
#line 1771 "../folks/individual-aggregator.vala"
		_tmp144_ = added_individuals;
#line 1771 "../folks/individual-aggregator.vala"
		_tmp145_ = removed_individuals;
#line 1771 "../folks/individual-aggregator.vala"
		_tmp146_ = individuals_changes;
#line 1771 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_emit_individuals_changed (self, (GeeSet*) _tmp144_, (GeeSet*) _tmp145_, (GeeMultiMap*) _tmp146_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1738 "../folks/individual-aggregator.vala"
		_g_object_unref0 (iter1);
#line 1738 "../folks/individual-aggregator.vala"
		_g_object_unref0 (added_individuals);
#line 7218 "individual-aggregator.c"
	}
#line 1777 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1777: Replacing Individuals due to linking:");
#line 1778 "../folks/individual-aggregator.vala"
	_tmp147_ = replaced_individuals;
#line 1778 "../folks/individual-aggregator.vala"
	_tmp148_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp147_);
#line 1778 "../folks/individual-aggregator.vala"
	iter2 = _tmp148_;
#line 1779 "../folks/individual-aggregator.vala"
	while (TRUE) {
#line 7230 "individual-aggregator.c"
		GeeMapIterator* _tmp149_;
		FolksIndividual* old_ind = NULL;
		GeeMapIterator* _tmp150_;
		gpointer _tmp151_;
		FolksIndividual* new_ind = NULL;
		GeeMapIterator* _tmp152_;
		gpointer _tmp153_;
		FolksIndividual* _tmp154_;
		const gchar* _tmp155_;
		const gchar* _tmp156_;
		FolksIndividual* _tmp157_;
		FolksIndividual* _tmp158_;
		const gchar* _tmp159_;
		const gchar* _tmp160_;
		FolksIndividual* _tmp161_;
		FolksIndividual* _tmp162_;
		FolksIndividual* _tmp163_;
#line 1779 "../folks/individual-aggregator.vala"
		_tmp149_ = iter2;
#line 1779 "../folks/individual-aggregator.vala"
		if (!(gee_map_iterator_next (_tmp149_) == TRUE)) {
#line 1779 "../folks/individual-aggregator.vala"
			break;
#line 7254 "individual-aggregator.c"
		}
#line 1781 "../folks/individual-aggregator.vala"
		_tmp150_ = iter2;
#line 1781 "../folks/individual-aggregator.vala"
		_tmp151_ = gee_map_iterator_get_key (_tmp150_);
#line 1781 "../folks/individual-aggregator.vala"
		old_ind = (FolksIndividual*) _tmp151_;
#line 1782 "../folks/individual-aggregator.vala"
		_tmp152_ = iter2;
#line 1782 "../folks/individual-aggregator.vala"
		_tmp153_ = gee_map_iterator_get_value (_tmp152_);
#line 1782 "../folks/individual-aggregator.vala"
		new_ind = (FolksIndividual*) _tmp153_;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp154_ = old_ind;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp155_ = folks_individual_get_id (_tmp154_);
#line 1784 "../folks/individual-aggregator.vala"
		_tmp156_ = _tmp155_;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp157_ = old_ind;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp158_ = new_ind;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp159_ = folks_individual_get_id (_tmp158_);
#line 1784 "../folks/individual-aggregator.vala"
		_tmp160_ = _tmp159_;
#line 1784 "../folks/individual-aggregator.vala"
		_tmp161_ = new_ind;
#line 1784 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1784:     %s (%p) → %s (%p)", _tmp156_, _tmp157_, _tmp160_, _tmp161_);
#line 1787 "../folks/individual-aggregator.vala"
		_tmp162_ = old_ind;
#line 1787 "../folks/individual-aggregator.vala"
		_tmp163_ = new_ind;
#line 1787 "../folks/individual-aggregator.vala"
		folks_individual_replace (_tmp162_, _tmp163_);
#line 1779 "../folks/individual-aggregator.vala"
		_g_object_unref0 (new_ind);
#line 1779 "../folks/individual-aggregator.vala"
		_g_object_unref0 (old_ind);
#line 7296 "individual-aggregator.c"
	}
#line 1791 "../folks/individual-aggregator.vala"
	_tmp164_ = self->priv->_debug;
#line 1791 "../folks/individual-aggregator.vala"
	_tmp165_ = folks_debug_get_debug_output_enabled (_tmp164_);
#line 1791 "../folks/individual-aggregator.vala"
	_tmp166_ = _tmp165_;
#line 1791 "../folks/individual-aggregator.vala"
	if (_tmp166_ == TRUE) {
#line 7306 "individual-aggregator.c"
		GHashTableIter link_map_iter = {0};
		GHashTable* _tmp167_;
		const gchar* link_key = NULL;
		GPtrArray* inds = NULL;
#line 1793 "../folks/individual-aggregator.vala"
		_tmp167_ = self->priv->_link_map;
#line 1793 "../folks/individual-aggregator.vala"
		g_hash_table_iter_init (&link_map_iter, _tmp167_);
#line 1798 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 7317 "individual-aggregator.c"
			gconstpointer _tmp168_ = NULL;
			gconstpointer _tmp169_ = NULL;
			gboolean _tmp170_;
#line 1798 "../folks/individual-aggregator.vala"
			_tmp170_ = g_hash_table_iter_next (&link_map_iter, (gpointer*) (&_tmp168_), (gpointer*) (&_tmp169_));
#line 1798 "../folks/individual-aggregator.vala"
			link_key = (const gchar*) _tmp168_;
#line 1798 "../folks/individual-aggregator.vala"
			inds = (GPtrArray*) _tmp169_;
#line 1798 "../folks/individual-aggregator.vala"
			if (!_tmp170_) {
#line 1798 "../folks/individual-aggregator.vala"
				break;
#line 7331 "individual-aggregator.c"
			}
			{
				guint i = 0U;
#line 1800 "../folks/individual-aggregator.vala"
				i = (guint) 0;
#line 7337 "individual-aggregator.c"
				{
					gboolean _tmp171_ = FALSE;
#line 1800 "../folks/individual-aggregator.vala"
					_tmp171_ = TRUE;
#line 1800 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 7344 "individual-aggregator.c"
						GPtrArray* _tmp173_;
						gint _tmp174_;
						gint _tmp175_;
						FolksIndividual* individual = NULL;
						GPtrArray* _tmp176_;
						gconstpointer _tmp177_;
						FolksIndividual* _tmp178_;
						FolksIndividual* _tmp179_;
						GeeMap* _tmp180_;
						FolksIndividual* _tmp181_;
						const gchar* _tmp182_;
						const gchar* _tmp183_;
						gpointer _tmp184_;
						FolksIndividual* _tmp185_;
						FolksIndividual* _tmp186_;
						gboolean _tmp187_;
#line 1800 "../folks/individual-aggregator.vala"
						if (!_tmp171_) {
#line 7363 "individual-aggregator.c"
							guint _tmp172_;
#line 1800 "../folks/individual-aggregator.vala"
							_tmp172_ = i;
#line 1800 "../folks/individual-aggregator.vala"
							i = _tmp172_ + 1;
#line 7369 "individual-aggregator.c"
						}
#line 1800 "../folks/individual-aggregator.vala"
						_tmp171_ = FALSE;
#line 1800 "../folks/individual-aggregator.vala"
						_tmp173_ = inds;
#line 1800 "../folks/individual-aggregator.vala"
						_tmp174_ = vala_g_ptr_array_get_length (_tmp173_);
#line 1800 "../folks/individual-aggregator.vala"
						_tmp175_ = _tmp174_;
#line 1800 "../folks/individual-aggregator.vala"
						if (!(i < ((guint) _tmp175_))) {
#line 1800 "../folks/individual-aggregator.vala"
							break;
#line 7383 "individual-aggregator.c"
						}
#line 1802 "../folks/individual-aggregator.vala"
						_tmp176_ = inds;
#line 1802 "../folks/individual-aggregator.vala"
						_tmp177_ = g_ptr_array_index (_tmp176_, i);
#line 1802 "../folks/individual-aggregator.vala"
						_tmp178_ = _g_object_ref0 ((FolksIndividual*) _tmp177_);
#line 1802 "../folks/individual-aggregator.vala"
						individual = _tmp178_;
#line 1803 "../folks/individual-aggregator.vala"
						_tmp179_ = individual;
#line 1803 "../folks/individual-aggregator.vala"
						_vala_assert (_tmp179_ != NULL, "individual != null");
#line 1805 "../folks/individual-aggregator.vala"
						_tmp180_ = self->priv->_individuals;
#line 1805 "../folks/individual-aggregator.vala"
						_tmp181_ = individual;
#line 1805 "../folks/individual-aggregator.vala"
						_tmp182_ = folks_individual_get_id (_tmp181_);
#line 1805 "../folks/individual-aggregator.vala"
						_tmp183_ = _tmp182_;
#line 1805 "../folks/individual-aggregator.vala"
						_tmp184_ = gee_map_get (_tmp180_, _tmp183_);
#line 1805 "../folks/individual-aggregator.vala"
						_tmp185_ = (FolksIndividual*) _tmp184_;
#line 1805 "../folks/individual-aggregator.vala"
						_tmp186_ = individual;
#line 1805 "../folks/individual-aggregator.vala"
						_tmp187_ = _tmp185_ != _tmp186_;
#line 1805 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_tmp185_);
#line 1805 "../folks/individual-aggregator.vala"
						if (_tmp187_) {
#line 7417 "individual-aggregator.c"
							const gchar* _tmp188_;
							FolksIndividual* _tmp189_;
							const gchar* _tmp190_;
							const gchar* _tmp191_;
							FolksIndividual* _tmp192_;
							FolksIndividual* _tmp193_;
							const gchar* _tmp194_;
							const gchar* _tmp195_;
							FolksIndividual* _tmp196_;
#line 1807 "../folks/individual-aggregator.vala"
							_tmp188_ = link_key;
#line 1807 "../folks/individual-aggregator.vala"
							_tmp189_ = individual;
#line 1807 "../folks/individual-aggregator.vala"
							_tmp190_ = folks_individual_get_id (_tmp189_);
#line 1807 "../folks/individual-aggregator.vala"
							_tmp191_ = _tmp190_;
#line 1807 "../folks/individual-aggregator.vala"
							_tmp192_ = individual;
#line 1807 "../folks/individual-aggregator.vala"
							g_warning ("Link map contains invalid mapping:\n" "    %s → %s (%p)", _tmp188_, _tmp191_, _tmp192_);
#line 1810 "../folks/individual-aggregator.vala"
							_tmp193_ = individual;
#line 1810 "../folks/individual-aggregator.vala"
							_tmp194_ = folks_individual_get_id (_tmp193_);
#line 1810 "../folks/individual-aggregator.vala"
							_tmp195_ = _tmp194_;
#line 1810 "../folks/individual-aggregator.vala"
							_tmp196_ = individual;
#line 1810 "../folks/individual-aggregator.vala"
							g_warning ("individual-aggregator.vala:1810: Individual %s (%p) personas:", _tmp195_, _tmp196_);
#line 7449 "individual-aggregator.c"
							{
								GeeIterator* _p_it = NULL;
								FolksIndividual* _tmp197_;
								GeeSet* _tmp198_;
								GeeSet* _tmp199_;
								GeeIterator* _tmp200_;
#line 1812 "../folks/individual-aggregator.vala"
								_tmp197_ = individual;
#line 1812 "../folks/individual-aggregator.vala"
								_tmp198_ = folks_individual_get_personas (_tmp197_);
#line 1812 "../folks/individual-aggregator.vala"
								_tmp199_ = _tmp198_;
#line 1812 "../folks/individual-aggregator.vala"
								_tmp200_ = gee_iterable_iterator ((GeeIterable*) _tmp199_);
#line 1812 "../folks/individual-aggregator.vala"
								_p_it = _tmp200_;
#line 1812 "../folks/individual-aggregator.vala"
								while (TRUE) {
#line 7468 "individual-aggregator.c"
									GeeIterator* _tmp201_;
									FolksPersona* p = NULL;
									GeeIterator* _tmp202_;
									gpointer _tmp203_;
									FolksPersona* _tmp204_;
									const gchar* _tmp205_;
									const gchar* _tmp206_;
									FolksPersona* _tmp207_;
#line 1812 "../folks/individual-aggregator.vala"
									_tmp201_ = _p_it;
#line 1812 "../folks/individual-aggregator.vala"
									if (!gee_iterator_next (_tmp201_)) {
#line 1812 "../folks/individual-aggregator.vala"
										break;
#line 7483 "individual-aggregator.c"
									}
#line 1812 "../folks/individual-aggregator.vala"
									_tmp202_ = _p_it;
#line 1812 "../folks/individual-aggregator.vala"
									_tmp203_ = gee_iterator_get (_tmp202_);
#line 1812 "../folks/individual-aggregator.vala"
									p = (FolksPersona*) _tmp203_;
#line 1814 "../folks/individual-aggregator.vala"
									_tmp204_ = p;
#line 1814 "../folks/individual-aggregator.vala"
									_tmp205_ = folks_persona_get_uid (_tmp204_);
#line 1814 "../folks/individual-aggregator.vala"
									_tmp206_ = _tmp205_;
#line 1814 "../folks/individual-aggregator.vala"
									_tmp207_ = p;
#line 1814 "../folks/individual-aggregator.vala"
									g_warning ("individual-aggregator.vala:1814:     %s (%p)", _tmp206_, _tmp207_);
#line 1812 "../folks/individual-aggregator.vala"
									_g_object_unref0 (p);
#line 7503 "individual-aggregator.c"
								}
#line 1812 "../folks/individual-aggregator.vala"
								_g_object_unref0 (_p_it);
#line 7507 "individual-aggregator.c"
							}
						}
						{
							guint j = 0U;
#line 1818 "../folks/individual-aggregator.vala"
							j = i + 1;
#line 7514 "individual-aggregator.c"
							{
								gboolean _tmp208_ = FALSE;
#line 1818 "../folks/individual-aggregator.vala"
								_tmp208_ = TRUE;
#line 1818 "../folks/individual-aggregator.vala"
								while (TRUE) {
#line 7521 "individual-aggregator.c"
									GPtrArray* _tmp210_;
									gint _tmp211_;
									gint _tmp212_;
									GPtrArray* _tmp213_;
									gconstpointer _tmp214_;
									GPtrArray* _tmp215_;
									gconstpointer _tmp216_;
#line 1818 "../folks/individual-aggregator.vala"
									if (!_tmp208_) {
#line 7531 "individual-aggregator.c"
										guint _tmp209_;
#line 1818 "../folks/individual-aggregator.vala"
										_tmp209_ = j;
#line 1818 "../folks/individual-aggregator.vala"
										j = _tmp209_ + 1;
#line 7537 "individual-aggregator.c"
									}
#line 1818 "../folks/individual-aggregator.vala"
									_tmp208_ = FALSE;
#line 1818 "../folks/individual-aggregator.vala"
									_tmp210_ = inds;
#line 1818 "../folks/individual-aggregator.vala"
									_tmp211_ = vala_g_ptr_array_get_length (_tmp210_);
#line 1818 "../folks/individual-aggregator.vala"
									_tmp212_ = _tmp211_;
#line 1818 "../folks/individual-aggregator.vala"
									if (!(j < ((guint) _tmp212_))) {
#line 1818 "../folks/individual-aggregator.vala"
										break;
#line 7551 "individual-aggregator.c"
									}
#line 1820 "../folks/individual-aggregator.vala"
									_tmp213_ = inds;
#line 1820 "../folks/individual-aggregator.vala"
									_tmp214_ = g_ptr_array_index (_tmp213_, i);
#line 1820 "../folks/individual-aggregator.vala"
									_tmp215_ = inds;
#line 1820 "../folks/individual-aggregator.vala"
									_tmp216_ = g_ptr_array_index (_tmp215_, j);
#line 1820 "../folks/individual-aggregator.vala"
									if (((FolksIndividual*) _tmp214_) == ((FolksIndividual*) _tmp216_)) {
#line 7563 "individual-aggregator.c"
										const gchar* _tmp217_;
										FolksIndividual* _tmp218_;
										const gchar* _tmp219_;
										const gchar* _tmp220_;
										FolksIndividual* _tmp221_;
#line 1822 "../folks/individual-aggregator.vala"
										_tmp217_ = link_key;
#line 1822 "../folks/individual-aggregator.vala"
										_tmp218_ = individual;
#line 1822 "../folks/individual-aggregator.vala"
										_tmp219_ = folks_individual_get_id (_tmp218_);
#line 1822 "../folks/individual-aggregator.vala"
										_tmp220_ = _tmp219_;
#line 1822 "../folks/individual-aggregator.vala"
										_tmp221_ = individual;
#line 1822 "../folks/individual-aggregator.vala"
										g_warning ("Link map contains non-unique " "Individual: %s → %s (%p) twice", _tmp217_, _tmp220_, _tmp221_);
#line 7581 "individual-aggregator.c"
									}
								}
							}
						}
#line 1800 "../folks/individual-aggregator.vala"
						_g_object_unref0 (individual);
#line 7588 "individual-aggregator.c"
					}
				}
			}
		}
	}
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (iter2);
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (user);
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (replaced_individuals);
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (relinked_personas);
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (individuals_changes);
#line 1609 "../folks/individual-aggregator.vala"
	_g_object_unref0 (removed_individuals);
#line 7606 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_is_primary_store_changed_cb (FolksIndividualAggregator* self,
                                                          GObject* object,
                                                          GParamSpec* pspec)
{
	FolksPersonaStore* store = NULL;
	FolksPersonaStore* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	FolksPersonaStore* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 1832 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1832 "../folks/individual-aggregator.vala"
	g_return_if_fail (object != NULL);
#line 1832 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1835 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore));
#line 1835 "../folks/individual-aggregator.vala"
	store = _tmp0_;
#line 1836 "../folks/individual-aggregator.vala"
	_tmp3_ = store;
#line 1836 "../folks/individual-aggregator.vala"
	_tmp4_ = folks_persona_store_get_is_primary_store (_tmp3_);
#line 1836 "../folks/individual-aggregator.vala"
	_tmp5_ = _tmp4_;
#line 1836 "../folks/individual-aggregator.vala"
	if (_tmp5_ == TRUE) {
#line 7639 "individual-aggregator.c"
		FolksPersonaStore* _tmp6_;
		FolksPersonaStore* _tmp7_;
#line 1837 "../folks/individual-aggregator.vala"
		_tmp6_ = store;
#line 1837 "../folks/individual-aggregator.vala"
		_tmp7_ = self->priv->_primary_store;
#line 1837 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp6_ == _tmp7_;
#line 7648 "individual-aggregator.c"
	} else {
#line 1836 "../folks/individual-aggregator.vala"
		_tmp2_ = FALSE;
#line 7652 "individual-aggregator.c"
	}
#line 1836 "../folks/individual-aggregator.vala"
	if (_tmp2_) {
#line 1836 "../folks/individual-aggregator.vala"
		_tmp1_ = TRUE;
#line 7658 "individual-aggregator.c"
	} else {
		gboolean _tmp8_ = FALSE;
		FolksPersonaStore* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 1838 "../folks/individual-aggregator.vala"
		_tmp9_ = store;
#line 1838 "../folks/individual-aggregator.vala"
		_tmp10_ = folks_persona_store_get_is_primary_store (_tmp9_);
#line 1838 "../folks/individual-aggregator.vala"
		_tmp11_ = _tmp10_;
#line 1838 "../folks/individual-aggregator.vala"
		if (_tmp11_ == FALSE) {
#line 7672 "individual-aggregator.c"
			FolksPersonaStore* _tmp12_;
			FolksPersonaStore* _tmp13_;
#line 1839 "../folks/individual-aggregator.vala"
			_tmp12_ = store;
#line 1839 "../folks/individual-aggregator.vala"
			_tmp13_ = self->priv->_primary_store;
#line 1839 "../folks/individual-aggregator.vala"
			_tmp8_ = _tmp12_ != _tmp13_;
#line 7681 "individual-aggregator.c"
		} else {
#line 1838 "../folks/individual-aggregator.vala"
			_tmp8_ = FALSE;
#line 7685 "individual-aggregator.c"
		}
#line 1838 "../folks/individual-aggregator.vala"
		_tmp1_ = _tmp8_;
#line 7689 "individual-aggregator.c"
	}
#line 1836 "../folks/individual-aggregator.vala"
	_vala_assert (_tmp1_, "(store.is_primary_store == true &&               store == this._primary_store) ||           (store.is_primary_store == false &&               store != this._primary_store)");
#line 1832 "../folks/individual-aggregator.vala"
	_g_object_unref0 (store);
#line 7695 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_persona_store_is_quiescent_changed_cb (FolksIndividualAggregator* self,
                                                                    GObject* obj,
                                                                    GParamSpec* pspec)
{
#line 1842 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1842 "../folks/individual-aggregator.vala"
	g_return_if_fail (obj != NULL);
#line 1842 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1846 "../folks/individual-aggregator.vala"
	if (self->priv->_non_quiescent_persona_store_count > ((guint) 0)) {
#line 7711 "individual-aggregator.c"
		guint _tmp0_;
#line 1848 "../folks/individual-aggregator.vala"
		_tmp0_ = self->priv->_non_quiescent_persona_store_count;
#line 1848 "../folks/individual-aggregator.vala"
		self->priv->_non_quiescent_persona_store_count = _tmp0_ - 1;
#line 1849 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_notify_if_is_quiescent (self);
#line 7719 "individual-aggregator.c"
	}
}

static void
_folks_individual_aggregator_backend_is_quiescent_changed_cb (FolksIndividualAggregator* self,
                                                              GObject* obj,
                                                              GParamSpec* pspec)
{
#line 1853 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1853 "../folks/individual-aggregator.vala"
	g_return_if_fail (obj != NULL);
#line 1853 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1855 "../folks/individual-aggregator.vala"
	if (self->priv->_non_quiescent_backend_count > ((guint) 0)) {
#line 7736 "individual-aggregator.c"
		guint _tmp0_;
#line 1857 "../folks/individual-aggregator.vala"
		_tmp0_ = self->priv->_non_quiescent_backend_count;
#line 1857 "../folks/individual-aggregator.vala"
		self->priv->_non_quiescent_backend_count = _tmp0_ - 1;
#line 1858 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_notify_if_is_quiescent (self);
#line 7744 "individual-aggregator.c"
	}
}

static void
_folks_individual_aggregator_notify_if_is_quiescent (FolksIndividualAggregator* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 1862 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1864 "../folks/individual-aggregator.vala"
	if (self->priv->_non_quiescent_backend_count == ((guint) 0)) {
#line 1865 "../folks/individual-aggregator.vala"
		_tmp1_ = self->priv->_non_quiescent_persona_store_count == ((guint) 0);
#line 7759 "individual-aggregator.c"
	} else {
#line 1864 "../folks/individual-aggregator.vala"
		_tmp1_ = FALSE;
#line 7763 "individual-aggregator.c"
	}
#line 1864 "../folks/individual-aggregator.vala"
	if (_tmp1_) {
#line 1866 "../folks/individual-aggregator.vala"
		_tmp0_ = self->priv->_is_quiescent == FALSE;
#line 7769 "individual-aggregator.c"
	} else {
#line 1864 "../folks/individual-aggregator.vala"
		_tmp0_ = FALSE;
#line 7773 "individual-aggregator.c"
	}
#line 1864 "../folks/individual-aggregator.vala"
	if (_tmp0_) {
#line 7777 "individual-aggregator.c"
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 1868 "../folks/individual-aggregator.vala"
		_tmp3_ = self->priv->_configured_primary_store_type_id;
#line 1868 "../folks/individual-aggregator.vala"
		_tmp4_ = strlen (_tmp3_);
#line 1868 "../folks/individual-aggregator.vala"
		_tmp5_ = _tmp4_;
#line 1868 "../folks/individual-aggregator.vala"
		if (_tmp5_ > 0) {
#line 7790 "individual-aggregator.c"
			FolksPersonaStore* _tmp6_;
#line 1869 "../folks/individual-aggregator.vala"
			_tmp6_ = self->priv->_primary_store;
#line 1869 "../folks/individual-aggregator.vala"
			_tmp2_ = _tmp6_ == NULL;
#line 7796 "individual-aggregator.c"
		} else {
#line 1868 "../folks/individual-aggregator.vala"
			_tmp2_ = FALSE;
#line 7800 "individual-aggregator.c"
		}
#line 1868 "../folks/individual-aggregator.vala"
		if (_tmp2_) {
#line 7804 "individual-aggregator.c"
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 1871 "../folks/individual-aggregator.vala"
			_tmp7_ = self->priv->_configured_primary_store_type_id;
#line 1871 "../folks/individual-aggregator.vala"
			_tmp8_ = self->priv->_configured_primary_store_id;
#line 1871 "../folks/individual-aggregator.vala"
			g_warning ("Failed to find primary PersonaStore with type ID " "'%s' and ID '%s'.\n" "Individuals will not be linked properly " "and creating new links between Personas will not work.\n" "The configured primary PersonaStore's backend may not be " "installed. If you are unsure, check with your " "distribution.", _tmp7_, _tmp8_);
#line 7813 "individual-aggregator.c"
		}
#line 1882 "../folks/individual-aggregator.vala"
		folks_internal_profiling_point ("%s", "reached quiescence in " "IndividualAggregator");
#line 1885 "../folks/individual-aggregator.vala"
		self->priv->_is_quiescent = TRUE;
#line 1886 "../folks/individual-aggregator.vala"
		g_object_notify ((GObject*) self, "is-quiescent");
#line 1889 "../folks/individual-aggregator.vala"
		if (self->priv->_quiescent_timeout_id != ((guint) 0)) {
#line 1891 "../folks/individual-aggregator.vala"
			g_source_remove (self->priv->_quiescent_timeout_id);
#line 1892 "../folks/individual-aggregator.vala"
			self->priv->_quiescent_timeout_id = (guint) 0;
#line 7827 "individual-aggregator.c"
		}
	}
}

static gboolean
_folks_individual_aggregator_quiescent_timeout_cb (FolksIndividualAggregator* self)
{
	gboolean result;
#line 1897 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1902 "../folks/individual-aggregator.vala"
	if (self->priv->_is_quiescent == FALSE) {
#line 1904 "../folks/individual-aggregator.vala"
		g_warning ("Failed to reach quiescence normally (%u backends and %u " "persona stores still haven't reached quiescence). Forcing " "IndividualAggregator quiescence due to reaching the timeout.", self->priv->_non_quiescent_backend_count, self->priv->_non_quiescent_persona_store_count);
#line 1910 "../folks/individual-aggregator.vala"
		self->priv->_is_quiescent = TRUE;
#line 1911 "../folks/individual-aggregator.vala"
		g_object_notify ((GObject*) self, "is-quiescent");
#line 7846 "individual-aggregator.c"
	}
#line 1915 "../folks/individual-aggregator.vala"
	self->priv->_quiescent_timeout_id = (guint) 0;
#line 1916 "../folks/individual-aggregator.vala"
	result = FALSE;
#line 1916 "../folks/individual-aggregator.vala"
	return result;
#line 7854 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_persona_store_is_user_set_default_changed_cb (FolksIndividualAggregator* self,
                                                                           GObject* obj,
                                                                           GParamSpec* pspec)
{
	FolksPersonaStore* store = NULL;
	FolksPersonaStore* _tmp0_;
	FolksPersonaStore* _tmp1_;
	FolksPersonaStore* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	FolksPersonaStore* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	FolksPersonaStore* _tmp8_;
#line 1919 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1919 "../folks/individual-aggregator.vala"
	g_return_if_fail (obj != NULL);
#line 1919 "../folks/individual-aggregator.vala"
	g_return_if_fail (pspec != NULL);
#line 1922 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore));
#line 1922 "../folks/individual-aggregator.vala"
	store = _tmp0_;
#line 1924 "../folks/individual-aggregator.vala"
	_tmp1_ = store;
#line 1924 "../folks/individual-aggregator.vala"
	_tmp2_ = store;
#line 1924 "../folks/individual-aggregator.vala"
	_tmp3_ = folks_persona_store_get_type_id (_tmp2_);
#line 1924 "../folks/individual-aggregator.vala"
	_tmp4_ = _tmp3_;
#line 1924 "../folks/individual-aggregator.vala"
	_tmp5_ = store;
#line 1924 "../folks/individual-aggregator.vala"
	_tmp6_ = folks_persona_store_get_id (_tmp5_);
#line 1924 "../folks/individual-aggregator.vala"
	_tmp7_ = _tmp6_;
#line 1924 "../folks/individual-aggregator.vala"
	g_debug ("PersonaStore.is-user-set-default changed for store %p " "(type ID: %s, ID: %s)", _tmp1_, _tmp4_, _tmp7_);
#line 1927 "../folks/individual-aggregator.vala"
	_tmp8_ = store;
#line 1927 "../folks/individual-aggregator.vala"
	if (_folks_individual_aggregator_maybe_configure_as_primary (self, _tmp8_)) {
#line 7902 "individual-aggregator.c"
		FolksPersonaStore* _tmp9_;
#line 1928 "../folks/individual-aggregator.vala"
		_tmp9_ = store;
#line 1928 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_set_primary_store (self, _tmp9_);
#line 7908 "individual-aggregator.c"
	}
#line 1919 "../folks/individual-aggregator.vala"
	_g_object_unref0 (store);
#line 7912 "individual-aggregator.c"
}

static gboolean
_folks_individual_aggregator_maybe_configure_as_primary (FolksIndividualAggregator* self,
                                                         FolksPersonaStore* store)
{
	gboolean configured = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1931 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1931 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (store != NULL, FALSE);
#line 1933 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:1933: _maybe_configure_as_primary()");
#line 1935 "../folks/individual-aggregator.vala"
	configured = FALSE;
#line 1937 "../folks/individual-aggregator.vala"
	if (!self->priv->_user_configured_primary_store) {
#line 7932 "individual-aggregator.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 1938 "../folks/individual-aggregator.vala"
		_tmp1_ = folks_persona_store_get_is_user_set_default (store);
#line 1938 "../folks/individual-aggregator.vala"
		_tmp2_ = _tmp1_;
#line 1938 "../folks/individual-aggregator.vala"
		_tmp0_ = _tmp2_;
#line 7941 "individual-aggregator.c"
	} else {
#line 1937 "../folks/individual-aggregator.vala"
		_tmp0_ = FALSE;
#line 7945 "individual-aggregator.c"
	}
#line 1937 "../folks/individual-aggregator.vala"
	if (_tmp0_) {
#line 7949 "individual-aggregator.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 1940 "../folks/individual-aggregator.vala"
		_tmp3_ = folks_persona_store_get_type_id (store);
#line 1940 "../folks/individual-aggregator.vala"
		_tmp4_ = _tmp3_;
#line 1940 "../folks/individual-aggregator.vala"
		_tmp5_ = folks_persona_store_get_id (store);
#line 1940 "../folks/individual-aggregator.vala"
		_tmp6_ = _tmp5_;
#line 1940 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1940: Setting primary store IDs to '%s' and" \
" '%s'.", _tmp4_, _tmp6_);
#line 1942 "../folks/individual-aggregator.vala"
		_tmp7_ = folks_persona_store_get_type_id (store);
#line 1942 "../folks/individual-aggregator.vala"
		_tmp8_ = _tmp7_;
#line 1942 "../folks/individual-aggregator.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 1942 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_type_id);
#line 1942 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_type_id = _tmp9_;
#line 1943 "../folks/individual-aggregator.vala"
		_tmp10_ = folks_persona_store_get_id (store);
#line 1943 "../folks/individual-aggregator.vala"
		_tmp11_ = _tmp10_;
#line 1943 "../folks/individual-aggregator.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 1943 "../folks/individual-aggregator.vala"
		_g_free0 (self->priv->_configured_primary_store_id);
#line 1943 "../folks/individual-aggregator.vala"
		self->priv->_configured_primary_store_id = _tmp12_;
#line 1944 "../folks/individual-aggregator.vala"
		configured = TRUE;
#line 7992 "individual-aggregator.c"
	}
#line 1947 "../folks/individual-aggregator.vala"
	result = configured;
#line 1947 "../folks/individual-aggregator.vala"
	return result;
#line 7998 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_individual_removed_cb (FolksIndividualAggregator* self,
                                                    FolksIndividual* i,
                                                    FolksIndividual* replacement)
{
	FolksIndividual* _tmp0_;
	GeeMap* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	FolksIndividual* _tmp5_;
	gboolean _tmp6_;
	GeeSet* _tmp13_;
	GeeSet* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 1950 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 1950 "../folks/individual-aggregator.vala"
	g_return_if_fail (i != NULL);
#line 1952 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_user;
#line 1952 "../folks/individual-aggregator.vala"
	if (_tmp0_ == i) {
#line 1953 "../folks/individual-aggregator.vala"
		folks_individual_aggregator_set_user (self, NULL);
#line 8027 "individual-aggregator.c"
	}
#line 1957 "../folks/individual-aggregator.vala"
	_tmp1_ = self->priv->_individuals;
#line 1957 "../folks/individual-aggregator.vala"
	_tmp2_ = folks_individual_get_id (i);
#line 1957 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 1957 "../folks/individual-aggregator.vala"
	_tmp4_ = gee_map_get (_tmp1_, _tmp3_);
#line 1957 "../folks/individual-aggregator.vala"
	_tmp5_ = (FolksIndividual*) _tmp4_;
#line 1957 "../folks/individual-aggregator.vala"
	_tmp6_ = _tmp5_ != i;
#line 1957 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_tmp5_);
#line 1957 "../folks/individual-aggregator.vala"
	if (_tmp6_) {
#line 1958 "../folks/individual-aggregator.vala"
		return;
#line 8047 "individual-aggregator.c"
	}
#line 1960 "../folks/individual-aggregator.vala"
	if (replacement != NULL) {
#line 8051 "individual-aggregator.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 1962 "../folks/individual-aggregator.vala"
		_tmp7_ = folks_individual_get_id (i);
#line 1962 "../folks/individual-aggregator.vala"
		_tmp8_ = _tmp7_;
#line 1962 "../folks/individual-aggregator.vala"
		_tmp9_ = folks_individual_get_id (G_TYPE_CHECK_INSTANCE_CAST (replacement, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 1962 "../folks/individual-aggregator.vala"
		_tmp10_ = _tmp9_;
#line 1962 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1962: Individual '%s' removed (replaced by " \
"'%s')", _tmp8_, _tmp10_);
#line 8066 "individual-aggregator.c"
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 1967 "../folks/individual-aggregator.vala"
		_tmp11_ = folks_individual_get_id (i);
#line 1967 "../folks/individual-aggregator.vala"
		_tmp12_ = _tmp11_;
#line 1967 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:1967: Individual '%s' removed (not replaced" \
")", _tmp12_);
#line 8076 "individual-aggregator.c"
	}
#line 1971 "../folks/individual-aggregator.vala"
	_tmp13_ = folks_individual_get_personas (i);
#line 1971 "../folks/individual-aggregator.vala"
	_tmp14_ = _tmp13_;
#line 1971 "../folks/individual-aggregator.vala"
	_tmp15_ = gee_collection_get_size ((GeeCollection*) _tmp14_);
#line 1971 "../folks/individual-aggregator.vala"
	_tmp16_ = _tmp15_;
#line 1971 "../folks/individual-aggregator.vala"
	if (_tmp16_ > 0) {
#line 8088 "individual-aggregator.c"
		GeeHashMultiMap* changes = NULL;
		GeeHashMultiMap* _tmp17_;
		FolksSmallSet* individuals = NULL;
		FolksSmallSet* _tmp18_;
		FolksSmallSet* _tmp19_;
		GeeHashMultiMap* _tmp20_;
		FolksSmallSet* _tmp21_;
		GeeHashMultiMap* _tmp22_;
#line 1973 "../folks/individual-aggregator.vala"
		_tmp17_ = gee_hash_multi_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1973 "../folks/individual-aggregator.vala"
		changes = _tmp17_;
#line 1974 "../folks/individual-aggregator.vala"
		_tmp18_ = folks_small_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1974 "../folks/individual-aggregator.vala"
		individuals = _tmp18_;
#line 1976 "../folks/individual-aggregator.vala"
		_tmp19_ = individuals;
#line 1976 "../folks/individual-aggregator.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, i);
#line 1977 "../folks/individual-aggregator.vala"
		_tmp20_ = changes;
#line 1977 "../folks/individual-aggregator.vala"
		gee_multi_map_set ((GeeMultiMap*) _tmp20_, i, replacement);
#line 1979 "../folks/individual-aggregator.vala"
		_tmp21_ = individuals;
#line 1979 "../folks/individual-aggregator.vala"
		_tmp22_ = changes;
#line 1979 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_emit_individuals_changed (self, NULL, (GeeSet*) _tmp21_, (GeeMultiMap*) _tmp22_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1971 "../folks/individual-aggregator.vala"
		_g_object_unref0 (individuals);
#line 1971 "../folks/individual-aggregator.vala"
		_g_object_unref0 (changes);
#line 8123 "individual-aggregator.c"
	}
#line 1982 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_disconnect_from_individual (self, i);
#line 8127 "individual-aggregator.c"
}

static void
folks_individual_aggregator_add_persona_from_details_data_free (gpointer _data)
{
	FolksIndividualAggregatorAddPersonaFromDetailsData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->parent);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->persona_store);
#line 125 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (_data_->details);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->result);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorAddPersonaFromDetailsData, _data_);
#line 8147 "individual-aggregator.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 125 "../folks/individual-aggregator.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 8155 "individual-aggregator.c"
}

void
folks_individual_aggregator_add_persona_from_details (FolksIndividualAggregator* self,
                                                      FolksIndividual* parent,
                                                      FolksPersonaStore* persona_store,
                                                      GHashTable* details,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	FolksIndividualAggregatorAddPersonaFromDetailsData* _data_;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividual* _tmp1_;
	FolksPersonaStore* _tmp2_;
	GHashTable* _tmp3_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (persona_store != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (details != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorAddPersonaFromDetailsData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_add_persona_from_details_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (parent);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->parent);
#line 125 "../folks/individual-aggregator.vala"
	_data_->parent = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp2_ = _g_object_ref0 (persona_store);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->persona_store);
#line 125 "../folks/individual-aggregator.vala"
	_data_->persona_store = _tmp2_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp3_ = _g_hash_table_ref0 (details);
#line 125 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (_data_->details);
#line 125 "../folks/individual-aggregator.vala"
	_data_->details = _tmp3_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_add_persona_from_details_co (_data_);
#line 8207 "individual-aggregator.c"
}

FolksPersona*
folks_individual_aggregator_add_persona_from_details_finish (FolksIndividualAggregator* self,
                                                             GAsyncResult* _res_,
                                                             GError** error)
{
	FolksPersona* result;
	FolksIndividualAggregatorAddPersonaFromDetailsData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return NULL;
#line 8223 "individual-aggregator.c"
	}
#line 125 "../folks/individual-aggregator.vala"
	result = _data_->result;
#line 125 "../folks/individual-aggregator.vala"
	_data_->result = NULL;
#line 125 "../folks/individual-aggregator.vala"
	return result;
#line 8231 "individual-aggregator.c"
}

/**
   * Add a new persona in the given {@link PersonaStore} based on the
   * ``details`` provided.
   *
   * If the target store is offline, this function will throw
   * {@link IndividualAggregatorError.STORE_OFFLINE}. It's the responsibility of
   * the caller to cache details and re-try this function if it wishes to make
   * offline adds work.
   *
   * The details hash is a backend-specific mapping of key, value strings.
   * Common keys include:
   *
   *  * contact - service-specific contact ID
   *  * message - a user-readable message to pass to the persona being added
   *
   * If a {@link Persona} with the given details already exists in the store, no
   * error will be thrown and this function will return ``null``.
   *
   * @param parent an optional {@link Individual} to add the new {@link Persona}
   * to. This persona will be appended to its ordered list of personas.
   * @param persona_store the {@link PersonaStore} to add the persona to
   * @param details a key-value map of details to use in creating the new
   * {@link Persona}
   * @return the new {@link Persona} or ``null`` if the corresponding
   * {@link Persona} already existed. If non-``null``, the new {@link Persona}
   * will also be added to a new or existing {@link Individual} as necessary.
   * @throws IndividualAggregatorError.STORE_OFFLINE if the persona store was
   * offline
   * @throws IndividualAggregatorError.ADD_FAILED if any other error occurred
   * while adding the persona
   *
   * @since 0.3.5
   */
static void
folks_individual_aggregator_add_persona_from_details_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	FolksIndividualAggregatorAddPersonaFromDetailsData* _data_;
#line 2026 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2026 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2026 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2026 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_add_persona_from_details_co (_data_);
#line 8281 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_add_persona_from_details_co (FolksIndividualAggregatorAddPersonaFromDetailsData* _data_)
{
#line 2018 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2018 "../folks/individual-aggregator.vala"
		case 0:
#line 8291 "individual-aggregator.c"
		goto _state_0;
#line 2018 "../folks/individual-aggregator.vala"
		case 1:
#line 8295 "individual-aggregator.c"
		goto _state_1;
		default:
#line 2018 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 8300 "individual-aggregator.c"
	}
	_state_0:
#line 2022 "../folks/individual-aggregator.vala"
	_data_->persona = NULL;
#line 8305 "individual-aggregator.c"
	{
#line 2025 "../folks/individual-aggregator.vala"
		_data_->_tmp0_ = _folks_individual_aggregator_asv_copy (_data_->self, _data_->details);
#line 2025 "../folks/individual-aggregator.vala"
		_data_->details_copy = _data_->_tmp0_;
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_tmp2_ = _data_->details_copy;
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_state_ = 1;
#line 2026 "../folks/individual-aggregator.vala"
		folks_persona_store_add_persona_from_details (_data_->persona_store, _data_->_tmp2_, folks_individual_aggregator_add_persona_from_details_ready, _data_);
#line 2026 "../folks/individual-aggregator.vala"
		return FALSE;
#line 8319 "individual-aggregator.c"
		_state_1:
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_tmp3_ = folks_persona_store_add_persona_from_details_finish (_data_->persona_store, _data_->_res_, &_data_->_inner_error0_);
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_tmp1_ = _data_->_tmp3_;
#line 2026 "../folks/individual-aggregator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2026 "../folks/individual-aggregator.vala"
			_g_hash_table_unref0 (_data_->details_copy);
#line 2026 "../folks/individual-aggregator.vala"
			if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 8331 "individual-aggregator.c"
				goto __catch0_folks_persona_store_error;
			}
#line 2026 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->persona);
#line 2026 "../folks/individual-aggregator.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2026 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2026 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2026 "../folks/individual-aggregator.vala"
			return FALSE;
#line 8344 "individual-aggregator.c"
		}
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_tmp4_ = _data_->_tmp1_;
#line 2026 "../folks/individual-aggregator.vala"
		_data_->_tmp1_ = NULL;
#line 2026 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->persona);
#line 2026 "../folks/individual-aggregator.vala"
		_data_->persona = _data_->_tmp4_;
#line 2023 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 2023 "../folks/individual-aggregator.vala"
		_g_hash_table_unref0 (_data_->details_copy);
#line 8358 "individual-aggregator.c"
	}
	goto __finally0;
	__catch0_folks_persona_store_error:
	{
#line 2023 "../folks/individual-aggregator.vala"
		_data_->e = _data_->_inner_error0_;
#line 2023 "../folks/individual-aggregator.vala"
		_data_->_inner_error0_ = NULL;
#line 2030 "../folks/individual-aggregator.vala"
		_data_->_tmp5_ = _data_->e;
#line 2030 "../folks/individual-aggregator.vala"
		if (g_error_matches (_data_->_tmp5_, FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE)) {
#line 2032 "../folks/individual-aggregator.vala"
			_data_->_tmp6_ = _data_->e;
#line 2032 "../folks/individual-aggregator.vala"
			_data_->_tmp7_ = _data_->_tmp6_->message;
#line 2032 "../folks/individual-aggregator.vala"
			_data_->_tmp8_ = g_error_new_literal (FOLKS_INDIVIDUAL_AGGREGATOR_ERROR, FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_STORE_OFFLINE, _data_->_tmp7_);
#line 2032 "../folks/individual-aggregator.vala"
			_data_->_inner_error0_ = _data_->_tmp8_;
#line 2032 "../folks/individual-aggregator.vala"
			_g_error_free0 (_data_->e);
#line 8381 "individual-aggregator.c"
			goto __finally0;
		} else {
#line 2036 "../folks/individual-aggregator.vala"
			_data_->_tmp9_ = folks_persona_store_get_type_id (_data_->persona_store);
#line 2036 "../folks/individual-aggregator.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 2036 "../folks/individual-aggregator.vala"
			_data_->_tmp11_ = folks_persona_store_get_id (_data_->persona_store);
#line 2036 "../folks/individual-aggregator.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 2036 "../folks/individual-aggregator.vala"
			_data_->_tmp13_ = _folks_individual_aggregator_get_store_full_id (_data_->self, _data_->_tmp10_, _data_->_tmp12_);
#line 2036 "../folks/individual-aggregator.vala"
			_data_->full_id = _data_->_tmp13_;
#line 2039 "../folks/individual-aggregator.vala"
			_data_->_tmp14_ = _data_->full_id;
#line 2039 "../folks/individual-aggregator.vala"
			_data_->_tmp15_ = _data_->e;
#line 2039 "../folks/individual-aggregator.vala"
			_data_->_tmp16_ = _data_->_tmp15_->message;
#line 2039 "../folks/individual-aggregator.vala"
			_data_->_tmp17_ = g_error_new (FOLKS_INDIVIDUAL_AGGREGATOR_ERROR, FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_ADD_FAILED, _ ("Failed to add contact for persona store ID ‘%s’: %s"), _data_->_tmp14_, _data_->_tmp16_);
#line 2039 "../folks/individual-aggregator.vala"
			_data_->_inner_error0_ = _data_->_tmp17_;
#line 2039 "../folks/individual-aggregator.vala"
			_g_free0 (_data_->full_id);
#line 2039 "../folks/individual-aggregator.vala"
			_g_error_free0 (_data_->e);
#line 8410 "individual-aggregator.c"
			goto __finally0;
		}
#line 2023 "../folks/individual-aggregator.vala"
		_g_error_free0 (_data_->e);
#line 8415 "individual-aggregator.c"
	}
	__finally0:
#line 2023 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2023 "../folks/individual-aggregator.vala"
		if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2023 "../folks/individual-aggregator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2023 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->persona);
#line 2023 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2023 "../folks/individual-aggregator.vala"
			return FALSE;
#line 8430 "individual-aggregator.c"
		} else {
#line 2023 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->persona);
#line 2023 "../folks/individual-aggregator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2023 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2023 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2023 "../folks/individual-aggregator.vala"
			return FALSE;
#line 8442 "individual-aggregator.c"
		}
	}
#line 2047 "../folks/individual-aggregator.vala"
	if (_data_->parent != NULL) {
#line 2047 "../folks/individual-aggregator.vala"
		_data_->_tmp19_ = _data_->persona;
#line 2047 "../folks/individual-aggregator.vala"
		_data_->_tmp18_ = _data_->_tmp19_ != NULL;
#line 8451 "individual-aggregator.c"
	} else {
#line 2047 "../folks/individual-aggregator.vala"
		_data_->_tmp18_ = FALSE;
#line 8455 "individual-aggregator.c"
	}
#line 2047 "../folks/individual-aggregator.vala"
	if (_data_->_tmp18_) {
#line 2049 "../folks/individual-aggregator.vala"
		_data_->_tmp20_ = folks_individual_get_personas (G_TYPE_CHECK_INSTANCE_CAST (_data_->parent, FOLKS_TYPE_INDIVIDUAL, FolksIndividual));
#line 2049 "../folks/individual-aggregator.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 2049 "../folks/individual-aggregator.vala"
		_data_->_tmp22_ = _data_->persona;
#line 2049 "../folks/individual-aggregator.vala"
		gee_collection_add ((GeeCollection*) _data_->_tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp22_, FOLKS_TYPE_PERSONA, FolksPersona));
#line 8467 "individual-aggregator.c"
	}
#line 2052 "../folks/individual-aggregator.vala"
	_data_->result = _data_->persona;
#line 2052 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2052 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2052 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2052 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8479 "individual-aggregator.c"
		}
	}
#line 2052 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2052 "../folks/individual-aggregator.vala"
	return FALSE;
#line 8486 "individual-aggregator.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 2055 "../folks/individual-aggregator.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 2055 "../folks/individual-aggregator.vala"
	return _data6_;
#line 8496 "individual-aggregator.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 2055 "../folks/individual-aggregator.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 8506 "individual-aggregator.c"
		FolksIndividualAggregator* self;
#line 2055 "../folks/individual-aggregator.vala"
		self = _data6_->self;
#line 2055 "../folks/individual-aggregator.vala"
		_g_hash_table_unref0 (_data6_->retval);
#line 2055 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self);
#line 2055 "../folks/individual-aggregator.vala"
		g_slice_free (Block6Data, _data6_);
#line 8516 "individual-aggregator.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 2057 "../folks/individual-aggregator.vala"
	var = (g_free (var), NULL);
#line 8525 "individual-aggregator.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 2057 "../folks/individual-aggregator.vala"
	g_boxed_free (G_TYPE_VALUE, self);
#line 8533 "individual-aggregator.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 2057 "../folks/individual-aggregator.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 8541 "individual-aggregator.c"
}

static GValue*
_g_value_dup (GValue* self)
{
#line 2061 "../folks/individual-aggregator.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 8549 "individual-aggregator.c"
}

static gpointer
__g_value_dup0 (gpointer self)
{
#line 2061 "../folks/individual-aggregator.vala"
	return self ? _g_value_dup (self) : NULL;
#line 8557 "individual-aggregator.c"
}

static void
__lambda70_ (Block6Data* _data6_,
             const gchar* k,
             GValue* v)
{
	FolksIndividualAggregator* self;
	gchar* _tmp0_;
	GValue* _tmp1_;
#line 2059 "../folks/individual-aggregator.vala"
	self = _data6_->self;
#line 2059 "../folks/individual-aggregator.vala"
	g_return_if_fail (k != NULL);
#line 2061 "../folks/individual-aggregator.vala"
	_tmp0_ = g_strdup ((const gchar*) k);
#line 2061 "../folks/individual-aggregator.vala"
	_tmp1_ = __g_value_dup0 (v);
#line 2061 "../folks/individual-aggregator.vala"
	g_hash_table_insert (_data6_->retval, _tmp0_, _tmp1_);
#line 8578 "individual-aggregator.c"
}

static void
___lambda70__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
#line 2059 "../folks/individual-aggregator.vala"
	__lambda70_ (self, (const gchar*) key, (GValue*) value);
#line 8588 "individual-aggregator.c"
}

static GHashTable*
_folks_individual_aggregator_asv_copy (FolksIndividualAggregator* self,
                                       GHashTable* asv)
{
	Block6Data* _data6_;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GHashTable* result;
#line 2055 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2055 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (asv != NULL, NULL);
#line 2055 "../folks/individual-aggregator.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 2055 "../folks/individual-aggregator.vala"
	_data6_->_ref_count_ = 1;
#line 2055 "../folks/individual-aggregator.vala"
	_data6_->self = g_object_ref (self);
#line 2057 "../folks/individual-aggregator.vala"
	_tmp0_ = g_str_hash;
#line 2057 "../folks/individual-aggregator.vala"
	_tmp1_ = g_str_equal;
#line 2057 "../folks/individual-aggregator.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, __vala_GValue_free0_);
#line 2057 "../folks/individual-aggregator.vala"
	_data6_->retval = _tmp2_;
#line 2059 "../folks/individual-aggregator.vala"
	g_hash_table_foreach (asv, ___lambda70__gh_func, _data6_);
#line 2064 "../folks/individual-aggregator.vala"
	_tmp3_ = _g_hash_table_ref0 (_data6_->retval);
#line 2064 "../folks/individual-aggregator.vala"
	result = _tmp3_;
#line 2064 "../folks/individual-aggregator.vala"
	block6_data_unref (_data6_);
#line 2064 "../folks/individual-aggregator.vala"
	_data6_ = NULL;
#line 2064 "../folks/individual-aggregator.vala"
	return result;
#line 8631 "individual-aggregator.c"
}

static void
folks_individual_aggregator_remove_individual_data_free (gpointer _data)
{
	FolksIndividualAggregatorRemoveIndividualData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorRemoveIndividualData, _data_);
#line 8645 "individual-aggregator.c"
}

void
folks_individual_aggregator_remove_individual (FolksIndividualAggregator* self,
                                               FolksIndividual* individual,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	FolksIndividualAggregatorRemoveIndividualData* _data_;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividual* _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorRemoveIndividualData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_remove_individual_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_data_->individual = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_remove_individual_co (_data_);
#line 8679 "individual-aggregator.c"
}

void
folks_individual_aggregator_remove_individual_finish (FolksIndividualAggregator* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	FolksIndividualAggregatorRemoveIndividualData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 8694 "individual-aggregator.c"
	}
}

/**
   * Completely remove the individual and all of its personas from their
   * backing stores.
   *
   * This method is safe to call multiple times concurrently (for the same
   * individual or different individuals).
   *
   * @param individual the {@link Individual} to remove
   * @throws GLib.Error if removing the persona failed — this will be passed
   * through from {@link PersonaStore.remove_persona}
   *
   * @since 0.1.11
   */
static void
folks_individual_aggregator_remove_individual_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	FolksIndividualAggregatorRemoveIndividualData* _data_;
#line 2088 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2088 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2088 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2088 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_remove_individual_co (_data_);
#line 8725 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_remove_individual_co (FolksIndividualAggregatorRemoveIndividualData* _data_)
{
#line 2080 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2080 "../folks/individual-aggregator.vala"
		case 0:
#line 8735 "individual-aggregator.c"
		goto _state_0;
#line 2080 "../folks/individual-aggregator.vala"
		case 1:
#line 8739 "individual-aggregator.c"
		goto _state_1;
		default:
#line 2080 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 8744 "individual-aggregator.c"
	}
	_state_0:
#line 2084 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = folks_individual_get_personas (_data_->individual);
#line 2084 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 2084 "../folks/individual-aggregator.vala"
	_data_->_tmp2_ = folks_small_set_copy (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeIterable*) _data_->_tmp1_, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2084 "../folks/individual-aggregator.vala"
	_data_->personas = _data_->_tmp2_;
#line 8755 "individual-aggregator.c"
	{
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_tmp3_ = _data_->personas;
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_persona_list = _data_->_tmp3_;
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_tmp4_ = _data_->_persona_list;
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_tmp5_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp4_);
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_persona_size = _data_->_tmp6_;
#line 2086 "../folks/individual-aggregator.vala"
		_data_->_persona_index = -1;
#line 2086 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_persona_index = _data_->_persona_index + 1;
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_tmp7_ = _data_->_persona_index;
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_tmp8_ = _data_->_persona_size;
#line 2086 "../folks/individual-aggregator.vala"
			if (!(_data_->_tmp7_ < _data_->_tmp8_)) {
#line 2086 "../folks/individual-aggregator.vala"
				break;
#line 8783 "individual-aggregator.c"
			}
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_tmp9_ = _data_->_persona_list;
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_tmp10_ = folks_small_set_get (_data_->_tmp9_, _data_->_persona_index);
#line 2086 "../folks/individual-aggregator.vala"
			_data_->_tmp11_ = _g_object_ref0 ((FolksPersona*) _data_->_tmp10_);
#line 2086 "../folks/individual-aggregator.vala"
			_data_->persona = _data_->_tmp11_;
#line 2088 "../folks/individual-aggregator.vala"
			_data_->_tmp12_ = _data_->persona;
#line 2088 "../folks/individual-aggregator.vala"
			_data_->_tmp13_ = folks_persona_get_store (_data_->_tmp12_);
#line 2088 "../folks/individual-aggregator.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 2088 "../folks/individual-aggregator.vala"
			_data_->_tmp15_ = _data_->persona;
#line 2088 "../folks/individual-aggregator.vala"
			_data_->_state_ = 1;
#line 2088 "../folks/individual-aggregator.vala"
			folks_persona_store_remove_persona (_data_->_tmp14_, _data_->_tmp15_, folks_individual_aggregator_remove_individual_ready, _data_);
#line 2088 "../folks/individual-aggregator.vala"
			return FALSE;
#line 8807 "individual-aggregator.c"
			_state_1:
#line 2088 "../folks/individual-aggregator.vala"
			folks_persona_store_remove_persona_finish (_data_->_tmp14_, _data_->_res_, &_data_->_inner_error0_);
#line 2088 "../folks/individual-aggregator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2088 "../folks/individual-aggregator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2088 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->persona);
#line 2088 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->personas);
#line 2088 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2088 "../folks/individual-aggregator.vala"
				return FALSE;
#line 8823 "individual-aggregator.c"
			}
#line 2086 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->persona);
#line 8827 "individual-aggregator.c"
		}
	}
#line 2080 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->personas);
#line 2080 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2080 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2080 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2080 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8840 "individual-aggregator.c"
		}
	}
#line 2080 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2080 "../folks/individual-aggregator.vala"
	return FALSE;
#line 8847 "individual-aggregator.c"
}

static void
folks_individual_aggregator_remove_persona_data_free (gpointer _data)
{
	FolksIndividualAggregatorRemovePersonaData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->persona);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorRemovePersonaData, _data_);
#line 8861 "individual-aggregator.c"
}

void
folks_individual_aggregator_remove_persona (FolksIndividualAggregator* self,
                                            FolksPersona* persona,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	FolksIndividualAggregatorRemovePersonaData* _data_;
	FolksIndividualAggregator* _tmp0_;
	FolksPersona* _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (persona != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorRemovePersonaData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_remove_persona_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (persona);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->persona);
#line 125 "../folks/individual-aggregator.vala"
	_data_->persona = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_remove_persona_co (_data_);
#line 8895 "individual-aggregator.c"
}

void
folks_individual_aggregator_remove_persona_finish (FolksIndividualAggregator* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	FolksIndividualAggregatorRemovePersonaData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 8910 "individual-aggregator.c"
	}
}

/**
   * Completely remove the persona from its backing store.
   *
   * This will leave other personas in the same individual alone.
   *
   * This method is safe to call multiple times concurrently (for the same
   * persona or different personas).
   *
   * @param persona the {@link Persona} to remove
   * @throws GLib.Error if removing the persona failed — this will be passed
   * through from {@link PersonaStore.remove_persona}
   *
   * @since 0.1.11
   */
static void
folks_individual_aggregator_remove_persona_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	FolksIndividualAggregatorRemovePersonaData* _data_;
#line 2108 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2108 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2108 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2108 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_remove_persona_co (_data_);
#line 8942 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_remove_persona_co (FolksIndividualAggregatorRemovePersonaData* _data_)
{
#line 2106 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2106 "../folks/individual-aggregator.vala"
		case 0:
#line 8952 "individual-aggregator.c"
		goto _state_0;
#line 2106 "../folks/individual-aggregator.vala"
		case 1:
#line 8956 "individual-aggregator.c"
		goto _state_1;
		default:
#line 2106 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 8961 "individual-aggregator.c"
	}
	_state_0:
#line 2108 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = folks_persona_get_store (_data_->persona);
#line 2108 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 2108 "../folks/individual-aggregator.vala"
	_data_->_state_ = 1;
#line 2108 "../folks/individual-aggregator.vala"
	folks_persona_store_remove_persona (_data_->_tmp1_, _data_->persona, folks_individual_aggregator_remove_persona_ready, _data_);
#line 2108 "../folks/individual-aggregator.vala"
	return FALSE;
#line 8974 "individual-aggregator.c"
	_state_1:
#line 2108 "../folks/individual-aggregator.vala"
	folks_persona_store_remove_persona_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 2108 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2108 "../folks/individual-aggregator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2108 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2108 "../folks/individual-aggregator.vala"
		return FALSE;
#line 8986 "individual-aggregator.c"
	}
#line 2106 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2106 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2106 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2106 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8996 "individual-aggregator.c"
		}
	}
#line 2106 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2106 "../folks/individual-aggregator.vala"
	return FALSE;
#line 9003 "individual-aggregator.c"
}

static void
folks_individual_aggregator_link_personas_data_free (gpointer _data)
{
	FolksIndividualAggregatorLinkPersonasData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->personas);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorLinkPersonasData, _data_);
#line 9017 "individual-aggregator.c"
}

void
folks_individual_aggregator_link_personas (FolksIndividualAggregator* self,
                                           GeeSet* personas,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksIndividualAggregatorLinkPersonasData* _data_;
	FolksIndividualAggregator* _tmp0_;
	GeeSet* _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (personas != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorLinkPersonasData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_link_personas_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (personas);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->personas);
#line 125 "../folks/individual-aggregator.vala"
	_data_->personas = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_link_personas_co (_data_);
#line 9051 "individual-aggregator.c"
}

void
folks_individual_aggregator_link_personas_finish (FolksIndividualAggregator* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	FolksIndividualAggregatorLinkPersonasData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 9066 "individual-aggregator.c"
	}
}

/**
   * Link the given {@link Persona}s together.
   *
   * Create links between the given {@link Persona}s so that they form a single
   * {@link Individual}. The new {@link Individual} will be returned via the
   * {@link IndividualAggregator.individuals_changed} signal.
   *
   * Removal of the {@link Individual}s which the {@link Persona}s were in
   * before is signalled by {@link IndividualAggregator.individuals_changed} and
   * {@link Individual.removed}.
   *
   * This method is safe to call multiple times concurrently.
   *
   * @param personas the {@link Persona}s to be linked
   * @throws IndividualAggregatorError.NO_PRIMARY_STORE if no primary store has
   * been configured for the individual aggregator
   * @throws IndividualAggregatorError if adding the linking persona failed —
   * this will be passed through from
   * {@link IndividualAggregator.add_persona_from_details}
   *
   * @since 0.5.1
   */
static void
folks_individual_aggregator_link_personas_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	FolksIndividualAggregatorLinkPersonasData* _data_;
#line 2164 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2164 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2164 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2164 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_link_personas_co (_data_);
#line 9106 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_link_personas_co (FolksIndividualAggregatorLinkPersonasData* _data_)
{
#line 2133 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2133 "../folks/individual-aggregator.vala"
		case 0:
#line 9116 "individual-aggregator.c"
		goto _state_0;
#line 2133 "../folks/individual-aggregator.vala"
		case 1:
#line 9120 "individual-aggregator.c"
		goto _state_1;
#line 2133 "../folks/individual-aggregator.vala"
		case 2:
#line 9124 "individual-aggregator.c"
		goto _state_2;
		default:
#line 2133 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 9129 "individual-aggregator.c"
	}
	_state_0:
#line 2136 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = _data_->self->priv->_stores;
#line 2136 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp0_, "key-file:relationships.ini");
#line 2136 "../folks/individual-aggregator.vala"
	_data_->key_file_store = (FolksPersonaStore*) _data_->_tmp1_;
#line 2138 "../folks/individual-aggregator.vala"
	_data_->_tmp2_ = _data_->key_file_store;
#line 2138 "../folks/individual-aggregator.vala"
	if (_data_->_tmp2_ == NULL) {
#line 2139 "../folks/individual-aggregator.vala"
		g_warning ("individual-aggregator.vala:2139: Can't link Personas: No keyfile");
#line 2140 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->key_file_store);
#line 2140 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2140 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 2140 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 2140 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9154 "individual-aggregator.c"
			}
		}
#line 2140 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2140 "../folks/individual-aggregator.vala"
		return FALSE;
#line 9161 "individual-aggregator.c"
	}
#line 2145 "../folks/individual-aggregator.vala"
	_data_->_tmp3_ = gee_collection_get_size ((GeeCollection*) _data_->personas);
#line 2145 "../folks/individual-aggregator.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 2145 "../folks/individual-aggregator.vala"
	if (_data_->_tmp4_ <= 1) {
#line 2146 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->key_file_store);
#line 2146 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2146 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 2146 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 2146 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9179 "individual-aggregator.c"
			}
		}
#line 2146 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2146 "../folks/individual-aggregator.vala"
		return FALSE;
#line 9186 "individual-aggregator.c"
	}
#line 2149 "../folks/individual-aggregator.vala"
	if (_data_->self->priv->_linking_enabled == FALSE) {
#line 2151 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:2151: Can't link Personas: linking disabled" \
".");
#line 2152 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->key_file_store);
#line 2152 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2152 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 2152 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 2152 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9202 "individual-aggregator.c"
			}
		}
#line 2152 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2152 "../folks/individual-aggregator.vala"
		return FALSE;
#line 9209 "individual-aggregator.c"
	}
	{
#line 2157 "../folks/individual-aggregator.vala"
		_data_->_tmp5_ = gee_iterable_iterator ((GeeIterable*) _data_->personas);
#line 2157 "../folks/individual-aggregator.vala"
		_data_->_p_it = _data_->_tmp5_;
#line 2157 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2157 "../folks/individual-aggregator.vala"
			_data_->_tmp6_ = _data_->_p_it;
#line 2157 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_data_->_tmp6_)) {
#line 2157 "../folks/individual-aggregator.vala"
				break;
#line 9224 "individual-aggregator.c"
			}
#line 2157 "../folks/individual-aggregator.vala"
			_data_->_tmp7_ = _data_->_p_it;
#line 2157 "../folks/individual-aggregator.vala"
			_data_->_tmp8_ = gee_iterator_get (_data_->_tmp7_);
#line 2157 "../folks/individual-aggregator.vala"
			_data_->p = (FolksPersona*) _data_->_tmp8_;
#line 2159 "../folks/individual-aggregator.vala"
			_data_->_tmp9_ = _data_->p;
#line 2159 "../folks/individual-aggregator.vala"
			_data_->_tmp10_ = _g_object_ref0 (FOLKS_IS_ANTI_LINKABLE (_data_->_tmp9_) ? ((FolksAntiLinkable*) _data_->_tmp9_) : NULL);
#line 2159 "../folks/individual-aggregator.vala"
			_data_->al = _data_->_tmp10_;
#line 2160 "../folks/individual-aggregator.vala"
			_data_->_tmp11_ = _data_->al;
#line 2160 "../folks/individual-aggregator.vala"
			if (_data_->_tmp11_ != NULL) {
#line 9242 "individual-aggregator.c"
				{
#line 2164 "../folks/individual-aggregator.vala"
					_data_->_tmp12_ = _data_->al;
#line 2164 "../folks/individual-aggregator.vala"
					_data_->_state_ = 1;
#line 2164 "../folks/individual-aggregator.vala"
					folks_anti_linkable_remove_anti_links (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, FOLKS_TYPE_ANTI_LINKABLE, FolksAntiLinkable), _data_->personas, folks_individual_aggregator_link_personas_ready, _data_);
#line 2164 "../folks/individual-aggregator.vala"
					return FALSE;
#line 9252 "individual-aggregator.c"
					_state_1:
#line 2164 "../folks/individual-aggregator.vala"
					folks_anti_linkable_remove_anti_links_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, FOLKS_TYPE_ANTI_LINKABLE, FolksAntiLinkable), _data_->_res_, &_data_->_inner_error0_);
#line 2164 "../folks/individual-aggregator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2164 "../folks/individual-aggregator.vala"
						if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 9260 "individual-aggregator.c"
							goto __catch0_folks_property_error;
						}
#line 2164 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->al);
#line 2164 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->p);
#line 2164 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_p_it);
#line 2164 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->key_file_store);
#line 2164 "../folks/individual-aggregator.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2164 "../folks/individual-aggregator.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 2164 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2164 "../folks/individual-aggregator.vala"
						return FALSE;
#line 9279 "individual-aggregator.c"
					}
				}
				goto __finally0;
				__catch0_folks_property_error:
				{
#line 2162 "../folks/individual-aggregator.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 2168 "../folks/individual-aggregator.vala"
					_data_->_tmp13_ = g_error_new_literal (FOLKS_INDIVIDUAL_AGGREGATOR_ERROR, FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_PROPERTY_NOT_WRITEABLE, _ ("Anti-links can’t be removed between personas being linked."));
#line 2168 "../folks/individual-aggregator.vala"
					_data_->_inner_error0_ = _data_->_tmp13_;
#line 9291 "individual-aggregator.c"
					goto __finally0;
				}
				__finally0:
#line 2162 "../folks/individual-aggregator.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2162 "../folks/individual-aggregator.vala"
					if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2162 "../folks/individual-aggregator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->al);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->p);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_p_it);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->key_file_store);
#line 2162 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2162 "../folks/individual-aggregator.vala"
						return FALSE;
#line 9313 "individual-aggregator.c"
					} else {
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->al);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->p);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_p_it);
#line 2162 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->key_file_store);
#line 2162 "../folks/individual-aggregator.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2162 "../folks/individual-aggregator.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 2162 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2162 "../folks/individual-aggregator.vala"
						return FALSE;
#line 9331 "individual-aggregator.c"
					}
				}
			}
#line 2157 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->al);
#line 2157 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->p);
#line 9339 "individual-aggregator.c"
		}
#line 2157 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->_p_it);
#line 9343 "individual-aggregator.c"
	}
#line 2174 "../folks/individual-aggregator.vala"
	_data_->_tmp14_ = _folks_individual_aggregator_build_linking_details (_data_->self, _data_->personas);
#line 2174 "../folks/individual-aggregator.vala"
	_data_->details = _data_->_tmp14_;
#line 2176 "../folks/individual-aggregator.vala"
	_data_->_tmp15_ = _data_->key_file_store;
#line 2176 "../folks/individual-aggregator.vala"
	_data_->_tmp16_ = _data_->details;
#line 2176 "../folks/individual-aggregator.vala"
	_data_->_state_ = 2;
#line 2176 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_add_persona_from_details (_data_->self, NULL, _data_->_tmp15_, _data_->_tmp16_, folks_individual_aggregator_link_personas_ready, _data_);
#line 2176 "../folks/individual-aggregator.vala"
	return FALSE;
#line 9359 "individual-aggregator.c"
	_state_2:
#line 2176 "../folks/individual-aggregator.vala"
	_data_->_tmp17_ = folks_individual_aggregator_add_persona_from_details_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2176 "../folks/individual-aggregator.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 2176 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->_tmp18_);
#line 2176 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2176 "../folks/individual-aggregator.vala"
		if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2176 "../folks/individual-aggregator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2176 "../folks/individual-aggregator.vala"
			_g_hash_table_unref0 (_data_->details);
#line 2176 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->key_file_store);
#line 2176 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2176 "../folks/individual-aggregator.vala"
			return FALSE;
#line 9381 "individual-aggregator.c"
		} else {
#line 2176 "../folks/individual-aggregator.vala"
			_g_hash_table_unref0 (_data_->details);
#line 2176 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->key_file_store);
#line 2176 "../folks/individual-aggregator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2176 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2176 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2176 "../folks/individual-aggregator.vala"
			return FALSE;
#line 9395 "individual-aggregator.c"
		}
	}
#line 2133 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (_data_->details);
#line 2133 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->key_file_store);
#line 2133 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2133 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2133 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2133 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9410 "individual-aggregator.c"
		}
	}
#line 2133 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2133 "../folks/individual-aggregator.vala"
	return FALSE;
#line 9417 "individual-aggregator.c"
}

static guint
_folks_abstract_field_details_hash_static_gee_hash_data_func (gconstpointer v,
                                                              gpointer self)
{
	guint result;
	result = folks_abstract_field_details_hash_static ((FolksAbstractFieldDetails*) v);
#line 2183 "../folks/individual-aggregator.vala"
	return result;
#line 9428 "individual-aggregator.c"
}

static gboolean
_folks_abstract_field_details_equal_static_gee_equal_data_func (gconstpointer a,
                                                                gconstpointer b,
                                                                gpointer self)
{
	gboolean result;
	result = folks_abstract_field_details_equal_static ((FolksAbstractFieldDetails*) a, (FolksAbstractFieldDetails*) b);
#line 2183 "../folks/individual-aggregator.vala"
	return result;
#line 9440 "individual-aggregator.c"
}

static GHashTable*
_folks_individual_aggregator_build_linking_details (FolksIndividualAggregator* self,
                                                    GeeSet* personas)
{
	GeeHashMultiMap* protocols_addrs_set = NULL;
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* web_service_addrs_set = NULL;
	GeeHashMultiMap* _tmp1_;
	FolksSmallSet* local_ids = NULL;
	FolksSmallSet* _tmp2_;
	GHashTable* details = NULL;
	GHashFunc _tmp47_;
	GEqualFunc _tmp48_;
	GHashTable* _tmp49_;
	GeeHashMultiMap* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	GeeHashMultiMap* _tmp61_;
	gint _tmp62_;
	gint _tmp63_;
	FolksSmallSet* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	GHashTable* result;
#line 2179 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2179 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (personas != NULL, NULL);
#line 2183 "../folks/individual-aggregator.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_IM_FIELD_DETAILS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _folks_abstract_field_details_hash_static_gee_hash_data_func, NULL, NULL, _folks_abstract_field_details_equal_static_gee_equal_data_func, NULL, NULL);
#line 2183 "../folks/individual-aggregator.vala"
	protocols_addrs_set = _tmp0_;
#line 2186 "../folks/individual-aggregator.vala"
	_tmp1_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_WEB_SERVICE_FIELD_DETAILS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _folks_abstract_field_details_hash_static_gee_hash_data_func, NULL, NULL, _folks_abstract_field_details_equal_static_gee_equal_data_func, NULL, NULL);
#line 2186 "../folks/individual-aggregator.vala"
	web_service_addrs_set = _tmp1_;
#line 2192 "../folks/individual-aggregator.vala"
	_tmp2_ = folks_small_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2192 "../folks/individual-aggregator.vala"
	local_ids = _tmp2_;
#line 9483 "individual-aggregator.c"
	{
		GeeIterator* _persona_it = NULL;
		GeeIterator* _tmp3_;
#line 2194 "../folks/individual-aggregator.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) personas);
#line 2194 "../folks/individual-aggregator.vala"
		_persona_it = _tmp3_;
#line 2194 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 9493 "individual-aggregator.c"
			GeeIterator* _tmp4_;
			FolksPersona* persona = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			FolksPersona* _tmp7_;
			FolksPersona* _tmp22_;
			FolksPersona* _tmp37_;
#line 2194 "../folks/individual-aggregator.vala"
			_tmp4_ = _persona_it;
#line 2194 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 2194 "../folks/individual-aggregator.vala"
				break;
#line 9507 "individual-aggregator.c"
			}
#line 2194 "../folks/individual-aggregator.vala"
			_tmp5_ = _persona_it;
#line 2194 "../folks/individual-aggregator.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 2194 "../folks/individual-aggregator.vala"
			persona = (FolksPersona*) _tmp6_;
#line 2196 "../folks/individual-aggregator.vala"
			_tmp7_ = persona;
#line 2196 "../folks/individual-aggregator.vala"
			if (FOLKS_IS_IM_DETAILS (_tmp7_)) {
#line 9519 "individual-aggregator.c"
				FolksImDetails* im_details = NULL;
				FolksPersona* _tmp8_;
				FolksImDetails* _tmp9_;
				GeeMapIterator* iter = NULL;
				FolksImDetails* _tmp10_;
				GeeMultiMap* _tmp11_;
				GeeMultiMap* _tmp12_;
				GeeMapIterator* _tmp13_;
#line 2198 "../folks/individual-aggregator.vala"
				_tmp8_ = persona;
#line 2198 "../folks/individual-aggregator.vala"
				_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, FOLKS_TYPE_IM_DETAILS, FolksImDetails));
#line 2198 "../folks/individual-aggregator.vala"
				im_details = _tmp9_;
#line 2199 "../folks/individual-aggregator.vala"
				_tmp10_ = im_details;
#line 2199 "../folks/individual-aggregator.vala"
				_tmp11_ = folks_im_details_get_im_addresses (_tmp10_);
#line 2199 "../folks/individual-aggregator.vala"
				_tmp12_ = _tmp11_;
#line 2199 "../folks/individual-aggregator.vala"
				_tmp13_ = gee_multi_map_map_iterator (_tmp12_);
#line 2199 "../folks/individual-aggregator.vala"
				iter = _tmp13_;
#line 2202 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 9546 "individual-aggregator.c"
					GeeMapIterator* _tmp14_;
					GeeHashMultiMap* _tmp15_;
					GeeMapIterator* _tmp16_;
					gpointer _tmp17_;
					gchar* _tmp18_;
					GeeMapIterator* _tmp19_;
					gpointer _tmp20_;
					FolksImFieldDetails* _tmp21_;
#line 2202 "../folks/individual-aggregator.vala"
					_tmp14_ = iter;
#line 2202 "../folks/individual-aggregator.vala"
					if (!gee_map_iterator_next (_tmp14_)) {
#line 2202 "../folks/individual-aggregator.vala"
						break;
#line 9561 "individual-aggregator.c"
					}
#line 2203 "../folks/individual-aggregator.vala"
					_tmp15_ = protocols_addrs_set;
#line 2203 "../folks/individual-aggregator.vala"
					_tmp16_ = iter;
#line 2203 "../folks/individual-aggregator.vala"
					_tmp17_ = gee_map_iterator_get_key (_tmp16_);
#line 2203 "../folks/individual-aggregator.vala"
					_tmp18_ = (gchar*) _tmp17_;
#line 2203 "../folks/individual-aggregator.vala"
					_tmp19_ = iter;
#line 2203 "../folks/individual-aggregator.vala"
					_tmp20_ = gee_map_iterator_get_value (_tmp19_);
#line 2203 "../folks/individual-aggregator.vala"
					_tmp21_ = (FolksImFieldDetails*) _tmp20_;
#line 2203 "../folks/individual-aggregator.vala"
					gee_multi_map_set ((GeeMultiMap*) _tmp15_, _tmp18_, _tmp21_);
#line 2203 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_tmp21_);
#line 2203 "../folks/individual-aggregator.vala"
					_g_free0 (_tmp18_);
#line 9583 "individual-aggregator.c"
				}
#line 2196 "../folks/individual-aggregator.vala"
				_g_object_unref0 (iter);
#line 2196 "../folks/individual-aggregator.vala"
				_g_object_unref0 (im_details);
#line 9589 "individual-aggregator.c"
			}
#line 2206 "../folks/individual-aggregator.vala"
			_tmp22_ = persona;
#line 2206 "../folks/individual-aggregator.vala"
			if (FOLKS_IS_WEB_SERVICE_DETAILS (_tmp22_)) {
#line 9595 "individual-aggregator.c"
				FolksWebServiceDetails* ws_details = NULL;
				FolksPersona* _tmp23_;
				FolksWebServiceDetails* _tmp24_;
				GeeMapIterator* iter = NULL;
				FolksWebServiceDetails* _tmp25_;
				GeeMultiMap* _tmp26_;
				GeeMultiMap* _tmp27_;
				GeeMapIterator* _tmp28_;
#line 2208 "../folks/individual-aggregator.vala"
				_tmp23_ = persona;
#line 2208 "../folks/individual-aggregator.vala"
				_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, FOLKS_TYPE_WEB_SERVICE_DETAILS, FolksWebServiceDetails));
#line 2208 "../folks/individual-aggregator.vala"
				ws_details = _tmp24_;
#line 2209 "../folks/individual-aggregator.vala"
				_tmp25_ = ws_details;
#line 2209 "../folks/individual-aggregator.vala"
				_tmp26_ = folks_web_service_details_get_web_service_addresses (_tmp25_);
#line 2209 "../folks/individual-aggregator.vala"
				_tmp27_ = _tmp26_;
#line 2209 "../folks/individual-aggregator.vala"
				_tmp28_ = gee_multi_map_map_iterator (_tmp27_);
#line 2209 "../folks/individual-aggregator.vala"
				iter = _tmp28_;
#line 2212 "../folks/individual-aggregator.vala"
				while (TRUE) {
#line 9622 "individual-aggregator.c"
					GeeMapIterator* _tmp29_;
					GeeHashMultiMap* _tmp30_;
					GeeMapIterator* _tmp31_;
					gpointer _tmp32_;
					gchar* _tmp33_;
					GeeMapIterator* _tmp34_;
					gpointer _tmp35_;
					FolksWebServiceFieldDetails* _tmp36_;
#line 2212 "../folks/individual-aggregator.vala"
					_tmp29_ = iter;
#line 2212 "../folks/individual-aggregator.vala"
					if (!gee_map_iterator_next (_tmp29_)) {
#line 2212 "../folks/individual-aggregator.vala"
						break;
#line 9637 "individual-aggregator.c"
					}
#line 2213 "../folks/individual-aggregator.vala"
					_tmp30_ = web_service_addrs_set;
#line 2213 "../folks/individual-aggregator.vala"
					_tmp31_ = iter;
#line 2213 "../folks/individual-aggregator.vala"
					_tmp32_ = gee_map_iterator_get_key (_tmp31_);
#line 2213 "../folks/individual-aggregator.vala"
					_tmp33_ = (gchar*) _tmp32_;
#line 2213 "../folks/individual-aggregator.vala"
					_tmp34_ = iter;
#line 2213 "../folks/individual-aggregator.vala"
					_tmp35_ = gee_map_iterator_get_value (_tmp34_);
#line 2213 "../folks/individual-aggregator.vala"
					_tmp36_ = (FolksWebServiceFieldDetails*) _tmp35_;
#line 2213 "../folks/individual-aggregator.vala"
					gee_multi_map_set ((GeeMultiMap*) _tmp30_, _tmp33_, _tmp36_);
#line 2213 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_tmp36_);
#line 2213 "../folks/individual-aggregator.vala"
					_g_free0 (_tmp33_);
#line 9659 "individual-aggregator.c"
				}
#line 2206 "../folks/individual-aggregator.vala"
				_g_object_unref0 (iter);
#line 2206 "../folks/individual-aggregator.vala"
				_g_object_unref0 (ws_details);
#line 9665 "individual-aggregator.c"
			}
#line 2216 "../folks/individual-aggregator.vala"
			_tmp37_ = persona;
#line 2216 "../folks/individual-aggregator.vala"
			if (FOLKS_IS_LOCAL_ID_DETAILS (_tmp37_)) {
#line 9671 "individual-aggregator.c"
				{
					GeeIterator* _id_it = NULL;
					FolksPersona* _tmp38_;
					GeeSet* _tmp39_;
					GeeSet* _tmp40_;
					GeeIterator* _tmp41_;
#line 2218 "../folks/individual-aggregator.vala"
					_tmp38_ = persona;
#line 2218 "../folks/individual-aggregator.vala"
					_tmp39_ = folks_local_id_details_get_local_ids (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, FOLKS_TYPE_LOCAL_ID_DETAILS, FolksLocalIdDetails));
#line 2218 "../folks/individual-aggregator.vala"
					_tmp40_ = _tmp39_;
#line 2218 "../folks/individual-aggregator.vala"
					_tmp41_ = gee_iterable_iterator ((GeeIterable*) _tmp40_);
#line 2218 "../folks/individual-aggregator.vala"
					_id_it = _tmp41_;
#line 2218 "../folks/individual-aggregator.vala"
					while (TRUE) {
#line 9690 "individual-aggregator.c"
						GeeIterator* _tmp42_;
						gchar* id = NULL;
						GeeIterator* _tmp43_;
						gpointer _tmp44_;
						FolksSmallSet* _tmp45_;
						const gchar* _tmp46_;
#line 2218 "../folks/individual-aggregator.vala"
						_tmp42_ = _id_it;
#line 2218 "../folks/individual-aggregator.vala"
						if (!gee_iterator_next (_tmp42_)) {
#line 2218 "../folks/individual-aggregator.vala"
							break;
#line 9703 "individual-aggregator.c"
						}
#line 2218 "../folks/individual-aggregator.vala"
						_tmp43_ = _id_it;
#line 2218 "../folks/individual-aggregator.vala"
						_tmp44_ = gee_iterator_get (_tmp43_);
#line 2218 "../folks/individual-aggregator.vala"
						id = (gchar*) _tmp44_;
#line 2220 "../folks/individual-aggregator.vala"
						_tmp45_ = local_ids;
#line 2220 "../folks/individual-aggregator.vala"
						_tmp46_ = id;
#line 2220 "../folks/individual-aggregator.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp45_, _tmp46_);
#line 2218 "../folks/individual-aggregator.vala"
						_g_free0 (id);
#line 9719 "individual-aggregator.c"
					}
#line 2218 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_id_it);
#line 9723 "individual-aggregator.c"
				}
			}
#line 2194 "../folks/individual-aggregator.vala"
			_g_object_unref0 (persona);
#line 9728 "individual-aggregator.c"
		}
#line 2194 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_persona_it);
#line 9732 "individual-aggregator.c"
	}
#line 2225 "../folks/individual-aggregator.vala"
	_tmp47_ = g_str_hash;
#line 2225 "../folks/individual-aggregator.vala"
	_tmp48_ = g_str_equal;
#line 2225 "../folks/individual-aggregator.vala"
	_tmp49_ = g_hash_table_new_full (_tmp47_, _tmp48_, _g_free0_, __vala_GValue_free0_);
#line 2225 "../folks/individual-aggregator.vala"
	details = _tmp49_;
#line 2227 "../folks/individual-aggregator.vala"
	_tmp50_ = protocols_addrs_set;
#line 2227 "../folks/individual-aggregator.vala"
	_tmp51_ = gee_multi_map_get_size ((GeeMultiMap*) _tmp50_);
#line 2227 "../folks/individual-aggregator.vala"
	_tmp52_ = _tmp51_;
#line 2227 "../folks/individual-aggregator.vala"
	if (_tmp52_ > 0) {
#line 9750 "individual-aggregator.c"
		GValue im_addresses_value = {0};
		GValue _tmp53_ = {0};
		GeeHashMultiMap* _tmp54_;
		GHashTable* _tmp55_;
		const gchar* _tmp56_;
		gchar* _tmp57_;
		GValue _tmp58_;
		GValue _tmp59_;
		GValue* _tmp60_;
#line 2229 "../folks/individual-aggregator.vala"
		g_value_init (&_tmp53_, GEE_TYPE_MULTI_MAP);
#line 2229 "../folks/individual-aggregator.vala"
		im_addresses_value = _tmp53_;
#line 2230 "../folks/individual-aggregator.vala"
		_tmp54_ = protocols_addrs_set;
#line 2230 "../folks/individual-aggregator.vala"
		g_value_set_object (&im_addresses_value, (GObject*) _tmp54_);
#line 2231 "../folks/individual-aggregator.vala"
		_tmp55_ = details;
#line 2231 "../folks/individual-aggregator.vala"
		_tmp56_ = folks_persona_store_detail_key (FOLKS_PERSONA_DETAIL_IM_ADDRESSES);
#line 2231 "../folks/individual-aggregator.vala"
		_tmp57_ = g_strdup ((const gchar*) _tmp56_);
#line 2231 "../folks/individual-aggregator.vala"
		_tmp58_ = im_addresses_value;
#line 2231 "../folks/individual-aggregator.vala"
		_tmp59_ = _tmp58_;
#line 2231 "../folks/individual-aggregator.vala"
		_tmp60_ = __g_value_dup0 (&_tmp59_);
#line 2231 "../folks/individual-aggregator.vala"
		g_hash_table_insert (_tmp55_, _tmp57_, _tmp60_);
#line 2227 "../folks/individual-aggregator.vala"
		G_IS_VALUE (&im_addresses_value) ? (g_value_unset (&im_addresses_value), NULL) : NULL;
#line 9784 "individual-aggregator.c"
	}
#line 2236 "../folks/individual-aggregator.vala"
	_tmp61_ = web_service_addrs_set;
#line 2236 "../folks/individual-aggregator.vala"
	_tmp62_ = gee_multi_map_get_size ((GeeMultiMap*) _tmp61_);
#line 2236 "../folks/individual-aggregator.vala"
	_tmp63_ = _tmp62_;
#line 2236 "../folks/individual-aggregator.vala"
	if (_tmp63_ > 0) {
#line 9794 "individual-aggregator.c"
		GValue web_service_addresses_value = {0};
		GValue _tmp64_ = {0};
		GeeHashMultiMap* _tmp65_;
		GHashTable* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		GValue _tmp69_;
		GValue _tmp70_;
		GValue* _tmp71_;
#line 2238 "../folks/individual-aggregator.vala"
		g_value_init (&_tmp64_, GEE_TYPE_MULTI_MAP);
#line 2238 "../folks/individual-aggregator.vala"
		web_service_addresses_value = _tmp64_;
#line 2239 "../folks/individual-aggregator.vala"
		_tmp65_ = web_service_addrs_set;
#line 2239 "../folks/individual-aggregator.vala"
		g_value_set_object (&web_service_addresses_value, (GObject*) _tmp65_);
#line 2240 "../folks/individual-aggregator.vala"
		_tmp66_ = details;
#line 2240 "../folks/individual-aggregator.vala"
		_tmp67_ = folks_persona_store_detail_key (FOLKS_PERSONA_DETAIL_WEB_SERVICE_ADDRESSES);
#line 2240 "../folks/individual-aggregator.vala"
		_tmp68_ = g_strdup ((const gchar*) _tmp67_);
#line 2240 "../folks/individual-aggregator.vala"
		_tmp69_ = web_service_addresses_value;
#line 2240 "../folks/individual-aggregator.vala"
		_tmp70_ = _tmp69_;
#line 2240 "../folks/individual-aggregator.vala"
		_tmp71_ = __g_value_dup0 (&_tmp70_);
#line 2240 "../folks/individual-aggregator.vala"
		g_hash_table_insert (_tmp66_, _tmp68_, _tmp71_);
#line 2236 "../folks/individual-aggregator.vala"
		G_IS_VALUE (&web_service_addresses_value) ? (g_value_unset (&web_service_addresses_value), NULL) : NULL;
#line 9828 "individual-aggregator.c"
	}
#line 2245 "../folks/individual-aggregator.vala"
	_tmp72_ = local_ids;
#line 2245 "../folks/individual-aggregator.vala"
	_tmp73_ = gee_collection_get_size ((GeeCollection*) _tmp72_);
#line 2245 "../folks/individual-aggregator.vala"
	_tmp74_ = _tmp73_;
#line 2245 "../folks/individual-aggregator.vala"
	if (_tmp74_ > 0) {
#line 9838 "individual-aggregator.c"
		GValue local_ids_value = {0};
		GValue _tmp75_ = {0};
		FolksSmallSet* _tmp76_;
		GHashTable* _tmp77_;
		const gchar* _tmp78_;
		gchar* _tmp79_;
		GValue _tmp80_;
		GValue _tmp81_;
		GValue* _tmp82_;
#line 2247 "../folks/individual-aggregator.vala"
		g_value_init (&_tmp75_, GEE_TYPE_SET);
#line 2247 "../folks/individual-aggregator.vala"
		local_ids_value = _tmp75_;
#line 2248 "../folks/individual-aggregator.vala"
		_tmp76_ = local_ids;
#line 2248 "../folks/individual-aggregator.vala"
		g_value_set_object (&local_ids_value, (GObject*) _tmp76_);
#line 2249 "../folks/individual-aggregator.vala"
		_tmp77_ = details;
#line 2249 "../folks/individual-aggregator.vala"
		_tmp78_ = folks_persona_store_detail_key (FOLKS_PERSONA_DETAIL_LOCAL_IDS);
#line 2249 "../folks/individual-aggregator.vala"
		_tmp79_ = g_strdup ((const gchar*) _tmp78_);
#line 2249 "../folks/individual-aggregator.vala"
		_tmp80_ = local_ids_value;
#line 2249 "../folks/individual-aggregator.vala"
		_tmp81_ = _tmp80_;
#line 2249 "../folks/individual-aggregator.vala"
		_tmp82_ = __g_value_dup0 (&_tmp81_);
#line 2249 "../folks/individual-aggregator.vala"
		g_hash_table_insert (_tmp77_, _tmp79_, _tmp82_);
#line 2245 "../folks/individual-aggregator.vala"
		G_IS_VALUE (&local_ids_value) ? (g_value_unset (&local_ids_value), NULL) : NULL;
#line 9872 "individual-aggregator.c"
	}
#line 2254 "../folks/individual-aggregator.vala"
	result = details;
#line 2254 "../folks/individual-aggregator.vala"
	_g_object_unref0 (local_ids);
#line 2254 "../folks/individual-aggregator.vala"
	_g_object_unref0 (web_service_addrs_set);
#line 2254 "../folks/individual-aggregator.vala"
	_g_object_unref0 (protocols_addrs_set);
#line 2254 "../folks/individual-aggregator.vala"
	return result;
#line 9884 "individual-aggregator.c"
}

static void
folks_individual_aggregator_unlink_individual_data_free (gpointer _data)
{
	FolksIndividualAggregatorUnlinkIndividualData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorUnlinkIndividualData, _data_);
#line 9898 "individual-aggregator.c"
}

void
folks_individual_aggregator_unlink_individual (FolksIndividualAggregator* self,
                                               FolksIndividual* individual,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	FolksIndividualAggregatorUnlinkIndividualData* _data_;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividual* _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorUnlinkIndividualData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_unlink_individual_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_data_->individual = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_unlink_individual_co (_data_);
#line 9932 "individual-aggregator.c"
}

void
folks_individual_aggregator_unlink_individual_finish (FolksIndividualAggregator* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	FolksIndividualAggregatorUnlinkIndividualData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return;
#line 9947 "individual-aggregator.c"
	}
}

/**
   * Unlinks the given {@link Individual} into its constituent {@link Persona}s.
   *
   * This completely unlinks the given {@link Individual}, destroying all of
   * its writeable {@link Persona}s.
   *
   * The {@link Individual}'s removal is signalled by
   * {@link IndividualAggregator.individuals_changed} and
   * {@link Individual.removed}.
   *
   * The {@link Persona}s comprising the {@link Individual} will be re-linked
   * into one or more new {@link Individual}s, depending on how much linking
   * data remains (typically only implicit links remain). The addition of these
   * new {@link Individual}s will be signalled by
   * {@link IndividualAggregator.individuals_changed}.
   *
   * This method is safe to call multiple times concurrently, although
   * concurrent calls for the same individual may result in duplicate personas
   * being created.
   *
   * @param individual the {@link Individual} to unlink
   * @throws GLib.Error if removing the linking persona failed — this will be
   * passed through from {@link PersonaStore.remove_persona}
   *
   * @since 0.1.13
   */
static void
folks_individual_aggregator_unlink_individual_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	FolksIndividualAggregatorUnlinkIndividualData* _data_;
#line 2323 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2323 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2323 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2323 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_unlink_individual_co (_data_);
#line 9991 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_unlink_individual_co (FolksIndividualAggregatorUnlinkIndividualData* _data_)
{
#line 2283 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2283 "../folks/individual-aggregator.vala"
		case 0:
#line 10001 "individual-aggregator.c"
		goto _state_0;
#line 2283 "../folks/individual-aggregator.vala"
		case 1:
#line 10005 "individual-aggregator.c"
		goto _state_1;
#line 2283 "../folks/individual-aggregator.vala"
		case 2:
#line 10009 "individual-aggregator.c"
		goto _state_2;
#line 2283 "../folks/individual-aggregator.vala"
		case 3:
#line 10013 "individual-aggregator.c"
		goto _state_3;
#line 2283 "../folks/individual-aggregator.vala"
		case 4:
#line 10017 "individual-aggregator.c"
		goto _state_4;
		default:
#line 2283 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 10022 "individual-aggregator.c"
	}
	_state_0:
#line 2285 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = _data_->self->priv->_stores;
#line 2285 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp0_, "key-file:relationships.ini");
#line 2285 "../folks/individual-aggregator.vala"
	_data_->key_file_store = (FolksPersonaStore*) _data_->_tmp1_;
#line 2287 "../folks/individual-aggregator.vala"
	if (_data_->self->priv->_linking_enabled == FALSE) {
#line 2289 "../folks/individual-aggregator.vala"
		_data_->_tmp2_ = folks_individual_get_id (_data_->individual);
#line 2289 "../folks/individual-aggregator.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 2289 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:2289: Can't unlink Individual '%s': linking" \
" disabled.", _data_->_tmp3_);
#line 2291 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->key_file_store);
#line 2291 "../folks/individual-aggregator.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2291 "../folks/individual-aggregator.vala"
		if (_data_->_state_ != 0) {
#line 2291 "../folks/individual-aggregator.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 2291 "../folks/individual-aggregator.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10049 "individual-aggregator.c"
			}
		}
#line 2291 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2291 "../folks/individual-aggregator.vala"
		return FALSE;
#line 10056 "individual-aggregator.c"
	}
#line 2294 "../folks/individual-aggregator.vala"
	_data_->_tmp4_ = folks_individual_get_id (_data_->individual);
#line 2294 "../folks/individual-aggregator.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 2294 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:2294: Unlinking Individual '%s':", _data_->_tmp5_);
#line 2308 "../folks/individual-aggregator.vala"
	_data_->_tmp6_ = folks_individual_get_personas (_data_->individual);
#line 2308 "../folks/individual-aggregator.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 2308 "../folks/individual-aggregator.vala"
	_data_->_tmp8_ = folks_small_set_copy (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeIterable*) _data_->_tmp7_, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2308 "../folks/individual-aggregator.vala"
	_data_->individual_personas = _data_->_tmp8_;
#line 2310 "../folks/individual-aggregator.vala"
	_data_->_tmp9_ = folks_small_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2310 "../folks/individual-aggregator.vala"
	_data_->key_file_personas = _data_->_tmp9_;
#line 10076 "individual-aggregator.c"
	{
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_tmp10_ = _data_->individual_personas;
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_p_list = _data_->_tmp10_;
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_tmp11_ = _data_->_p_list;
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_tmp12_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp11_);
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_p_size = _data_->_tmp13_;
#line 2313 "../folks/individual-aggregator.vala"
		_data_->_p_index = -1;
#line 2313 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_p_index = _data_->_p_index + 1;
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_tmp14_ = _data_->_p_index;
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_tmp15_ = _data_->_p_size;
#line 2313 "../folks/individual-aggregator.vala"
			if (!(_data_->_tmp14_ < _data_->_tmp15_)) {
#line 2313 "../folks/individual-aggregator.vala"
				break;
#line 10104 "individual-aggregator.c"
			}
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_tmp16_ = _data_->_p_list;
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_tmp17_ = folks_small_set_get (_data_->_tmp16_, _data_->_p_index);
#line 2313 "../folks/individual-aggregator.vala"
			_data_->_tmp18_ = _g_object_ref0 ((FolksPersona*) _data_->_tmp17_);
#line 2313 "../folks/individual-aggregator.vala"
			_data_->p = _data_->_tmp18_;
#line 2314 "../folks/individual-aggregator.vala"
			_data_->_tmp19_ = _data_->p;
#line 2314 "../folks/individual-aggregator.vala"
			_data_->_tmp20_ = folks_persona_get_store (_data_->_tmp19_);
#line 2314 "../folks/individual-aggregator.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 2314 "../folks/individual-aggregator.vala"
			_data_->_tmp22_ = folks_persona_store_get_type_id (_data_->_tmp21_);
#line 2314 "../folks/individual-aggregator.vala"
			_data_->_tmp23_ = _data_->_tmp22_;
#line 2314 "../folks/individual-aggregator.vala"
			if (g_strcmp0 (_data_->_tmp23_, "key-file") == 0) {
#line 2315 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:2315: Remove linking persona from key-file " \
"store");
#line 2316 "../folks/individual-aggregator.vala"
				_data_->_tmp24_ = _data_->key_file_personas;
#line 2316 "../folks/individual-aggregator.vala"
				_data_->_tmp25_ = _data_->p;
#line 2316 "../folks/individual-aggregator.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp24_, _data_->_tmp25_);
#line 2317 "../folks/individual-aggregator.vala"
				_data_->_tmp26_ = _data_->individual_personas;
#line 2317 "../folks/individual-aggregator.vala"
				_data_->_tmp27_ = _data_->p;
#line 2317 "../folks/individual-aggregator.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _data_->_tmp26_, _data_->_tmp27_);
#line 2323 "../folks/individual-aggregator.vala"
				_data_->_tmp28_ = _data_->p;
#line 2323 "../folks/individual-aggregator.vala"
				_data_->_tmp29_ = folks_persona_get_store (_data_->_tmp28_);
#line 2323 "../folks/individual-aggregator.vala"
				_data_->_tmp30_ = _data_->_tmp29_;
#line 2323 "../folks/individual-aggregator.vala"
				_data_->_tmp31_ = _data_->p;
#line 2323 "../folks/individual-aggregator.vala"
				_data_->_state_ = 1;
#line 2323 "../folks/individual-aggregator.vala"
				folks_persona_store_remove_persona (_data_->_tmp30_, _data_->_tmp31_, folks_individual_aggregator_unlink_individual_ready, _data_);
#line 2323 "../folks/individual-aggregator.vala"
				return FALSE;
#line 10154 "individual-aggregator.c"
				_state_1:
#line 2323 "../folks/individual-aggregator.vala"
				folks_persona_store_remove_persona_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error0_);
#line 2323 "../folks/individual-aggregator.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2323 "../folks/individual-aggregator.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2323 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->p);
#line 2323 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->key_file_personas);
#line 2323 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->individual_personas);
#line 2323 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->key_file_store);
#line 2323 "../folks/individual-aggregator.vala"
					g_object_unref (_data_->_async_result);
#line 2323 "../folks/individual-aggregator.vala"
					return FALSE;
#line 10174 "individual-aggregator.c"
				}
			}
#line 2313 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->p);
#line 10179 "individual-aggregator.c"
		}
	}
	{
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_tmp32_ = _data_->individual_personas;
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_vala1__p_list = _data_->_tmp32_;
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_tmp33_ = _data_->_vala1__p_list;
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_tmp34_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp33_);
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_vala1__p_size = _data_->_tmp35_;
#line 2327 "../folks/individual-aggregator.vala"
		_data_->_vala1__p_index = -1;
#line 2327 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_vala1__p_index = _data_->_vala1__p_index + 1;
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_tmp36_ = _data_->_vala1__p_index;
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_tmp37_ = _data_->_vala1__p_size;
#line 2327 "../folks/individual-aggregator.vala"
			if (!(_data_->_tmp36_ < _data_->_tmp37_)) {
#line 2327 "../folks/individual-aggregator.vala"
				break;
#line 10209 "individual-aggregator.c"
			}
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_tmp38_ = _data_->_vala1__p_list;
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_tmp39_ = folks_small_set_get (_data_->_tmp38_, _data_->_vala1__p_index);
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_tmp40_ = _g_object_ref0 ((FolksPersona*) _data_->_tmp39_);
#line 2327 "../folks/individual-aggregator.vala"
			_data_->_vala1_p = _data_->_tmp40_;
#line 2328 "../folks/individual-aggregator.vala"
			_data_->_tmp41_ = _data_->_vala1_p;
#line 2328 "../folks/individual-aggregator.vala"
			_data_->_tmp42_ = _g_object_ref0 (FOLKS_IS_ANTI_LINKABLE (_data_->_tmp41_) ? ((FolksAntiLinkable*) _data_->_tmp41_) : NULL);
#line 2328 "../folks/individual-aggregator.vala"
			_data_->al = _data_->_tmp42_;
#line 2329 "../folks/individual-aggregator.vala"
			_data_->_tmp43_ = _data_->al;
#line 2329 "../folks/individual-aggregator.vala"
			_vala_assert (_data_->_tmp43_ != NULL, "al != null");
#line 2330 "../folks/individual-aggregator.vala"
			_data_->_tmp44_ = _data_->al;
#line 2330 "../folks/individual-aggregator.vala"
			_data_->_tmp45_ = _data_->key_file_personas;
#line 2330 "../folks/individual-aggregator.vala"
			_data_->_state_ = 2;
#line 2330 "../folks/individual-aggregator.vala"
			folks_anti_linkable_remove_anti_links (_data_->_tmp44_, (GeeSet*) _data_->_tmp45_, folks_individual_aggregator_unlink_individual_ready, _data_);
#line 2330 "../folks/individual-aggregator.vala"
			return FALSE;
#line 10239 "individual-aggregator.c"
			_state_2:
#line 2330 "../folks/individual-aggregator.vala"
			folks_anti_linkable_remove_anti_links_finish (_data_->_tmp44_, _data_->_res_, &_data_->_inner_error0_);
#line 2330 "../folks/individual-aggregator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2330 "../folks/individual-aggregator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2330 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->al);
#line 2330 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->_vala1_p);
#line 2330 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->key_file_personas);
#line 2330 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->individual_personas);
#line 2330 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->key_file_store);
#line 2330 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2330 "../folks/individual-aggregator.vala"
				return FALSE;
#line 10261 "individual-aggregator.c"
			}
#line 2327 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->al);
#line 2327 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_vala1_p);
#line 10267 "individual-aggregator.c"
		}
	}
#line 2333 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:2333:     Inserting anti-links:");
#line 10272 "individual-aggregator.c"
	{
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_tmp46_ = _data_->individual_personas;
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_pers_list = _data_->_tmp46_;
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_tmp47_ = _data_->_pers_list;
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_tmp48_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp47_);
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_pers_size = _data_->_tmp49_;
#line 2334 "../folks/individual-aggregator.vala"
		_data_->_pers_index = -1;
#line 2334 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_pers_index = _data_->_pers_index + 1;
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_tmp50_ = _data_->_pers_index;
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_tmp51_ = _data_->_pers_size;
#line 2334 "../folks/individual-aggregator.vala"
			if (!(_data_->_tmp50_ < _data_->_tmp51_)) {
#line 2334 "../folks/individual-aggregator.vala"
				break;
#line 10300 "individual-aggregator.c"
			}
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_tmp52_ = _data_->_pers_list;
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_tmp53_ = folks_small_set_get (_data_->_tmp52_, _data_->_pers_index);
#line 2334 "../folks/individual-aggregator.vala"
			_data_->_tmp54_ = _g_object_ref0 ((FolksPersona*) _data_->_tmp53_);
#line 2334 "../folks/individual-aggregator.vala"
			_data_->pers = _data_->_tmp54_;
#line 2336 "../folks/individual-aggregator.vala"
			_data_->_tmp55_ = _data_->pers;
#line 2336 "../folks/individual-aggregator.vala"
			_data_->_tmp56_ = folks_persona_get_uid (_data_->_tmp55_);
#line 2336 "../folks/individual-aggregator.vala"
			_data_->_tmp57_ = _data_->_tmp56_;
#line 2336 "../folks/individual-aggregator.vala"
			_data_->_tmp58_ = _data_->pers;
#line 2336 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:2336:         Anti-linking persona '%s' (%p" \
")", _data_->_tmp57_, _data_->_tmp58_);
#line 2339 "../folks/individual-aggregator.vala"
			_data_->_tmp59_ = _data_->pers;
#line 2339 "../folks/individual-aggregator.vala"
			if (!_folks_individual_aggregator_is_anti_link_property_writeable (_data_->self, _data_->_tmp59_)) {
#line 2340 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:2340: Anti link property isn't writeable, c" \
"reate a persona in the key-file store");
#line 2342 "../folks/individual-aggregator.vala"
				_data_->_tmp60_ = _data_->key_file_store;
#line 2342 "../folks/individual-aggregator.vala"
				if (_data_->_tmp60_ != NULL) {
#line 2343 "../folks/individual-aggregator.vala"
					_data_->_tmp61_ = folks_small_set_new (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2343 "../folks/individual-aggregator.vala"
					_data_->personas = _data_->_tmp61_;
#line 2344 "../folks/individual-aggregator.vala"
					_data_->_tmp62_ = _data_->personas;
#line 2344 "../folks/individual-aggregator.vala"
					_data_->_tmp63_ = _data_->pers;
#line 2344 "../folks/individual-aggregator.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp62_, _data_->_tmp63_);
#line 2346 "../folks/individual-aggregator.vala"
					_data_->_tmp64_ = _data_->personas;
#line 2346 "../folks/individual-aggregator.vala"
					_data_->_tmp65_ = _folks_individual_aggregator_build_linking_details (_data_->self, (GeeSet*) _data_->_tmp64_);
#line 2346 "../folks/individual-aggregator.vala"
					_data_->details = _data_->_tmp65_;
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp67_ = _data_->key_file_store;
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp68_ = _data_->details;
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_state_ = 3;
#line 2347 "../folks/individual-aggregator.vala"
					folks_individual_aggregator_add_persona_from_details (_data_->self, NULL, _data_->_tmp67_, _data_->_tmp68_, folks_individual_aggregator_unlink_individual_ready, _data_);
#line 2347 "../folks/individual-aggregator.vala"
					return FALSE;
#line 10356 "individual-aggregator.c"
					_state_3:
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp69_ = folks_individual_aggregator_add_persona_from_details_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp66_ = _data_->_tmp69_;
#line 2347 "../folks/individual-aggregator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2347 "../folks/individual-aggregator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2347 "../folks/individual-aggregator.vala"
						_g_hash_table_unref0 (_data_->details);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->personas);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->writeable_persona);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->pers);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->key_file_personas);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->individual_personas);
#line 2347 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->key_file_store);
#line 2347 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2347 "../folks/individual-aggregator.vala"
						return FALSE;
#line 10384 "individual-aggregator.c"
					}
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp70_ = _data_->_tmp66_;
#line 2347 "../folks/individual-aggregator.vala"
					_data_->_tmp66_ = NULL;
#line 2347 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->writeable_persona);
#line 2347 "../folks/individual-aggregator.vala"
					_data_->writeable_persona = _data_->_tmp70_;
#line 2342 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->_tmp66_);
#line 2342 "../folks/individual-aggregator.vala"
					_g_hash_table_unref0 (_data_->details);
#line 2342 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->personas);
#line 10400 "individual-aggregator.c"
				} else {
#line 2349 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:2349: Key file store doesn't exist, can cre" \
"ate a new writeable persona");
#line 2350 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->writeable_persona);
#line 2350 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->pers);
#line 2350 "../folks/individual-aggregator.vala"
					continue;
#line 10410 "individual-aggregator.c"
				}
			} else {
#line 2353 "../folks/individual-aggregator.vala"
				_data_->_tmp71_ = _data_->pers;
#line 2353 "../folks/individual-aggregator.vala"
				_data_->_tmp72_ = _g_object_ref0 (_data_->_tmp71_);
#line 2353 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->writeable_persona);
#line 2353 "../folks/individual-aggregator.vala"
				_data_->writeable_persona = _data_->_tmp72_;
#line 10421 "individual-aggregator.c"
			}
#line 2357 "../folks/individual-aggregator.vala"
			_data_->_tmp73_ = _data_->individual_personas;
#line 2357 "../folks/individual-aggregator.vala"
			_data_->_tmp74_ = folks_small_set_copy (FOLKS_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeIterable*) _data_->_tmp73_, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2357 "../folks/individual-aggregator.vala"
			_data_->anti_link_personas = _data_->_tmp74_;
#line 2358 "../folks/individual-aggregator.vala"
			_data_->_tmp75_ = _data_->anti_link_personas;
#line 2358 "../folks/individual-aggregator.vala"
			_data_->_tmp76_ = _data_->pers;
#line 2358 "../folks/individual-aggregator.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _data_->_tmp75_, _data_->_tmp76_);
#line 2360 "../folks/individual-aggregator.vala"
			_data_->_tmp77_ = _data_->writeable_persona;
#line 2360 "../folks/individual-aggregator.vala"
			_data_->_tmp78_ = _g_object_ref0 (FOLKS_IS_ANTI_LINKABLE (_data_->_tmp77_) ? ((FolksAntiLinkable*) _data_->_tmp77_) : NULL);
#line 2360 "../folks/individual-aggregator.vala"
			_data_->_vala1_al = _data_->_tmp78_;
#line 2361 "../folks/individual-aggregator.vala"
			_data_->_tmp79_ = _data_->_vala1_al;
#line 2361 "../folks/individual-aggregator.vala"
			_vala_assert (_data_->_tmp79_ != NULL, "al != null");
#line 2362 "../folks/individual-aggregator.vala"
			_data_->_tmp80_ = _data_->_vala1_al;
#line 2362 "../folks/individual-aggregator.vala"
			_data_->_tmp81_ = _data_->anti_link_personas;
#line 2362 "../folks/individual-aggregator.vala"
			_data_->_state_ = 4;
#line 2362 "../folks/individual-aggregator.vala"
			folks_anti_linkable_add_anti_links (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp80_, FOLKS_TYPE_ANTI_LINKABLE, FolksAntiLinkable), (GeeSet*) _data_->_tmp81_, folks_individual_aggregator_unlink_individual_ready, _data_);
#line 2362 "../folks/individual-aggregator.vala"
			return FALSE;
#line 10455 "individual-aggregator.c"
			_state_4:
#line 2362 "../folks/individual-aggregator.vala"
			folks_anti_linkable_add_anti_links_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp80_, FOLKS_TYPE_ANTI_LINKABLE, FolksAntiLinkable), _data_->_res_, &_data_->_inner_error0_);
#line 2362 "../folks/individual-aggregator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2362 "../folks/individual-aggregator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->_vala1_al);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->anti_link_personas);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->writeable_persona);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->pers);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->key_file_personas);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->individual_personas);
#line 2362 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->key_file_store);
#line 2362 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2362 "../folks/individual-aggregator.vala"
				return FALSE;
#line 10481 "individual-aggregator.c"
			}
#line 2363 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:2363: ");
#line 2334 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_vala1_al);
#line 2334 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->anti_link_personas);
#line 2334 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->writeable_persona);
#line 2334 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->pers);
#line 10493 "individual-aggregator.c"
		}
	}
#line 2283 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->key_file_personas);
#line 2283 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual_personas);
#line 2283 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->key_file_store);
#line 2283 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2283 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2283 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2283 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10510 "individual-aggregator.c"
		}
	}
#line 2283 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2283 "../folks/individual-aggregator.vala"
	return FALSE;
#line 10517 "individual-aggregator.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 2369 "../folks/individual-aggregator.vala"
	for (i = 0; i < stack_length; i++) {
#line 2369 "../folks/individual-aggregator.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 2369 "../folks/individual-aggregator.vala"
			return TRUE;
#line 10532 "individual-aggregator.c"
		}
	}
#line 2369 "../folks/individual-aggregator.vala"
	return FALSE;
#line 10537 "individual-aggregator.c"
}

static gboolean
_folks_individual_aggregator_is_anti_link_property_writeable (FolksIndividualAggregator* self,
                                                              FolksPersona* persona)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 2367 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2367 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (persona != NULL, FALSE);
#line 2369 "../folks/individual-aggregator.vala"
	_tmp0_ = folks_persona_get_writeable_properties (persona, &_tmp1_);
#line 2369 "../folks/individual-aggregator.vala"
	_tmp0__length1 = _tmp1_;
#line 2369 "../folks/individual-aggregator.vala"
	_tmp2_ = _tmp0_;
#line 2369 "../folks/individual-aggregator.vala"
	_tmp2__length1 = _tmp0__length1;
#line 2369 "../folks/individual-aggregator.vala"
	result = _vala_string_array_contains (_tmp2_, _tmp2__length1, "anti-links");
#line 2369 "../folks/individual-aggregator.vala"
	return result;
#line 10566 "individual-aggregator.c"
}

static void
folks_individual_aggregator_ensure_individual_property_writeable_data_free (gpointer _data)
{
	FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->property_name);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->result);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorEnsureIndividualPropertyWriteableData, _data_);
#line 10584 "individual-aggregator.c"
}

void
folks_individual_aggregator_ensure_individual_property_writeable (FolksIndividualAggregator* self,
                                                                  FolksIndividual* individual,
                                                                  const gchar* property_name,
                                                                  GAsyncReadyCallback _callback_,
                                                                  gpointer _user_data_)
{
	FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_;
	FolksIndividualAggregator* _tmp0_;
	FolksIndividual* _tmp1_;
	gchar* _tmp2_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (individual != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (property_name != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorEnsureIndividualPropertyWriteableData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_ensure_individual_property_writeable_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (individual);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->individual);
#line 125 "../folks/individual-aggregator.vala"
	_data_->individual = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp2_ = g_strdup (property_name);
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->property_name);
#line 125 "../folks/individual-aggregator.vala"
	_data_->property_name = _tmp2_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_ensure_individual_property_writeable_co (_data_);
#line 10628 "individual-aggregator.c"
}

FolksPersona*
folks_individual_aggregator_ensure_individual_property_writeable_finish (FolksIndividualAggregator* self,
                                                                         GAsyncResult* _res_,
                                                                         GError** error)
{
	FolksPersona* result;
	FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return NULL;
#line 10644 "individual-aggregator.c"
	}
#line 125 "../folks/individual-aggregator.vala"
	result = _data_->result;
#line 125 "../folks/individual-aggregator.vala"
	_data_->result = NULL;
#line 125 "../folks/individual-aggregator.vala"
	return result;
#line 10652 "individual-aggregator.c"
}

/**
   * Ensure that the given property is writeable for the given
   * {@link Individual}.
   *
   * This makes sure that there is at least one {@link Persona} in the
   * individual which has ``property_name`` in its
   * {@link Persona.writeable_properties}. If no such persona exists in the
   * individual, a new one will be created and linked to the individual. (Note
   * that due to the design of the aggregator, this will result in the previous
   * individual being removed and replaced by a new one with the new persona;
   * listen to the {@link Individual.removed} signal to see the replacement.)
   *
   * It may not be possible to create a new persona which has the given property
   * as writeable. In that case, a
   * {@link IndividualAggregatorError.NO_PRIMARY_STORE} or
   * {@link IndividualAggregatorError.PROPERTY_NOT_WRITEABLE} error will be
   * thrown.
   *
   * This method is safe to call multiple times concurrently, although
   * concurrent calls for the same individual may result in duplicate personas
   * being created.
   *
   * @param individual the individual for which ``property_name`` should be
   * writeable
   * @param property_name the name of the property which needs to be writeable
   * (this should be in lower case using hyphens, e.g. “web-service-addresses”)
   * @return a persona (new or existing) which has the given property as
   * writeable
   * @throws IndividualAggregatorError.NO_PRIMARY_STORE if no primary store was
   * configured for this individual aggregator
   * @throws IndividualAggregatorError.PROPERTY_NOT_WRITEABLE if the given
   * ``property_name`` referred to a non-writeable property
   * @throws IndividualAggregatorError if adding a new persona (using
   * {@link IndividualAggregator.add_persona_from_details}) failed, or if
   * linking personas (using {@link IndividualAggregator.link_personas}) failed
   *
   * @since 0.6.2
   */
static void
folks_individual_aggregator_ensure_individual_property_writeable_ready (GObject* source_object,
                                                                        GAsyncResult* _res_,
                                                                        gpointer _user_data_)
{
	FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_;
#line 2418 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2418 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_ensure_individual_property_writeable_co (_data_);
#line 10707 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_ensure_individual_property_writeable_co (FolksIndividualAggregatorEnsureIndividualPropertyWriteableData* _data_)
{
#line 2411 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2411 "../folks/individual-aggregator.vala"
		case 0:
#line 10717 "individual-aggregator.c"
		goto _state_0;
#line 2411 "../folks/individual-aggregator.vala"
		case 1:
#line 10721 "individual-aggregator.c"
		goto _state_1;
		default:
#line 2411 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 10726 "individual-aggregator.c"
	}
	_state_0:
#line 2415 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = folks_individual_get_id (_data_->individual);
#line 2415 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 2415 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:2415: ensure_individual_property_writeable:" \
" %s, %s", _data_->_tmp1_, _data_->property_name);
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_tmp2_ = folks_individual_get_personas (_data_->individual);
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_state_ = 1;
#line 2418 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_ensure_personas_property_writeable (_data_->self, _data_->_tmp3_, _data_->property_name, folks_individual_aggregator_ensure_individual_property_writeable_ready, _data_);
#line 2418 "../folks/individual-aggregator.vala"
	return FALSE;
#line 10745 "individual-aggregator.c"
	_state_1:
#line 2418 "../folks/individual-aggregator.vala"
	_data_->_tmp4_ = _folks_individual_aggregator_ensure_personas_property_writeable_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2418 "../folks/individual-aggregator.vala"
	_data_->p = _data_->_tmp4_;
#line 2418 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2418 "../folks/individual-aggregator.vala"
		if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2418 "../folks/individual-aggregator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2418 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2418 "../folks/individual-aggregator.vala"
			return FALSE;
#line 10761 "individual-aggregator.c"
		} else {
#line 2418 "../folks/individual-aggregator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2418 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2418 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2418 "../folks/individual-aggregator.vala"
			return FALSE;
#line 10771 "individual-aggregator.c"
		}
	}
#line 2420 "../folks/individual-aggregator.vala"
	_data_->result = _data_->p;
#line 2420 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2420 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2420 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2420 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10784 "individual-aggregator.c"
		}
	}
#line 2420 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2420 "../folks/individual-aggregator.vala"
	return FALSE;
#line 10791 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_ensure_personas_property_writeable_data_free (gpointer _data)
{
	FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->personas);
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->property_name);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->result);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorEnsurePersonasPropertyWriteableData, _data_);
#line 10809 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_ensure_personas_property_writeable (FolksIndividualAggregator* self,
                                                                 GeeSet* personas,
                                                                 const gchar* property_name,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_)
{
	FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_;
	FolksIndividualAggregator* _tmp0_;
	GeeSet* _tmp1_;
	gchar* _tmp2_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (personas != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (property_name != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorEnsurePersonasPropertyWriteableData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_individual_aggregator_ensure_personas_property_writeable_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = _g_object_ref0 (personas);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->personas);
#line 125 "../folks/individual-aggregator.vala"
	_data_->personas = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp2_ = g_strdup (property_name);
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->property_name);
#line 125 "../folks/individual-aggregator.vala"
	_data_->property_name = _tmp2_;
#line 125 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_ensure_personas_property_writeable_co (_data_);
#line 10853 "individual-aggregator.c"
}

static FolksPersona*
_folks_individual_aggregator_ensure_personas_property_writeable_finish (FolksIndividualAggregator* self,
                                                                        GAsyncResult* _res_,
                                                                        GError** error)
{
	FolksPersona* result;
	FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return NULL;
#line 10869 "individual-aggregator.c"
	}
#line 125 "../folks/individual-aggregator.vala"
	result = _data_->result;
#line 125 "../folks/individual-aggregator.vala"
	_data_->result = NULL;
#line 125 "../folks/individual-aggregator.vala"
	return result;
#line 10877 "individual-aggregator.c"
}

static void
_folks_individual_aggregator_ensure_personas_property_writeable_ready (GObject* source_object,
                                                                       GAsyncResult* _res_,
                                                                       gpointer _user_data_)
{
	FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_;
#line 2453 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2453 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2453 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2453 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_ensure_personas_property_writeable_co (_data_);
#line 10894 "individual-aggregator.c"
}

static gboolean
_folks_individual_aggregator_ensure_personas_property_writeable_co (FolksIndividualAggregatorEnsurePersonasPropertyWriteableData* _data_)
{
#line 2426 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2426 "../folks/individual-aggregator.vala"
		case 0:
#line 10904 "individual-aggregator.c"
		goto _state_0;
#line 2426 "../folks/individual-aggregator.vala"
		case 1:
#line 10908 "individual-aggregator.c"
		goto _state_1;
#line 2426 "../folks/individual-aggregator.vala"
		case 2:
#line 10912 "individual-aggregator.c"
		goto _state_2;
		default:
#line 2426 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 10917 "individual-aggregator.c"
	}
	_state_0:
	{
#line 2431 "../folks/individual-aggregator.vala"
		_data_->_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data_->personas);
#line 2431 "../folks/individual-aggregator.vala"
		_data_->_p1_it = _data_->_tmp0_;
#line 2431 "../folks/individual-aggregator.vala"
		while (TRUE) {
#line 2431 "../folks/individual-aggregator.vala"
			_data_->_tmp1_ = _data_->_p1_it;
#line 2431 "../folks/individual-aggregator.vala"
			if (!gee_iterator_next (_data_->_tmp1_)) {
#line 2431 "../folks/individual-aggregator.vala"
				break;
#line 10933 "individual-aggregator.c"
			}
#line 2431 "../folks/individual-aggregator.vala"
			_data_->_tmp2_ = _data_->_p1_it;
#line 2431 "../folks/individual-aggregator.vala"
			_data_->_tmp3_ = gee_iterator_get (_data_->_tmp2_);
#line 2431 "../folks/individual-aggregator.vala"
			_data_->p1 = (FolksPersona*) _data_->_tmp3_;
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp4_ = _data_->p1;
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp6_ = 0;
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp5_ = folks_persona_get_writeable_properties (_data_->_tmp4_, &_data_->_tmp6_);
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp5__length1 = _data_->_tmp6_;
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp7_ = _data_->_tmp5_;
#line 2433 "../folks/individual-aggregator.vala"
			_data_->_tmp7__length1 = _data_->_tmp5__length1;
#line 2433 "../folks/individual-aggregator.vala"
			if (_vala_string_array_contains (_data_->_tmp7_, _data_->_tmp7__length1, _data_->property_name)) {
#line 2435 "../folks/individual-aggregator.vala"
				_data_->_tmp8_ = _data_->p1;
#line 2435 "../folks/individual-aggregator.vala"
				_data_->_tmp9_ = folks_persona_get_uid (_data_->_tmp8_);
#line 2435 "../folks/individual-aggregator.vala"
				_data_->_tmp10_ = _data_->_tmp9_;
#line 2435 "../folks/individual-aggregator.vala"
				g_debug ("individual-aggregator.vala:2435:     Returning existing persona: %s", _data_->_tmp10_);
#line 2436 "../folks/individual-aggregator.vala"
				_data_->result = _data_->p1;
#line 2436 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->_p1_it);
#line 2436 "../folks/individual-aggregator.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2436 "../folks/individual-aggregator.vala"
				if (_data_->_state_ != 0) {
#line 2436 "../folks/individual-aggregator.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 2436 "../folks/individual-aggregator.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10975 "individual-aggregator.c"
					}
				}
#line 2436 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2436 "../folks/individual-aggregator.vala"
				return FALSE;
#line 10982 "individual-aggregator.c"
			}
#line 2431 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->p1);
#line 10986 "individual-aggregator.c"
		}
#line 2431 "../folks/individual-aggregator.vala"
		_g_object_unref0 (_data_->_p1_it);
#line 10990 "individual-aggregator.c"
	}
#line 2443 "../folks/individual-aggregator.vala"
	_data_->_tmp11_ = _folks_individual_aggregator_build_linking_details (_data_->self, _data_->personas);
#line 2443 "../folks/individual-aggregator.vala"
	_data_->details = _data_->_tmp11_;
#line 2444 "../folks/individual-aggregator.vala"
	_data_->new_persona = NULL;
#line 2446 "../folks/individual-aggregator.vala"
	_data_->_tmp13_ = _data_->self->priv->_primary_store;
#line 2446 "../folks/individual-aggregator.vala"
	if (_data_->_tmp13_ != NULL) {
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp14_ = _data_->self->priv->_primary_store;
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp16_ = 0;
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp15_ = folks_persona_store_get_always_writeable_properties (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore), &_data_->_tmp16_);
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp15__length1 = _data_->_tmp16_;
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp17_ = _data_->_tmp15_;
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp17__length1 = _data_->_tmp15__length1;
#line 2447 "../folks/individual-aggregator.vala"
		_data_->_tmp12_ = _vala_string_array_contains (_data_->_tmp17_, _data_->_tmp17__length1, _data_->property_name);
#line 11016 "individual-aggregator.c"
	} else {
#line 2446 "../folks/individual-aggregator.vala"
		_data_->_tmp12_ = FALSE;
#line 11020 "individual-aggregator.c"
	}
#line 2446 "../folks/individual-aggregator.vala"
	if (_data_->_tmp12_) {
#line 11024 "individual-aggregator.c"
		{
#line 2452 "../folks/individual-aggregator.vala"
			g_debug ("individual-aggregator.vala:2452:     Using writeable store");
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp19_ = _data_->self->priv->_primary_store;
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp20_ = _data_->details;
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_state_ = 1;
#line 2453 "../folks/individual-aggregator.vala"
			folks_individual_aggregator_add_persona_from_details (_data_->self, NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp19_, FOLKS_TYPE_PERSONA_STORE, FolksPersonaStore), _data_->_tmp20_, _folks_individual_aggregator_ensure_personas_property_writeable_ready, _data_);
#line 2453 "../folks/individual-aggregator.vala"
			return FALSE;
#line 11038 "individual-aggregator.c"
			_state_1:
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp21_ = folks_individual_aggregator_add_persona_from_details_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp18_ = _data_->_tmp21_;
#line 2453 "../folks/individual-aggregator.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2453 "../folks/individual-aggregator.vala"
				if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 11048 "individual-aggregator.c"
					goto __catch0_folks_individual_aggregator_error;
				}
#line 2453 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->new_persona);
#line 2453 "../folks/individual-aggregator.vala"
				_g_hash_table_unref0 (_data_->details);
#line 2453 "../folks/individual-aggregator.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2453 "../folks/individual-aggregator.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 2453 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2453 "../folks/individual-aggregator.vala"
				return FALSE;
#line 11063 "individual-aggregator.c"
			}
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp22_ = _data_->_tmp18_;
#line 2453 "../folks/individual-aggregator.vala"
			_data_->_tmp18_ = NULL;
#line 2453 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->new_persona);
#line 2453 "../folks/individual-aggregator.vala"
			_data_->new_persona = _data_->_tmp22_;
#line 2450 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_tmp18_);
#line 11075 "individual-aggregator.c"
		}
		goto __finally0;
		__catch0_folks_individual_aggregator_error:
		{
#line 2450 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2459 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->new_persona);
#line 2459 "../folks/individual-aggregator.vala"
			_data_->new_persona = NULL;
#line 11086 "individual-aggregator.c"
		}
		__finally0:
#line 2450 "../folks/individual-aggregator.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2450 "../folks/individual-aggregator.vala"
			if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2450 "../folks/individual-aggregator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2450 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->new_persona);
#line 2450 "../folks/individual-aggregator.vala"
				_g_hash_table_unref0 (_data_->details);
#line 2450 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2450 "../folks/individual-aggregator.vala"
				return FALSE;
#line 11103 "individual-aggregator.c"
			} else {
#line 2450 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->new_persona);
#line 2450 "../folks/individual-aggregator.vala"
				_g_hash_table_unref0 (_data_->details);
#line 2450 "../folks/individual-aggregator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2450 "../folks/individual-aggregator.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 2450 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2450 "../folks/individual-aggregator.vala"
				return FALSE;
#line 11117 "individual-aggregator.c"
			}
		}
	}
#line 2463 "../folks/individual-aggregator.vala"
	_data_->_tmp23_ = _data_->new_persona;
#line 2463 "../folks/individual-aggregator.vala"
	if (_data_->_tmp23_ == NULL) {
#line 11125 "individual-aggregator.c"
		{
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp24_ = _data_->self->priv->_stores;
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp25_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp24_);
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp26_ = _data_->_tmp25_;
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp27_ = _data_->_tmp26_;
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp28_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp27_);
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_tmp29_ = _data_->_tmp28_;
#line 2465 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_tmp27_);
#line 2465 "../folks/individual-aggregator.vala"
			_data_->_s_it = _data_->_tmp29_;
#line 2465 "../folks/individual-aggregator.vala"
			while (TRUE) {
#line 2465 "../folks/individual-aggregator.vala"
				_data_->_tmp30_ = _data_->_s_it;
#line 2465 "../folks/individual-aggregator.vala"
				if (!gee_iterator_next (_data_->_tmp30_)) {
#line 2465 "../folks/individual-aggregator.vala"
					break;
#line 11151 "individual-aggregator.c"
				}
#line 2465 "../folks/individual-aggregator.vala"
				_data_->_tmp31_ = _data_->_s_it;
#line 2465 "../folks/individual-aggregator.vala"
				_data_->_tmp32_ = gee_iterator_get (_data_->_tmp31_);
#line 2465 "../folks/individual-aggregator.vala"
				_data_->s = (FolksPersonaStore*) _data_->_tmp32_;
#line 2467 "../folks/individual-aggregator.vala"
				_data_->_tmp34_ = _data_->s;
#line 2467 "../folks/individual-aggregator.vala"
				_data_->_tmp35_ = _data_->self->priv->_primary_store;
#line 2467 "../folks/individual-aggregator.vala"
				if (_data_->_tmp34_ == _data_->_tmp35_) {
#line 2467 "../folks/individual-aggregator.vala"
					_data_->_tmp33_ = TRUE;
#line 11167 "individual-aggregator.c"
				} else {
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp36_ = _data_->s;
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp38_ = 0;
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp37_ = folks_persona_store_get_always_writeable_properties (_data_->_tmp36_, &_data_->_tmp38_);
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp37__length1 = _data_->_tmp38_;
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp39_ = _data_->_tmp37_;
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp39__length1 = _data_->_tmp37__length1;
#line 2468 "../folks/individual-aggregator.vala"
					_data_->_tmp33_ = !_vala_string_array_contains (_data_->_tmp39_, _data_->_tmp39__length1, _data_->property_name);
#line 11183 "individual-aggregator.c"
				}
#line 2467 "../folks/individual-aggregator.vala"
				if (_data_->_tmp33_) {
#line 2471 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->s);
#line 2471 "../folks/individual-aggregator.vala"
					continue;
#line 11191 "individual-aggregator.c"
				}
				{
#line 2476 "../folks/individual-aggregator.vala"
					_data_->_tmp40_ = _data_->s;
#line 2476 "../folks/individual-aggregator.vala"
					_data_->_tmp41_ = folks_persona_store_get_id (_data_->_tmp40_);
#line 2476 "../folks/individual-aggregator.vala"
					_data_->_tmp42_ = _data_->_tmp41_;
#line 2476 "../folks/individual-aggregator.vala"
					g_debug ("individual-aggregator.vala:2476:     Using store %s", _data_->_tmp42_);
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp44_ = _data_->s;
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp45_ = _data_->details;
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_state_ = 2;
#line 2477 "../folks/individual-aggregator.vala"
					folks_individual_aggregator_add_persona_from_details (_data_->self, NULL, _data_->_tmp44_, _data_->_tmp45_, _folks_individual_aggregator_ensure_personas_property_writeable_ready, _data_);
#line 2477 "../folks/individual-aggregator.vala"
					return FALSE;
#line 11212 "individual-aggregator.c"
					_state_2:
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp46_ = folks_individual_aggregator_add_persona_from_details_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp43_ = _data_->_tmp46_;
#line 2477 "../folks/individual-aggregator.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2477 "../folks/individual-aggregator.vala"
						if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 11222 "individual-aggregator.c"
							goto __catch1_folks_individual_aggregator_error;
						}
#line 2477 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->s);
#line 2477 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_s_it);
#line 2477 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->new_persona);
#line 2477 "../folks/individual-aggregator.vala"
						_g_hash_table_unref0 (_data_->details);
#line 2477 "../folks/individual-aggregator.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2477 "../folks/individual-aggregator.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 2477 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2477 "../folks/individual-aggregator.vala"
						return FALSE;
#line 11241 "individual-aggregator.c"
					}
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp47_ = _data_->_tmp43_;
#line 2477 "../folks/individual-aggregator.vala"
					_data_->_tmp43_ = NULL;
#line 2477 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->new_persona);
#line 2477 "../folks/individual-aggregator.vala"
					_data_->new_persona = _data_->_tmp47_;
#line 2474 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->_tmp43_);
#line 11253 "individual-aggregator.c"
				}
				goto __finally1;
				__catch1_folks_individual_aggregator_error:
				{
#line 2474 "../folks/individual-aggregator.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 2483 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->new_persona);
#line 2483 "../folks/individual-aggregator.vala"
					_data_->new_persona = NULL;
#line 2484 "../folks/individual-aggregator.vala"
					_g_object_unref0 (_data_->s);
#line 2484 "../folks/individual-aggregator.vala"
					continue;
#line 11268 "individual-aggregator.c"
				}
				__finally1:
#line 2474 "../folks/individual-aggregator.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2474 "../folks/individual-aggregator.vala"
					if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2474 "../folks/individual-aggregator.vala"
						g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->s);
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_s_it);
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->new_persona);
#line 2474 "../folks/individual-aggregator.vala"
						_g_hash_table_unref0 (_data_->details);
#line 2474 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2474 "../folks/individual-aggregator.vala"
						return FALSE;
#line 11289 "individual-aggregator.c"
					} else {
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->s);
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->_s_it);
#line 2474 "../folks/individual-aggregator.vala"
						_g_object_unref0 (_data_->new_persona);
#line 2474 "../folks/individual-aggregator.vala"
						_g_hash_table_unref0 (_data_->details);
#line 2474 "../folks/individual-aggregator.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2474 "../folks/individual-aggregator.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 2474 "../folks/individual-aggregator.vala"
						g_object_unref (_data_->_async_result);
#line 2474 "../folks/individual-aggregator.vala"
						return FALSE;
#line 11307 "individual-aggregator.c"
					}
				}
#line 2465 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->s);
#line 11312 "individual-aggregator.c"
			}
#line 2465 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->_s_it);
#line 11316 "individual-aggregator.c"
		}
	}
#line 2490 "../folks/individual-aggregator.vala"
	_data_->_tmp49_ = _data_->new_persona;
#line 2490 "../folks/individual-aggregator.vala"
	if (_data_->_tmp49_ == NULL) {
#line 2490 "../folks/individual-aggregator.vala"
		_data_->_tmp50_ = _data_->self->priv->_primary_store;
#line 2490 "../folks/individual-aggregator.vala"
		_data_->_tmp48_ = _data_->_tmp50_ == NULL;
#line 11327 "individual-aggregator.c"
	} else {
#line 2490 "../folks/individual-aggregator.vala"
		_data_->_tmp48_ = FALSE;
#line 11331 "individual-aggregator.c"
	}
#line 2490 "../folks/individual-aggregator.vala"
	if (_data_->_tmp48_) {
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp51_ = g_strconcat (_ ("Can’t add personas with no primary store."), "\n", NULL);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp53_ = g_strconcat (_data_->_tmp52_, _ ("Persona store ‘%s:%s’ is configured as primary, but could not be found" \
" or failed to load."), NULL);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp55_ = g_strconcat (_data_->_tmp54_, "\n", NULL);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp56_ = _data_->_tmp55_;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp57_ = g_strconcat (_data_->_tmp56_, _ ("Check the relevant service is running, or change the default store in " \
"that service or using the ‘%s’ GSettings key."), NULL);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp58_ = _data_->_tmp57_;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp59_ = _data_->self->priv->_configured_primary_store_type_id;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp60_ = _data_->self->priv->_configured_primary_store_id;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp61_ = g_strdup_printf ("%s %s", FOLKS_INDIVIDUAL_AGGREGATOR__FOLKS_GSETTINGS_SCHEMA, FOLKS_INDIVIDUAL_AGGREGATOR__PRIMARY_STORE_CONFIG_KEY);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp62_ = _data_->_tmp61_;
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp63_ = g_error_new (FOLKS_INDIVIDUAL_AGGREGATOR_ERROR, FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_NO_PRIMARY_STORE, _data_->_tmp58_, _data_->_tmp59_, _data_->_tmp60_, _data_->_tmp62_);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 2492 "../folks/individual-aggregator.vala"
		_g_free0 (_data_->_tmp62_);
#line 2492 "../folks/individual-aggregator.vala"
		_g_free0 (_data_->_tmp58_);
#line 2492 "../folks/individual-aggregator.vala"
		_g_free0 (_data_->_tmp56_);
#line 2492 "../folks/individual-aggregator.vala"
		_g_free0 (_data_->_tmp54_);
#line 2492 "../folks/individual-aggregator.vala"
		_g_free0 (_data_->_tmp52_);
#line 2492 "../folks/individual-aggregator.vala"
		_data_->_inner_error0_ = _data_->_tmp64_;
#line 2492 "../folks/individual-aggregator.vala"
		if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2492 "../folks/individual-aggregator.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2492 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->new_persona);
#line 2492 "../folks/individual-aggregator.vala"
			_g_hash_table_unref0 (_data_->details);
#line 2492 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2492 "../folks/individual-aggregator.vala"
			return FALSE;
#line 11387 "individual-aggregator.c"
		} else {
#line 2492 "../folks/individual-aggregator.vala"
			_g_object_unref0 (_data_->new_persona);
#line 2492 "../folks/individual-aggregator.vala"
			_g_hash_table_unref0 (_data_->details);
#line 2492 "../folks/individual-aggregator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2492 "../folks/individual-aggregator.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 2492 "../folks/individual-aggregator.vala"
			g_object_unref (_data_->_async_result);
#line 2492 "../folks/individual-aggregator.vala"
			return FALSE;
#line 11401 "individual-aggregator.c"
		}
	} else {
#line 2501 "../folks/individual-aggregator.vala"
		_data_->_tmp65_ = _data_->new_persona;
#line 2501 "../folks/individual-aggregator.vala"
		if (_data_->_tmp65_ == NULL) {
#line 2503 "../folks/individual-aggregator.vala"
			_data_->_tmp66_ = g_error_new (FOLKS_INDIVIDUAL_AGGREGATOR_ERROR, FOLKS_INDIVIDUAL_AGGREGATOR_ERROR_PROPERTY_NOT_WRITEABLE, _ ("Can’t write to requested property (‘%s’) of the writeable store."), _data_->property_name);
#line 2503 "../folks/individual-aggregator.vala"
			_data_->_inner_error0_ = _data_->_tmp66_;
#line 2503 "../folks/individual-aggregator.vala"
			if (_data_->_inner_error0_->domain == FOLKS_INDIVIDUAL_AGGREGATOR_ERROR) {
#line 2503 "../folks/individual-aggregator.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2503 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->new_persona);
#line 2503 "../folks/individual-aggregator.vala"
				_g_hash_table_unref0 (_data_->details);
#line 2503 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2503 "../folks/individual-aggregator.vala"
				return FALSE;
#line 11424 "individual-aggregator.c"
			} else {
#line 2503 "../folks/individual-aggregator.vala"
				_g_object_unref0 (_data_->new_persona);
#line 2503 "../folks/individual-aggregator.vala"
				_g_hash_table_unref0 (_data_->details);
#line 2503 "../folks/individual-aggregator.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 2503 "../folks/individual-aggregator.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 2503 "../folks/individual-aggregator.vala"
				g_object_unref (_data_->_async_result);
#line 2503 "../folks/individual-aggregator.vala"
				return FALSE;
#line 11438 "individual-aggregator.c"
			}
		}
	}
#line 2510 "../folks/individual-aggregator.vala"
	_data_->_tmp67_ = _data_->new_persona;
#line 2510 "../folks/individual-aggregator.vala"
	_data_->_tmp68_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp67_, FOLKS_TYPE_PERSONA, FolksPersona));
#line 2510 "../folks/individual-aggregator.vala"
	_data_->result = _data_->_tmp68_;
#line 2510 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->new_persona);
#line 2510 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (_data_->details);
#line 2510 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2510 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2510 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2510 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11460 "individual-aggregator.c"
		}
	}
#line 2510 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2510 "../folks/individual-aggregator.vala"
	return FALSE;
#line 11467 "individual-aggregator.c"
}

static void
folks_individual_aggregator_look_up_individual_data_free (gpointer _data)
{
	FolksIndividualAggregatorLookUpIndividualData* _data_;
	_data_ = _data;
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->id);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->result);
#line 125 "../folks/individual-aggregator.vala"
	_g_object_unref0 (_data_->self);
#line 125 "../folks/individual-aggregator.vala"
	g_slice_free (FolksIndividualAggregatorLookUpIndividualData, _data_);
#line 11483 "individual-aggregator.c"
}

void
folks_individual_aggregator_look_up_individual (FolksIndividualAggregator* self,
                                                const gchar* id,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	FolksIndividualAggregatorLookUpIndividualData* _data_;
	FolksIndividualAggregator* _tmp0_;
	gchar* _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (id != NULL);
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_slice_new0 (FolksIndividualAggregatorLookUpIndividualData);
#line 125 "../folks/individual-aggregator.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 125 "../folks/individual-aggregator.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_individual_aggregator_look_up_individual_data_free);
#line 125 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 125 "../folks/individual-aggregator.vala"
	_data_->self = _tmp0_;
#line 125 "../folks/individual-aggregator.vala"
	_tmp1_ = g_strdup (id);
#line 125 "../folks/individual-aggregator.vala"
	_g_free0 (_data_->id);
#line 125 "../folks/individual-aggregator.vala"
	_data_->id = _tmp1_;
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_look_up_individual_co (_data_);
#line 11517 "individual-aggregator.c"
}

FolksIndividual*
folks_individual_aggregator_look_up_individual_finish (FolksIndividualAggregator* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	FolksIndividual* result;
	FolksIndividualAggregatorLookUpIndividualData* _data_;
#line 125 "../folks/individual-aggregator.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 125 "../folks/individual-aggregator.vala"
	if (NULL == _data_) {
#line 125 "../folks/individual-aggregator.vala"
		return NULL;
#line 11533 "individual-aggregator.c"
	}
#line 125 "../folks/individual-aggregator.vala"
	result = _data_->result;
#line 125 "../folks/individual-aggregator.vala"
	_data_->result = NULL;
#line 125 "../folks/individual-aggregator.vala"
	return result;
#line 11541 "individual-aggregator.c"
}

/**
   * Look up an individual in the aggregator.
   *
   * This returns the {@link Individual} with the given ``id`` if it exists in
   * the aggregator, and ``null`` otherwise.
   *
   * In future, when lazy-loading of individuals' properties is added to folks,
   * this method guarantees to load all properties of the individual, even if
   * the aggregator hasn't lazy-loaded anything else.
   *
   * This method is safe to call before {@link IndividualAggregator.prepare} has
   * been called, and will call {@link IndividualAggregator.prepare} itself in
   * that case.
   *
   * This method is safe to call multiple times concurrently.
   *
   * @param id ID of the individual to look up
   * @return individual with ``id``, or ``null`` if no such individual was found
   * @throws GLib.Error from {@link IndividualAggregator.prepare}
   *
   * @since 0.7.0
   */
static void
folks_individual_aggregator_look_up_individual_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	FolksIndividualAggregatorLookUpIndividualData* _data_;
#line 2538 "../folks/individual-aggregator.vala"
	_data_ = _user_data_;
#line 2538 "../folks/individual-aggregator.vala"
	_data_->_source_object_ = source_object;
#line 2538 "../folks/individual-aggregator.vala"
	_data_->_res_ = _res_;
#line 2538 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_look_up_individual_co (_data_);
#line 11580 "individual-aggregator.c"
}

static gboolean
folks_individual_aggregator_look_up_individual_co (FolksIndividualAggregatorLookUpIndividualData* _data_)
{
#line 2535 "../folks/individual-aggregator.vala"
	switch (_data_->_state_) {
#line 2535 "../folks/individual-aggregator.vala"
		case 0:
#line 11590 "individual-aggregator.c"
		goto _state_0;
#line 2535 "../folks/individual-aggregator.vala"
		case 1:
#line 11594 "individual-aggregator.c"
		goto _state_1;
		default:
#line 2535 "../folks/individual-aggregator.vala"
		g_assert_not_reached ();
#line 11599 "individual-aggregator.c"
	}
	_state_0:
#line 2538 "../folks/individual-aggregator.vala"
	_data_->_state_ = 1;
#line 2538 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_prepare (_data_->self, folks_individual_aggregator_look_up_individual_ready, _data_);
#line 2538 "../folks/individual-aggregator.vala"
	return FALSE;
#line 11608 "individual-aggregator.c"
	_state_1:
#line 2538 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_prepare_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 2538 "../folks/individual-aggregator.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2538 "../folks/individual-aggregator.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 2538 "../folks/individual-aggregator.vala"
		g_object_unref (_data_->_async_result);
#line 2538 "../folks/individual-aggregator.vala"
		return FALSE;
#line 11620 "individual-aggregator.c"
	}
#line 2541 "../folks/individual-aggregator.vala"
	_data_->_tmp0_ = _data_->self->priv->_individuals;
#line 2541 "../folks/individual-aggregator.vala"
	_data_->_tmp1_ = gee_map_get (_data_->_tmp0_, _data_->id);
#line 2541 "../folks/individual-aggregator.vala"
	_data_->result = (FolksIndividual*) _data_->_tmp1_;
#line 2541 "../folks/individual-aggregator.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 2541 "../folks/individual-aggregator.vala"
	if (_data_->_state_ != 0) {
#line 2541 "../folks/individual-aggregator.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 2541 "../folks/individual-aggregator.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 11636 "individual-aggregator.c"
		}
	}
#line 2541 "../folks/individual-aggregator.vala"
	g_object_unref (_data_->_async_result);
#line 2541 "../folks/individual-aggregator.vala"
	return FALSE;
#line 11643 "individual-aggregator.c"
}

gboolean
folks_individual_aggregator_get_is_prepared (FolksIndividualAggregator* self)
{
	gboolean result;
#line 186 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 186 "../folks/individual-aggregator.vala"
	result = self->priv->_is_prepared;
#line 186 "../folks/individual-aggregator.vala"
	return result;
#line 11656 "individual-aggregator.c"
}

gboolean
folks_individual_aggregator_get_is_quiescent (FolksIndividualAggregator* self)
{
	gboolean result;
#line 204 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 204 "../folks/individual-aggregator.vala"
	result = self->priv->_is_quiescent;
#line 204 "../folks/individual-aggregator.vala"
	return result;
#line 11669 "individual-aggregator.c"
}

FolksPersonaStore*
folks_individual_aggregator_get_primary_store (FolksIndividualAggregator* self)
{
	FolksPersonaStore* result;
	FolksPersonaStore* _tmp0_;
#line 221 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 221 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_primary_store;
#line 221 "../folks/individual-aggregator.vala"
	result = _tmp0_;
#line 221 "../folks/individual-aggregator.vala"
	return result;
#line 11685 "individual-aggregator.c"
}

FolksBackendStore*
folks_individual_aggregator_get_backend_store (FolksIndividualAggregator* self)
{
	FolksBackendStore* result;
	FolksBackendStore* _tmp0_;
#line 231 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_backend_store;
#line 231 "../folks/individual-aggregator.vala"
	result = _tmp0_;
#line 231 "../folks/individual-aggregator.vala"
	return result;
#line 11701 "individual-aggregator.c"
}

static void
folks_individual_aggregator_set_backend_store (FolksIndividualAggregator* self,
                                               FolksBackendStore* value)
{
	FolksBackendStore* _tmp0_;
#line 232 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 232 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 232 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_backend_store);
#line 232 "../folks/individual-aggregator.vala"
	self->priv->_backend_store = _tmp0_;
#line 232 "../folks/individual-aggregator.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY]);
#line 11719 "individual-aggregator.c"
}

GeeMap*
folks_individual_aggregator_get_individuals (FolksIndividualAggregator* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 252 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 252 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_individuals_ro;
#line 252 "../folks/individual-aggregator.vala"
	result = _tmp0_;
#line 252 "../folks/individual-aggregator.vala"
	return result;
#line 11735 "individual-aggregator.c"
}

static void
folks_individual_aggregator_set_individuals (FolksIndividualAggregator* self,
                                             GeeMap* value)
{
	GeeMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
#line 253 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 255 "../folks/individual-aggregator.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 255 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals);
#line 255 "../folks/individual-aggregator.vala"
	self->priv->_individuals = _tmp0_;
#line 256 "../folks/individual-aggregator.vala"
	_tmp1_ = self->priv->_individuals;
#line 256 "../folks/individual-aggregator.vala"
	_tmp2_ = gee_map_get_read_only_view (_tmp1_);
#line 256 "../folks/individual-aggregator.vala"
	_tmp3_ = _tmp2_;
#line 256 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals_ro);
#line 256 "../folks/individual-aggregator.vala"
	self->priv->_individuals_ro = _tmp3_;
#line 253 "../folks/individual-aggregator.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY]);
#line 11766 "individual-aggregator.c"
}

FolksIndividual*
folks_individual_aggregator_get_user (FolksIndividualAggregator* self)
{
	FolksIndividual* result;
	FolksIndividual* _tmp0_;
#line 269 "../folks/individual-aggregator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_user;
#line 269 "../folks/individual-aggregator.vala"
	result = _tmp0_;
#line 269 "../folks/individual-aggregator.vala"
	return result;
#line 11782 "individual-aggregator.c"
}

static void
folks_individual_aggregator_set_user (FolksIndividualAggregator* self,
                                      FolksIndividual* value)
{
	FolksIndividual* old_value;
#line 269 "../folks/individual-aggregator.vala"
	g_return_if_fail (self != NULL);
#line 269 "../folks/individual-aggregator.vala"
	old_value = folks_individual_aggregator_get_user (self);
#line 269 "../folks/individual-aggregator.vala"
	if (old_value != value) {
#line 11796 "individual-aggregator.c"
		FolksIndividual* _tmp0_;
#line 269 "../folks/individual-aggregator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 269 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self->priv->_user);
#line 269 "../folks/individual-aggregator.vala"
		self->priv->_user = _tmp0_;
#line 269 "../folks/individual-aggregator.vala"
		g_object_notify_by_pspec ((GObject *) self, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY]);
#line 11806 "individual-aggregator.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM (GClosure * closure,
                                                                GValue * return_value,
                                                                guint n_param_values,
                                                                const GValue * param_values,
                                                                gpointer invocation_hint,
                                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM) (gpointer data1, gpointer arg_1, gpointer arg_2, const char* arg_3, gpointer arg_4, gint arg_5, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 125 "../folks/individual-aggregator.vala"
	g_return_if_fail (n_param_values == 6);
#line 125 "../folks/individual-aggregator.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 125 "../folks/individual-aggregator.vala"
		data1 = closure->data;
#line 125 "../folks/individual-aggregator.vala"
		data2 = param_values->data[0].v_pointer;
#line 11832 "individual-aggregator.c"
	} else {
#line 125 "../folks/individual-aggregator.vala"
		data1 = param_values->data[0].v_pointer;
#line 125 "../folks/individual-aggregator.vala"
		data2 = closure->data;
#line 11838 "individual-aggregator.c"
	}
#line 125 "../folks/individual-aggregator.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 125 "../folks/individual-aggregator.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_string (param_values + 3), g_value_get_object (param_values + 4), g_value_get_enum (param_values + 5), data2);
#line 11844 "individual-aggregator.c"
}

static void
_g_ptr_array_unref0_ (gpointer var)
{
#line 456 "../folks/individual-aggregator.vala"
	(var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL));
#line 11852 "individual-aggregator.c"
}

static void
__folks_individual_aggregator_primary_store_setting_changed_cb_g_settings_changed (GSettings* _sender,
                                                                                   const gchar* key,
                                                                                   gpointer self)
{
#line 497 "../folks/individual-aggregator.vala"
	_folks_individual_aggregator_primary_store_setting_changed_cb ((FolksIndividualAggregator*) self, _sender, key);
#line 11862 "individual-aggregator.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1378 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1379 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1379 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1380 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1381 "glib-2.0.vapi"
	result = _result_;
#line 1381 "glib-2.0.vapi"
	return result;
#line 11883 "individual-aggregator.c"
}

static GObject *
folks_individual_aggregator_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksIndividualAggregator * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	GeeMap* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	FolksSmallSet* _tmp8_;
	FolksDebug* _tmp9_;
	FolksDebug* _tmp10_;
	gchar* store_config_ids = NULL;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp21_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* disable_linking = NULL;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	const gchar* _tmp42_;
#line 451 "../folks/individual-aggregator.vala"
	parent_class = G_OBJECT_CLASS (folks_individual_aggregator_parent_class);
#line 451 "../folks/individual-aggregator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 451 "../folks/individual-aggregator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator);
#line 453 "../folks/individual-aggregator.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 453 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_stores);
#line 453 "../folks/individual-aggregator.vala"
	self->priv->_stores = _tmp0_;
#line 454 "../folks/individual-aggregator.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 454 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals);
#line 454 "../folks/individual-aggregator.vala"
	self->priv->_individuals = (GeeMap*) _tmp1_;
#line 455 "../folks/individual-aggregator.vala"
	_tmp2_ = self->priv->_individuals;
#line 455 "../folks/individual-aggregator.vala"
	_tmp3_ = gee_map_get_read_only_view (_tmp2_);
#line 455 "../folks/individual-aggregator.vala"
	_tmp4_ = _tmp3_;
#line 455 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals_ro);
#line 455 "../folks/individual-aggregator.vala"
	self->priv->_individuals_ro = _tmp4_;
#line 456 "../folks/individual-aggregator.vala"
	_tmp5_ = g_str_hash;
#line 456 "../folks/individual-aggregator.vala"
	_tmp6_ = g_str_equal;
#line 456 "../folks/individual-aggregator.vala"
	_tmp7_ = g_hash_table_new_full (_tmp5_, _tmp6_, _g_free0_, _g_ptr_array_unref0_);
#line 456 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (self->priv->_link_map);
#line 456 "../folks/individual-aggregator.vala"
	self->priv->_link_map = _tmp7_;
#line 459 "../folks/individual-aggregator.vala"
	_tmp8_ = folks_small_set_new (FOLKS_TYPE_BACKEND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 459 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_backends);
#line 459 "../folks/individual-aggregator.vala"
	self->priv->_backends = _tmp8_;
#line 460 "../folks/individual-aggregator.vala"
	_tmp9_ = folks_debug_dup ();
#line 460 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_debug);
#line 460 "../folks/individual-aggregator.vala"
	self->priv->_debug = _tmp9_;
#line 461 "../folks/individual-aggregator.vala"
	_tmp10_ = self->priv->_debug;
#line 461 "../folks/individual-aggregator.vala"
	g_signal_connect_object (_tmp10_, "print-status", (GCallback) __folks_individual_aggregator_debug_print_status_folks_debug_print_status, self, 0);
#line 464 "../folks/individual-aggregator.vala"
	_tmp11_ = g_getenv ("FOLKS_PRIMARY_STORE");
#line 464 "../folks/individual-aggregator.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 464 "../folks/individual-aggregator.vala"
	store_config_ids = _tmp12_;
#line 465 "../folks/individual-aggregator.vala"
	_tmp13_ = store_config_ids;
#line 465 "../folks/individual-aggregator.vala"
	if (_tmp13_ == NULL) {
#line 11983 "individual-aggregator.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
#line 467 "../folks/individual-aggregator.vala"
		_tmp14_ = g_getenv ("FOLKS_WRITEABLE_STORE");
#line 467 "../folks/individual-aggregator.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 467 "../folks/individual-aggregator.vala"
		_g_free0 (store_config_ids);
#line 467 "../folks/individual-aggregator.vala"
		store_config_ids = _tmp15_;
#line 468 "../folks/individual-aggregator.vala"
		_tmp16_ = store_config_ids;
#line 468 "../folks/individual-aggregator.vala"
		if (_tmp16_ != NULL) {
#line 11999 "individual-aggregator.c"
			gchar* deprecated_warn = NULL;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			const gchar* _tmp20_;
#line 470 "../folks/individual-aggregator.vala"
			_tmp17_ = g_strdup ("FOLKS_WRITEABLE_STORE is deprecated, ");
#line 470 "../folks/individual-aggregator.vala"
			deprecated_warn = _tmp17_;
#line 471 "../folks/individual-aggregator.vala"
			_tmp18_ = deprecated_warn;
#line 471 "../folks/individual-aggregator.vala"
			_tmp19_ = g_strconcat (_tmp18_, "use FOLKS_PRIMARY_STORE", NULL);
#line 471 "../folks/individual-aggregator.vala"
			_g_free0 (deprecated_warn);
#line 471 "../folks/individual-aggregator.vala"
			deprecated_warn = _tmp19_;
#line 472 "../folks/individual-aggregator.vala"
			_tmp20_ = deprecated_warn;
#line 472 "../folks/individual-aggregator.vala"
			g_warning ("individual-aggregator.vala:472: %s", _tmp20_);
#line 468 "../folks/individual-aggregator.vala"
			_g_free0 (deprecated_warn);
#line 12023 "individual-aggregator.c"
		}
	}
#line 476 "../folks/individual-aggregator.vala"
	_tmp21_ = store_config_ids;
#line 476 "../folks/individual-aggregator.vala"
	if (_tmp21_ != NULL) {
#line 12030 "individual-aggregator.c"
		const gchar* _tmp22_;
#line 478 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:478: Setting primary store IDs from environ" \
"ment variable.");
#line 479 "../folks/individual-aggregator.vala"
		_tmp22_ = store_config_ids;
#line 479 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_configure_primary_store (self, (const gchar*) _tmp22_);
#line 12038 "individual-aggregator.c"
	} else {
		GSettings* _tmp27_;
		GSettings* _tmp28_;
		gchar* _tmp29_;
		GSettings* _tmp30_;
#line 483 "../folks/individual-aggregator.vala"
		g_debug ("individual-aggregator.vala:483: Setting primary store IDs to defaults.");
#line 484 "../folks/individual-aggregator.vala"
		if (HAVE_EDS) {
#line 12048 "individual-aggregator.c"
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 486 "../folks/individual-aggregator.vala"
			_tmp23_ = g_strdup ("eds");
#line 486 "../folks/individual-aggregator.vala"
			_g_free0 (self->priv->_configured_primary_store_type_id);
#line 486 "../folks/individual-aggregator.vala"
			self->priv->_configured_primary_store_type_id = _tmp23_;
#line 487 "../folks/individual-aggregator.vala"
			_tmp24_ = g_strdup ("system-address-book");
#line 487 "../folks/individual-aggregator.vala"
			_g_free0 (self->priv->_configured_primary_store_id);
#line 487 "../folks/individual-aggregator.vala"
			self->priv->_configured_primary_store_id = _tmp24_;
#line 12063 "individual-aggregator.c"
		} else {
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 491 "../folks/individual-aggregator.vala"
			_tmp25_ = g_strdup ("key-file");
#line 491 "../folks/individual-aggregator.vala"
			_g_free0 (self->priv->_configured_primary_store_type_id);
#line 491 "../folks/individual-aggregator.vala"
			self->priv->_configured_primary_store_type_id = _tmp25_;
#line 492 "../folks/individual-aggregator.vala"
			_tmp26_ = g_strdup ("");
#line 492 "../folks/individual-aggregator.vala"
			_g_free0 (self->priv->_configured_primary_store_id);
#line 492 "../folks/individual-aggregator.vala"
			self->priv->_configured_primary_store_id = _tmp26_;
#line 12079 "individual-aggregator.c"
		}
#line 495 "../folks/individual-aggregator.vala"
		_tmp27_ = g_settings_new (FOLKS_INDIVIDUAL_AGGREGATOR__FOLKS_GSETTINGS_SCHEMA);
#line 495 "../folks/individual-aggregator.vala"
		_g_object_unref0 (self->priv->_primary_store_setting);
#line 495 "../folks/individual-aggregator.vala"
		self->priv->_primary_store_setting = _tmp27_;
#line 497 "../folks/individual-aggregator.vala"
		_tmp28_ = self->priv->_primary_store_setting;
#line 497 "../folks/individual-aggregator.vala"
		_tmp29_ = g_strconcat ("changed::", FOLKS_INDIVIDUAL_AGGREGATOR__PRIMARY_STORE_CONFIG_KEY, NULL);
#line 497 "../folks/individual-aggregator.vala"
		g_signal_connect_object (_tmp28_, _tmp29_, (GCallback) __folks_individual_aggregator_primary_store_setting_changed_cb_g_settings_changed, self, 0);
#line 497 "../folks/individual-aggregator.vala"
		_g_free0 (_tmp29_);
#line 499 "../folks/individual-aggregator.vala"
		_tmp30_ = self->priv->_primary_store_setting;
#line 499 "../folks/individual-aggregator.vala"
		_folks_individual_aggregator_primary_store_setting_changed_cb (self, _tmp30_, FOLKS_INDIVIDUAL_AGGREGATOR__PRIMARY_STORE_CONFIG_KEY);
#line 12099 "individual-aggregator.c"
	}
#line 503 "../folks/individual-aggregator.vala"
	_tmp31_ = self->priv->_configured_primary_store_type_id;
#line 503 "../folks/individual-aggregator.vala"
	_tmp32_ = self->priv->_configured_primary_store_id;
#line 503 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:503: Primary store IDs are '%s' and '%s'.", _tmp31_, _tmp32_);
#line 507 "../folks/individual-aggregator.vala"
	_tmp33_ = g_getenv ("FOLKS_DISABLE_LINKING");
#line 507 "../folks/individual-aggregator.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 507 "../folks/individual-aggregator.vala"
	disable_linking = _tmp34_;
#line 508 "../folks/individual-aggregator.vala"
	_tmp35_ = disable_linking;
#line 508 "../folks/individual-aggregator.vala"
	if (_tmp35_ != NULL) {
#line 12117 "individual-aggregator.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 509 "../folks/individual-aggregator.vala"
		_tmp36_ = disable_linking;
#line 509 "../folks/individual-aggregator.vala"
		_tmp37_ = string_strip ((const gchar*) _tmp36_);
#line 509 "../folks/individual-aggregator.vala"
		_tmp38_ = _tmp37_;
#line 509 "../folks/individual-aggregator.vala"
		_tmp39_ = g_utf8_strdown (_tmp38_, (gssize) -1);
#line 509 "../folks/individual-aggregator.vala"
		_g_free0 (disable_linking);
#line 509 "../folks/individual-aggregator.vala"
		disable_linking = _tmp39_;
#line 509 "../folks/individual-aggregator.vala"
		_g_free0 (_tmp38_);
#line 12136 "individual-aggregator.c"
	}
#line 510 "../folks/individual-aggregator.vala"
	_tmp42_ = disable_linking;
#line 510 "../folks/individual-aggregator.vala"
	if (_tmp42_ == NULL) {
#line 510 "../folks/individual-aggregator.vala"
		_tmp41_ = TRUE;
#line 12144 "individual-aggregator.c"
	} else {
		const gchar* _tmp43_;
#line 511 "../folks/individual-aggregator.vala"
		_tmp43_ = disable_linking;
#line 511 "../folks/individual-aggregator.vala"
		_tmp41_ = g_strcmp0 (_tmp43_, "no") == 0;
#line 12151 "individual-aggregator.c"
	}
#line 510 "../folks/individual-aggregator.vala"
	if (_tmp41_) {
#line 510 "../folks/individual-aggregator.vala"
		_tmp40_ = TRUE;
#line 12157 "individual-aggregator.c"
	} else {
		const gchar* _tmp44_;
#line 511 "../folks/individual-aggregator.vala"
		_tmp44_ = disable_linking;
#line 511 "../folks/individual-aggregator.vala"
		_tmp40_ = g_strcmp0 (_tmp44_, "0") == 0;
#line 12164 "individual-aggregator.c"
	}
#line 510 "../folks/individual-aggregator.vala"
	self->priv->_linking_enabled = _tmp40_;
#line 513 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:513: Constructing IndividualAggregator %p", self);
#line 451 "../folks/individual-aggregator.vala"
	_g_free0 (disable_linking);
#line 451 "../folks/individual-aggregator.vala"
	_g_free0 (store_config_ids);
#line 451 "../folks/individual-aggregator.vala"
	return obj;
#line 12176 "individual-aggregator.c"
}

static void
folks_individual_aggregator_class_init (FolksIndividualAggregatorClass * klass,
                                        gpointer klass_data)
{
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_parent_class = g_type_class_peek_parent (klass);
#line 125 "../folks/individual-aggregator.vala"
	g_type_class_adjust_private_offset (klass, &FolksIndividualAggregator_private_offset);
#line 125 "../folks/individual-aggregator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_individual_aggregator_get_property;
#line 125 "../folks/individual-aggregator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_individual_aggregator_set_property;
#line 125 "../folks/individual-aggregator.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_individual_aggregator_constructor;
#line 125 "../folks/individual-aggregator.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_individual_aggregator_finalize;
#line 12195 "individual-aggregator.c"
	/**
	   * Whether {@link IndividualAggregator.prepare} has successfully completed for
	   * this aggregator.
	   *
	   * @since 0.3.0
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_IS_PREPARED_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12204 "individual-aggregator.c"
	/**
	   * Whether the aggregator has reached a quiescent state. This will happen at
	   * some point after {@link IndividualAggregator.prepare} has successfully
	   * completed for the aggregator. An aggregator is in a quiescent state when
	   * all the {@link PersonaStore}s listed by its backends have reached a
	   * quiescent state. Once it's reached a quiescent state, this property will
	   * never change again (from ``true`` to ``false``).
	   *
	   * It's guaranteed that this property's value will only ever change after
	   * {@link IndividualAggregator.is_prepared} has changed to ``true``.
	   *
	   * @since 0.6.2
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_IS_QUIESCENT_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12220 "individual-aggregator.c"
	/**
	   * Our configured primary (writeable) store.
	   *
	   * Which one to use is decided (in order or precedence)
	   * by:
	   *
	   * - the FOLKS_PRIMARY_STORE env var (mostly for debugging)
	   * - the GSettings key set in ``_PRIMARY_STORE_CONFIG_KEY`` (system set store)
	   * - going with the ``key-file`` or ``eds`` store as the fall-back option
	   *
	   * @since 0.5.0
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_PRIMARY_STORE_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_PRIMARY_STORE_PROPERTY] = g_param_spec_object ("primary-store", "primary-store", "primary-store", FOLKS_TYPE_PERSONA_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12235 "individual-aggregator.c"
	/**
	   * The backend store providing the persona stores for this aggregator.
	   *
	   * @since 0.9.7
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY] = g_param_spec_object ("backend-store", "backend-store", "backend-store", FOLKS_TYPE_BACKEND_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 12243 "individual-aggregator.c"
	/**
	   * A map from {@link Individual.id}s to their {@link Individual}s.
	   *
	   * This is the canonical set of {@link Individual}s provided by this
	   * IndividualAggregator.
	   *
	   * {@link Individual}s may be added or removed using
	   * {@link IndividualAggregator.add_persona_from_details} and
	   * {@link IndividualAggregator.remove_individual}, respectively.
	   *
	   * @since 0.5.1
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY] = g_param_spec_object ("individuals", "individuals", "individuals", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12258 "individual-aggregator.c"
	/**
	   * The {@link Individual} representing the user.
	   *
	   * If it exists, this holds the {@link Individual} who is the user: the
	   * {@link Individual} containing the {@link Persona}s who are the owners of
	   * the accounts for their respective backends.
	   *
	   * @since 0.3.0
	   */
#line 125 "../folks/individual-aggregator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY, folks_individual_aggregator_properties[FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", FOLKS_TYPE_INDIVIDUAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12270 "individual-aggregator.c"
	/**
	   * Emitted when one or more {@link Individual}s are added to or removed from
	   * the aggregator.
	   *
	   * If more information about the relationships between {@link Individual}s
	   * which have been linked and unlinked is needed, consider connecting to
	   * {@link IndividualAggregator.individuals_changed_detailed} instead, which is
	   * emitted at the same time as this signal.
	   *
	   * This will not be emitted until after {@link IndividualAggregator.prepare}
	   * has been called.
	   *
	   * @param added a list of {@link Individual}s which have been added
	   * @param removed a list of {@link Individual}s which have been removed
	   * @param message a string message from the backend, if any
	   * @param actor the {@link Persona} who made the change, if known
	   * @param reason the reason for the change
	   *
	   * @since 0.5.1
	   */
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_signals[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_SIGNAL] = g_signal_new ("individuals-changed", FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, G_SIGNAL_RUN_LAST | G_SIGNAL_DEPRECATED, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_STRING_OBJECT_ENUM, G_TYPE_NONE, 5, GEE_TYPE_SET, GEE_TYPE_SET, G_TYPE_STRING, FOLKS_TYPE_PERSONA, FOLKS_GROUP_DETAILS_TYPE_CHANGE_REASON);
#line 12293 "individual-aggregator.c"
	/**
	   * Emitted when one or more {@link Individual}s are added to or removed from
	   * the aggregator.
	   *
	   * This is emitted at the same time as
	   * {@link IndividualAggregator.individuals_changed}, but includes more
	   * information about the relationships between {@link Individual}s which have
	   * been linked and unlinked.
	   *
	   * Individuals which have been linked will be listed in the multi-map as
	   * mappings from the old individuals to the single new individual which
	   * replaces them (i.e. each of the old individuals will map to the same new
	   * individual). This new individual is the one which will be specified as the
	   * ``replacement_individual`` in the {@link Individual.removed} signal for the
	   * old individuals.
	   *
	   * Individuals which have been unlinked will be listed in the multi-map as
	   * a mapping from the unlinked individual to a set of one or more individuals
	   * which replace it.
	   *
	   * Individuals which have been added will be listed in the multi-map as a
	   * mapping from ``null`` to the set of added individuals. If ``null`` doesn't
	   * map to anything, no individuals have been added to the aggregator.
	   *
	   * Individuals which have been removed will be listed in the multi-map as
	   * mappings from the removed individual to ``null``.
	   *
	   * This will not be emitted until after {@link IndividualAggregator.prepare}
	   * has been called.
	   *
	   * @param changes a mapping of old {@link Individual}s to new
	   * {@link Individual}s for the individuals which have changed in the
	   * aggregator
	   *
	   * @since 0.6.2
	   */
#line 125 "../folks/individual-aggregator.vala"
	folks_individual_aggregator_signals[FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_CHANGED_DETAILED_SIGNAL] = g_signal_new ("individuals-changed-detailed", FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_MULTI_MAP);
#line 12332 "individual-aggregator.c"
}

static void
folks_individual_aggregator_instance_init (FolksIndividualAggregator * self,
                                           gpointer klass)
{
#line 125 "../folks/individual-aggregator.vala"
	self->priv = folks_individual_aggregator_get_instance_private (self);
#line 131 "../folks/individual-aggregator.vala"
	self->priv->_primary_store = NULL;
#line 134 "../folks/individual-aggregator.vala"
	self->priv->_primary_store_setting = NULL;
#line 145 "../folks/individual-aggregator.vala"
	self->priv->_linking_enabled = TRUE;
#line 146 "../folks/individual-aggregator.vala"
	self->priv->_is_prepared = FALSE;
#line 147 "../folks/individual-aggregator.vala"
	self->priv->_prepare_pending = FALSE;
#line 161 "../folks/individual-aggregator.vala"
	self->priv->_non_quiescent_persona_store_count = (guint) 0;
#line 163 "../folks/individual-aggregator.vala"
	self->priv->_non_quiescent_backend_count = (guint) 0;
#line 164 "../folks/individual-aggregator.vala"
	self->priv->_is_quiescent = FALSE;
#line 168 "../folks/individual-aggregator.vala"
	self->priv->_quiescent_timeout_id = (guint) 0;
#line 176 "../folks/individual-aggregator.vala"
	self->priv->_user_configured_primary_store = FALSE;
#line 12361 "individual-aggregator.c"
}

static void
folks_individual_aggregator_finalize (GObject * obj)
{
	FolksIndividualAggregator * self;
	FolksBackendStore* _tmp0_;
	guint _tmp1_;
	FolksDebug* _tmp2_;
	guint _tmp3_;
#line 125 "../folks/individual-aggregator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator);
#line 518 "../folks/individual-aggregator.vala"
	g_debug ("individual-aggregator.vala:518: Destroying IndividualAggregator %p", self);
#line 520 "../folks/individual-aggregator.vala"
	if (self->priv->_quiescent_timeout_id != ((guint) 0)) {
#line 522 "../folks/individual-aggregator.vala"
		g_source_remove (self->priv->_quiescent_timeout_id);
#line 523 "../folks/individual-aggregator.vala"
		self->priv->_quiescent_timeout_id = (guint) 0;
#line 12382 "individual-aggregator.c"
	}
#line 526 "../folks/individual-aggregator.vala"
	_tmp0_ = self->priv->_backend_store;
#line 526 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("backend-available", FOLKS_TYPE_BACKEND_STORE, &_tmp1_, NULL, FALSE);
#line 526 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) __folks_individual_aggregator_backend_available_cb_folks_backend_store_backend_available, self);
#line 529 "../folks/individual-aggregator.vala"
	_tmp2_ = self->priv->_debug;
#line 529 "../folks/individual-aggregator.vala"
	g_signal_parse_name ("print-status", FOLKS_TYPE_DEBUG, &_tmp3_, NULL, FALSE);
#line 529 "../folks/individual-aggregator.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) __folks_individual_aggregator_debug_print_status_folks_debug_print_status, self);
#line 532 "../folks/individual-aggregator.vala"
	folks_individual_aggregator__instance = NULL;
#line 129 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_backend_store);
#line 130 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_stores);
#line 132 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_backends);
#line 134 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_primary_store_setting);
#line 143 "../folks/individual-aggregator.vala"
	_g_hash_table_unref0 (self->priv->_link_map);
#line 148 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_debug);
#line 149 "../folks/individual-aggregator.vala"
	_g_free0 (self->priv->_configured_primary_store_type_id);
#line 150 "../folks/individual-aggregator.vala"
	_g_free0 (self->priv->_configured_primary_store_id);
#line 235 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals);
#line 236 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_individuals_ro);
#line 269 "../folks/individual-aggregator.vala"
	_g_object_unref0 (self->priv->_user);
#line 125 "../folks/individual-aggregator.vala"
	G_OBJECT_CLASS (folks_individual_aggregator_parent_class)->finalize (obj);
#line 12422 "individual-aggregator.c"
}

/**
 * Stores {@link Individual}s which have been created through
 * aggregation of all the {@link Persona}s provided by the various
 * {@link Backend}s.
 *
 * This is the main interface for client applications.
 *
 * Linking and unlinking of personas and individuals is performed entirely
 * through the aggregator. Personas may be linked together to form individuals;
 * for example, the personas which form ``individual1`` and ``individual2`` may
 * be linked together with ``another_persona`` to give a new {@link Individual}:
 *
 * {{{
 *   var personas = new HashSet<Persona> ();
 *   personas.add_all (individual1.personas);
 *   personas.add_all (individual2.personas);
 *   personas.add (another_persona);
 *   yield my_individual_aggregator.link_personas (personas);
 * }}}
 *
 * The individuals which contained those personas will be removed when
 * {@link IndividualAggregator.link_personas} is called. Any personas in those
 * individuals which were not included in the linking call may end up implicitly
 * linked to the new individual, or may be aggregated into other new
 * individuals.
 *
 * For example, consider the situation where ``individual1`` contains two
 * personas, ``persona1A`` and ``persona1B``; ``individual2`` contains one
 * persona, ``persona2A``; and ``another_persona`` comes from ``individual3``,
 * which also contains ``persona3A`` and ``persona3B``. Calling
 * {@link IndividualAggregator.link_personas} on ``persona1A``, ``persona1B``,
 * ``persona2A`` and ``another_persona`` will result in ``individual1`` and
 * ``individual2`` being removed. A new {@link Individual} will be created
 * containing all the personas passed to the linking function. It might also
 * contain ``persona3A`` and ``persona3B``; or they might be in one or two other
 * new individuals.
 *
 * An existing individual may be unlinked to form singleton
 * individuals for each of its personas:
 * {{{
 *   yield my_individual_aggregator.unlink_individual (my_individual);
 * }}}
 *
 * Note that to link two individuals together, their two sets of personas must
 * be linked together. There is no API to directly link the individuals
 * themselves, as conceptually folks links {@link Persona}s, not
 * {@link Individual}s.
 *
 * Folks does not support having more than one IndividualAggregator
 * instantiated at the same time. Most clients should use
 * {@link IndividualAggregator.dup} to retrieve the IndividualAggregator
 * singleton.
 *
 */
static GType
folks_individual_aggregator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksIndividualAggregatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_individual_aggregator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksIndividualAggregator), 0, (GInstanceInitFunc) folks_individual_aggregator_instance_init, NULL };
	GType folks_individual_aggregator_type_id;
	folks_individual_aggregator_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksIndividualAggregator", &g_define_type_info, 0);
	FolksIndividualAggregator_private_offset = g_type_add_instance_private (folks_individual_aggregator_type_id, sizeof (FolksIndividualAggregatorPrivate));
	return folks_individual_aggregator_type_id;
}

GType
folks_individual_aggregator_get_type (void)
{
	static volatile gsize folks_individual_aggregator_type_id__once = 0;
	if (g_once_init_enter (&folks_individual_aggregator_type_id__once)) {
		GType folks_individual_aggregator_type_id;
		folks_individual_aggregator_type_id = folks_individual_aggregator_get_type_once ();
		g_once_init_leave (&folks_individual_aggregator_type_id__once, folks_individual_aggregator_type_id);
	}
	return folks_individual_aggregator_type_id__once;
}

static void
_vala_folks_individual_aggregator_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	FolksIndividualAggregator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator);
#line 125 "../folks/individual-aggregator.vala"
	switch (property_id) {
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_IS_PREPARED_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_boolean (value, folks_individual_aggregator_get_is_prepared (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_IS_QUIESCENT_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_boolean (value, folks_individual_aggregator_get_is_quiescent (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_PRIMARY_STORE_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_object (value, folks_individual_aggregator_get_primary_store (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_object (value, folks_individual_aggregator_get_backend_store (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_object (value, folks_individual_aggregator_get_individuals (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		g_value_set_object (value, folks_individual_aggregator_get_user (self));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 12547 "individual-aggregator.c"
		default:
#line 125 "../folks/individual-aggregator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 12553 "individual-aggregator.c"
	}
}

static void
_vala_folks_individual_aggregator_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	FolksIndividualAggregator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, FolksIndividualAggregator);
#line 125 "../folks/individual-aggregator.vala"
	switch (property_id) {
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_BACKEND_STORE_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		folks_individual_aggregator_set_backend_store (self, g_value_get_object (value));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_INDIVIDUALS_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		folks_individual_aggregator_set_individuals (self, g_value_get_object (value));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 125 "../folks/individual-aggregator.vala"
		case FOLKS_INDIVIDUAL_AGGREGATOR_USER_PROPERTY:
#line 125 "../folks/individual-aggregator.vala"
		folks_individual_aggregator_set_user (self, g_value_get_object (value));
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 12585 "individual-aggregator.c"
		default:
#line 125 "../folks/individual-aggregator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 125 "../folks/individual-aggregator.vala"
		break;
#line 12591 "individual-aggregator.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

